module Politoscope where

import Prelude
import Data.Tuple (Tuple (..))
import Graph (Graph, undirected, fromEdges)

gPolitoscope :: Graph
gPolitoscope = undirected $ fromEdges $ edges

edges :: Array (Tuple Int Int)
edges = 
    [(Tuple 0 1),
    (Tuple 0 2),
    (Tuple 0 3),
    (Tuple 0 4),
    (Tuple 0 5),
    (Tuple 0 6),
    (Tuple 0 7),
    (Tuple 0 8),
    (Tuple 0 9),
    (Tuple 0 10),
    (Tuple 0 11),
    (Tuple 0 12),
    (Tuple 0 13),
    (Tuple 0 14),
    (Tuple 0 15),
    (Tuple 0 16),
    (Tuple 17 18),
    (Tuple 17 19),
    (Tuple 17 20),
    (Tuple 17 21),
    (Tuple 17 22),
    (Tuple 17 23),
    (Tuple 17 16),
    (Tuple 24 25),
    (Tuple 26 27),
    (Tuple 26 28),
    (Tuple 26 29),
    (Tuple 26 30),
    (Tuple 26 20),
    (Tuple 26 31),
    (Tuple 26 32),
    (Tuple 26 33),
    (Tuple 26 34),
    (Tuple 26 35),
    (Tuple 26 36),
    (Tuple 26 37),
    (Tuple 26 38),
    (Tuple 26 39),
    (Tuple 26 40),
    (Tuple 26 22),
    (Tuple 26 41),
    (Tuple 26 42),
    (Tuple 26 43),
    (Tuple 26 44),
    (Tuple 26 45),
    (Tuple 26 46),
    (Tuple 26 47),
    (Tuple 26 48),
    (Tuple 26 49),
    (Tuple 26 50),
    (Tuple 26 51),
    (Tuple 26 52),
    (Tuple 26 53),
    (Tuple 26 54),
    (Tuple 26 55),
    (Tuple 26 56),
    (Tuple 26 57),
    (Tuple 26 58),
    (Tuple 26 59),
    (Tuple 26 16),
    (Tuple 26 60),
    (Tuple 61 62),
    (Tuple 61 30),
    (Tuple 61 63),
    (Tuple 61 64),
    (Tuple 61 65),
    (Tuple 61 66),
    (Tuple 61 67),
    (Tuple 61 53),
    (Tuple 61 68),
    (Tuple 61 69),
    (Tuple 61 70),
    (Tuple 71 71),
    (Tuple 71 72),
    (Tuple 71 73),
    (Tuple 71 74),
    (Tuple 71 75),
    (Tuple 71 76),
    (Tuple 71 77),
    (Tuple 71 78),
    (Tuple 71 79),
    (Tuple 71 80),
    (Tuple 71 81),
    (Tuple 71 82),
    (Tuple 71 83),
    (Tuple 71 37),
    (Tuple 71 84),
    (Tuple 71 85),
    (Tuple 71 86),
    (Tuple 71 87),
    (Tuple 71 88),
    (Tuple 71 89),
    (Tuple 71 90),
    (Tuple 71 91),
    (Tuple 71 92),
    (Tuple 71 93),
    (Tuple 71 94),
    (Tuple 71 95),
    (Tuple 71 96),
    (Tuple 71 41),
    (Tuple 71 97),
    (Tuple 71 98),
    (Tuple 71 99),
    (Tuple 71 100),
    (Tuple 71 101),
    (Tuple 71 102),
    (Tuple 71 103),
    (Tuple 71 104),
    (Tuple 71 105),
    (Tuple 71 106),
    (Tuple 71 107),
    (Tuple 71 108),
    (Tuple 71 109),
    (Tuple 71 110),
    (Tuple 71 111),
    (Tuple 71 112),
    (Tuple 71 113),
    (Tuple 71 114),
    (Tuple 71 52),
    (Tuple 71 115),
    (Tuple 71 116),
    (Tuple 71 117),
    (Tuple 71 118),
    (Tuple 71 119),
    (Tuple 71 120),
    (Tuple 71 121),
    (Tuple 71 56),
    (Tuple 71 122),
    (Tuple 71 123),
    (Tuple 71 124),
    (Tuple 71 125),
    (Tuple 71 126),
    (Tuple 71 127),
    (Tuple 71 128),
    (Tuple 71 129),
    (Tuple 71 130),
    (Tuple 71 131),
    (Tuple 71 132),
    (Tuple 71 133),
    (Tuple 134 135),
    (Tuple 134 3),
    (Tuple 134 136),
    (Tuple 134 137),
    (Tuple 134 138),
    (Tuple 134 31),
    (Tuple 134 139),
    (Tuple 134 5),
    (Tuple 134 140),
    (Tuple 134 141),
    (Tuple 134 142),
    (Tuple 134 143),
    (Tuple 134 7),
    (Tuple 134 144),
    (Tuple 134 145),
    (Tuple 134 8),
    (Tuple 134 146),
    (Tuple 134 9),
    (Tuple 134 10),
    (Tuple 134 11),
    (Tuple 134 147),
    (Tuple 134 12),
    (Tuple 134 148),
    (Tuple 134 13),
    (Tuple 134 14),
    (Tuple 134 149),
    (Tuple 134 150),
    (Tuple 134 151),
    (Tuple 134 152),
    (Tuple 134 153),
    (Tuple 134 154),
    (Tuple 134 155),
    (Tuple 156 157),
    (Tuple 156 158),
    (Tuple 156 159),
    (Tuple 156 31),
    (Tuple 156 160),
    (Tuple 156 161),
    (Tuple 156 162),
    (Tuple 156 6),
    (Tuple 156 163),
    (Tuple 156 164),
    (Tuple 156 165),
    (Tuple 156 7),
    (Tuple 156 166),
    (Tuple 156 167),
    (Tuple 156 168),
    (Tuple 156 169),
    (Tuple 156 170),
    (Tuple 156 171),
    (Tuple 156 16),
    (Tuple 156 172),
    (Tuple 156 173),
    (Tuple 174 157),
    (Tuple 174 175),
    (Tuple 174 176),
    (Tuple 174 177),
    (Tuple 174 178),
    (Tuple 174 179),
    (Tuple 174 180),
    (Tuple 174 181),
    (Tuple 174 182),
    (Tuple 174 183),
    (Tuple 174 62),
    (Tuple 174 30),
    (Tuple 174 184),
    (Tuple 174 185),
    (Tuple 174 186),
    (Tuple 174 187),
    (Tuple 174 63),
    (Tuple 174 188),
    (Tuple 174 189),
    (Tuple 174 160),
    (Tuple 174 190),
    (Tuple 174 191),
    (Tuple 174 192),
    (Tuple 174 193),
    (Tuple 174 194),
    (Tuple 174 162),
    (Tuple 174 195),
    (Tuple 174 21),
    (Tuple 174 64),
    (Tuple 174 196),
    (Tuple 174 197),
    (Tuple 174 198),
    (Tuple 174 199),
    (Tuple 174 39),
    (Tuple 174 165),
    (Tuple 174 200),
    (Tuple 174 22),
    (Tuple 174 201),
    (Tuple 174 202),
    (Tuple 174 203),
    (Tuple 174 166),
    (Tuple 174 204),
    (Tuple 174 205),
    (Tuple 174 206),
    (Tuple 174 207),
    (Tuple 174 208),
    (Tuple 174 167),
    (Tuple 174 209),
    (Tuple 174 210),
    (Tuple 174 211),
    (Tuple 174 168),
    (Tuple 174 170),
    (Tuple 174 212),
    (Tuple 174 213),
    (Tuple 174 23),
    (Tuple 174 214),
    (Tuple 174 215),
    (Tuple 174 66),
    (Tuple 174 216),
    (Tuple 174 50),
    (Tuple 174 217),
    (Tuple 174 218),
    (Tuple 174 219),
    (Tuple 174 220),
    (Tuple 174 221),
    (Tuple 174 222),
    (Tuple 174 16),
    (Tuple 174 223),
    (Tuple 174 224),
    (Tuple 174 225),
    (Tuple 226 226),
    (Tuple 226 227),
    (Tuple 228 229),
    (Tuple 228 230),
    (Tuple 228 231),
    (Tuple 228 20),
    (Tuple 228 63),
    (Tuple 228 232),
    (Tuple 228 233),
    (Tuple 228 40),
    (Tuple 228 234),
    (Tuple 228 235),
    (Tuple 228 43),
    (Tuple 228 45),
    (Tuple 228 65),
    (Tuple 228 46),
    (Tuple 228 104),
    (Tuple 228 236),
    (Tuple 228 237),
    (Tuple 228 52),
    (Tuple 228 238),
    (Tuple 228 239),
    (Tuple 228 240),
    (Tuple 228 241),
    (Tuple 228 173),
    (Tuple 242 242),
    (Tuple 242 243),
    (Tuple 242 244),
    (Tuple 242 245),
    (Tuple 242 246),
    (Tuple 242 247),
    (Tuple 242 248),
    (Tuple 242 249),
    (Tuple 242 250),
    (Tuple 242 251),
    (Tuple 242 252),
    (Tuple 242 253),
    (Tuple 242 62),
    (Tuple 242 254),
    (Tuple 242 255),
    (Tuple 242 256),
    (Tuple 242 161),
    (Tuple 242 257),
    (Tuple 242 258),
    (Tuple 242 259),
    (Tuple 242 198),
    (Tuple 242 206),
    (Tuple 242 260),
    (Tuple 242 25),
    (Tuple 242 23),
    (Tuple 242 261),
    (Tuple 242 262),
    (Tuple 1 1),
    (Tuple 1 19),
    (Tuple 1 28),
    (Tuple 1 78),
    (Tuple 1 263),
    (Tuple 1 37),
    (Tuple 1 234),
    (Tuple 1 235),
    (Tuple 1 264),
    (Tuple 1 97),
    (Tuple 1 265),
    (Tuple 1 49),
    (Tuple 1 237),
    (Tuple 1 266),
    (Tuple 1 267),
    (Tuple 243 244),
    (Tuple 243 175),
    (Tuple 243 176),
    (Tuple 243 177),
    (Tuple 243 268),
    (Tuple 243 248),
    (Tuple 243 269),
    (Tuple 243 270),
    (Tuple 243 179),
    (Tuple 243 180),
    (Tuple 243 271),
    (Tuple 243 272),
    (Tuple 243 183),
    (Tuple 243 273),
    (Tuple 243 274),
    (Tuple 243 62),
    (Tuple 243 184),
    (Tuple 243 20),
    (Tuple 243 185),
    (Tuple 243 187),
    (Tuple 243 275),
    (Tuple 243 276),
    (Tuple 243 189),
    (Tuple 243 190),
    (Tuple 243 191),
    (Tuple 243 192),
    (Tuple 243 193),
    (Tuple 243 194),
    (Tuple 243 162),
    (Tuple 243 195),
    (Tuple 243 277),
    (Tuple 243 64),
    (Tuple 243 197),
    (Tuple 243 278),
    (Tuple 243 279),
    (Tuple 243 280),
    (Tuple 243 199),
    (Tuple 243 281),
    (Tuple 243 282),
    (Tuple 243 40),
    (Tuple 243 200),
    (Tuple 243 22),
    (Tuple 243 283),
    (Tuple 243 202),
    (Tuple 243 203),
    (Tuple 243 166),
    (Tuple 243 204),
    (Tuple 243 206),
    (Tuple 243 208),
    (Tuple 243 284),
    (Tuple 243 167),
    (Tuple 243 285),
    (Tuple 243 286),
    (Tuple 243 209),
    (Tuple 243 287),
    (Tuple 243 211),
    (Tuple 243 170),
    (Tuple 243 288),
    (Tuple 243 23),
    (Tuple 243 289),
    (Tuple 243 214),
    (Tuple 243 216),
    (Tuple 243 217),
    (Tuple 243 171),
    (Tuple 243 219),
    (Tuple 243 220),
    (Tuple 243 222),
    (Tuple 243 16),
    (Tuple 243 290),
    (Tuple 243 224),
    (Tuple 243 225),
    (Tuple 243 60),
    (Tuple 291 291),
    (Tuple 291 292),
    (Tuple 291 293),
    (Tuple 291 9),
    (Tuple 291 294),
    (Tuple 291 295),
    (Tuple 291 296),
    (Tuple 291 297),
    (Tuple 298 299),
    (Tuple 298 300),
    (Tuple 298 301),
    (Tuple 298 63),
    (Tuple 298 302),
    (Tuple 298 303),
    (Tuple 298 41),
    (Tuple 298 304),
    (Tuple 298 97),
    (Tuple 298 43),
    (Tuple 298 65),
    (Tuple 298 305),
    (Tuple 298 104),
    (Tuple 298 236),
    (Tuple 298 306),
    (Tuple 298 112),
    (Tuple 298 115),
    (Tuple 298 117),
    (Tuple 298 119),
    (Tuple 298 126),
    (Tuple 298 307),
    (Tuple 298 308),
    (Tuple 298 309),
    (Tuple 310 18),
    (Tuple 310 21),
    (Tuple 310 199),
    (Tuple 310 39),
    (Tuple 310 311),
    (Tuple 310 312),
    (Tuple 310 55),
    (Tuple 310 126),
    (Tuple 310 173),
    (Tuple 313 314),
    (Tuple 313 30),
    (Tuple 313 32),
    (Tuple 313 315),
    (Tuple 313 170),
    (Tuple 313 316),
    (Tuple 313 173),
    (Tuple 317 18),
    (Tuple 317 229),
    (Tuple 317 72),
    (Tuple 317 318),
    (Tuple 317 319),
    (Tuple 317 320),
    (Tuple 317 300),
    (Tuple 317 321),
    (Tuple 317 28),
    (Tuple 317 322),
    (Tuple 317 323),
    (Tuple 317 78),
    (Tuple 317 324),
    (Tuple 317 263),
    (Tuple 317 325),
    (Tuple 317 326),
    (Tuple 317 327),
    (Tuple 317 328),
    (Tuple 317 83),
    (Tuple 317 37),
    (Tuple 317 84),
    (Tuple 317 329),
    (Tuple 317 85),
    (Tuple 317 38),
    (Tuple 317 330),
    (Tuple 317 331),
    (Tuple 317 87),
    (Tuple 317 88),
    (Tuple 317 332),
    (Tuple 317 92),
    (Tuple 317 333),
    (Tuple 317 334),
    (Tuple 317 335),
    (Tuple 317 336),
    (Tuple 317 337),
    (Tuple 317 338),
    (Tuple 317 207),
    (Tuple 317 339),
    (Tuple 317 42),
    (Tuple 317 340),
    (Tuple 317 98),
    (Tuple 317 312),
    (Tuple 317 100),
    (Tuple 317 341),
    (Tuple 317 342),
    (Tuple 317 343),
    (Tuple 317 344),
    (Tuple 317 345),
    (Tuple 317 346),
    (Tuple 317 103),
    (Tuple 317 305),
    (Tuple 317 347),
    (Tuple 317 106),
    (Tuple 317 348),
    (Tuple 317 114),
    (Tuple 317 52),
    (Tuple 317 349),
    (Tuple 317 350),
    (Tuple 317 351),
    (Tuple 317 352),
    (Tuple 317 353),
    (Tuple 317 124),
    (Tuple 317 354),
    (Tuple 317 131),
    (Tuple 317 355),
    (Tuple 317 356),
    (Tuple 317 60),
    (Tuple 317 357),
    (Tuple 18 18),
    (Tuple 18 358),
    (Tuple 18 229),
    (Tuple 18 28),
    (Tuple 18 78),
    (Tuple 18 359),
    (Tuple 18 360),
    (Tuple 18 311),
    (Tuple 18 361),
    (Tuple 18 330),
    (Tuple 18 235),
    (Tuple 18 265),
    (Tuple 18 341),
    (Tuple 18 362),
    (Tuple 18 343),
    (Tuple 18 345),
    (Tuple 18 305),
    (Tuple 18 49),
    (Tuple 18 363),
    (Tuple 18 14),
    (Tuple 18 122),
    (Tuple 18 353),
    (Tuple 18 364),
    (Tuple 365 365),
    (Tuple 365 366),
    (Tuple 365 29),
    (Tuple 365 322),
    (Tuple 365 367),
    (Tuple 365 368),
    (Tuple 365 32),
    (Tuple 365 33),
    (Tuple 365 89),
    (Tuple 365 112),
    (Tuple 365 369),
    (Tuple 365 370),
    (Tuple 371 372),
    (Tuple 371 373),
    (Tuple 371 260),
    (Tuple 244 157),
    (Tuple 244 175),
    (Tuple 244 176),
    (Tuple 244 268),
    (Tuple 244 178),
    (Tuple 244 269),
    (Tuple 244 270),
    (Tuple 244 179),
    (Tuple 244 318),
    (Tuple 244 249),
    (Tuple 244 374),
    (Tuple 244 183),
    (Tuple 244 273),
    (Tuple 244 274),
    (Tuple 244 62),
    (Tuple 244 30),
    (Tuple 244 184),
    (Tuple 244 20),
    (Tuple 244 185),
    (Tuple 244 375),
    (Tuple 244 187),
    (Tuple 244 275),
    (Tuple 244 63),
    (Tuple 244 276),
    (Tuple 244 189),
    (Tuple 244 190),
    (Tuple 244 191),
    (Tuple 244 192),
    (Tuple 244 193),
    (Tuple 244 376),
    (Tuple 244 194),
    (Tuple 244 162),
    (Tuple 244 195),
    (Tuple 244 232),
    (Tuple 244 360),
    (Tuple 244 377),
    (Tuple 244 21),
    (Tuple 244 64),
    (Tuple 244 196),
    (Tuple 244 197),
    (Tuple 244 198),
    (Tuple 244 278),
    (Tuple 244 164),
    (Tuple 244 280),
    (Tuple 244 199),
    (Tuple 244 281),
    (Tuple 244 282),
    (Tuple 244 39),
    (Tuple 244 40),
    (Tuple 244 200),
    (Tuple 244 22),
    (Tuple 244 361),
    (Tuple 244 202),
    (Tuple 244 378),
    (Tuple 244 203),
    (Tuple 244 166),
    (Tuple 244 204),
    (Tuple 244 205),
    (Tuple 244 206),
    (Tuple 244 379),
    (Tuple 244 380),
    (Tuple 244 208),
    (Tuple 244 284),
    (Tuple 244 167),
    (Tuple 244 285),
    (Tuple 244 286),
    (Tuple 244 209),
    (Tuple 244 210),
    (Tuple 244 312),
    (Tuple 244 211),
    (Tuple 244 168),
    (Tuple 244 362),
    (Tuple 244 170),
    (Tuple 244 65),
    (Tuple 244 288),
    (Tuple 244 212),
    (Tuple 244 23),
    (Tuple 244 289),
    (Tuple 244 381),
    (Tuple 244 382),
    (Tuple 244 214),
    (Tuple 244 383),
    (Tuple 244 66),
    (Tuple 244 216),
    (Tuple 244 384),
    (Tuple 244 217),
    (Tuple 244 385),
    (Tuple 244 171),
    (Tuple 244 386),
    (Tuple 244 218),
    (Tuple 244 219),
    (Tuple 244 387),
    (Tuple 244 388),
    (Tuple 244 389),
    (Tuple 244 390),
    (Tuple 244 56),
    (Tuple 244 391),
    (Tuple 244 68),
    (Tuple 244 221),
    (Tuple 244 222),
    (Tuple 244 392),
    (Tuple 244 16),
    (Tuple 244 290),
    (Tuple 244 224),
    (Tuple 244 356),
    (Tuple 244 225),
    (Tuple 244 393),
    (Tuple 244 60),
    (Tuple 244 394),
    (Tuple 244 173),
    (Tuple 358 395),
    (Tuple 358 396),
    (Tuple 358 397),
    (Tuple 358 20),
    (Tuple 358 398),
    (Tuple 358 196),
    (Tuple 358 199),
    (Tuple 358 285),
    (Tuple 358 23),
    (Tuple 358 16),
    (Tuple 399 399),
    (Tuple 399 72),
    (Tuple 399 400),
    (Tuple 399 75),
    (Tuple 399 401),
    (Tuple 399 76),
    (Tuple 399 78),
    (Tuple 399 63),
    (Tuple 399 302),
    (Tuple 399 359),
    (Tuple 399 326),
    (Tuple 399 81),
    (Tuple 399 328),
    (Tuple 399 37),
    (Tuple 399 84),
    (Tuple 399 402),
    (Tuple 399 403),
    (Tuple 399 404),
    (Tuple 399 405),
    (Tuple 399 361),
    (Tuple 399 331),
    (Tuple 399 89),
    (Tuple 399 90),
    (Tuple 399 406),
    (Tuple 399 333),
    (Tuple 399 334),
    (Tuple 399 407),
    (Tuple 399 408),
    (Tuple 399 303),
    (Tuple 399 94),
    (Tuple 399 95),
    (Tuple 399 235),
    (Tuple 399 409),
    (Tuple 399 97),
    (Tuple 399 99),
    (Tuple 399 312),
    (Tuple 399 43),
    (Tuple 399 410),
    (Tuple 399 411),
    (Tuple 399 412),
    (Tuple 399 65),
    (Tuple 399 344),
    (Tuple 399 413),
    (Tuple 399 414),
    (Tuple 399 415),
    (Tuple 399 416),
    (Tuple 399 417),
    (Tuple 399 418),
    (Tuple 399 102),
    (Tuple 399 103),
    (Tuple 399 305),
    (Tuple 399 104),
    (Tuple 399 419),
    (Tuple 399 420),
    (Tuple 399 421),
    (Tuple 399 105),
    (Tuple 399 106),
    (Tuple 399 107),
    (Tuple 399 108),
    (Tuple 399 422),
    (Tuple 399 109),
    (Tuple 399 110),
    (Tuple 399 306),
    (Tuple 399 49),
    (Tuple 399 423),
    (Tuple 399 112),
    (Tuple 399 237),
    (Tuple 399 113),
    (Tuple 399 385),
    (Tuple 399 424),
    (Tuple 399 369),
    (Tuple 399 52),
    (Tuple 399 425),
    (Tuple 399 115),
    (Tuple 399 349),
    (Tuple 399 238),
    (Tuple 399 117),
    (Tuple 399 118),
    (Tuple 399 119),
    (Tuple 399 426),
    (Tuple 399 120),
    (Tuple 399 121),
    (Tuple 399 427),
    (Tuple 399 428),
    (Tuple 399 429),
    (Tuple 399 267),
    (Tuple 399 123),
    (Tuple 399 57),
    (Tuple 399 124),
    (Tuple 399 125),
    (Tuple 399 126),
    (Tuple 399 127),
    (Tuple 399 430),
    (Tuple 399 239),
    (Tuple 399 431),
    (Tuple 399 128),
    (Tuple 399 432),
    (Tuple 399 129),
    (Tuple 399 130),
    (Tuple 399 131),
    (Tuple 399 433),
    (Tuple 399 434),
    (Tuple 399 308),
    (Tuple 399 435),
    (Tuple 399 133),
    (Tuple 399 309),
    (Tuple 436 19),
    (Tuple 436 2),
    (Tuple 436 437),
    (Tuple 436 5),
    (Tuple 436 6),
    (Tuple 436 145),
    (Tuple 436 9),
    (Tuple 436 10),
    (Tuple 436 438),
    (Tuple 436 14),
    (Tuple 436 153),
    (Tuple 436 154),
    (Tuple 436 155),
    (Tuple 439 248),
    (Tuple 439 289),
    (Tuple 157 175),
    (Tuple 157 176),
    (Tuple 157 246),
    (Tuple 157 248),
    (Tuple 157 440),
    (Tuple 157 441),
    (Tuple 157 270),
    (Tuple 157 19),
    (Tuple 157 158),
    (Tuple 157 442),
    (Tuple 157 443),
    (Tuple 157 444),
    (Tuple 157 374),
    (Tuple 157 273),
    (Tuple 157 135),
    (Tuple 157 445),
    (Tuple 157 446),
    (Tuple 157 447),
    (Tuple 157 373),
    (Tuple 157 448),
    (Tuple 157 449),
    (Tuple 157 450),
    (Tuple 157 3),
    (Tuple 157 254),
    (Tuple 157 137),
    (Tuple 157 437),
    (Tuple 157 138),
    (Tuple 157 31),
    (Tuple 157 451),
    (Tuple 157 5),
    (Tuple 157 140),
    (Tuple 157 193),
    (Tuple 157 452),
    (Tuple 157 453),
    (Tuple 157 141),
    (Tuple 157 64),
    (Tuple 157 278),
    (Tuple 157 164),
    (Tuple 157 39),
    (Tuple 157 454),
    (Tuple 157 144),
    (Tuple 157 455),
    (Tuple 157 8),
    (Tuple 157 379),
    (Tuple 157 146),
    (Tuple 157 10),
    (Tuple 157 11),
    (Tuple 157 287),
    (Tuple 157 12),
    (Tuple 157 213),
    (Tuple 157 13),
    (Tuple 157 456),
    (Tuple 157 386),
    (Tuple 157 14),
    (Tuple 157 150),
    (Tuple 157 457),
    (Tuple 157 458),
    (Tuple 157 16),
    (Tuple 157 459),
    (Tuple 157 153),
    (Tuple 157 460),
    (Tuple 175 175),
    (Tuple 175 176),
    (Tuple 175 177),
    (Tuple 175 178),
    (Tuple 175 270),
    (Tuple 175 179),
    (Tuple 175 180),
    (Tuple 175 181),
    (Tuple 175 249),
    (Tuple 175 461),
    (Tuple 175 374),
    (Tuple 175 183),
    (Tuple 175 273),
    (Tuple 175 274),
    (Tuple 175 62),
    (Tuple 175 184),
    (Tuple 175 20),
    (Tuple 175 185),
    (Tuple 175 462),
    (Tuple 175 186),
    (Tuple 175 187),
    (Tuple 175 275),
    (Tuple 175 188),
    (Tuple 175 189),
    (Tuple 175 160),
    (Tuple 175 190),
    (Tuple 175 191),
    (Tuple 175 193),
    (Tuple 175 194),
    (Tuple 175 463),
    (Tuple 175 162),
    (Tuple 175 195),
    (Tuple 175 258),
    (Tuple 175 64),
    (Tuple 175 196),
    (Tuple 175 197),
    (Tuple 175 198),
    (Tuple 175 278),
    (Tuple 175 199),
    (Tuple 175 282),
    (Tuple 175 39),
    (Tuple 175 165),
    (Tuple 175 200),
    (Tuple 175 22),
    (Tuple 175 201),
    (Tuple 175 202),
    (Tuple 175 378),
    (Tuple 175 203),
    (Tuple 175 166),
    (Tuple 175 204),
    (Tuple 175 205),
    (Tuple 175 464),
    (Tuple 175 206),
    (Tuple 175 379),
    (Tuple 175 208),
    (Tuple 175 284),
    (Tuple 175 167),
    (Tuple 175 286),
    (Tuple 175 209),
    (Tuple 175 210),
    (Tuple 175 211),
    (Tuple 175 168),
    (Tuple 175 170),
    (Tuple 175 212),
    (Tuple 175 213),
    (Tuple 175 23),
    (Tuple 175 289),
    (Tuple 175 214),
    (Tuple 175 383),
    (Tuple 175 215),
    (Tuple 175 66),
    (Tuple 175 216),
    (Tuple 175 50),
    (Tuple 175 217),
    (Tuple 175 171),
    (Tuple 175 218),
    (Tuple 175 219),
    (Tuple 175 387),
    (Tuple 175 220),
    (Tuple 175 390),
    (Tuple 175 353),
    (Tuple 175 221),
    (Tuple 175 222),
    (Tuple 175 392),
    (Tuple 175 16),
    (Tuple 175 290),
    (Tuple 175 223),
    (Tuple 175 224),
    (Tuple 175 225),
    (Tuple 465 466),
    (Tuple 465 158),
    (Tuple 465 467),
    (Tuple 465 373),
    (Tuple 465 3),
    (Tuple 465 437),
    (Tuple 465 468),
    (Tuple 465 31),
    (Tuple 465 6),
    (Tuple 465 469),
    (Tuple 465 470),
    (Tuple 465 9),
    (Tuple 465 471),
    (Tuple 465 14),
    (Tuple 465 15),
    (Tuple 465 155),
    (Tuple 472 472),
    (Tuple 472 473),
    (Tuple 472 474),
    (Tuple 472 302),
    (Tuple 472 32),
    (Tuple 472 33),
    (Tuple 472 475),
    (Tuple 472 40),
    (Tuple 472 311),
    (Tuple 472 361),
    (Tuple 472 234),
    (Tuple 472 476),
    (Tuple 472 89),
    (Tuple 472 303),
    (Tuple 472 477),
    (Tuple 472 478),
    (Tuple 472 236),
    (Tuple 472 306),
    (Tuple 472 50),
    (Tuple 472 369),
    (Tuple 472 51),
    (Tuple 472 115),
    (Tuple 472 117),
    (Tuple 472 370),
    (Tuple 472 55),
    (Tuple 472 56),
    (Tuple 472 391),
    (Tuple 472 126),
    (Tuple 472 479),
    (Tuple 472 480),
    (Tuple 472 308),
    (Tuple 472 60),
    (Tuple 472 173),
    (Tuple 176 177),
    (Tuple 176 178),
    (Tuple 176 481),
    (Tuple 176 184),
    (Tuple 176 482),
    (Tuple 176 186),
    (Tuple 176 187),
    (Tuple 176 190),
    (Tuple 176 191),
    (Tuple 176 194),
    (Tuple 176 198),
    (Tuple 176 165),
    (Tuple 176 200),
    (Tuple 176 204),
    (Tuple 176 208),
    (Tuple 176 211),
    (Tuple 176 23),
    (Tuple 176 382),
    (Tuple 176 216),
    (Tuple 176 262),
    (Tuple 176 387),
    (Tuple 176 220),
    (Tuple 176 390),
    (Tuple 176 222),
    (Tuple 176 483),
    (Tuple 176 392),
    (Tuple 176 223),
    (Tuple 176 224),
    (Tuple 176 394),
    (Tuple 245 62),
    (Tuple 245 30),
    (Tuple 245 20),
    (Tuple 245 31),
    (Tuple 245 191),
    (Tuple 245 232),
    (Tuple 245 64),
    (Tuple 245 196),
    (Tuple 245 40),
    (Tuple 245 200),
    (Tuple 245 380),
    (Tuple 245 170),
    (Tuple 245 212),
    (Tuple 245 214),
    (Tuple 245 390),
    (Tuple 245 221),
    (Tuple 245 16),
    (Tuple 245 224),
    (Tuple 245 173),
    (Tuple 466 247),
    (Tuple 466 158),
    (Tuple 466 443),
    (Tuple 466 135),
    (Tuple 466 446),
    (Tuple 466 447),
    (Tuple 466 484),
    (Tuple 466 5),
    (Tuple 466 140),
    (Tuple 466 141),
    (Tuple 466 257),
    (Tuple 466 485),
    (Tuple 466 486),
    (Tuple 466 152),
    (Tuple 466 172),
    (Tuple 487 488),
    (Tuple 487 442),
    (Tuple 487 489),
    (Tuple 487 490),
    (Tuple 487 491),
    (Tuple 487 492),
    (Tuple 487 493),
    (Tuple 487 32),
    (Tuple 487 33),
    (Tuple 487 475),
    (Tuple 487 35),
    (Tuple 487 494),
    (Tuple 487 199),
    (Tuple 487 311),
    (Tuple 487 495),
    (Tuple 487 303),
    (Tuple 487 315),
    (Tuple 487 170),
    (Tuple 487 316),
    (Tuple 487 236),
    (Tuple 487 496),
    (Tuple 487 497),
    (Tuple 487 53),
    (Tuple 487 115),
    (Tuple 487 117),
    (Tuple 487 370),
    (Tuple 487 54),
    (Tuple 487 55),
    (Tuple 487 56),
    (Tuple 487 391),
    (Tuple 487 58),
    (Tuple 487 126),
    (Tuple 487 59),
    (Tuple 487 173),
    (Tuple 487 309),
    (Tuple 498 318),
    (Tuple 498 401),
    (Tuple 498 76),
    (Tuple 498 499),
    (Tuple 498 20),
    (Tuple 498 78),
    (Tuple 498 500),
    (Tuple 498 32),
    (Tuple 498 501),
    (Tuple 498 502),
    (Tuple 498 199),
    (Tuple 498 405),
    (Tuple 498 311),
    (Tuple 498 495),
    (Tuple 498 88),
    (Tuple 498 91),
    (Tuple 498 235),
    (Tuple 498 98),
    (Tuple 498 23),
    (Tuple 498 503),
    (Tuple 498 420),
    (Tuple 498 105),
    (Tuple 498 504),
    (Tuple 498 106),
    (Tuple 498 236),
    (Tuple 498 50),
    (Tuple 498 59),
    (Tuple 498 505),
    (Tuple 498 60),
    (Tuple 177 268),
    (Tuple 177 248),
    (Tuple 177 440),
    (Tuple 177 441),
    (Tuple 177 180),
    (Tuple 177 250),
    (Tuple 177 251),
    (Tuple 177 20),
    (Tuple 177 187),
    (Tuple 177 188),
    (Tuple 177 191),
    (Tuple 177 257),
    (Tuple 177 23),
    (Tuple 177 506),
    (Tuple 177 223),
    (Tuple 177 507),
    (Tuple 508 72),
    (Tuple 508 75),
    (Tuple 508 76),
    (Tuple 508 78),
    (Tuple 508 81),
    (Tuple 508 84),
    (Tuple 508 405),
    (Tuple 508 87),
    (Tuple 508 88),
    (Tuple 508 407),
    (Tuple 508 509),
    (Tuple 508 41),
    (Tuple 508 99),
    (Tuple 508 417),
    (Tuple 508 102),
    (Tuple 508 103),
    (Tuple 508 104),
    (Tuple 508 107),
    (Tuple 508 108),
    (Tuple 508 109),
    (Tuple 508 306),
    (Tuple 508 113),
    (Tuple 508 114),
    (Tuple 508 52),
    (Tuple 508 117),
    (Tuple 508 120),
    (Tuple 508 121),
    (Tuple 508 267),
    (Tuple 508 123),
    (Tuple 508 124),
    (Tuple 508 125),
    (Tuple 508 126),
    (Tuple 508 127),
    (Tuple 508 129),
    (Tuple 508 132),
    (Tuple 508 308),
    (Tuple 508 309),
    (Tuple 246 247),
    (Tuple 246 248),
    (Tuple 246 395),
    (Tuple 246 249),
    (Tuple 246 461),
    (Tuple 246 251),
    (Tuple 246 510),
    (Tuple 246 253),
    (Tuple 246 20),
    (Tuple 246 254),
    (Tuple 246 255),
    (Tuple 246 462),
    (Tuple 246 161),
    (Tuple 246 197),
    (Tuple 246 205),
    (Tuple 246 206),
    (Tuple 246 286),
    (Tuple 246 25),
    (Tuple 246 511),
    (Tuple 246 215),
    (Tuple 246 261),
    (Tuple 246 262),
    (Tuple 246 507),
    (Tuple 268 268),
    (Tuple 268 512),
    (Tuple 268 64),
    (Tuple 268 279),
    (Tuple 268 282),
    (Tuple 268 200),
    (Tuple 268 166),
    (Tuple 268 288),
    (Tuple 268 214),
    (Tuple 268 224),
    (Tuple 247 269),
    (Tuple 247 249),
    (Tuple 247 484),
    (Tuple 247 30),
    (Tuple 247 20),
    (Tuple 247 474),
    (Tuple 247 437),
    (Tuple 247 468),
    (Tuple 247 63),
    (Tuple 247 31),
    (Tuple 247 189),
    (Tuple 247 191),
    (Tuple 247 193),
    (Tuple 247 194),
    (Tuple 247 463),
    (Tuple 247 195),
    (Tuple 247 398),
    (Tuple 247 6),
    (Tuple 247 232),
    (Tuple 247 64),
    (Tuple 247 196),
    (Tuple 247 470),
    (Tuple 247 199),
    (Tuple 247 40),
    (Tuple 247 22),
    (Tuple 247 202),
    (Tuple 247 203),
    (Tuple 247 205),
    (Tuple 247 206),
    (Tuple 247 380),
    (Tuple 247 167),
    (Tuple 247 285),
    (Tuple 247 211),
    (Tuple 247 169),
    (Tuple 247 170),
    (Tuple 247 65),
    (Tuple 247 23),
    (Tuple 247 214),
    (Tuple 247 471),
    (Tuple 247 112),
    (Tuple 247 171),
    (Tuple 247 14),
    (Tuple 247 55),
    (Tuple 247 56),
    (Tuple 247 513),
    (Tuple 247 221),
    (Tuple 247 126),
    (Tuple 247 514),
    (Tuple 247 16),
    (Tuple 247 515),
    (Tuple 247 241),
    (Tuple 247 173),
    (Tuple 247 309),
    (Tuple 516 517),
    (Tuple 516 62),
    (Tuple 516 187),
    (Tuple 516 194),
    (Tuple 516 64),
    (Tuple 516 202),
    (Tuple 516 167),
    (Tuple 516 170),
    (Tuple 516 220),
    (Tuple 248 178),
    (Tuple 248 395),
    (Tuple 248 518),
    (Tuple 248 181),
    (Tuple 248 249),
    (Tuple 248 461),
    (Tuple 248 272),
    (Tuple 248 251),
    (Tuple 248 510),
    (Tuple 248 252),
    (Tuple 248 253),
    (Tuple 248 517),
    (Tuple 248 519),
    (Tuple 248 20),
    (Tuple 248 254),
    (Tuple 248 255),
    (Tuple 248 256),
    (Tuple 248 462),
    (Tuple 248 482),
    (Tuple 248 187),
    (Tuple 248 31),
    (Tuple 248 188),
    (Tuple 248 161),
    (Tuple 248 190),
    (Tuple 248 191),
    (Tuple 248 194),
    (Tuple 248 162),
    (Tuple 248 195),
    (Tuple 248 232),
    (Tuple 248 257),
    (Tuple 248 377),
    (Tuple 248 64),
    (Tuple 248 197),
    (Tuple 248 198),
    (Tuple 248 164),
    (Tuple 248 470),
    (Tuple 248 200),
    (Tuple 248 361),
    (Tuple 248 203),
    (Tuple 248 166),
    (Tuple 248 205),
    (Tuple 248 206),
    (Tuple 248 167),
    (Tuple 248 286),
    (Tuple 248 211),
    (Tuple 248 168),
    (Tuple 248 25),
    (Tuple 248 511),
    (Tuple 248 23),
    (Tuple 248 381),
    (Tuple 248 520),
    (Tuple 248 214),
    (Tuple 248 215),
    (Tuple 248 66),
    (Tuple 248 369),
    (Tuple 248 261),
    (Tuple 248 262),
    (Tuple 248 220),
    (Tuple 248 56),
    (Tuple 248 221),
    (Tuple 248 126),
    (Tuple 248 172),
    (Tuple 521 78),
    (Tuple 521 311),
    (Tuple 521 97),
    (Tuple 521 265),
    (Tuple 521 305),
    (Tuple 521 49),
    (Tuple 521 369),
    (Tuple 521 126),
    (Tuple 522 137),
    (Tuple 440 318),
    (Tuple 440 189),
    (Tuple 440 192),
    (Tuple 440 21),
    (Tuple 440 64),
    (Tuple 440 211),
    (Tuple 440 169),
    (Tuple 440 170),
    (Tuple 440 288),
    (Tuple 440 214),
    (Tuple 440 16),
    (Tuple 440 224),
    (Tuple 441 64),
    (Tuple 441 311),
    (Tuple 441 214),
    (Tuple 441 171),
    (Tuple 441 16),
    (Tuple 441 224),
    (Tuple 178 178),
    (Tuple 178 180),
    (Tuple 178 372),
    (Tuple 178 482),
    (Tuple 178 187),
    (Tuple 178 188),
    (Tuple 178 161),
    (Tuple 178 191),
    (Tuple 178 194),
    (Tuple 178 162),
    (Tuple 178 277),
    (Tuple 178 205),
    (Tuple 178 25),
    (Tuple 178 23),
    (Tuple 178 262),
    (Tuple 178 220),
    (Tuple 178 223),
    (Tuple 523 523),
    (Tuple 523 318),
    (Tuple 523 73),
    (Tuple 523 401),
    (Tuple 523 322),
    (Tuple 523 76),
    (Tuple 523 524),
    (Tuple 523 499),
    (Tuple 523 78),
    (Tuple 523 500),
    (Tuple 523 63),
    (Tuple 523 359),
    (Tuple 523 81),
    (Tuple 523 328),
    (Tuple 523 525),
    (Tuple 523 37),
    (Tuple 523 403),
    (Tuple 523 404),
    (Tuple 523 526),
    (Tuple 523 527),
    (Tuple 523 331),
    (Tuple 523 87),
    (Tuple 523 88),
    (Tuple 523 91),
    (Tuple 523 92),
    (Tuple 523 408),
    (Tuple 523 95),
    (Tuple 523 509),
    (Tuple 523 235),
    (Tuple 523 409),
    (Tuple 523 97),
    (Tuple 523 265),
    (Tuple 523 98),
    (Tuple 523 99),
    (Tuple 523 312),
    (Tuple 523 294),
    (Tuple 523 411),
    (Tuple 523 100),
    (Tuple 523 65),
    (Tuple 523 416),
    (Tuple 523 418),
    (Tuple 523 102),
    (Tuple 523 103),
    (Tuple 523 104),
    (Tuple 523 420),
    (Tuple 523 106),
    (Tuple 523 107),
    (Tuple 523 108),
    (Tuple 523 109),
    (Tuple 523 111),
    (Tuple 523 49),
    (Tuple 523 528),
    (Tuple 523 112),
    (Tuple 523 113),
    (Tuple 523 529),
    (Tuple 523 363),
    (Tuple 523 424),
    (Tuple 523 530),
    (Tuple 523 369),
    (Tuple 523 114),
    (Tuple 523 531),
    (Tuple 523 52),
    (Tuple 523 116),
    (Tuple 523 349),
    (Tuple 523 117),
    (Tuple 523 426),
    (Tuple 523 120),
    (Tuple 523 266),
    (Tuple 523 55),
    (Tuple 523 428),
    (Tuple 523 122),
    (Tuple 523 267),
    (Tuple 523 123),
    (Tuple 523 124),
    (Tuple 523 126),
    (Tuple 523 430),
    (Tuple 523 532),
    (Tuple 523 533),
    (Tuple 523 534),
    (Tuple 523 432),
    (Tuple 523 364),
    (Tuple 523 130),
    (Tuple 523 307),
    (Tuple 523 131),
    (Tuple 523 433),
    (Tuple 523 132),
    (Tuple 229 535),
    (Tuple 229 230),
    (Tuple 229 182),
    (Tuple 229 318),
    (Tuple 229 28),
    (Tuple 229 396),
    (Tuple 229 76),
    (Tuple 229 231),
    (Tuple 229 323),
    (Tuple 229 499),
    (Tuple 229 78),
    (Tuple 229 263),
    (Tuple 229 500),
    (Tuple 229 536),
    (Tuple 229 537),
    (Tuple 229 80),
    (Tuple 229 325),
    (Tuple 229 538),
    (Tuple 229 81),
    (Tuple 229 233),
    (Tuple 229 360),
    (Tuple 229 328),
    (Tuple 229 525),
    (Tuple 229 539),
    (Tuple 229 501),
    (Tuple 229 84),
    (Tuple 229 540),
    (Tuple 229 39),
    (Tuple 229 404),
    (Tuple 229 541),
    (Tuple 229 405),
    (Tuple 229 234),
    (Tuple 229 331),
    (Tuple 229 406),
    (Tuple 229 92),
    (Tuple 229 334),
    (Tuple 229 303),
    (Tuple 229 235),
    (Tuple 229 42),
    (Tuple 229 409),
    (Tuple 229 97),
    (Tuple 229 542),
    (Tuple 229 265),
    (Tuple 229 543),
    (Tuple 229 43),
    (Tuple 229 100),
    (Tuple 229 45),
    (Tuple 229 341),
    (Tuple 229 544),
    (Tuple 229 362),
    (Tuple 229 545),
    (Tuple 229 46),
    (Tuple 229 413),
    (Tuple 229 345),
    (Tuple 229 417),
    (Tuple 229 418),
    (Tuple 229 546),
    (Tuple 229 102),
    (Tuple 229 305),
    (Tuple 229 104),
    (Tuple 229 420),
    (Tuple 229 421),
    (Tuple 229 105),
    (Tuple 229 547),
    (Tuple 229 422),
    (Tuple 229 236),
    (Tuple 229 49),
    (Tuple 229 548),
    (Tuple 229 112),
    (Tuple 229 237),
    (Tuple 229 529),
    (Tuple 229 363),
    (Tuple 229 530),
    (Tuple 229 369),
    (Tuple 229 51),
    (Tuple 229 52),
    (Tuple 229 349),
    (Tuple 229 549),
    (Tuple 229 426),
    (Tuple 229 120),
    (Tuple 229 550),
    (Tuple 229 266),
    (Tuple 229 389),
    (Tuple 229 428),
    (Tuple 229 267),
    (Tuple 229 123),
    (Tuple 229 124),
    (Tuple 229 551),
    (Tuple 229 125),
    (Tuple 229 126),
    (Tuple 229 552),
    (Tuple 229 239),
    (Tuple 229 532),
    (Tuple 229 534),
    (Tuple 229 553),
    (Tuple 229 432),
    (Tuple 229 554),
    (Tuple 229 364),
    (Tuple 229 307),
    (Tuple 229 131),
    (Tuple 229 433),
    (Tuple 229 355),
    (Tuple 229 480),
    (Tuple 229 240),
    (Tuple 229 505),
    (Tuple 229 60),
    (Tuple 229 241),
    (Tuple 229 133),
    (Tuple 229 357),
    (Tuple 229 309),
    (Tuple 555 30),
    (Tuple 555 302),
    (Tuple 556 83),
    (Tuple 556 557),
    (Tuple 556 115),
    (Tuple 556 558),
    (Tuple 556 126),
    (Tuple 556 309),
    (Tuple 535 230),
    (Tuple 535 559),
    (Tuple 535 28),
    (Tuple 535 231),
    (Tuple 535 537),
    (Tuple 535 325),
    (Tuple 535 360),
    (Tuple 535 540),
    (Tuple 535 234),
    (Tuple 535 235),
    (Tuple 535 42),
    (Tuple 535 43),
    (Tuple 535 560),
    (Tuple 535 45),
    (Tuple 535 544),
    (Tuple 535 46),
    (Tuple 535 414),
    (Tuple 535 561),
    (Tuple 535 546),
    (Tuple 535 562),
    (Tuple 535 547),
    (Tuple 535 422),
    (Tuple 535 236),
    (Tuple 535 548),
    (Tuple 535 424),
    (Tuple 535 51),
    (Tuple 535 52),
    (Tuple 535 550),
    (Tuple 535 389),
    (Tuple 535 57),
    (Tuple 535 551),
    (Tuple 535 552),
    (Tuple 535 239),
    (Tuple 535 431),
    (Tuple 535 534),
    (Tuple 535 553),
    (Tuple 535 554),
    (Tuple 535 563),
    (Tuple 535 364),
    (Tuple 535 307),
    (Tuple 535 355),
    (Tuple 535 480),
    (Tuple 535 564),
    (Tuple 535 434),
    (Tuple 535 240),
    (Tuple 535 505),
    (Tuple 535 60),
    (Tuple 535 133),
    (Tuple 72 72),
    (Tuple 72 73),
    (Tuple 72 366),
    (Tuple 72 565),
    (Tuple 72 320),
    (Tuple 72 74),
    (Tuple 72 566),
    (Tuple 72 567),
    (Tuple 72 300),
    (Tuple 72 321),
    (Tuple 72 75),
    (Tuple 72 568),
    (Tuple 72 569),
    (Tuple 72 570),
    (Tuple 72 571),
    (Tuple 72 401),
    (Tuple 72 322),
    (Tuple 72 77),
    (Tuple 72 572),
    (Tuple 72 323),
    (Tuple 72 499),
    (Tuple 72 573),
    (Tuple 72 78),
    (Tuple 72 574),
    (Tuple 72 575),
    (Tuple 72 500),
    (Tuple 72 301),
    (Tuple 72 576),
    (Tuple 72 577),
    (Tuple 72 578),
    (Tuple 72 359),
    (Tuple 72 326),
    (Tuple 72 579),
    (Tuple 72 81),
    (Tuple 72 82),
    (Tuple 72 328),
    (Tuple 72 83),
    (Tuple 72 580),
    (Tuple 72 259),
    (Tuple 72 581),
    (Tuple 72 582),
    (Tuple 72 37),
    (Tuple 72 84),
    (Tuple 72 85),
    (Tuple 72 402),
    (Tuple 72 39),
    (Tuple 72 404),
    (Tuple 72 86),
    (Tuple 72 583),
    (Tuple 72 331),
    (Tuple 72 584),
    (Tuple 72 87),
    (Tuple 72 88),
    (Tuple 72 91),
    (Tuple 72 585),
    (Tuple 72 332),
    (Tuple 72 406),
    (Tuple 72 92),
    (Tuple 72 334),
    (Tuple 72 335),
    (Tuple 72 336),
    (Tuple 72 93),
    (Tuple 72 408),
    (Tuple 72 337),
    (Tuple 72 94),
    (Tuple 72 338),
    (Tuple 72 95),
    (Tuple 72 586),
    (Tuple 72 509),
    (Tuple 72 41),
    (Tuple 72 339),
    (Tuple 72 340),
    (Tuple 72 587),
    (Tuple 72 588),
    (Tuple 72 97),
    (Tuple 72 542),
    (Tuple 72 98),
    (Tuple 72 99),
    (Tuple 72 410),
    (Tuple 72 589),
    (Tuple 72 100),
    (Tuple 72 557),
    (Tuple 72 590),
    (Tuple 72 101),
    (Tuple 72 413),
    (Tuple 72 102),
    (Tuple 72 103),
    (Tuple 72 305),
    (Tuple 72 104),
    (Tuple 72 591),
    (Tuple 72 420),
    (Tuple 72 421),
    (Tuple 72 105),
    (Tuple 72 106),
    (Tuple 72 107),
    (Tuple 72 109),
    (Tuple 72 110),
    (Tuple 72 111),
    (Tuple 72 49),
    (Tuple 72 528),
    (Tuple 72 592),
    (Tuple 72 112),
    (Tuple 72 237),
    (Tuple 72 529),
    (Tuple 72 530),
    (Tuple 72 114),
    (Tuple 72 531),
    (Tuple 72 52),
    (Tuple 72 425),
    (Tuple 72 116),
    (Tuple 72 349),
    (Tuple 72 593),
    (Tuple 72 118),
    (Tuple 72 549),
    (Tuple 72 120),
    (Tuple 72 121),
    (Tuple 72 427),
    (Tuple 72 428),
    (Tuple 72 122),
    (Tuple 72 267),
    (Tuple 72 123),
    (Tuple 72 124),
    (Tuple 72 125),
    (Tuple 72 126),
    (Tuple 72 127),
    (Tuple 72 430),
    (Tuple 72 354),
    (Tuple 72 128),
    (Tuple 72 594),
    (Tuple 72 595),
    (Tuple 72 131),
    (Tuple 72 433),
    (Tuple 72 596),
    (Tuple 72 356),
    (Tuple 72 597),
    (Tuple 72 132),
    (Tuple 72 308),
    (Tuple 72 435),
    (Tuple 72 357),
    (Tuple 598 598),
    (Tuple 598 599),
    (Tuple 598 43),
    (Tuple 598 562),
    (Tuple 598 363),
    (Tuple 598 57),
    (Tuple 598 431),
    (Tuple 598 532),
    (Tuple 600 601),
    (Tuple 600 37),
    (Tuple 600 602),
    (Tuple 600 403),
    (Tuple 600 603),
    (Tuple 600 87),
    (Tuple 600 89),
    (Tuple 600 90),
    (Tuple 600 407),
    (Tuple 600 97),
    (Tuple 600 413),
    (Tuple 600 108),
    (Tuple 600 306),
    (Tuple 600 113),
    (Tuple 600 369),
    (Tuple 600 52),
    (Tuple 600 116),
    (Tuple 600 426),
    (Tuple 600 126),
    (Tuple 600 129),
    (Tuple 600 132),
    (Tuple 600 309),
    (Tuple 230 230),
    (Tuple 230 604),
    (Tuple 230 231),
    (Tuple 230 537),
    (Tuple 230 325),
    (Tuple 230 540),
    (Tuple 230 605),
    (Tuple 230 606),
    (Tuple 230 42),
    (Tuple 230 43),
    (Tuple 230 45),
    (Tuple 230 46),
    (Tuple 230 418),
    (Tuple 230 546),
    (Tuple 230 547),
    (Tuple 230 422),
    (Tuple 230 236),
    (Tuple 230 548),
    (Tuple 230 51),
    (Tuple 230 52),
    (Tuple 230 389),
    (Tuple 230 552),
    (Tuple 230 239),
    (Tuple 230 431),
    (Tuple 230 534),
    (Tuple 230 553),
    (Tuple 230 554),
    (Tuple 230 307),
    (Tuple 230 355),
    (Tuple 230 434),
    (Tuple 230 240),
    (Tuple 230 505),
    (Tuple 230 60),
    (Tuple 230 133),
    (Tuple 395 395),
    (Tuple 395 249),
    (Tuple 395 607),
    (Tuple 395 367),
    (Tuple 395 20),
    (Tuple 395 254),
    (Tuple 395 137),
    (Tuple 395 482),
    (Tuple 395 31),
    (Tuple 395 190),
    (Tuple 395 194),
    (Tuple 395 162),
    (Tuple 395 165),
    (Tuple 395 200),
    (Tuple 395 378),
    (Tuple 395 203),
    (Tuple 395 166),
    (Tuple 395 205),
    (Tuple 395 206),
    (Tuple 395 211),
    (Tuple 395 168),
    (Tuple 395 260),
    (Tuple 395 511),
    (Tuple 395 381),
    (Tuple 395 520),
    (Tuple 395 608),
    (Tuple 395 148),
    (Tuple 395 262),
    (Tuple 395 224),
    (Tuple 395 225),
    (Tuple 481 512),
    (Tuple 481 20),
    (Tuple 481 191),
    (Tuple 481 214),
    (Tuple 481 483),
    (Tuple 609 135),
    (Tuple 609 3),
    (Tuple 609 610),
    (Tuple 609 137),
    (Tuple 609 468),
    (Tuple 609 31),
    (Tuple 609 160),
    (Tuple 609 139),
    (Tuple 609 5),
    (Tuple 609 140),
    (Tuple 609 141),
    (Tuple 609 142),
    (Tuple 609 143),
    (Tuple 609 454),
    (Tuple 609 7),
    (Tuple 609 611),
    (Tuple 609 8),
    (Tuple 609 146),
    (Tuple 609 9),
    (Tuple 609 10),
    (Tuple 609 11),
    (Tuple 609 12),
    (Tuple 609 608),
    (Tuple 609 148),
    (Tuple 609 13),
    (Tuple 609 456),
    (Tuple 609 14),
    (Tuple 609 15),
    (Tuple 609 150),
    (Tuple 609 457),
    (Tuple 609 612),
    (Tuple 609 153),
    (Tuple 609 154),
    (Tuple 609 155),
    (Tuple 609 613),
    (Tuple 269 180),
    (Tuple 269 512),
    (Tuple 269 62),
    (Tuple 269 184),
    (Tuple 269 20),
    (Tuple 269 64),
    (Tuple 269 279),
    (Tuple 269 281),
    (Tuple 269 260),
    (Tuple 269 66),
    (Tuple 269 389),
    (Tuple 269 16),
    (Tuple 614 20),
    (Tuple 614 6),
    (Tuple 614 64),
    (Tuple 614 9),
    (Tuple 614 170),
    (Tuple 614 16),
    (Tuple 614 615),
    (Tuple 614 241),
    (Tuple 270 270),
    (Tuple 270 179),
    (Tuple 270 616),
    (Tuple 270 374),
    (Tuple 270 273),
    (Tuple 270 445),
    (Tuple 270 62),
    (Tuple 270 20),
    (Tuple 270 617),
    (Tuple 270 275),
    (Tuple 270 31),
    (Tuple 270 189),
    (Tuple 270 193),
    (Tuple 270 194),
    (Tuple 270 463),
    (Tuple 270 257),
    (Tuple 270 259),
    (Tuple 270 196),
    (Tuple 270 282),
    (Tuple 270 166),
    (Tuple 270 204),
    (Tuple 270 211),
    (Tuple 270 169),
    (Tuple 270 288),
    (Tuple 270 289),
    (Tuple 270 382),
    (Tuple 270 216),
    (Tuple 270 387),
    (Tuple 270 392),
    (Tuple 270 225),
    (Tuple 270 618),
    (Tuple 270 394),
    (Tuple 619 620),
    (Tuple 619 621),
    (Tuple 622 623),
    (Tuple 622 367),
    (Tuple 622 324),
    (Tuple 622 536),
    (Tuple 622 624),
    (Tuple 622 359),
    (Tuple 622 625),
    (Tuple 622 525),
    (Tuple 622 626),
    (Tuple 622 37),
    (Tuple 622 627),
    (Tuple 622 628),
    (Tuple 622 235),
    (Tuple 622 264),
    (Tuple 622 629),
    (Tuple 622 265),
    (Tuple 622 345),
    (Tuple 622 630),
    (Tuple 622 305),
    (Tuple 622 503),
    (Tuple 622 504),
    (Tuple 622 385),
    (Tuple 622 363),
    (Tuple 622 424),
    (Tuple 622 631),
    (Tuple 622 52),
    (Tuple 622 115),
    (Tuple 622 238),
    (Tuple 622 632),
    (Tuple 622 428),
    (Tuple 622 57),
    (Tuple 622 125),
    (Tuple 622 239),
    (Tuple 622 532),
    (Tuple 622 633),
    (Tuple 622 634),
    (Tuple 622 533),
    (Tuple 622 615),
    (Tuple 622 515),
    (Tuple 622 173),
    (Tuple 635 635),
    (Tuple 635 616),
    (Tuple 635 368),
    (Tuple 635 257),
    (Tuple 635 525),
    (Tuple 635 196),
    (Tuple 635 200),
    (Tuple 635 527),
    (Tuple 635 630),
    (Tuple 635 305),
    (Tuple 635 422),
    (Tuple 635 237),
    (Tuple 635 351),
    (Tuple 636 488),
    (Tuple 636 442),
    (Tuple 636 491),
    (Tuple 636 637),
    (Tuple 636 482),
    (Tuple 636 638),
    (Tuple 636 577),
    (Tuple 636 639),
    (Tuple 636 80),
    (Tuple 636 640),
    (Tuple 636 312),
    (Tuple 636 44),
    (Tuple 636 621),
    (Tuple 636 236),
    (Tuple 636 369),
    (Tuple 636 641),
    (Tuple 636 115),
    (Tuple 636 119),
    (Tuple 636 431),
    (Tuple 636 129),
    (Tuple 642 32),
    (Tuple 642 33),
    (Tuple 642 53),
    (Tuple 642 54),
    (Tuple 642 56),
    (Tuple 642 58),
    (Tuple 179 182),
    (Tuple 179 272),
    (Tuple 179 374),
    (Tuple 179 643),
    (Tuple 179 273),
    (Tuple 179 274),
    (Tuple 179 467),
    (Tuple 179 30),
    (Tuple 179 185),
    (Tuple 179 375),
    (Tuple 179 275),
    (Tuple 179 189),
    (Tuple 179 192),
    (Tuple 179 193),
    (Tuple 179 376),
    (Tuple 179 463),
    (Tuple 179 644),
    (Tuple 179 195),
    (Tuple 179 258),
    (Tuple 179 196),
    (Tuple 179 279),
    (Tuple 179 280),
    (Tuple 179 166),
    (Tuple 179 204),
    (Tuple 179 379),
    (Tuple 179 284),
    (Tuple 179 209),
    (Tuple 179 210),
    (Tuple 179 212),
    (Tuple 179 213),
    (Tuple 179 645),
    (Tuple 179 289),
    (Tuple 179 382),
    (Tuple 179 646),
    (Tuple 179 383),
    (Tuple 179 647),
    (Tuple 179 216),
    (Tuple 179 384),
    (Tuple 179 217),
    (Tuple 179 218),
    (Tuple 179 219),
    (Tuple 179 648),
    (Tuple 179 390),
    (Tuple 179 649),
    (Tuple 179 68),
    (Tuple 179 392),
    (Tuple 179 290),
    (Tuple 179 225),
    (Tuple 19 158),
    (Tuple 19 650),
    (Tuple 19 2),
    (Tuple 19 651),
    (Tuple 19 467),
    (Tuple 19 3),
    (Tuple 19 617),
    (Tuple 19 144),
    (Tuple 19 147),
    (Tuple 19 652),
    (Tuple 19 386),
    (Tuple 19 653),
    (Tuple 19 654),
    (Tuple 19 458),
    (Tuple 19 655),
    (Tuple 656 22),
    (Tuple 518 518),
    (Tuple 518 167),
    (Tuple 518 172),
    (Tuple 488 488),
    (Tuple 488 442),
    (Tuple 488 489),
    (Tuple 488 490),
    (Tuple 488 491),
    (Tuple 488 29),
    (Tuple 488 517),
    (Tuple 488 492),
    (Tuple 488 367),
    (Tuple 488 493),
    (Tuple 488 32),
    (Tuple 488 33),
    (Tuple 488 35),
    (Tuple 488 657),
    (Tuple 488 494),
    (Tuple 488 311),
    (Tuple 488 303),
    (Tuple 488 496),
    (Tuple 488 497),
    (Tuple 488 53),
    (Tuple 488 370),
    (Tuple 488 54),
    (Tuple 488 55),
    (Tuple 488 391),
    (Tuple 488 58),
    (Tuple 488 59),
    (Tuple 488 658),
    (Tuple 559 517),
    (Tuple 559 75),
    (Tuple 559 231),
    (Tuple 559 537),
    (Tuple 559 233),
    (Tuple 559 540),
    (Tuple 559 659),
    (Tuple 559 605),
    (Tuple 559 89),
    (Tuple 559 42),
    (Tuple 559 43),
    (Tuple 559 45),
    (Tuple 559 46),
    (Tuple 559 414),
    (Tuple 559 288),
    (Tuple 559 561),
    (Tuple 559 546),
    (Tuple 559 422),
    (Tuple 559 236),
    (Tuple 559 548),
    (Tuple 559 52),
    (Tuple 559 115),
    (Tuple 559 550),
    (Tuple 559 389),
    (Tuple 559 56),
    (Tuple 559 126),
    (Tuple 559 239),
    (Tuple 559 532),
    (Tuple 559 553),
    (Tuple 559 554),
    (Tuple 559 364),
    (Tuple 559 129),
    (Tuple 559 307),
    (Tuple 559 355),
    (Tuple 559 480),
    (Tuple 559 434),
    (Tuple 559 240),
    (Tuple 559 505),
    (Tuple 559 308),
    (Tuple 559 241),
    (Tuple 559 133),
    (Tuple 158 2),
    (Tuple 158 467),
    (Tuple 158 4),
    (Tuple 158 437),
    (Tuple 158 31),
    (Tuple 158 463),
    (Tuple 158 6),
    (Tuple 158 469),
    (Tuple 158 232),
    (Tuple 158 470),
    (Tuple 158 201),
    (Tuple 158 485),
    (Tuple 158 9),
    (Tuple 158 471),
    (Tuple 158 660),
    (Tuple 158 386),
    (Tuple 158 14),
    (Tuple 158 661),
    (Tuple 158 15),
    (Tuple 158 221),
    (Tuple 158 152),
    (Tuple 158 154),
    (Tuple 158 155),
    (Tuple 662 663),
    (Tuple 662 664),
    (Tuple 662 257),
    (Tuple 662 665),
    (Tuple 662 666),
    (Tuple 662 627),
    (Tuple 662 667),
    (Tuple 662 668),
    (Tuple 662 669),
    (Tuple 662 670),
    (Tuple 662 671),
    (Tuple 662 672),
    (Tuple 662 673),
    (Tuple 662 48),
    (Tuple 662 674),
    (Tuple 662 675),
    (Tuple 662 676),
    (Tuple 662 677),
    (Tuple 180 461),
    (Tuple 180 374),
    (Tuple 180 194),
    (Tuple 180 195),
    (Tuple 180 280),
    (Tuple 180 284),
    (Tuple 180 220),
    (Tuple 180 507),
    (Tuple 181 251),
    (Tuple 181 445),
    (Tuple 181 252),
    (Tuple 181 20),
    (Tuple 181 482),
    (Tuple 181 187),
    (Tuple 181 31),
    (Tuple 181 191),
    (Tuple 181 194),
    (Tuple 181 644),
    (Tuple 181 21),
    (Tuple 181 258),
    (Tuple 181 259),
    (Tuple 181 200),
    (Tuple 181 202),
    (Tuple 181 206),
    (Tuple 181 212),
    (Tuple 181 23),
    (Tuple 181 262),
    (Tuple 181 387),
    (Tuple 181 220),
    (Tuple 182 182),
    (Tuple 182 249),
    (Tuple 182 274),
    (Tuple 182 76),
    (Tuple 182 20),
    (Tuple 182 63),
    (Tuple 182 31),
    (Tuple 182 33),
    (Tuple 182 463),
    (Tuple 182 196),
    (Tuple 182 199),
    (Tuple 182 678),
    (Tuple 182 203),
    (Tuple 182 205),
    (Tuple 182 380),
    (Tuple 182 208),
    (Tuple 182 209),
    (Tuple 182 211),
    (Tuple 182 168),
    (Tuple 182 65),
    (Tuple 182 212),
    (Tuple 182 216),
    (Tuple 182 123),
    (Tuple 182 68),
    (Tuple 372 20),
    (Tuple 372 185),
    (Tuple 372 679),
    (Tuple 372 63),
    (Tuple 372 680),
    (Tuple 372 398),
    (Tuple 372 232),
    (Tuple 372 34),
    (Tuple 372 40),
    (Tuple 372 681),
    (Tuple 372 170),
    (Tuple 372 65),
    (Tuple 372 682),
    (Tuple 372 23),
    (Tuple 372 381),
    (Tuple 372 126),
    (Tuple 372 16),
    (Tuple 372 683),
    (Tuple 318 442),
    (Tuple 318 319),
    (Tuple 318 512),
    (Tuple 318 684),
    (Tuple 318 566),
    (Tuple 318 685),
    (Tuple 318 29),
    (Tuple 318 322),
    (Tuple 318 686),
    (Tuple 318 78),
    (Tuple 318 263),
    (Tuple 318 79),
    (Tuple 318 80),
    (Tuple 318 325),
    (Tuple 318 81),
    (Tuple 318 398),
    (Tuple 318 687),
    (Tuple 318 258),
    (Tuple 318 83),
    (Tuple 318 540),
    (Tuple 318 39),
    (Tuple 318 87),
    (Tuple 318 688),
    (Tuple 318 338),
    (Tuple 318 689),
    (Tuple 318 235),
    (Tuple 318 339),
    (Tuple 318 42),
    (Tuple 318 97),
    (Tuple 318 265),
    (Tuple 318 410),
    (Tuple 318 342),
    (Tuple 318 413),
    (Tuple 318 561),
    (Tuple 318 690),
    (Tuple 318 103),
    (Tuple 318 419),
    (Tuple 318 236),
    (Tuple 318 49),
    (Tuple 318 112),
    (Tuple 318 349),
    (Tuple 318 350),
    (Tuple 318 352),
    (Tuple 318 676),
    (Tuple 318 357),
    (Tuple 442 366),
    (Tuple 442 565),
    (Tuple 442 74),
    (Tuple 442 489),
    (Tuple 442 491),
    (Tuple 442 517),
    (Tuple 442 450),
    (Tuple 442 637),
    (Tuple 442 79),
    (Tuple 442 638),
    (Tuple 442 302),
    (Tuple 442 577),
    (Tuple 442 639),
    (Tuple 442 32),
    (Tuple 442 33),
    (Tuple 442 80),
    (Tuple 442 37),
    (Tuple 442 691),
    (Tuple 442 659),
    (Tuple 442 39),
    (Tuple 442 40),
    (Tuple 442 311),
    (Tuple 442 361),
    (Tuple 442 692),
    (Tuple 442 234),
    (Tuple 442 303),
    (Tuple 442 338),
    (Tuple 442 640),
    (Tuple 442 265),
    (Tuple 442 312),
    (Tuple 442 43),
    (Tuple 442 621),
    (Tuple 442 478),
    (Tuple 442 25),
    (Tuple 442 421),
    (Tuple 442 106),
    (Tuple 442 108),
    (Tuple 442 422),
    (Tuple 442 236),
    (Tuple 442 306),
    (Tuple 442 50),
    (Tuple 442 693),
    (Tuple 442 424),
    (Tuple 442 369),
    (Tuple 442 641),
    (Tuple 442 51),
    (Tuple 442 52),
    (Tuple 442 53),
    (Tuple 442 115),
    (Tuple 442 117),
    (Tuple 442 370),
    (Tuple 442 119),
    (Tuple 442 550),
    (Tuple 442 55),
    (Tuple 442 56),
    (Tuple 442 267),
    (Tuple 442 57),
    (Tuple 442 391),
    (Tuple 442 58),
    (Tuple 442 126),
    (Tuple 442 127),
    (Tuple 442 59),
    (Tuple 442 431),
    (Tuple 442 432),
    (Tuple 442 364),
    (Tuple 442 129),
    (Tuple 442 307),
    (Tuple 442 355),
    (Tuple 442 480),
    (Tuple 442 505),
    (Tuple 442 308),
    (Tuple 442 60),
    (Tuple 442 133),
    (Tuple 442 173),
    (Tuple 442 309),
    (Tuple 319 694),
    (Tuple 319 664),
    (Tuple 319 263),
    (Tuple 319 500),
    (Tuple 319 536),
    (Tuple 319 625),
    (Tuple 319 695),
    (Tuple 319 329),
    (Tuple 319 38),
    (Tuple 319 526),
    (Tuple 319 527),
    (Tuple 319 95),
    (Tuple 319 207),
    (Tuple 319 235),
    (Tuple 319 696),
    (Tuple 319 668),
    (Tuple 319 100),
    (Tuple 319 697),
    (Tuple 319 343),
    (Tuple 319 413),
    (Tuple 319 414),
    (Tuple 319 345),
    (Tuple 319 103),
    (Tuple 319 547),
    (Tuple 319 106),
    (Tuple 319 348),
    (Tuple 319 111),
    (Tuple 319 49),
    (Tuple 319 698),
    (Tuple 319 112),
    (Tuple 319 237),
    (Tuple 319 363),
    (Tuple 319 531),
    (Tuple 319 52),
    (Tuple 319 425),
    (Tuple 319 349),
    (Tuple 319 351),
    (Tuple 319 699),
    (Tuple 319 267),
    (Tuple 319 700),
    (Tuple 319 125),
    (Tuple 319 701),
    (Tuple 319 532),
    (Tuple 319 677),
    (Tuple 319 702),
    (Tuple 319 703),
    (Tuple 319 357),
    (Tuple 650 31),
    (Tuple 650 16),
    (Tuple 73 73),
    (Tuple 73 320),
    (Tuple 73 74),
    (Tuple 73 566),
    (Tuple 73 300),
    (Tuple 73 321),
    (Tuple 73 75),
    (Tuple 73 569),
    (Tuple 73 570),
    (Tuple 73 571),
    (Tuple 73 322),
    (Tuple 73 77),
    (Tuple 73 323),
    (Tuple 73 499),
    (Tuple 73 78),
    (Tuple 73 574),
    (Tuple 73 575),
    (Tuple 73 576),
    (Tuple 73 577),
    (Tuple 73 578),
    (Tuple 73 359),
    (Tuple 73 704),
    (Tuple 73 325),
    (Tuple 73 579),
    (Tuple 73 81),
    (Tuple 73 82),
    (Tuple 73 705),
    (Tuple 73 83),
    (Tuple 73 581),
    (Tuple 73 706),
    (Tuple 73 37),
    (Tuple 73 84),
    (Tuple 73 85),
    (Tuple 73 402),
    (Tuple 73 403),
    (Tuple 73 404),
    (Tuple 73 526),
    (Tuple 73 583),
    (Tuple 73 331),
    (Tuple 73 584),
    (Tuple 73 87),
    (Tuple 73 91),
    (Tuple 73 406),
    (Tuple 73 92),
    (Tuple 73 334),
    (Tuple 73 336),
    (Tuple 73 93),
    (Tuple 73 408),
    (Tuple 73 337),
    (Tuple 73 94),
    (Tuple 73 586),
    (Tuple 73 509),
    (Tuple 73 96),
    (Tuple 73 340),
    (Tuple 73 587),
    (Tuple 73 588),
    (Tuple 73 97),
    (Tuple 73 265),
    (Tuple 73 98),
    (Tuple 73 312),
    (Tuple 73 100),
    (Tuple 73 557),
    (Tuple 73 590),
    (Tuple 73 101),
    (Tuple 73 102),
    (Tuple 73 103),
    (Tuple 73 305),
    (Tuple 73 104),
    (Tuple 73 420),
    (Tuple 73 421),
    (Tuple 73 105),
    (Tuple 73 106),
    (Tuple 73 108),
    (Tuple 73 110),
    (Tuple 73 111),
    (Tuple 73 49),
    (Tuple 73 528),
    (Tuple 73 112),
    (Tuple 73 693),
    (Tuple 73 530),
    (Tuple 73 114),
    (Tuple 73 531),
    (Tuple 73 425),
    (Tuple 73 116),
    (Tuple 73 349),
    (Tuple 73 120),
    (Tuple 73 350),
    (Tuple 73 123),
    (Tuple 73 352),
    (Tuple 73 124),
    (Tuple 73 125),
    (Tuple 73 707),
    (Tuple 73 126),
    (Tuple 73 430),
    (Tuple 73 128),
    (Tuple 73 594),
    (Tuple 73 596),
    (Tuple 73 597),
    (Tuple 73 132),
    (Tuple 73 435),
    (Tuple 73 309),
    (Tuple 249 272),
    (Tuple 249 251),
    (Tuple 249 273),
    (Tuple 249 252),
    (Tuple 249 253),
    (Tuple 249 517),
    (Tuple 249 254),
    (Tuple 249 255),
    (Tuple 249 375),
    (Tuple 249 256),
    (Tuple 249 462),
    (Tuple 249 275),
    (Tuple 249 161),
    (Tuple 249 193),
    (Tuple 249 463),
    (Tuple 249 644),
    (Tuple 249 195),
    (Tuple 249 398),
    (Tuple 249 257),
    (Tuple 249 258),
    (Tuple 249 259),
    (Tuple 249 196),
    (Tuple 249 279),
    (Tuple 249 282),
    (Tuple 249 200),
    (Tuple 249 205),
    (Tuple 249 464),
    (Tuple 249 206),
    (Tuple 249 286),
    (Tuple 249 210),
    (Tuple 249 708),
    (Tuple 249 25),
    (Tuple 249 212),
    (Tuple 249 213),
    (Tuple 249 511),
    (Tuple 249 382),
    (Tuple 249 646),
    (Tuple 249 383),
    (Tuple 249 647),
    (Tuple 249 384),
    (Tuple 249 217),
    (Tuple 249 218),
    (Tuple 249 262),
    (Tuple 249 219),
    (Tuple 249 648),
    (Tuple 249 390),
    (Tuple 249 649),
    (Tuple 249 68),
    (Tuple 249 290),
    (Tuple 249 394),
    (Tuple 709 710),
    (Tuple 709 360),
    (Tuple 709 711),
    (Tuple 709 163),
    (Tuple 709 712),
    (Tuple 709 236),
    (Tuple 709 364),
    (Tuple 709 173),
    (Tuple 443 2),
    (Tuple 443 713),
    (Tuple 443 446),
    (Tuple 443 447),
    (Tuple 443 714),
    (Tuple 443 437),
    (Tuple 443 256),
    (Tuple 443 468),
    (Tuple 443 31),
    (Tuple 443 5),
    (Tuple 443 6),
    (Tuple 443 470),
    (Tuple 443 144),
    (Tuple 443 455),
    (Tuple 443 715),
    (Tuple 443 9),
    (Tuple 443 11),
    (Tuple 443 716),
    (Tuple 443 717),
    (Tuple 443 608),
    (Tuple 443 653),
    (Tuple 443 14),
    (Tuple 443 152),
    (Tuple 443 16),
    (Tuple 443 153),
    (Tuple 443 655),
    (Tuple 443 172),
    (Tuple 718 718),
    (Tuple 718 694),
    (Tuple 718 719),
    (Tuple 718 720),
    (Tuple 718 721),
    (Tuple 718 722),
    (Tuple 718 723),
    (Tuple 718 160),
    (Tuple 718 724),
    (Tuple 718 725),
    (Tuple 718 627),
    (Tuple 718 726),
    (Tuple 718 727),
    (Tuple 718 667),
    (Tuple 718 207),
    (Tuple 718 728),
    (Tuple 718 668),
    (Tuple 718 729),
    (Tuple 718 730),
    (Tuple 718 731),
    (Tuple 718 670),
    (Tuple 718 732),
    (Tuple 718 733),
    (Tuple 718 675),
    (Tuple 718 734),
    (Tuple 718 735),
    (Tuple 718 736),
    (Tuple 718 737),
    (Tuple 718 738),
    (Tuple 718 739),
    (Tuple 718 676),
    (Tuple 718 740),
    (Tuple 741 444),
    (Tuple 741 464),
    (Tuple 366 366),
    (Tuple 366 567),
    (Tuple 366 321),
    (Tuple 366 29),
    (Tuple 366 75),
    (Tuple 366 638),
    (Tuple 366 338),
    (Tuple 366 640),
    (Tuple 366 478),
    (Tuple 366 369),
    (Tuple 366 641),
    (Tuple 366 117),
    (Tuple 366 126),
    (Tuple 2 2),
    (Tuple 2 250),
    (Tuple 2 367),
    (Tuple 2 714),
    (Tuple 2 437),
    (Tuple 2 31),
    (Tuple 2 160),
    (Tuple 2 624),
    (Tuple 2 6),
    (Tuple 2 199),
    (Tuple 2 7),
    (Tuple 2 144),
    (Tuple 2 145),
    (Tuple 2 12),
    (Tuple 2 742),
    (Tuple 2 653),
    (Tuple 2 14),
    (Tuple 2 152),
    (Tuple 2 458),
    (Tuple 2 153),
    (Tuple 2 172),
    (Tuple 743 489),
    (Tuple 743 492),
    (Tuple 743 450),
    (Tuple 743 32),
    (Tuple 743 33),
    (Tuple 743 475),
    (Tuple 743 35),
    (Tuple 743 502),
    (Tuple 743 39),
    (Tuple 743 311),
    (Tuple 743 303),
    (Tuple 743 42),
    (Tuple 743 236),
    (Tuple 743 52),
    (Tuple 743 53),
    (Tuple 743 370),
    (Tuple 743 55),
    (Tuple 743 391),
    (Tuple 743 58),
    (Tuple 743 126),
    (Tuple 743 59),
    (Tuple 565 320),
    (Tuple 565 74),
    (Tuple 565 567),
    (Tuple 565 321),
    (Tuple 565 75),
    (Tuple 565 570),
    (Tuple 565 571),
    (Tuple 565 87),
    (Tuple 565 42),
    (Tuple 565 557),
    (Tuple 565 478),
    (Tuple 565 417),
    (Tuple 565 103),
    (Tuple 565 420),
    (Tuple 565 49),
    (Tuple 565 113),
    (Tuple 565 116),
    (Tuple 565 126),
    (Tuple 565 597),
    (Tuple 565 132),
    (Tuple 320 400),
    (Tuple 320 321),
    (Tuple 320 571),
    (Tuple 320 401),
    (Tuple 320 322),
    (Tuple 320 76),
    (Tuple 320 77),
    (Tuple 320 572),
    (Tuple 320 323),
    (Tuple 320 499),
    (Tuple 320 78),
    (Tuple 320 500),
    (Tuple 320 301),
    (Tuple 320 576),
    (Tuple 320 359),
    (Tuple 320 326),
    (Tuple 320 327),
    (Tuple 320 81),
    (Tuple 320 328),
    (Tuple 320 83),
    (Tuple 320 37),
    (Tuple 320 84),
    (Tuple 320 85),
    (Tuple 320 403),
    (Tuple 320 404),
    (Tuple 320 86),
    (Tuple 320 583),
    (Tuple 320 405),
    (Tuple 320 744),
    (Tuple 320 331),
    (Tuple 320 87),
    (Tuple 320 88),
    (Tuple 320 90),
    (Tuple 320 91),
    (Tuple 320 585),
    (Tuple 320 332),
    (Tuple 320 406),
    (Tuple 320 92),
    (Tuple 320 333),
    (Tuple 320 334),
    (Tuple 320 407),
    (Tuple 320 408),
    (Tuple 320 337),
    (Tuple 320 94),
    (Tuple 320 95),
    (Tuple 320 586),
    (Tuple 320 509),
    (Tuple 320 235),
    (Tuple 320 41),
    (Tuple 320 42),
    (Tuple 320 409),
    (Tuple 320 97),
    (Tuple 320 542),
    (Tuple 320 98),
    (Tuple 320 99),
    (Tuple 320 312),
    (Tuple 320 411),
    (Tuple 320 100),
    (Tuple 320 557),
    (Tuple 320 412),
    (Tuple 320 590),
    (Tuple 320 101),
    (Tuple 320 344),
    (Tuple 320 413),
    (Tuple 320 414),
    (Tuple 320 416),
    (Tuple 320 417),
    (Tuple 320 102),
    (Tuple 320 103),
    (Tuple 320 104),
    (Tuple 320 745),
    (Tuple 320 420),
    (Tuple 320 421),
    (Tuple 320 105),
    (Tuple 320 106),
    (Tuple 320 107),
    (Tuple 320 108),
    (Tuple 320 109),
    (Tuple 320 746),
    (Tuple 320 110),
    (Tuple 320 306),
    (Tuple 320 111),
    (Tuple 320 49),
    (Tuple 320 528),
    (Tuple 320 592),
    (Tuple 320 112),
    (Tuple 320 237),
    (Tuple 320 113),
    (Tuple 320 693),
    (Tuple 320 530),
    (Tuple 320 369),
    (Tuple 320 114),
    (Tuple 320 531),
    (Tuple 320 52),
    (Tuple 320 425),
    (Tuple 320 115),
    (Tuple 320 116),
    (Tuple 320 349),
    (Tuple 320 238),
    (Tuple 320 118),
    (Tuple 320 119),
    (Tuple 320 426),
    (Tuple 320 120),
    (Tuple 320 121),
    (Tuple 320 427),
    (Tuple 320 428),
    (Tuple 320 122),
    (Tuple 320 267),
    (Tuple 320 123),
    (Tuple 320 57),
    (Tuple 320 124),
    (Tuple 320 125),
    (Tuple 320 126),
    (Tuple 320 127),
    (Tuple 320 430),
    (Tuple 320 532),
    (Tuple 320 129),
    (Tuple 320 130),
    (Tuple 320 594),
    (Tuple 320 595),
    (Tuple 320 131),
    (Tuple 320 433),
    (Tuple 320 132),
    (Tuple 320 308),
    (Tuple 320 435),
    (Tuple 320 133),
    (Tuple 320 357),
    (Tuple 320 309),
    (Tuple 271 214),
    (Tuple 747 748),
    (Tuple 747 519),
    (Tuple 747 749),
    (Tuple 747 750),
    (Tuple 747 751),
    (Tuple 747 388),
    (Tuple 747 513),
    (Tuple 747 752),
    (Tuple 747 753),
    (Tuple 747 754),
    (Tuple 747 755),
    (Tuple 756 322),
    (Tuple 756 31),
    (Tuple 756 9),
    (Tuple 756 151),
    (Tuple 757 757),
    (Tuple 757 758),
    (Tuple 757 759),
    (Tuple 74 567),
    (Tuple 74 321),
    (Tuple 74 491),
    (Tuple 74 75),
    (Tuple 74 569),
    (Tuple 74 76),
    (Tuple 74 77),
    (Tuple 74 638),
    (Tuple 74 302),
    (Tuple 74 359),
    (Tuple 74 81),
    (Tuple 74 83),
    (Tuple 74 84),
    (Tuple 74 403),
    (Tuple 74 405),
    (Tuple 74 361),
    (Tuple 74 331),
    (Tuple 74 87),
    (Tuple 74 88),
    (Tuple 74 89),
    (Tuple 74 91),
    (Tuple 74 640),
    (Tuple 74 42),
    (Tuple 74 99),
    (Tuple 74 312),
    (Tuple 74 410),
    (Tuple 74 478),
    (Tuple 74 101),
    (Tuple 74 417),
    (Tuple 74 546),
    (Tuple 74 102),
    (Tuple 74 103),
    (Tuple 74 104),
    (Tuple 74 420),
    (Tuple 74 105),
    (Tuple 74 106),
    (Tuple 74 107),
    (Tuple 74 108),
    (Tuple 74 109),
    (Tuple 74 306),
    (Tuple 74 111),
    (Tuple 74 49),
    (Tuple 74 112),
    (Tuple 74 113),
    (Tuple 74 369),
    (Tuple 74 114),
    (Tuple 74 641),
    (Tuple 74 52),
    (Tuple 74 115),
    (Tuple 74 116),
    (Tuple 74 117),
    (Tuple 74 119),
    (Tuple 74 426),
    (Tuple 74 122),
    (Tuple 74 267),
    (Tuple 74 57),
    (Tuple 74 707),
    (Tuple 74 126),
    (Tuple 74 127),
    (Tuple 74 129),
    (Tuple 74 130),
    (Tuple 74 595),
    (Tuple 74 131),
    (Tuple 74 597),
    (Tuple 74 132),
    (Tuple 74 308),
    (Tuple 74 133),
    (Tuple 74 309),
    (Tuple 314 62),
    (Tuple 314 33),
    (Tuple 314 315),
    (Tuple 314 55),
    (Tuple 461 20),
    (Tuple 461 188),
    (Tuple 461 193),
    (Tuple 461 21),
    (Tuple 461 22),
    (Tuple 461 206),
    (Tuple 461 286),
    (Tuple 461 171),
    (Tuple 461 507),
    (Tuple 616 643),
    (Tuple 616 30),
    (Tuple 616 20),
    (Tuple 616 185),
    (Tuple 616 187),
    (Tuple 616 193),
    (Tuple 616 194),
    (Tuple 616 195),
    (Tuple 616 64),
    (Tuple 616 278),
    (Tuple 616 280),
    (Tuple 616 282),
    (Tuple 616 200),
    (Tuple 616 22),
    (Tuple 616 202),
    (Tuple 616 166),
    (Tuple 616 284),
    (Tuple 616 168),
    (Tuple 616 170),
    (Tuple 616 288),
    (Tuple 616 214),
    (Tuple 616 215),
    (Tuple 616 66),
    (Tuple 616 171),
    (Tuple 616 220),
    (Tuple 616 221),
    (Tuple 616 60),
    (Tuple 616 173),
    (Tuple 694 694),
    (Tuple 694 685),
    (Tuple 694 321),
    (Tuple 694 28),
    (Tuple 694 75),
    (Tuple 694 760),
    (Tuple 694 722),
    (Tuple 694 536),
    (Tuple 694 761),
    (Tuple 694 359),
    (Tuple 694 325),
    (Tuple 694 762),
    (Tuple 694 763),
    (Tuple 694 724),
    (Tuple 694 34),
    (Tuple 694 626),
    (Tuple 694 502),
    (Tuple 694 540),
    (Tuple 694 764),
    (Tuple 694 495),
    (Tuple 694 765),
    (Tuple 694 766),
    (Tuple 694 337),
    (Tuple 694 667),
    (Tuple 694 207),
    (Tuple 694 264),
    (Tuple 694 42),
    (Tuple 694 587),
    (Tuple 694 409),
    (Tuple 694 629),
    (Tuple 694 668),
    (Tuple 694 265),
    (Tuple 694 767),
    (Tuple 694 768),
    (Tuple 694 769),
    (Tuple 694 770),
    (Tuple 694 771),
    (Tuple 694 772),
    (Tuple 694 773),
    (Tuple 694 669),
    (Tuple 694 345),
    (Tuple 694 774),
    (Tuple 694 415),
    (Tuple 694 47),
    (Tuple 694 630),
    (Tuple 694 731),
    (Tuple 694 682),
    (Tuple 694 775),
    (Tuple 694 776),
    (Tuple 694 671),
    (Tuple 694 672),
    (Tuple 694 503),
    (Tuple 694 673),
    (Tuple 694 733),
    (Tuple 694 777),
    (Tuple 694 778),
    (Tuple 694 734),
    (Tuple 694 112),
    (Tuple 694 363),
    (Tuple 694 424),
    (Tuple 694 779),
    (Tuple 694 51),
    (Tuple 694 736),
    (Tuple 694 52),
    (Tuple 694 780),
    (Tuple 694 781),
    (Tuple 694 782),
    (Tuple 694 351),
    (Tuple 694 699),
    (Tuple 694 56),
    (Tuple 694 123),
    (Tuple 694 57),
    (Tuple 694 783),
    (Tuple 694 784),
    (Tuple 694 353),
    (Tuple 694 785),
    (Tuple 694 125),
    (Tuple 694 786),
    (Tuple 694 787),
    (Tuple 694 788),
    (Tuple 694 532),
    (Tuple 694 789),
    (Tuple 694 683),
    (Tuple 694 790),
    (Tuple 694 393),
    (Tuple 694 791),
    (Tuple 694 60),
    (Tuple 694 515),
    (Tuple 250 445),
    (Tuple 250 30),
    (Tuple 250 20),
    (Tuple 250 474),
    (Tuple 250 437),
    (Tuple 250 31),
    (Tuple 250 276),
    (Tuple 250 189),
    (Tuple 250 193),
    (Tuple 250 194),
    (Tuple 250 398),
    (Tuple 250 6),
    (Tuple 250 232),
    (Tuple 250 64),
    (Tuple 250 197),
    (Tuple 250 164),
    (Tuple 250 40),
    (Tuple 250 205),
    (Tuple 250 285),
    (Tuple 250 169),
    (Tuple 250 170),
    (Tuple 250 23),
    (Tuple 250 214),
    (Tuple 250 55),
    (Tuple 250 221),
    (Tuple 250 16),
    (Tuple 272 272),
    (Tuple 272 274),
    (Tuple 272 62),
    (Tuple 272 20),
    (Tuple 272 185),
    (Tuple 272 31),
    (Tuple 272 189),
    (Tuple 272 190),
    (Tuple 272 192),
    (Tuple 272 193),
    (Tuple 272 376),
    (Tuple 272 162),
    (Tuple 272 21),
    (Tuple 272 64),
    (Tuple 272 197),
    (Tuple 272 200),
    (Tuple 272 361),
    (Tuple 272 203),
    (Tuple 272 166),
    (Tuple 272 204),
    (Tuple 272 208),
    (Tuple 272 167),
    (Tuple 272 211),
    (Tuple 272 168),
    (Tuple 272 170),
    (Tuple 272 288),
    (Tuple 272 381),
    (Tuple 272 214),
    (Tuple 272 66),
    (Tuple 272 216),
    (Tuple 272 219),
    (Tuple 272 68),
    (Tuple 272 392),
    (Tuple 272 224),
    (Tuple 272 60),
    (Tuple 444 62),
    (Tuple 444 373),
    (Tuple 444 160),
    (Tuple 444 451),
    (Tuple 444 162),
    (Tuple 444 792),
    (Tuple 444 164),
    (Tuple 444 39),
    (Tuple 444 167),
    (Tuple 444 170),
    (Tuple 444 171),
    (Tuple 444 386),
    (Tuple 444 793),
    (Tuple 444 16),
    (Tuple 444 794),
    (Tuple 444 795),
    (Tuple 512 512),
    (Tuple 512 445),
    (Tuple 512 252),
    (Tuple 512 274),
    (Tuple 512 62),
    (Tuple 512 30),
    (Tuple 512 184),
    (Tuple 512 20),
    (Tuple 512 185),
    (Tuple 512 187),
    (Tuple 512 275),
    (Tuple 512 63),
    (Tuple 512 189),
    (Tuple 512 190),
    (Tuple 512 191),
    (Tuple 512 192),
    (Tuple 512 376),
    (Tuple 512 194),
    (Tuple 512 644),
    (Tuple 512 162),
    (Tuple 512 195),
    (Tuple 512 277),
    (Tuple 512 377),
    (Tuple 512 21),
    (Tuple 512 64),
    (Tuple 512 196),
    (Tuple 512 278),
    (Tuple 512 280),
    (Tuple 512 199),
    (Tuple 512 281),
    (Tuple 512 39),
    (Tuple 512 40),
    (Tuple 512 165),
    (Tuple 512 200),
    (Tuple 512 227),
    (Tuple 512 361),
    (Tuple 512 201),
    (Tuple 512 202),
    (Tuple 512 203),
    (Tuple 512 166),
    (Tuple 512 379),
    (Tuple 512 380),
    (Tuple 512 208),
    (Tuple 512 284),
    (Tuple 512 167),
    (Tuple 512 285),
    (Tuple 512 210),
    (Tuple 512 312),
    (Tuple 512 168),
    (Tuple 512 170),
    (Tuple 512 65),
    (Tuple 512 288),
    (Tuple 512 345),
    (Tuple 512 212),
    (Tuple 512 796),
    (Tuple 512 289),
    (Tuple 512 381),
    (Tuple 512 214),
    (Tuple 512 383),
    (Tuple 512 66),
    (Tuple 512 216),
    (Tuple 512 50),
    (Tuple 512 385),
    (Tuple 512 171),
    (Tuple 512 219),
    (Tuple 512 220),
    (Tuple 512 56),
    (Tuple 512 221),
    (Tuple 512 222),
    (Tuple 512 483),
    (Tuple 512 290),
    (Tuple 512 224),
    (Tuple 512 225),
    (Tuple 512 173),
    (Tuple 512 797),
    (Tuple 299 33),
    (Tuple 299 798),
    (Tuple 299 370),
    (Tuple 251 510),
    (Tuple 251 252),
    (Tuple 251 253),
    (Tuple 251 517),
    (Tuple 251 20),
    (Tuple 251 254),
    (Tuple 251 255),
    (Tuple 251 256),
    (Tuple 251 462),
    (Tuple 251 188),
    (Tuple 251 161),
    (Tuple 251 232),
    (Tuple 251 64),
    (Tuple 251 198),
    (Tuple 251 200),
    (Tuple 251 361),
    (Tuple 251 166),
    (Tuple 251 206),
    (Tuple 251 211),
    (Tuple 251 44),
    (Tuple 251 168),
    (Tuple 251 25),
    (Tuple 251 511),
    (Tuple 251 23),
    (Tuple 251 215),
    (Tuple 251 422),
    (Tuple 251 110),
    (Tuple 251 369),
    (Tuple 251 261),
    (Tuple 251 262),
    (Tuple 251 56),
    (Tuple 251 799),
    (Tuple 251 431),
    (Tuple 251 515),
    (Tuple 400 566),
    (Tuple 400 300),
    (Tuple 400 685),
    (Tuple 400 321),
    (Tuple 400 75),
    (Tuple 400 568),
    (Tuple 400 569),
    (Tuple 400 570),
    (Tuple 400 322),
    (Tuple 400 572),
    (Tuple 400 574),
    (Tuple 400 576),
    (Tuple 400 579),
    (Tuple 400 327),
    (Tuple 400 83),
    (Tuple 400 581),
    (Tuple 400 582),
    (Tuple 400 85),
    (Tuple 400 38),
    (Tuple 400 402),
    (Tuple 400 87),
    (Tuple 400 332),
    (Tuple 400 688),
    (Tuple 400 333),
    (Tuple 400 334),
    (Tuple 400 335),
    (Tuple 400 338),
    (Tuple 400 689),
    (Tuple 400 207),
    (Tuple 400 339),
    (Tuple 400 340),
    (Tuple 400 800),
    (Tuple 400 588),
    (Tuple 400 668),
    (Tuple 400 98),
    (Tuple 400 100),
    (Tuple 400 557),
    (Tuple 400 412),
    (Tuple 400 342),
    (Tuple 400 344),
    (Tuple 400 801),
    (Tuple 400 103),
    (Tuple 400 745),
    (Tuple 400 591),
    (Tuple 400 106),
    (Tuple 400 348),
    (Tuple 400 116),
    (Tuple 400 352),
    (Tuple 400 707),
    (Tuple 400 354),
    (Tuple 400 596),
    (Tuple 400 132),
    (Tuple 374 183),
    (Tuple 374 274),
    (Tuple 374 62),
    (Tuple 374 20),
    (Tuple 374 185),
    (Tuple 374 187),
    (Tuple 374 189),
    (Tuple 374 160),
    (Tuple 374 190),
    (Tuple 374 192),
    (Tuple 374 193),
    (Tuple 374 376),
    (Tuple 374 194),
    (Tuple 374 463),
    (Tuple 374 162),
    (Tuple 374 199),
    (Tuple 374 165),
    (Tuple 374 200),
    (Tuple 374 203),
    (Tuple 374 166),
    (Tuple 374 204),
    (Tuple 374 208),
    (Tuple 374 209),
    (Tuple 374 211),
    (Tuple 374 168),
    (Tuple 374 170),
    (Tuple 374 212),
    (Tuple 374 213),
    (Tuple 374 214),
    (Tuple 374 66),
    (Tuple 374 216),
    (Tuple 374 171),
    (Tuple 374 218),
    (Tuple 374 220),
    (Tuple 374 390),
    (Tuple 374 68),
    (Tuple 374 221),
    (Tuple 374 222),
    (Tuple 374 392),
    (Tuple 374 223),
    (Tuple 374 224),
    (Tuple 374 225),
    (Tuple 684 445),
    (Tuple 684 802),
    (Tuple 684 29),
    (Tuple 684 499),
    (Tuple 684 762),
    (Tuple 684 803),
    (Tuple 684 232),
    (Tuple 684 34),
    (Tuple 684 626),
    (Tuple 684 38),
    (Tuple 684 199),
    (Tuple 684 86),
    (Tuple 684 627),
    (Tuple 684 234),
    (Tuple 684 527),
    (Tuple 684 303),
    (Tuple 684 304),
    (Tuple 684 804),
    (Tuple 684 409),
    (Tuple 684 97),
    (Tuple 684 265),
    (Tuple 684 697),
    (Tuple 684 630),
    (Tuple 684 102),
    (Tuple 684 305),
    (Tuple 684 673),
    (Tuple 684 112),
    (Tuple 684 237),
    (Tuple 684 52),
    (Tuple 684 425),
    (Tuple 684 782),
    (Tuple 684 632),
    (Tuple 684 699),
    (Tuple 684 428),
    (Tuple 684 784),
    (Tuple 684 124),
    (Tuple 684 786),
    (Tuple 684 239),
    (Tuple 684 701),
    (Tuple 684 60),
    (Tuple 489 489),
    (Tuple 489 490),
    (Tuple 489 29),
    (Tuple 489 492),
    (Tuple 489 638),
    (Tuple 489 32),
    (Tuple 489 33),
    (Tuple 489 35),
    (Tuple 489 311),
    (Tuple 489 476),
    (Tuple 489 303),
    (Tuple 489 640),
    (Tuple 489 236),
    (Tuple 489 641),
    (Tuple 489 53),
    (Tuple 489 370),
    (Tuple 489 121),
    (Tuple 489 58),
    (Tuple 489 126),
    (Tuple 489 59),
    (Tuple 620 517),
    (Tuple 620 711),
    (Tuple 620 621),
    (Tuple 620 712),
    (Tuple 805 28),
    (Tuple 805 322),
    (Tuple 805 324),
    (Tuple 805 500),
    (Tuple 805 79),
    (Tuple 805 806),
    (Tuple 805 695),
    (Tuple 805 803),
    (Tuple 805 34),
    (Tuple 805 525),
    (Tuple 805 807),
    (Tuple 805 37),
    (Tuple 805 38),
    (Tuple 805 404),
    (Tuple 805 627),
    (Tuple 805 331),
    (Tuple 805 92),
    (Tuple 805 334),
    (Tuple 805 337),
    (Tuple 805 207),
    (Tuple 805 235),
    (Tuple 805 97),
    (Tuple 805 697),
    (Tuple 805 418),
    (Tuple 805 682),
    (Tuple 805 776),
    (Tuple 805 103),
    (Tuple 805 104),
    (Tuple 805 420),
    (Tuple 805 363),
    (Tuple 805 424),
    (Tuple 805 530),
    (Tuple 805 631),
    (Tuple 805 52),
    (Tuple 805 238),
    (Tuple 805 120),
    (Tuple 805 427),
    (Tuple 805 428),
    (Tuple 805 429),
    (Tuple 805 267),
    (Tuple 805 123),
    (Tuple 805 57),
    (Tuple 805 125),
    (Tuple 805 126),
    (Tuple 805 127),
    (Tuple 805 634),
    (Tuple 805 789),
    (Tuple 805 60),
    (Tuple 805 357),
    (Tuple 808 711),
    (Tuple 808 311),
    (Tuple 808 303),
    (Tuple 808 712),
    (Tuple 808 793),
    (Tuple 808 431),
    (Tuple 808 173),
    (Tuple 748 519),
    (Tuple 748 749),
    (Tuple 748 750),
    (Tuple 748 809),
    (Tuple 748 810),
    (Tuple 748 811),
    (Tuple 748 388),
    (Tuple 748 513),
    (Tuple 748 752),
    (Tuple 748 753),
    (Tuple 748 754),
    (Tuple 748 755),
    (Tuple 183 274),
    (Tuple 183 62),
    (Tuple 183 20),
    (Tuple 183 375),
    (Tuple 183 187),
    (Tuple 183 189),
    (Tuple 183 190),
    (Tuple 183 191),
    (Tuple 183 192),
    (Tuple 183 193),
    (Tuple 183 376),
    (Tuple 183 194),
    (Tuple 183 195),
    (Tuple 183 21),
    (Tuple 183 196),
    (Tuple 183 199),
    (Tuple 183 165),
    (Tuple 183 200),
    (Tuple 183 378),
    (Tuple 183 166),
    (Tuple 183 204),
    (Tuple 183 208),
    (Tuple 183 284),
    (Tuple 183 209),
    (Tuple 183 211),
    (Tuple 183 170),
    (Tuple 183 212),
    (Tuple 183 213),
    (Tuple 183 23),
    (Tuple 183 382),
    (Tuple 183 383),
    (Tuple 183 66),
    (Tuple 183 216),
    (Tuple 183 387),
    (Tuple 183 390),
    (Tuple 183 221),
    (Tuple 183 222),
    (Tuple 183 392),
    (Tuple 183 223),
    (Tuple 183 225),
    (Tuple 183 394),
    (Tuple 812 812),
    (Tuple 812 664),
    (Tuple 812 667),
    (Tuple 812 813),
    (Tuple 812 774),
    (Tuple 812 532),
    (Tuple 812 677),
    (Tuple 812 789),
    (Tuple 814 380),
    (Tuple 814 815),
    (Tuple 814 110),
    (Tuple 713 713),
    (Tuple 713 437),
    (Tuple 713 470),
    (Tuple 713 14),
    (Tuple 713 152),
    (Tuple 713 154),
    (Tuple 713 172),
    (Tuple 816 816),
    (Tuple 719 802),
    (Tuple 719 721),
    (Tuple 719 817),
    (Tuple 719 818),
    (Tuple 719 819),
    (Tuple 719 722),
    (Tuple 719 723),
    (Tuple 719 679),
    (Tuple 719 63),
    (Tuple 719 536),
    (Tuple 719 820),
    (Tuple 719 821),
    (Tuple 719 680),
    (Tuple 719 822),
    (Tuple 719 762),
    (Tuple 719 803),
    (Tuple 719 724),
    (Tuple 719 823),
    (Tuple 719 34),
    (Tuple 719 626),
    (Tuple 719 824),
    (Tuple 719 627),
    (Tuple 719 527),
    (Tuple 719 764),
    (Tuple 719 825),
    (Tuple 719 726),
    (Tuple 719 727),
    (Tuple 719 766),
    (Tuple 719 667),
    (Tuple 719 509),
    (Tuple 719 728),
    (Tuple 719 264),
    (Tuple 719 826),
    (Tuple 719 696),
    (Tuple 719 629),
    (Tuple 719 827),
    (Tuple 719 769),
    (Tuple 719 828),
    (Tuple 719 829),
    (Tuple 719 770),
    (Tuple 719 813),
    (Tuple 719 771),
    (Tuple 719 772),
    (Tuple 719 669),
    (Tuple 719 47),
    (Tuple 719 729),
    (Tuple 719 730),
    (Tuple 719 731),
    (Tuple 719 682),
    (Tuple 719 775),
    (Tuple 719 673),
    (Tuple 719 830),
    (Tuple 719 831),
    (Tuple 719 733),
    (Tuple 719 832),
    (Tuple 719 675),
    (Tuple 719 734),
    (Tuple 719 698),
    (Tuple 719 735),
    (Tuple 719 529),
    (Tuple 719 385),
    (Tuple 719 833),
    (Tuple 719 631),
    (Tuple 719 779),
    (Tuple 719 834),
    (Tuple 719 736),
    (Tuple 719 835),
    (Tuple 719 780),
    (Tuple 719 781),
    (Tuple 719 836),
    (Tuple 719 837),
    (Tuple 719 782),
    (Tuple 719 738),
    (Tuple 719 838),
    (Tuple 719 839),
    (Tuple 719 632),
    (Tuple 719 699),
    (Tuple 719 429),
    (Tuple 719 840),
    (Tuple 719 57),
    (Tuple 719 841),
    (Tuple 719 783),
    (Tuple 719 784),
    (Tuple 719 353),
    (Tuple 719 785),
    (Tuple 719 786),
    (Tuple 719 787),
    (Tuple 719 788),
    (Tuple 719 701),
    (Tuple 719 514),
    (Tuple 719 634),
    (Tuple 719 533),
    (Tuple 719 683),
    (Tuple 719 790),
    (Tuple 719 393),
    (Tuple 719 615),
    (Tuple 719 515),
    (Tuple 719 842),
    (Tuple 719 843),
    (Tuple 643 187),
    (Tuple 643 276),
    (Tuple 643 192),
    (Tuple 643 193),
    (Tuple 643 194),
    (Tuple 643 195),
    (Tuple 643 199),
    (Tuple 643 200),
    (Tuple 643 202),
    (Tuple 643 166),
    (Tuple 643 284),
    (Tuple 643 214),
    (Tuple 643 216),
    (Tuple 643 171),
    (Tuple 643 220),
    (Tuple 643 224),
    (Tuple 273 273),
    (Tuple 273 274),
    (Tuple 273 62),
    (Tuple 273 30),
    (Tuple 273 20),
    (Tuple 273 185),
    (Tuple 273 375),
    (Tuple 273 462),
    (Tuple 273 187),
    (Tuple 273 275),
    (Tuple 273 276),
    (Tuple 273 189),
    (Tuple 273 190),
    (Tuple 273 191),
    (Tuple 273 192),
    (Tuple 273 193),
    (Tuple 273 194),
    (Tuple 273 644),
    (Tuple 273 162),
    (Tuple 273 195),
    (Tuple 273 64),
    (Tuple 273 196),
    (Tuple 273 199),
    (Tuple 273 165),
    (Tuple 273 200),
    (Tuple 273 22),
    (Tuple 273 361),
    (Tuple 273 201),
    (Tuple 273 202),
    (Tuple 273 378),
    (Tuple 273 203),
    (Tuple 273 166),
    (Tuple 273 208),
    (Tuple 273 167),
    (Tuple 273 285),
    (Tuple 273 286),
    (Tuple 273 209),
    (Tuple 273 210),
    (Tuple 273 211),
    (Tuple 273 168),
    (Tuple 273 170),
    (Tuple 273 288),
    (Tuple 273 212),
    (Tuple 273 23),
    (Tuple 273 289),
    (Tuple 273 381),
    (Tuple 273 646),
    (Tuple 273 214),
    (Tuple 273 215),
    (Tuple 273 66),
    (Tuple 273 216),
    (Tuple 273 384),
    (Tuple 273 50),
    (Tuple 273 217),
    (Tuple 273 171),
    (Tuple 273 218),
    (Tuple 273 219),
    (Tuple 273 387),
    (Tuple 273 220),
    (Tuple 273 390),
    (Tuple 273 68),
    (Tuple 273 221),
    (Tuple 273 126),
    (Tuple 273 222),
    (Tuple 273 16),
    (Tuple 273 224),
    (Tuple 273 225),
    (Tuple 273 394),
    (Tuple 273 173),
    (Tuple 720 817),
    (Tuple 720 818),
    (Tuple 720 819),
    (Tuple 720 723),
    (Tuple 720 679),
    (Tuple 720 536),
    (Tuple 720 680),
    (Tuple 720 762),
    (Tuple 720 724),
    (Tuple 720 34),
    (Tuple 720 626),
    (Tuple 720 824),
    (Tuple 720 666),
    (Tuple 720 627),
    (Tuple 720 825),
    (Tuple 720 726),
    (Tuple 720 727),
    (Tuple 720 766),
    (Tuple 720 264),
    (Tuple 720 826),
    (Tuple 720 827),
    (Tuple 720 769),
    (Tuple 720 770),
    (Tuple 720 772),
    (Tuple 720 47),
    (Tuple 720 729),
    (Tuple 720 731),
    (Tuple 720 670),
    (Tuple 720 682),
    (Tuple 720 673),
    (Tuple 720 733),
    (Tuple 720 832),
    (Tuple 720 363),
    (Tuple 720 631),
    (Tuple 720 779),
    (Tuple 720 780),
    (Tuple 720 781),
    (Tuple 720 837),
    (Tuple 720 782),
    (Tuple 720 737),
    (Tuple 720 839),
    (Tuple 720 632),
    (Tuple 720 699),
    (Tuple 720 841),
    (Tuple 720 783),
    (Tuple 720 784),
    (Tuple 720 353),
    (Tuple 720 785),
    (Tuple 720 739),
    (Tuple 720 786),
    (Tuple 720 787),
    (Tuple 720 788),
    (Tuple 720 701),
    (Tuple 720 514),
    (Tuple 720 532),
    (Tuple 720 683),
    (Tuple 720 393),
    (Tuple 720 615),
    (Tuple 844 367),
    (Tuple 844 760),
    (Tuple 844 845),
    (Tuple 844 761),
    (Tuple 844 763),
    (Tuple 844 846),
    (Tuple 844 847),
    (Tuple 844 765),
    (Tuple 844 767),
    (Tuple 844 771),
    (Tuple 844 848),
    (Tuple 844 503),
    (Tuple 844 849),
    (Tuple 844 850),
    (Tuple 844 777),
    (Tuple 844 778),
    (Tuple 844 363),
    (Tuple 844 532),
    (Tuple 844 791),
    (Tuple 651 343),
    (Tuple 510 256),
    (Tuple 510 462),
    (Tuple 510 279),
    (Tuple 510 215),
    (Tuple 135 3),
    (Tuple 135 610),
    (Tuple 135 664),
    (Tuple 135 136),
    (Tuple 135 137),
    (Tuple 135 468),
    (Tuple 135 138),
    (Tuple 135 31),
    (Tuple 135 160),
    (Tuple 135 624),
    (Tuple 135 139),
    (Tuple 135 851),
    (Tuple 135 5),
    (Tuple 135 140),
    (Tuple 135 141),
    (Tuple 135 142),
    (Tuple 135 143),
    (Tuple 135 470),
    (Tuple 135 39),
    (Tuple 135 526),
    (Tuple 135 454),
    (Tuple 135 7),
    (Tuple 135 144),
    (Tuple 135 611),
    (Tuple 135 145),
    (Tuple 135 852),
    (Tuple 135 8),
    (Tuple 135 146),
    (Tuple 135 9),
    (Tuple 135 10),
    (Tuple 135 11),
    (Tuple 135 312),
    (Tuple 135 147),
    (Tuple 135 12),
    (Tuple 135 608),
    (Tuple 135 148),
    (Tuple 135 13),
    (Tuple 135 471),
    (Tuple 135 456),
    (Tuple 135 385),
    (Tuple 135 14),
    (Tuple 135 661),
    (Tuple 135 149),
    (Tuple 135 15),
    (Tuple 135 150),
    (Tuple 135 151),
    (Tuple 135 457),
    (Tuple 135 221),
    (Tuple 135 459),
    (Tuple 135 612),
    (Tuple 135 153),
    (Tuple 135 853),
    (Tuple 135 154),
    (Tuple 135 155),
    (Tuple 135 356),
    (Tuple 135 172),
    (Tuple 135 173),
    (Tuple 135 613),
    (Tuple 135 309),
    (Tuple 445 62),
    (Tuple 445 20),
    (Tuple 445 31),
    (Tuple 445 190),
    (Tuple 445 191),
    (Tuple 445 165),
    (Tuple 445 200),
    (Tuple 445 361),
    (Tuple 445 202),
    (Tuple 445 208),
    (Tuple 445 167),
    (Tuple 445 288),
    (Tuple 445 212),
    (Tuple 445 23),
    (Tuple 445 214),
    (Tuple 445 224),
    (Tuple 490 491),
    (Tuple 490 492),
    (Tuple 490 493),
    (Tuple 490 32),
    (Tuple 490 33),
    (Tuple 490 475),
    (Tuple 490 35),
    (Tuple 490 494),
    (Tuple 490 605),
    (Tuple 490 311),
    (Tuple 490 361),
    (Tuple 490 303),
    (Tuple 490 316),
    (Tuple 490 496),
    (Tuple 490 497),
    (Tuple 490 52),
    (Tuple 490 53),
    (Tuple 490 370),
    (Tuple 490 54),
    (Tuple 490 55),
    (Tuple 490 56),
    (Tuple 490 391),
    (Tuple 490 58),
    (Tuple 490 126),
    (Tuple 490 59),
    (Tuple 490 173),
    (Tuple 566 566),
    (Tuple 566 75),
    (Tuple 566 570),
    (Tuple 566 401),
    (Tuple 566 76),
    (Tuple 566 323),
    (Tuple 566 499),
    (Tuple 566 78),
    (Tuple 566 575),
    (Tuple 566 79),
    (Tuple 566 63),
    (Tuple 566 302),
    (Tuple 566 359),
    (Tuple 566 81),
    (Tuple 566 232),
    (Tuple 566 328),
    (Tuple 566 37),
    (Tuple 566 85),
    (Tuple 566 402),
    (Tuple 566 403),
    (Tuple 566 39),
    (Tuple 566 404),
    (Tuple 566 526),
    (Tuple 566 86),
    (Tuple 566 405),
    (Tuple 566 361),
    (Tuple 566 744),
    (Tuple 566 603),
    (Tuple 566 87),
    (Tuple 566 88),
    (Tuple 566 89),
    (Tuple 566 90),
    (Tuple 566 91),
    (Tuple 566 585),
    (Tuple 566 332),
    (Tuple 566 92),
    (Tuple 566 334),
    (Tuple 566 335),
    (Tuple 566 407),
    (Tuple 566 408),
    (Tuple 566 337),
    (Tuple 566 94),
    (Tuple 566 95),
    (Tuple 566 586),
    (Tuple 566 509),
    (Tuple 566 235),
    (Tuple 566 41),
    (Tuple 566 97),
    (Tuple 566 542),
    (Tuple 566 265),
    (Tuple 566 98),
    (Tuple 566 99),
    (Tuple 566 410),
    (Tuple 566 589),
    (Tuple 566 100),
    (Tuple 566 590),
    (Tuple 566 170),
    (Tuple 566 65),
    (Tuple 566 417),
    (Tuple 566 102),
    (Tuple 566 103),
    (Tuple 566 305),
    (Tuple 566 104),
    (Tuple 566 745),
    (Tuple 566 420),
    (Tuple 566 421),
    (Tuple 566 105),
    (Tuple 566 106),
    (Tuple 566 107),
    (Tuple 566 108),
    (Tuple 566 109),
    (Tuple 566 110),
    (Tuple 566 306),
    (Tuple 566 111),
    (Tuple 566 49),
    (Tuple 566 528),
    (Tuple 566 592),
    (Tuple 566 112),
    (Tuple 566 237),
    (Tuple 566 113),
    (Tuple 566 529),
    (Tuple 566 693),
    (Tuple 566 385),
    (Tuple 566 424),
    (Tuple 566 530),
    (Tuple 566 369),
    (Tuple 566 114),
    (Tuple 566 531),
    (Tuple 566 52),
    (Tuple 566 115),
    (Tuple 566 116),
    (Tuple 566 349),
    (Tuple 566 238),
    (Tuple 566 117),
    (Tuple 566 118),
    (Tuple 566 119),
    (Tuple 566 426),
    (Tuple 566 120),
    (Tuple 566 121),
    (Tuple 566 55),
    (Tuple 566 56),
    (Tuple 566 427),
    (Tuple 566 428),
    (Tuple 566 122),
    (Tuple 566 267),
    (Tuple 566 123),
    (Tuple 566 124),
    (Tuple 566 125),
    (Tuple 566 126),
    (Tuple 566 127),
    (Tuple 566 128),
    (Tuple 566 129),
    (Tuple 566 130),
    (Tuple 566 594),
    (Tuple 566 595),
    (Tuple 566 131),
    (Tuple 566 433),
    (Tuple 566 132),
    (Tuple 566 308),
    (Tuple 566 435),
    (Tuple 566 133),
    (Tuple 566 309),
    (Tuple 854 20),
    (Tuple 854 276),
    (Tuple 854 232),
    (Tuple 854 170),
    (Tuple 854 23),
    (Tuple 855 110),
    (Tuple 855 799),
    (Tuple 252 252),
    (Tuple 252 253),
    (Tuple 252 20),
    (Tuple 252 254),
    (Tuple 252 462),
    (Tuple 252 161),
    (Tuple 252 200),
    (Tuple 252 206),
    (Tuple 252 9),
    (Tuple 252 23),
    (Tuple 252 215),
    (Tuple 252 262),
    (Tuple 604 537),
    (Tuple 604 325),
    (Tuple 604 539),
    (Tuple 604 234),
    (Tuple 604 42),
    (Tuple 604 43),
    (Tuple 604 45),
    (Tuple 604 46),
    (Tuple 604 546),
    (Tuple 604 547),
    (Tuple 604 236),
    (Tuple 604 548),
    (Tuple 604 51),
    (Tuple 604 52),
    (Tuple 604 550),
    (Tuple 604 389),
    (Tuple 604 431),
    (Tuple 604 553),
    (Tuple 604 554),
    (Tuple 604 364),
    (Tuple 604 307),
    (Tuple 604 355),
    (Tuple 604 480),
    (Tuple 604 434),
    (Tuple 604 240),
    (Tuple 604 505),
    (Tuple 604 60),
    (Tuple 27 263),
    (Tuple 27 540),
    (Tuple 27 87),
    (Tuple 27 338),
    (Tuple 27 412),
    (Tuple 27 106),
    (Tuple 27 116),
    (Tuple 27 132),
    (Tuple 27 133),
    (Tuple 567 491),
    (Tuple 567 75),
    (Tuple 567 569),
    (Tuple 567 87),
    (Tuple 567 42),
    (Tuple 567 412),
    (Tuple 567 478),
    (Tuple 567 422),
    (Tuple 567 369),
    (Tuple 567 52),
    (Tuple 567 115),
    (Tuple 567 116),
    (Tuple 567 119),
    (Tuple 567 121),
    (Tuple 567 707),
    (Tuple 567 126),
    (Tuple 567 597),
    (Tuple 567 132),
    (Tuple 567 308),
    (Tuple 856 579),
    (Tuple 856 712),
    (Tuple 856 857),
    (Tuple 856 117),
    (Tuple 300 300),
    (Tuple 300 321),
    (Tuple 300 75),
    (Tuple 300 569),
    (Tuple 300 401),
    (Tuple 300 76),
    (Tuple 300 77),
    (Tuple 300 499),
    (Tuple 300 78),
    (Tuple 300 500),
    (Tuple 300 302),
    (Tuple 300 359),
    (Tuple 300 579),
    (Tuple 300 81),
    (Tuple 300 328),
    (Tuple 300 83),
    (Tuple 300 581),
    (Tuple 300 37),
    (Tuple 300 84),
    (Tuple 300 85),
    (Tuple 300 402),
    (Tuple 300 403),
    (Tuple 300 39),
    (Tuple 300 404),
    (Tuple 300 86),
    (Tuple 300 583),
    (Tuple 300 405),
    (Tuple 300 744),
    (Tuple 300 331),
    (Tuple 300 87),
    (Tuple 300 88),
    (Tuple 300 89),
    (Tuple 300 90),
    (Tuple 300 91),
    (Tuple 300 585),
    (Tuple 300 332),
    (Tuple 300 406),
    (Tuple 300 92),
    (Tuple 300 407),
    (Tuple 300 408),
    (Tuple 300 95),
    (Tuple 300 586),
    (Tuple 300 41),
    (Tuple 300 97),
    (Tuple 300 542),
    (Tuple 300 98),
    (Tuple 300 99),
    (Tuple 300 100),
    (Tuple 300 557),
    (Tuple 300 101),
    (Tuple 300 413),
    (Tuple 300 345),
    (Tuple 300 416),
    (Tuple 300 417),
    (Tuple 300 102),
    (Tuple 300 103),
    (Tuple 300 305),
    (Tuple 300 104),
    (Tuple 300 420),
    (Tuple 300 105),
    (Tuple 300 106),
    (Tuple 300 107),
    (Tuple 300 108),
    (Tuple 300 109),
    (Tuple 300 110),
    (Tuple 300 306),
    (Tuple 300 49),
    (Tuple 300 528),
    (Tuple 300 112),
    (Tuple 300 237),
    (Tuple 300 113),
    (Tuple 300 424),
    (Tuple 300 530),
    (Tuple 300 369),
    (Tuple 300 114),
    (Tuple 300 52),
    (Tuple 300 425),
    (Tuple 300 115),
    (Tuple 300 116),
    (Tuple 300 117),
    (Tuple 300 119),
    (Tuple 300 120),
    (Tuple 300 121),
    (Tuple 300 427),
    (Tuple 300 428),
    (Tuple 300 122),
    (Tuple 300 267),
    (Tuple 300 123),
    (Tuple 300 124),
    (Tuple 300 126),
    (Tuple 300 127),
    (Tuple 300 430),
    (Tuple 300 239),
    (Tuple 300 128),
    (Tuple 300 129),
    (Tuple 300 130),
    (Tuple 300 594),
    (Tuple 300 595),
    (Tuple 300 131),
    (Tuple 300 433),
    (Tuple 300 132),
    (Tuple 300 308),
    (Tuple 300 435),
    (Tuple 300 133),
    (Tuple 300 309),
    (Tuple 623 623),
    (Tuple 623 628),
    (Tuple 623 504),
    (Tuple 685 231),
    (Tuple 685 500),
    (Tuple 685 302),
    (Tuple 685 624),
    (Tuple 685 359),
    (Tuple 685 806),
    (Tuple 685 325),
    (Tuple 685 803),
    (Tuple 685 858),
    (Tuple 685 525),
    (Tuple 685 626),
    (Tuple 685 37),
    (Tuple 685 404),
    (Tuple 685 405),
    (Tuple 685 234),
    (Tuple 685 527),
    (Tuple 685 744),
    (Tuple 685 406),
    (Tuple 685 92),
    (Tuple 685 407),
    (Tuple 685 337),
    (Tuple 685 235),
    (Tuple 685 264),
    (Tuple 685 42),
    (Tuple 685 97),
    (Tuple 685 265),
    (Tuple 685 43),
    (Tuple 685 697),
    (Tuple 685 669),
    (Tuple 685 414),
    (Tuple 685 345),
    (Tuple 685 47),
    (Tuple 685 630),
    (Tuple 685 418),
    (Tuple 685 546),
    (Tuple 685 776),
    (Tuple 685 305),
    (Tuple 685 562),
    (Tuple 685 486),
    (Tuple 685 108),
    (Tuple 685 422),
    (Tuple 685 236),
    (Tuple 685 674),
    (Tuple 685 111),
    (Tuple 685 832),
    (Tuple 685 49),
    (Tuple 685 112),
    (Tuple 685 385),
    (Tuple 685 363),
    (Tuple 685 424),
    (Tuple 685 530),
    (Tuple 685 631),
    (Tuple 685 531),
    (Tuple 685 52),
    (Tuple 685 425),
    (Tuple 685 238),
    (Tuple 685 117),
    (Tuple 685 119),
    (Tuple 685 549),
    (Tuple 685 351),
    (Tuple 685 428),
    (Tuple 685 859),
    (Tuple 685 429),
    (Tuple 685 267),
    (Tuple 685 123),
    (Tuple 685 57),
    (Tuple 685 125),
    (Tuple 685 126),
    (Tuple 685 552),
    (Tuple 685 787),
    (Tuple 685 239),
    (Tuple 685 532),
    (Tuple 685 634),
    (Tuple 685 789),
    (Tuple 685 533),
    (Tuple 685 534),
    (Tuple 685 553),
    (Tuple 685 307),
    (Tuple 685 433),
    (Tuple 685 355),
    (Tuple 685 480),
    (Tuple 685 505),
    (Tuple 685 308),
    (Tuple 685 60),
    (Tuple 685 133),
    (Tuple 685 357),
    (Tuple 685 309),
    (Tuple 321 75),
    (Tuple 321 569),
    (Tuple 321 571),
    (Tuple 321 401),
    (Tuple 321 322),
    (Tuple 321 396),
    (Tuple 321 76),
    (Tuple 321 77),
    (Tuple 321 572),
    (Tuple 321 323),
    (Tuple 321 499),
    (Tuple 321 573),
    (Tuple 321 78),
    (Tuple 321 574),
    (Tuple 321 500),
    (Tuple 321 79),
    (Tuple 321 63),
    (Tuple 321 302),
    (Tuple 321 536),
    (Tuple 321 160),
    (Tuple 321 359),
    (Tuple 321 80),
    (Tuple 321 326),
    (Tuple 321 579),
    (Tuple 321 81),
    (Tuple 321 803),
    (Tuple 321 82),
    (Tuple 321 328),
    (Tuple 321 525),
    (Tuple 321 83),
    (Tuple 321 626),
    (Tuple 321 37),
    (Tuple 321 860),
    (Tuple 321 84),
    (Tuple 321 85),
    (Tuple 321 402),
    (Tuple 321 403),
    (Tuple 321 39),
    (Tuple 321 404),
    (Tuple 321 526),
    (Tuple 321 86),
    (Tuple 321 583),
    (Tuple 321 405),
    (Tuple 321 361),
    (Tuple 321 234),
    (Tuple 321 744),
    (Tuple 321 331),
    (Tuple 321 87),
    (Tuple 321 88),
    (Tuple 321 89),
    (Tuple 321 90),
    (Tuple 321 91),
    (Tuple 321 585),
    (Tuple 321 332),
    (Tuple 321 688),
    (Tuple 321 406),
    (Tuple 321 92),
    (Tuple 321 333),
    (Tuple 321 334),
    (Tuple 321 335),
    (Tuple 321 407),
    (Tuple 321 408),
    (Tuple 321 303),
    (Tuple 321 337),
    (Tuple 321 94),
    (Tuple 321 689),
    (Tuple 321 95),
    (Tuple 321 586),
    (Tuple 321 509),
    (Tuple 321 96),
    (Tuple 321 235),
    (Tuple 321 41),
    (Tuple 321 804),
    (Tuple 321 409),
    (Tuple 321 97),
    (Tuple 321 542),
    (Tuple 321 265),
    (Tuple 321 98),
    (Tuple 321 99),
    (Tuple 321 312),
    (Tuple 321 861),
    (Tuple 321 410),
    (Tuple 321 411),
    (Tuple 321 100),
    (Tuple 321 557),
    (Tuple 321 412),
    (Tuple 321 697),
    (Tuple 321 590),
    (Tuple 321 101),
    (Tuple 321 65),
    (Tuple 321 344),
    (Tuple 321 413),
    (Tuple 321 414),
    (Tuple 321 345),
    (Tuple 321 862),
    (Tuple 321 415),
    (Tuple 321 630),
    (Tuple 321 416),
    (Tuple 321 417),
    (Tuple 321 346),
    (Tuple 321 776),
    (Tuple 321 102),
    (Tuple 321 103),
    (Tuple 321 305),
    (Tuple 321 104),
    (Tuple 321 745),
    (Tuple 321 347),
    (Tuple 321 503),
    (Tuple 321 420),
    (Tuple 321 105),
    (Tuple 321 106),
    (Tuple 321 107),
    (Tuple 321 108),
    (Tuple 321 422),
    (Tuple 321 109),
    (Tuple 321 746),
    (Tuple 321 110),
    (Tuple 321 306),
    (Tuple 321 111),
    (Tuple 321 49),
    (Tuple 321 528),
    (Tuple 321 592),
    (Tuple 321 112),
    (Tuple 321 237),
    (Tuple 321 113),
    (Tuple 321 529),
    (Tuple 321 693),
    (Tuple 321 385),
    (Tuple 321 363),
    (Tuple 321 424),
    (Tuple 321 530),
    (Tuple 321 369),
    (Tuple 321 114),
    (Tuple 321 52),
    (Tuple 321 425),
    (Tuple 321 115),
    (Tuple 321 116),
    (Tuple 321 349),
    (Tuple 321 863),
    (Tuple 321 238),
    (Tuple 321 117),
    (Tuple 321 118),
    (Tuple 321 119),
    (Tuple 321 549),
    (Tuple 321 426),
    (Tuple 321 120),
    (Tuple 321 121),
    (Tuple 321 56),
    (Tuple 321 427),
    (Tuple 321 428),
    (Tuple 321 122),
    (Tuple 321 429),
    (Tuple 321 267),
    (Tuple 321 123),
    (Tuple 321 57),
    (Tuple 321 124),
    (Tuple 321 799),
    (Tuple 321 221),
    (Tuple 321 125),
    (Tuple 321 126),
    (Tuple 321 127),
    (Tuple 321 552),
    (Tuple 321 430),
    (Tuple 321 239),
    (Tuple 321 532),
    (Tuple 321 128),
    (Tuple 321 634),
    (Tuple 321 432),
    (Tuple 321 129),
    (Tuple 321 130),
    (Tuple 321 594),
    (Tuple 321 595),
    (Tuple 321 131),
    (Tuple 321 433),
    (Tuple 321 703),
    (Tuple 321 596),
    (Tuple 321 356),
    (Tuple 321 597),
    (Tuple 321 505),
    (Tuple 321 132),
    (Tuple 321 308),
    (Tuple 321 435),
    (Tuple 321 133),
    (Tuple 321 357),
    (Tuple 321 309),
    (Tuple 274 274),
    (Tuple 274 30),
    (Tuple 274 864),
    (Tuple 274 185),
    (Tuple 274 275),
    (Tuple 274 190),
    (Tuple 274 193),
    (Tuple 274 376),
    (Tuple 274 194),
    (Tuple 274 463),
    (Tuple 274 195),
    (Tuple 274 196),
    (Tuple 274 279),
    (Tuple 274 280),
    (Tuple 274 199),
    (Tuple 274 282),
    (Tuple 274 200),
    (Tuple 274 204),
    (Tuple 274 208),
    (Tuple 274 284),
    (Tuple 274 209),
    (Tuple 274 210),
    (Tuple 274 168),
    (Tuple 274 288),
    (Tuple 274 213),
    (Tuple 274 289),
    (Tuple 274 383),
    (Tuple 274 647),
    (Tuple 274 67),
    (Tuple 274 217),
    (Tuple 274 219),
    (Tuple 274 648),
    (Tuple 274 390),
    (Tuple 274 221),
    (Tuple 274 222),
    (Tuple 274 392),
    (Tuple 274 290),
    (Tuple 274 225),
    (Tuple 467 373),
    (Tuple 467 20),
    (Tuple 467 375),
    (Tuple 467 31),
    (Tuple 467 189),
    (Tuple 467 5),
    (Tuple 467 463),
    (Tuple 467 398),
    (Tuple 467 6),
    (Tuple 467 469),
    (Tuple 467 21),
    (Tuple 467 196),
    (Tuple 467 199),
    (Tuple 467 200),
    (Tuple 467 201),
    (Tuple 467 380),
    (Tuple 467 9),
    (Tuple 467 221),
    (Tuple 467 152),
    (Tuple 467 16),
    (Tuple 491 491),
    (Tuple 491 492),
    (Tuple 491 638),
    (Tuple 491 302),
    (Tuple 491 32),
    (Tuple 491 33),
    (Tuple 491 35),
    (Tuple 491 657),
    (Tuple 491 692),
    (Tuple 491 303),
    (Tuple 491 640),
    (Tuple 491 478),
    (Tuple 491 25),
    (Tuple 491 422),
    (Tuple 491 236),
    (Tuple 491 497),
    (Tuple 491 641),
    (Tuple 491 53),
    (Tuple 491 117),
    (Tuple 491 370),
    (Tuple 491 54),
    (Tuple 491 55),
    (Tuple 491 391),
    (Tuple 491 58),
    (Tuple 491 59),
    (Tuple 28 263),
    (Tuple 28 537),
    (Tuple 28 325),
    (Tuple 28 858),
    (Tuple 28 233),
    (Tuple 28 360),
    (Tuple 28 501),
    (Tuple 28 540),
    (Tuple 28 329),
    (Tuple 28 39),
    (Tuple 28 330),
    (Tuple 28 234),
    (Tuple 28 495),
    (Tuple 28 207),
    (Tuple 28 42),
    (Tuple 28 865),
    (Tuple 28 668),
    (Tuple 28 543),
    (Tuple 28 43),
    (Tuple 28 341),
    (Tuple 28 544),
    (Tuple 28 545),
    (Tuple 28 773),
    (Tuple 28 712),
    (Tuple 28 546),
    (Tuple 28 672),
    (Tuple 28 348),
    (Tuple 28 548),
    (Tuple 28 350),
    (Tuple 28 551),
    (Tuple 28 239),
    (Tuple 28 307),
    (Tuple 28 355),
    (Tuple 28 866),
    (Tuple 607 607),
    (Tuple 607 20),
    (Tuple 802 722),
    (Tuple 802 723),
    (Tuple 802 536),
    (Tuple 802 822),
    (Tuple 802 762),
    (Tuple 802 867),
    (Tuple 802 724),
    (Tuple 802 34),
    (Tuple 802 727),
    (Tuple 802 766),
    (Tuple 802 667),
    (Tuple 802 728),
    (Tuple 802 264),
    (Tuple 802 868),
    (Tuple 802 629),
    (Tuple 802 668),
    (Tuple 802 772),
    (Tuple 802 47),
    (Tuple 802 731),
    (Tuple 802 672),
    (Tuple 802 733),
    (Tuple 802 734),
    (Tuple 802 779),
    (Tuple 802 834),
    (Tuple 802 736),
    (Tuple 802 737),
    (Tuple 802 859),
    (Tuple 802 784),
    (Tuple 802 701),
    (Tuple 802 633),
    (Tuple 802 533),
    (Tuple 802 740),
    (Tuple 802 842),
    (Tuple 29 29),
    (Tuple 29 367),
    (Tuple 29 78),
    (Tuple 29 302),
    (Tuple 29 368),
    (Tuple 29 32),
    (Tuple 29 33),
    (Tuple 29 257),
    (Tuple 29 21),
    (Tuple 29 525),
    (Tuple 29 502),
    (Tuple 29 196),
    (Tuple 29 165),
    (Tuple 29 311),
    (Tuple 29 234),
    (Tuple 29 89),
    (Tuple 29 90),
    (Tuple 29 303),
    (Tuple 29 235),
    (Tuple 29 97),
    (Tuple 29 312),
    (Tuple 29 341),
    (Tuple 29 697),
    (Tuple 29 168),
    (Tuple 29 414),
    (Tuple 29 415),
    (Tuple 29 746),
    (Tuple 29 384),
    (Tuple 29 369),
    (Tuple 29 53),
    (Tuple 29 115),
    (Tuple 29 117),
    (Tuple 29 370),
    (Tuple 29 54),
    (Tuple 29 699),
    (Tuple 29 55),
    (Tuple 29 123),
    (Tuple 29 391),
    (Tuple 29 125),
    (Tuple 29 58),
    (Tuple 29 126),
    (Tuple 29 356),
    (Tuple 29 173),
    (Tuple 869 31),
    (Tuple 869 189),
    (Tuple 869 190),
    (Tuple 869 193),
    (Tuple 869 162),
    (Tuple 869 199),
    (Tuple 869 39),
    (Tuple 869 165),
    (Tuple 869 204),
    (Tuple 869 380),
    (Tuple 869 167),
    (Tuple 869 169),
    (Tuple 869 23),
    (Tuple 869 471),
    (Tuple 869 50),
    (Tuple 869 171),
    (Tuple 869 387),
    (Tuple 869 222),
    (Tuple 869 483),
    (Tuple 869 16),
    (Tuple 253 255),
    (Tuple 253 462),
    (Tuple 253 31),
    (Tuple 253 161),
    (Tuple 253 232),
    (Tuple 253 198),
    (Tuple 253 206),
    (Tuple 253 23),
    (Tuple 253 215),
    (Tuple 253 262),
    (Tuple 870 870),
    (Tuple 870 75),
    (Tuple 870 569),
    (Tuple 870 76),
    (Tuple 870 302),
    (Tuple 870 81),
    (Tuple 870 82),
    (Tuple 870 87),
    (Tuple 870 88),
    (Tuple 870 89),
    (Tuple 870 92),
    (Tuple 870 407),
    (Tuple 870 99),
    (Tuple 870 100),
    (Tuple 870 557),
    (Tuple 870 260),
    (Tuple 870 102),
    (Tuple 870 103),
    (Tuple 870 305),
    (Tuple 870 106),
    (Tuple 870 369),
    (Tuple 870 52),
    (Tuple 870 116),
    (Tuple 870 120),
    (Tuple 870 121),
    (Tuple 870 124),
    (Tuple 870 707),
    (Tuple 870 126),
    (Tuple 870 130),
    (Tuple 870 132),
    (Tuple 870 308),
    (Tuple 870 133),
    (Tuple 870 309),
    (Tuple 517 20),
    (Tuple 517 79),
    (Tuple 517 80),
    (Tuple 517 475),
    (Tuple 517 194),
    (Tuple 517 162),
    (Tuple 517 377),
    (Tuple 517 64),
    (Tuple 517 40),
    (Tuple 517 202),
    (Tuple 517 204),
    (Tuple 517 205),
    (Tuple 517 667),
    (Tuple 517 167),
    (Tuple 517 170),
    (Tuple 517 23),
    (Tuple 517 289),
    (Tuple 517 591),
    (Tuple 517 214),
    (Tuple 517 171),
    (Tuple 517 52),
    (Tuple 517 126),
    (Tuple 517 60),
    (Tuple 75 401),
    (Tuple 75 76),
    (Tuple 75 450),
    (Tuple 75 77),
    (Tuple 75 231),
    (Tuple 75 323),
    (Tuple 75 499),
    (Tuple 75 78),
    (Tuple 75 574),
    (Tuple 75 79),
    (Tuple 75 638),
    (Tuple 75 63),
    (Tuple 75 302),
    (Tuple 75 576),
    (Tuple 75 639),
    (Tuple 75 578),
    (Tuple 75 359),
    (Tuple 75 325),
    (Tuple 75 871),
    (Tuple 75 81),
    (Tuple 75 82),
    (Tuple 75 360),
    (Tuple 75 328),
    (Tuple 75 539),
    (Tuple 75 83),
    (Tuple 75 582),
    (Tuple 75 37),
    (Tuple 75 860),
    (Tuple 75 84),
    (Tuple 75 540),
    (Tuple 75 85),
    (Tuple 75 403),
    (Tuple 75 404),
    (Tuple 75 86),
    (Tuple 75 405),
    (Tuple 75 361),
    (Tuple 75 234),
    (Tuple 75 331),
    (Tuple 75 584),
    (Tuple 75 87),
    (Tuple 75 88),
    (Tuple 75 89),
    (Tuple 75 90),
    (Tuple 75 91),
    (Tuple 75 406),
    (Tuple 75 92),
    (Tuple 75 334),
    (Tuple 75 407),
    (Tuple 75 408),
    (Tuple 75 303),
    (Tuple 75 337),
    (Tuple 75 94),
    (Tuple 75 338),
    (Tuple 75 586),
    (Tuple 75 509),
    (Tuple 75 235),
    (Tuple 75 42),
    (Tuple 75 804),
    (Tuple 75 409),
    (Tuple 75 97),
    (Tuple 75 542),
    (Tuple 75 265),
    (Tuple 75 99),
    (Tuple 75 312),
    (Tuple 75 43),
    (Tuple 75 410),
    (Tuple 75 100),
    (Tuple 75 412),
    (Tuple 75 101),
    (Tuple 75 65),
    (Tuple 75 46),
    (Tuple 75 413),
    (Tuple 75 414),
    (Tuple 75 415),
    (Tuple 75 416),
    (Tuple 75 417),
    (Tuple 75 418),
    (Tuple 75 561),
    (Tuple 75 546),
    (Tuple 75 102),
    (Tuple 75 103),
    (Tuple 75 305),
    (Tuple 75 104),
    (Tuple 75 419),
    (Tuple 75 503),
    (Tuple 75 420),
    (Tuple 75 421),
    (Tuple 75 105),
    (Tuple 75 106),
    (Tuple 75 107),
    (Tuple 75 108),
    (Tuple 75 422),
    (Tuple 75 109),
    (Tuple 75 236),
    (Tuple 75 110),
    (Tuple 75 306),
    (Tuple 75 872),
    (Tuple 75 111),
    (Tuple 75 49),
    (Tuple 75 528),
    (Tuple 75 548),
    (Tuple 75 112),
    (Tuple 75 237),
    (Tuple 75 113),
    (Tuple 75 529),
    (Tuple 75 424),
    (Tuple 75 530),
    (Tuple 75 369),
    (Tuple 75 114),
    (Tuple 75 531),
    (Tuple 75 52),
    (Tuple 75 425),
    (Tuple 75 115),
    (Tuple 75 349),
    (Tuple 75 238),
    (Tuple 75 117),
    (Tuple 75 118),
    (Tuple 75 119),
    (Tuple 75 426),
    (Tuple 75 120),
    (Tuple 75 121),
    (Tuple 75 55),
    (Tuple 75 56),
    (Tuple 75 427),
    (Tuple 75 428),
    (Tuple 75 122),
    (Tuple 75 429),
    (Tuple 75 267),
    (Tuple 75 123),
    (Tuple 75 124),
    (Tuple 75 125),
    (Tuple 75 126),
    (Tuple 75 127),
    (Tuple 75 430),
    (Tuple 75 239),
    (Tuple 75 431),
    (Tuple 75 532),
    (Tuple 75 128),
    (Tuple 75 432),
    (Tuple 75 129),
    (Tuple 75 130),
    (Tuple 75 594),
    (Tuple 75 307),
    (Tuple 75 595),
    (Tuple 75 131),
    (Tuple 75 433),
    (Tuple 75 480),
    (Tuple 75 434),
    (Tuple 75 505),
    (Tuple 75 308),
    (Tuple 75 60),
    (Tuple 75 435),
    (Tuple 75 241),
    (Tuple 75 133),
    (Tuple 75 173),
    (Tuple 75 309),
    (Tuple 568 76),
    (Tuple 568 78),
    (Tuple 568 85),
    (Tuple 568 403),
    (Tuple 568 86),
    (Tuple 568 405),
    (Tuple 568 87),
    (Tuple 568 90),
    (Tuple 568 91),
    (Tuple 568 407),
    (Tuple 568 41),
    (Tuple 568 97),
    (Tuple 568 99),
    (Tuple 568 101),
    (Tuple 568 417),
    (Tuple 568 102),
    (Tuple 568 103),
    (Tuple 568 104),
    (Tuple 568 105),
    (Tuple 568 107),
    (Tuple 568 109),
    (Tuple 568 111),
    (Tuple 568 49),
    (Tuple 568 113),
    (Tuple 568 114),
    (Tuple 568 52),
    (Tuple 568 425),
    (Tuple 568 116),
    (Tuple 568 349),
    (Tuple 568 117),
    (Tuple 568 121),
    (Tuple 568 267),
    (Tuple 568 124),
    (Tuple 568 126),
    (Tuple 568 127),
    (Tuple 568 129),
    (Tuple 568 130),
    (Tuple 568 131),
    (Tuple 568 132),
    (Tuple 568 308),
    (Tuple 721 819),
    (Tuple 721 722),
    (Tuple 721 723),
    (Tuple 721 820),
    (Tuple 721 821),
    (Tuple 721 680),
    (Tuple 721 762),
    (Tuple 721 724),
    (Tuple 721 34),
    (Tuple 721 824),
    (Tuple 721 764),
    (Tuple 721 825),
    (Tuple 721 727),
    (Tuple 721 264),
    (Tuple 721 826),
    (Tuple 721 47),
    (Tuple 721 729),
    (Tuple 721 731),
    (Tuple 721 673),
    (Tuple 721 830),
    (Tuple 721 733),
    (Tuple 721 832),
    (Tuple 721 736),
    (Tuple 721 780),
    (Tuple 721 781),
    (Tuple 721 837),
    (Tuple 721 699),
    (Tuple 721 841),
    (Tuple 721 783),
    (Tuple 721 784),
    (Tuple 721 785),
    (Tuple 721 786),
    (Tuple 721 787),
    (Tuple 721 788),
    (Tuple 721 683),
    (Tuple 721 615),
    (Tuple 446 446),
    (Tuple 446 447),
    (Tuple 446 714),
    (Tuple 446 256),
    (Tuple 446 468),
    (Tuple 446 31),
    (Tuple 446 160),
    (Tuple 446 470),
    (Tuple 446 7),
    (Tuple 446 715),
    (Tuple 446 716),
    (Tuple 446 717),
    (Tuple 446 23),
    (Tuple 446 148),
    (Tuple 446 653),
    (Tuple 446 14),
    (Tuple 446 152),
    (Tuple 446 154),
    (Tuple 446 172),
    (Tuple 569 570),
    (Tuple 569 571),
    (Tuple 569 401),
    (Tuple 569 76),
    (Tuple 569 77),
    (Tuple 569 572),
    (Tuple 569 499),
    (Tuple 569 78),
    (Tuple 569 79),
    (Tuple 569 359),
    (Tuple 569 81),
    (Tuple 569 328),
    (Tuple 569 83),
    (Tuple 569 37),
    (Tuple 569 84),
    (Tuple 569 85),
    (Tuple 569 402),
    (Tuple 569 403),
    (Tuple 569 605),
    (Tuple 569 404),
    (Tuple 569 86),
    (Tuple 569 583),
    (Tuple 569 405),
    (Tuple 569 331),
    (Tuple 569 88),
    (Tuple 569 89),
    (Tuple 569 90),
    (Tuple 569 91),
    (Tuple 569 585),
    (Tuple 569 406),
    (Tuple 569 92),
    (Tuple 569 407),
    (Tuple 569 93),
    (Tuple 569 408),
    (Tuple 569 337),
    (Tuple 569 94),
    (Tuple 569 509),
    (Tuple 569 96),
    (Tuple 569 41),
    (Tuple 569 97),
    (Tuple 569 542),
    (Tuple 569 98),
    (Tuple 569 99),
    (Tuple 569 312),
    (Tuple 569 100),
    (Tuple 569 557),
    (Tuple 569 101),
    (Tuple 569 344),
    (Tuple 569 414),
    (Tuple 569 417),
    (Tuple 569 102),
    (Tuple 569 103),
    (Tuple 569 305),
    (Tuple 569 104),
    (Tuple 569 419),
    (Tuple 569 420),
    (Tuple 569 106),
    (Tuple 569 107),
    (Tuple 569 108),
    (Tuple 569 109),
    (Tuple 569 110),
    (Tuple 569 306),
    (Tuple 569 49),
    (Tuple 569 528),
    (Tuple 569 112),
    (Tuple 569 113),
    (Tuple 569 369),
    (Tuple 569 114),
    (Tuple 569 52),
    (Tuple 569 425),
    (Tuple 569 115),
    (Tuple 569 116),
    (Tuple 569 349),
    (Tuple 569 863),
    (Tuple 569 117),
    (Tuple 569 118),
    (Tuple 569 119),
    (Tuple 569 426),
    (Tuple 569 121),
    (Tuple 569 427),
    (Tuple 569 122),
    (Tuple 569 429),
    (Tuple 569 267),
    (Tuple 569 123),
    (Tuple 569 57),
    (Tuple 569 124),
    (Tuple 569 125),
    (Tuple 569 126),
    (Tuple 569 127),
    (Tuple 569 128),
    (Tuple 569 129),
    (Tuple 569 130),
    (Tuple 569 595),
    (Tuple 569 131),
    (Tuple 569 132),
    (Tuple 569 308),
    (Tuple 569 309),
    (Tuple 570 401),
    (Tuple 570 76),
    (Tuple 570 77),
    (Tuple 570 572),
    (Tuple 570 323),
    (Tuple 570 499),
    (Tuple 570 573),
    (Tuple 570 78),
    (Tuple 570 575),
    (Tuple 570 63),
    (Tuple 570 302),
    (Tuple 570 639),
    (Tuple 570 359),
    (Tuple 570 579),
    (Tuple 570 81),
    (Tuple 570 37),
    (Tuple 570 84),
    (Tuple 570 85),
    (Tuple 570 402),
    (Tuple 570 403),
    (Tuple 570 404),
    (Tuple 570 86),
    (Tuple 570 583),
    (Tuple 570 405),
    (Tuple 570 361),
    (Tuple 570 744),
    (Tuple 570 331),
    (Tuple 570 87),
    (Tuple 570 88),
    (Tuple 570 89),
    (Tuple 570 90),
    (Tuple 570 91),
    (Tuple 570 585),
    (Tuple 570 332),
    (Tuple 570 92),
    (Tuple 570 333),
    (Tuple 570 335),
    (Tuple 570 407),
    (Tuple 570 408),
    (Tuple 570 94),
    (Tuple 570 586),
    (Tuple 570 509),
    (Tuple 570 96),
    (Tuple 570 41),
    (Tuple 570 409),
    (Tuple 570 97),
    (Tuple 570 542),
    (Tuple 570 98),
    (Tuple 570 99),
    (Tuple 570 312),
    (Tuple 570 410),
    (Tuple 570 411),
    (Tuple 570 589),
    (Tuple 570 100),
    (Tuple 570 101),
    (Tuple 570 65),
    (Tuple 570 344),
    (Tuple 570 413),
    (Tuple 570 416),
    (Tuple 570 102),
    (Tuple 570 103),
    (Tuple 570 305),
    (Tuple 570 104),
    (Tuple 570 745),
    (Tuple 570 420),
    (Tuple 570 105),
    (Tuple 570 106),
    (Tuple 570 107),
    (Tuple 570 108),
    (Tuple 570 109),
    (Tuple 570 746),
    (Tuple 570 110),
    (Tuple 570 306),
    (Tuple 570 111),
    (Tuple 570 49),
    (Tuple 570 528),
    (Tuple 570 112),
    (Tuple 570 113),
    (Tuple 570 529),
    (Tuple 570 363),
    (Tuple 570 369),
    (Tuple 570 114),
    (Tuple 570 531),
    (Tuple 570 52),
    (Tuple 570 425),
    (Tuple 570 115),
    (Tuple 570 116),
    (Tuple 570 349),
    (Tuple 570 117),
    (Tuple 570 118),
    (Tuple 570 119),
    (Tuple 570 426),
    (Tuple 570 121),
    (Tuple 570 427),
    (Tuple 570 428),
    (Tuple 570 122),
    (Tuple 570 267),
    (Tuple 570 123),
    (Tuple 570 124),
    (Tuple 570 125),
    (Tuple 570 126),
    (Tuple 570 127),
    (Tuple 570 432),
    (Tuple 570 129),
    (Tuple 570 130),
    (Tuple 570 594),
    (Tuple 570 595),
    (Tuple 570 131),
    (Tuple 570 433),
    (Tuple 570 596),
    (Tuple 570 597),
    (Tuple 570 132),
    (Tuple 570 308),
    (Tuple 570 133),
    (Tuple 570 309),
    (Tuple 571 401),
    (Tuple 571 322),
    (Tuple 571 76),
    (Tuple 571 323),
    (Tuple 571 78),
    (Tuple 571 301),
    (Tuple 571 79),
    (Tuple 571 579),
    (Tuple 571 82),
    (Tuple 571 83),
    (Tuple 571 403),
    (Tuple 571 405),
    (Tuple 571 87),
    (Tuple 571 407),
    (Tuple 571 41),
    (Tuple 571 99),
    (Tuple 571 100),
    (Tuple 571 102),
    (Tuple 571 103),
    (Tuple 571 104),
    (Tuple 571 107),
    (Tuple 571 109),
    (Tuple 571 52),
    (Tuple 571 115),
    (Tuple 571 427),
    (Tuple 571 267),
    (Tuple 571 126),
    (Tuple 571 130),
    (Tuple 401 322),
    (Tuple 401 574),
    (Tuple 401 575),
    (Tuple 401 301),
    (Tuple 401 576),
    (Tuple 401 704),
    (Tuple 401 579),
    (Tuple 401 327),
    (Tuple 401 82),
    (Tuple 401 83),
    (Tuple 401 706),
    (Tuple 401 582),
    (Tuple 401 87),
    (Tuple 401 91),
    (Tuple 401 333),
    (Tuple 401 335),
    (Tuple 401 338),
    (Tuple 401 96),
    (Tuple 401 41),
    (Tuple 401 340),
    (Tuple 401 587),
    (Tuple 401 588),
    (Tuple 401 312),
    (Tuple 401 100),
    (Tuple 401 557),
    (Tuple 401 591),
    (Tuple 401 419),
    (Tuple 401 348),
    (Tuple 401 116),
    (Tuple 401 352),
    (Tuple 401 354),
    (Tuple 401 596),
    (Tuple 401 356),
    (Tuple 401 132),
    (Tuple 62 449),
    (Tuple 62 30),
    (Tuple 62 256),
    (Tuple 62 276),
    (Tuple 62 188),
    (Tuple 62 873),
    (Tuple 62 193),
    (Tuple 62 280),
    (Tuple 62 282),
    (Tuple 62 678),
    (Tuple 62 874),
    (Tuple 62 165),
    (Tuple 62 283),
    (Tuple 62 201),
    (Tuple 62 464),
    (Tuple 62 284),
    (Tuple 62 286),
    (Tuple 62 287),
    (Tuple 62 288),
    (Tuple 62 796),
    (Tuple 62 289),
    (Tuple 62 875),
    (Tuple 62 382),
    (Tuple 62 67),
    (Tuple 62 219),
    (Tuple 62 390),
    (Tuple 62 69),
    (Tuple 62 392),
    (Tuple 62 223),
    (Tuple 62 394),
    (Tuple 322 322),
    (Tuple 322 76),
    (Tuple 322 77),
    (Tuple 322 572),
    (Tuple 322 499),
    (Tuple 322 78),
    (Tuple 322 500),
    (Tuple 322 63),
    (Tuple 322 302),
    (Tuple 322 493),
    (Tuple 322 624),
    (Tuple 322 359),
    (Tuple 322 325),
    (Tuple 322 326),
    (Tuple 322 327),
    (Tuple 322 81),
    (Tuple 322 82),
    (Tuple 322 705),
    (Tuple 322 328),
    (Tuple 322 525),
    (Tuple 322 582),
    (Tuple 322 37),
    (Tuple 322 84),
    (Tuple 322 540),
    (Tuple 322 85),
    (Tuple 322 38),
    (Tuple 322 402),
    (Tuple 322 403),
    (Tuple 322 605),
    (Tuple 322 404),
    (Tuple 322 86),
    (Tuple 322 583),
    (Tuple 322 405),
    (Tuple 322 361),
    (Tuple 322 234),
    (Tuple 322 744),
    (Tuple 322 331),
    (Tuple 322 584),
    (Tuple 322 87),
    (Tuple 322 88),
    (Tuple 322 90),
    (Tuple 322 585),
    (Tuple 322 332),
    (Tuple 322 406),
    (Tuple 322 92),
    (Tuple 322 333),
    (Tuple 322 334),
    (Tuple 322 335),
    (Tuple 322 408),
    (Tuple 322 303),
    (Tuple 322 337),
    (Tuple 322 94),
    (Tuple 322 338),
    (Tuple 322 95),
    (Tuple 322 586),
    (Tuple 322 509),
    (Tuple 322 235),
    (Tuple 322 42),
    (Tuple 322 340),
    (Tuple 322 588),
    (Tuple 322 97),
    (Tuple 322 542),
    (Tuple 322 265),
    (Tuple 322 98),
    (Tuple 322 99),
    (Tuple 322 312),
    (Tuple 322 43),
    (Tuple 322 861),
    (Tuple 322 410),
    (Tuple 322 411),
    (Tuple 322 100),
    (Tuple 322 341),
    (Tuple 322 557),
    (Tuple 322 697),
    (Tuple 322 590),
    (Tuple 322 101),
    (Tuple 322 65),
    (Tuple 322 414),
    (Tuple 322 345),
    (Tuple 322 862),
    (Tuple 322 630),
    (Tuple 322 416),
    (Tuple 322 417),
    (Tuple 322 418),
    (Tuple 322 561),
    (Tuple 322 346),
    (Tuple 322 801),
    (Tuple 322 776),
    (Tuple 322 102),
    (Tuple 322 103),
    (Tuple 322 305),
    (Tuple 322 104),
    (Tuple 322 562),
    (Tuple 322 214),
    (Tuple 322 420),
    (Tuple 322 421),
    (Tuple 322 106),
    (Tuple 322 107),
    (Tuple 322 108),
    (Tuple 322 422),
    (Tuple 322 109),
    (Tuple 322 236),
    (Tuple 322 746),
    (Tuple 322 110),
    (Tuple 322 306),
    (Tuple 322 111),
    (Tuple 322 49),
    (Tuple 322 496),
    (Tuple 322 528),
    (Tuple 322 698),
    (Tuple 322 592),
    (Tuple 322 112),
    (Tuple 322 237),
    (Tuple 322 113),
    (Tuple 322 529),
    (Tuple 322 693),
    (Tuple 322 363),
    (Tuple 322 424),
    (Tuple 322 530),
    (Tuple 322 369),
    (Tuple 322 114),
    (Tuple 322 51),
    (Tuple 322 531),
    (Tuple 322 52),
    (Tuple 322 425),
    (Tuple 322 115),
    (Tuple 322 116),
    (Tuple 322 349),
    (Tuple 322 117),
    (Tuple 322 118),
    (Tuple 322 549),
    (Tuple 322 120),
    (Tuple 322 266),
    (Tuple 322 350),
    (Tuple 322 351),
    (Tuple 322 389),
    (Tuple 322 699),
    (Tuple 322 55),
    (Tuple 322 56),
    (Tuple 322 427),
    (Tuple 322 428),
    (Tuple 322 122),
    (Tuple 322 429),
    (Tuple 322 267),
    (Tuple 322 123),
    (Tuple 322 57),
    (Tuple 322 352),
    (Tuple 322 391),
    (Tuple 322 124),
    (Tuple 322 125),
    (Tuple 322 707),
    (Tuple 322 126),
    (Tuple 322 127),
    (Tuple 322 430),
    (Tuple 322 239),
    (Tuple 322 532),
    (Tuple 322 634),
    (Tuple 322 432),
    (Tuple 322 129),
    (Tuple 322 594),
    (Tuple 322 595),
    (Tuple 322 131),
    (Tuple 322 433),
    (Tuple 322 703),
    (Tuple 322 480),
    (Tuple 322 356),
    (Tuple 322 505),
    (Tuple 322 132),
    (Tuple 322 876),
    (Tuple 322 308),
    (Tuple 322 60),
    (Tuple 322 515),
    (Tuple 322 435),
    (Tuple 322 241),
    (Tuple 322 133),
    (Tuple 322 357),
    (Tuple 322 309),
    (Tuple 492 450),
    (Tuple 492 877),
    (Tuple 492 32),
    (Tuple 492 33),
    (Tuple 492 475),
    (Tuple 492 494),
    (Tuple 492 311),
    (Tuple 492 316),
    (Tuple 492 496),
    (Tuple 492 53),
    (Tuple 492 55),
    (Tuple 492 58),
    (Tuple 492 59),
    (Tuple 396 397),
    (Tuple 396 89),
    (Tuple 396 91),
    (Tuple 396 265),
    (Tuple 396 99),
    (Tuple 396 306),
    (Tuple 396 52),
    (Tuple 396 121),
    (Tuple 396 126),
    (Tuple 447 714),
    (Tuple 447 31),
    (Tuple 447 6),
    (Tuple 447 470),
    (Tuple 447 715),
    (Tuple 447 716),
    (Tuple 447 717),
    (Tuple 447 148),
    (Tuple 447 653),
    (Tuple 447 14),
    (Tuple 447 152),
    (Tuple 447 153),
    (Tuple 447 172),
    (Tuple 373 373),
    (Tuple 373 31),
    (Tuple 373 451),
    (Tuple 373 259),
    (Tuple 373 792),
    (Tuple 373 168),
    (Tuple 373 386),
    (Tuple 373 661),
    (Tuple 373 793),
    (Tuple 373 794),
    (Tuple 373 795),
    (Tuple 448 63),
    (Tuple 448 878),
    (Tuple 448 39),
    (Tuple 448 744),
    (Tuple 448 879),
    (Tuple 448 106),
    (Tuple 448 385),
    (Tuple 448 424),
    (Tuple 448 369),
    (Tuple 448 114),
    (Tuple 448 119),
    (Tuple 448 57),
    (Tuple 448 126),
    (Tuple 448 127),
    (Tuple 448 431),
    (Tuple 448 308),
    (Tuple 448 173),
    (Tuple 519 750),
    (Tuple 519 880),
    (Tuple 519 809),
    (Tuple 519 711),
    (Tuple 519 811),
    (Tuple 519 751),
    (Tuple 519 881),
    (Tuple 519 882),
    (Tuple 519 388),
    (Tuple 519 513),
    (Tuple 519 752),
    (Tuple 519 754),
    (Tuple 519 883),
    (Tuple 519 884),
    (Tuple 519 885),
    (Tuple 886 20),
    (Tuple 886 137),
    (Tuple 76 574),
    (Tuple 76 575),
    (Tuple 76 301),
    (Tuple 76 576),
    (Tuple 76 577),
    (Tuple 76 578),
    (Tuple 76 80),
    (Tuple 76 579),
    (Tuple 76 233),
    (Tuple 76 82),
    (Tuple 76 501),
    (Tuple 76 83),
    (Tuple 76 581),
    (Tuple 76 582),
    (Tuple 76 860),
    (Tuple 76 540),
    (Tuple 76 39),
    (Tuple 76 87),
    (Tuple 76 335),
    (Tuple 76 93),
    (Tuple 76 338),
    (Tuple 76 640),
    (Tuple 76 96),
    (Tuple 76 41),
    (Tuple 76 42),
    (Tuple 76 587),
    (Tuple 76 99),
    (Tuple 76 557),
    (Tuple 76 591),
    (Tuple 76 347),
    (Tuple 76 419),
    (Tuple 76 116),
    (Tuple 76 121),
    (Tuple 76 597),
    (Tuple 76 132),
    (Tuple 449 30),
    (Tuple 449 20),
    (Tuple 449 185),
    (Tuple 449 873),
    (Tuple 449 192),
    (Tuple 449 162),
    (Tuple 449 195),
    (Tuple 449 64),
    (Tuple 449 199),
    (Tuple 449 165),
    (Tuple 449 200),
    (Tuple 449 202),
    (Tuple 449 166),
    (Tuple 449 208),
    (Tuple 449 211),
    (Tuple 449 170),
    (Tuple 449 212),
    (Tuple 449 214),
    (Tuple 449 171),
    (Tuple 449 218),
    (Tuple 449 387),
    (Tuple 449 222),
    (Tuple 449 224),
    (Tuple 887 887),
    (Tuple 887 888),
    (Tuple 887 624),
    (Tuple 887 889),
    (Tuple 887 890),
    (Tuple 887 891),
    (Tuple 887 892),
    (Tuple 887 893),
    (Tuple 887 438),
    (Tuple 887 486),
    (Tuple 887 894),
    (Tuple 887 895),
    (Tuple 887 896),
    (Tuple 887 14),
    (Tuple 887 897),
    (Tuple 887 898),
    (Tuple 887 899),
    (Tuple 887 900),
    (Tuple 524 324),
    (Tuple 524 536),
    (Tuple 524 806),
    (Tuple 524 81),
    (Tuple 524 803),
    (Tuple 524 687),
    (Tuple 524 807),
    (Tuple 524 878),
    (Tuple 524 38),
    (Tuple 524 403),
    (Tuple 524 337),
    (Tuple 524 97),
    (Tuple 524 769),
    (Tuple 524 731),
    (Tuple 524 104),
    (Tuple 524 419),
    (Tuple 524 673),
    (Tuple 524 733),
    (Tuple 524 237),
    (Tuple 524 529),
    (Tuple 524 631),
    (Tuple 524 51),
    (Tuple 524 52),
    (Tuple 524 780),
    (Tuple 524 238),
    (Tuple 524 119),
    (Tuple 524 839),
    (Tuple 524 351),
    (Tuple 524 57),
    (Tuple 524 783),
    (Tuple 524 786),
    (Tuple 524 126),
    (Tuple 524 787),
    (Tuple 524 239),
    (Tuple 524 789),
    (Tuple 524 790),
    (Tuple 524 615),
    (Tuple 524 60),
    (Tuple 817 819),
    (Tuple 817 722),
    (Tuple 817 723),
    (Tuple 817 821),
    (Tuple 817 822),
    (Tuple 817 724),
    (Tuple 817 627),
    (Tuple 817 764),
    (Tuple 817 726),
    (Tuple 817 727),
    (Tuple 817 667),
    (Tuple 817 207),
    (Tuple 817 264),
    (Tuple 817 668),
    (Tuple 817 729),
    (Tuple 817 731),
    (Tuple 817 673),
    (Tuple 817 733),
    (Tuple 817 832),
    (Tuple 817 675),
    (Tuple 817 734),
    (Tuple 817 631),
    (Tuple 817 834),
    (Tuple 817 736),
    (Tuple 817 781),
    (Tuple 817 837),
    (Tuple 817 859),
    (Tuple 817 783),
    (Tuple 817 786),
    (Tuple 817 787),
    (Tuple 817 788),
    (Tuple 817 740),
    (Tuple 367 450),
    (Tuple 367 864),
    (Tuple 367 324),
    (Tuple 367 256),
    (Tuple 367 32),
    (Tuple 367 325),
    (Tuple 367 792),
    (Tuple 367 581),
    (Tuple 367 847),
    (Tuple 367 199),
    (Tuple 367 337),
    (Tuple 367 97),
    (Tuple 367 767),
    (Tuple 367 169),
    (Tuple 367 170),
    (Tuple 367 415),
    (Tuple 367 520),
    (Tuple 367 104),
    (Tuple 367 849),
    (Tuple 367 777),
    (Tuple 367 778),
    (Tuple 367 49),
    (Tuple 367 631),
    (Tuple 367 53),
    (Tuple 367 57),
    (Tuple 367 786),
    (Tuple 367 126),
    (Tuple 367 127),
    (Tuple 367 128),
    (Tuple 367 60),
    (Tuple 367 435),
    (Tuple 484 30),
    (Tuple 484 20),
    (Tuple 484 32),
    (Tuple 484 463),
    (Tuple 484 232),
    (Tuple 484 40),
    (Tuple 484 22),
    (Tuple 484 361),
    (Tuple 484 202),
    (Tuple 484 41),
    (Tuple 484 380),
    (Tuple 484 285),
    (Tuple 484 211),
    (Tuple 484 170),
    (Tuple 484 23),
    (Tuple 484 214),
    (Tuple 484 784),
    (Tuple 484 16),
    (Tuple 484 241),
    (Tuple 484 173),
    (Tuple 484 309),
    (Tuple 686 686),
    (Tuple 686 368),
    (Tuple 686 32),
    (Tuple 686 803),
    (Tuple 686 35),
    (Tuple 686 37),
    (Tuple 686 605),
    (Tuple 686 405),
    (Tuple 686 361),
    (Tuple 686 235),
    (Tuple 686 861),
    (Tuple 686 414),
    (Tuple 686 415),
    (Tuple 686 417),
    (Tuple 686 420),
    (Tuple 686 236),
    (Tuple 686 528),
    (Tuple 686 901),
    (Tuple 686 363),
    (Tuple 686 530),
    (Tuple 686 531),
    (Tuple 686 52),
    (Tuple 686 115),
    (Tuple 686 266),
    (Tuple 686 125),
    (Tuple 686 126),
    (Tuple 686 308),
    (Tuple 686 133),
    (Tuple 159 187),
    (Tuple 159 194),
    (Tuple 159 164),
    (Tuple 159 165),
    (Tuple 159 169),
    (Tuple 902 902),
    (Tuple 902 187),
    (Tuple 902 376),
    (Tuple 902 232),
    (Tuple 902 288),
    (Tuple 902 172),
    (Tuple 450 231),
    (Tuple 450 638),
    (Tuple 450 302),
    (Tuple 450 32),
    (Tuple 450 360),
    (Tuple 450 711),
    (Tuple 450 540),
    (Tuple 450 234),
    (Tuple 450 407),
    (Tuple 450 303),
    (Tuple 450 42),
    (Tuple 450 43),
    (Tuple 450 742),
    (Tuple 450 46),
    (Tuple 450 418),
    (Tuple 450 546),
    (Tuple 450 102),
    (Tuple 450 420),
    (Tuple 450 547),
    (Tuple 450 422),
    (Tuple 450 236),
    (Tuple 450 872),
    (Tuple 450 424),
    (Tuple 450 641),
    (Tuple 450 52),
    (Tuple 450 53),
    (Tuple 450 119),
    (Tuple 450 55),
    (Tuple 450 56),
    (Tuple 450 391),
    (Tuple 450 58),
    (Tuple 450 126),
    (Tuple 450 127),
    (Tuple 450 552),
    (Tuple 450 534),
    (Tuple 450 129),
    (Tuple 450 307),
    (Tuple 450 355),
    (Tuple 450 240),
    (Tuple 450 505),
    (Tuple 450 133),
    (Tuple 450 357),
    (Tuple 450 173),
    (Tuple 450 309),
    (Tuple 450 866),
    (Tuple 77 806),
    (Tuple 77 579),
    (Tuple 77 82),
    (Tuple 77 83),
    (Tuple 77 85),
    (Tuple 77 38),
    (Tuple 77 402),
    (Tuple 77 405),
    (Tuple 77 584),
    (Tuple 77 87),
    (Tuple 77 332),
    (Tuple 77 688),
    (Tuple 77 333),
    (Tuple 77 334),
    (Tuple 77 335),
    (Tuple 77 337),
    (Tuple 77 338),
    (Tuple 77 689),
    (Tuple 77 95),
    (Tuple 77 41),
    (Tuple 77 340),
    (Tuple 77 587),
    (Tuple 77 588),
    (Tuple 77 98),
    (Tuple 77 312),
    (Tuple 77 557),
    (Tuple 77 412),
    (Tuple 77 342),
    (Tuple 77 590),
    (Tuple 77 862),
    (Tuple 77 416),
    (Tuple 77 103),
    (Tuple 77 305),
    (Tuple 77 672),
    (Tuple 77 347),
    (Tuple 77 419),
    (Tuple 77 420),
    (Tuple 77 106),
    (Tuple 77 746),
    (Tuple 77 348),
    (Tuple 77 592),
    (Tuple 77 863),
    (Tuple 77 426),
    (Tuple 77 120),
    (Tuple 77 532),
    (Tuple 77 703),
    (Tuple 77 903),
    (Tuple 473 474),
    (Tuple 473 361),
    (Tuple 473 476),
    (Tuple 473 477),
    (Tuple 473 50),
    (Tuple 473 115),
    (Tuple 473 479),
    (Tuple 904 437),
    (Tuple 904 16),
    (Tuple 30 864),
    (Tuple 30 20),
    (Tuple 30 375),
    (Tuple 30 873),
    (Tuple 30 190),
    (Tuple 30 195),
    (Tuple 30 453),
    (Tuple 30 257),
    (Tuple 30 21),
    (Tuple 30 258),
    (Tuple 30 64),
    (Tuple 30 259),
    (Tuple 30 282),
    (Tuple 30 39),
    (Tuple 30 165),
    (Tuple 30 200),
    (Tuple 30 201),
    (Tuple 30 202),
    (Tuple 30 166),
    (Tuple 30 208),
    (Tuple 30 211),
    (Tuple 30 288),
    (Tuple 30 213),
    (Tuple 30 23),
    (Tuple 30 646),
    (Tuple 30 66),
    (Tuple 30 67),
    (Tuple 30 390),
    (Tuple 30 68),
    (Tuple 30 222),
    (Tuple 30 905),
    (Tuple 30 460),
    (Tuple 30 797),
    (Tuple 184 184),
    (Tuple 184 186),
    (Tuple 184 187),
    (Tuple 184 189),
    (Tuple 184 160),
    (Tuple 184 190),
    (Tuple 184 191),
    (Tuple 184 192),
    (Tuple 184 376),
    (Tuple 184 194),
    (Tuple 184 162),
    (Tuple 184 195),
    (Tuple 184 21),
    (Tuple 184 196),
    (Tuple 184 166),
    (Tuple 184 208),
    (Tuple 184 209),
    (Tuple 184 211),
    (Tuple 184 23),
    (Tuple 184 215),
    (Tuple 184 66),
    (Tuple 184 218),
    (Tuple 184 387),
    (Tuple 184 392),
    (Tuple 184 223),
    (Tuple 184 224),
    (Tuple 397 397),
    (Tuple 397 91),
    (Tuple 397 863),
    (Tuple 397 56),
    (Tuple 572 572),
    (Tuple 572 573),
    (Tuple 572 574),
    (Tuple 572 359),
    (Tuple 572 326),
    (Tuple 572 328),
    (Tuple 572 83),
    (Tuple 572 581),
    (Tuple 572 84),
    (Tuple 572 85),
    (Tuple 572 38),
    (Tuple 572 402),
    (Tuple 572 744),
    (Tuple 572 87),
    (Tuple 572 332),
    (Tuple 572 408),
    (Tuple 572 337),
    (Tuple 572 94),
    (Tuple 572 340),
    (Tuple 572 587),
    (Tuple 572 542),
    (Tuple 572 98),
    (Tuple 572 312),
    (Tuple 572 411),
    (Tuple 572 100),
    (Tuple 572 342),
    (Tuple 572 346),
    (Tuple 572 102),
    (Tuple 572 103),
    (Tuple 572 347),
    (Tuple 572 420),
    (Tuple 572 106),
    (Tuple 572 108),
    (Tuple 572 49),
    (Tuple 572 528),
    (Tuple 572 114),
    (Tuple 572 52),
    (Tuple 572 349),
    (Tuple 572 124),
    (Tuple 572 707),
    (Tuple 572 126),
    (Tuple 572 354),
    (Tuple 572 131),
    (Tuple 572 435),
    (Tuple 818 663),
    (Tuple 818 722),
    (Tuple 818 888),
    (Tuple 818 723),
    (Tuple 818 822),
    (Tuple 818 724),
    (Tuple 818 627),
    (Tuple 818 764),
    (Tuple 818 726),
    (Tuple 818 727),
    (Tuple 818 766),
    (Tuple 818 667),
    (Tuple 818 728),
    (Tuple 818 868),
    (Tuple 818 668),
    (Tuple 818 906),
    (Tuple 818 731),
    (Tuple 818 672),
    (Tuple 818 831),
    (Tuple 818 675),
    (Tuple 818 734),
    (Tuple 818 907),
    (Tuple 818 834),
    (Tuple 818 736),
    (Tuple 818 737),
    (Tuple 818 908),
    (Tuple 818 738),
    (Tuple 818 859),
    (Tuple 818 909),
    (Tuple 818 740),
    (Tuple 818 910),
    (Tuple 231 325),
    (Tuple 231 871),
    (Tuple 231 233),
    (Tuple 231 539),
    (Tuple 231 711),
    (Tuple 231 540),
    (Tuple 231 659),
    (Tuple 231 42),
    (Tuple 231 543),
    (Tuple 231 43),
    (Tuple 231 560),
    (Tuple 231 544),
    (Tuple 231 545),
    (Tuple 231 46),
    (Tuple 231 561),
    (Tuple 231 546),
    (Tuple 231 872),
    (Tuple 231 548),
    (Tuple 231 551),
    (Tuple 231 554),
    (Tuple 231 563),
    (Tuple 231 307),
    (Tuple 231 355),
    (Tuple 231 911),
    (Tuple 231 564),
    (Tuple 231 240),
    (Tuple 231 866),
    (Tuple 323 573),
    (Tuple 323 500),
    (Tuple 323 579),
    (Tuple 323 867),
    (Tuple 323 327),
    (Tuple 323 82),
    (Tuple 323 83),
    (Tuple 323 706),
    (Tuple 323 84),
    (Tuple 323 85),
    (Tuple 323 402),
    (Tuple 323 405),
    (Tuple 323 87),
    (Tuple 323 91),
    (Tuple 323 332),
    (Tuple 323 688),
    (Tuple 323 335),
    (Tuple 323 689),
    (Tuple 323 207),
    (Tuple 323 339),
    (Tuple 323 340),
    (Tuple 323 587),
    (Tuple 323 588),
    (Tuple 323 98),
    (Tuple 323 312),
    (Tuple 323 861),
    (Tuple 323 100),
    (Tuple 323 557),
    (Tuple 323 342),
    (Tuple 323 103),
    (Tuple 323 591),
    (Tuple 323 347),
    (Tuple 323 348),
    (Tuple 323 592),
    (Tuple 323 116),
    (Tuple 323 120),
    (Tuple 323 350),
    (Tuple 323 703),
    (Tuple 323 596),
    (Tuple 323 356),
    (Tuple 323 132),
    (Tuple 499 573),
    (Tuple 499 574),
    (Tuple 499 500),
    (Tuple 499 325),
    (Tuple 499 326),
    (Tuple 499 327),
    (Tuple 499 81),
    (Tuple 499 687),
    (Tuple 499 83),
    (Tuple 499 581),
    (Tuple 499 706),
    (Tuple 499 38),
    (Tuple 499 402),
    (Tuple 499 87),
    (Tuple 499 332),
    (Tuple 499 688),
    (Tuple 499 912),
    (Tuple 499 333),
    (Tuple 499 334),
    (Tuple 499 335),
    (Tuple 499 337),
    (Tuple 499 338),
    (Tuple 499 689),
    (Tuple 499 95),
    (Tuple 499 207),
    (Tuple 499 340),
    (Tuple 499 587),
    (Tuple 499 588),
    (Tuple 499 668),
    (Tuple 499 98),
    (Tuple 499 100),
    (Tuple 499 341),
    (Tuple 499 557),
    (Tuple 499 590),
    (Tuple 499 414),
    (Tuple 499 862),
    (Tuple 499 416),
    (Tuple 499 103),
    (Tuple 499 305),
    (Tuple 499 745),
    (Tuple 499 562),
    (Tuple 499 347),
    (Tuple 499 419),
    (Tuple 499 106),
    (Tuple 499 746),
    (Tuple 499 348),
    (Tuple 499 592),
    (Tuple 499 693),
    (Tuple 499 530),
    (Tuple 499 863),
    (Tuple 499 426),
    (Tuple 499 120),
    (Tuple 499 350),
    (Tuple 499 351),
    (Tuple 499 352),
    (Tuple 499 124),
    (Tuple 499 125),
    (Tuple 499 676),
    (Tuple 499 703),
    (Tuple 499 596),
    (Tuple 499 356),
    (Tuple 499 435),
    (Tuple 499 866),
    (Tuple 637 637),
    (Tuple 637 638),
    (Tuple 637 539),
    (Tuple 637 540),
    (Tuple 637 640),
    (Tuple 637 42),
    (Tuple 637 43),
    (Tuple 637 46),
    (Tuple 637 546),
    (Tuple 637 641),
    (Tuple 637 550),
    (Tuple 637 307),
    (Tuple 637 355),
    (Tuple 637 480),
    (Tuple 637 911),
    (Tuple 913 292),
    (Tuple 913 914),
    (Tuple 913 915),
    (Tuple 913 293),
    (Tuple 913 916),
    (Tuple 913 294),
    (Tuple 913 295),
    (Tuple 913 296),
    (Tuple 913 297),
    (Tuple 864 189),
    (Tuple 864 190),
    (Tuple 864 463),
    (Tuple 864 21),
    (Tuple 864 259),
    (Tuple 864 279),
    (Tuple 864 199),
    (Tuple 864 678),
    (Tuple 864 165),
    (Tuple 864 200),
    (Tuple 864 203),
    (Tuple 864 170),
    (Tuple 864 212),
    (Tuple 864 214),
    (Tuple 864 67),
    (Tuple 864 218),
    (Tuple 864 53),
    (Tuple 864 387),
    (Tuple 864 68),
    (Tuple 864 69),
    (Tuple 749 880),
    (Tuple 749 809),
    (Tuple 749 811),
    (Tuple 749 751),
    (Tuple 749 882),
    (Tuple 749 388),
    (Tuple 749 513),
    (Tuple 749 752),
    (Tuple 749 753),
    (Tuple 749 754),
    (Tuple 749 883),
    (Tuple 749 755),
    (Tuple 749 884),
    (Tuple 663 514),
    (Tuple 573 78),
    (Tuple 573 574),
    (Tuple 573 359),
    (Tuple 573 81),
    (Tuple 573 83),
    (Tuple 573 38),
    (Tuple 573 404),
    (Tuple 573 526),
    (Tuple 573 583),
    (Tuple 573 331),
    (Tuple 573 87),
    (Tuple 573 91),
    (Tuple 573 92),
    (Tuple 573 408),
    (Tuple 573 337),
    (Tuple 573 338),
    (Tuple 573 587),
    (Tuple 573 97),
    (Tuple 573 542),
    (Tuple 573 98),
    (Tuple 573 410),
    (Tuple 573 100),
    (Tuple 573 697),
    (Tuple 573 413),
    (Tuple 573 345),
    (Tuple 573 102),
    (Tuple 573 103),
    (Tuple 573 305),
    (Tuple 573 420),
    (Tuple 573 105),
    (Tuple 573 106),
    (Tuple 573 108),
    (Tuple 573 109),
    (Tuple 573 110),
    (Tuple 573 49),
    (Tuple 573 112),
    (Tuple 573 530),
    (Tuple 573 114),
    (Tuple 573 531),
    (Tuple 573 52),
    (Tuple 573 425),
    (Tuple 573 116),
    (Tuple 573 349),
    (Tuple 573 118),
    (Tuple 573 549),
    (Tuple 573 120),
    (Tuple 573 350),
    (Tuple 573 427),
    (Tuple 573 267),
    (Tuple 573 352),
    (Tuple 573 124),
    (Tuple 573 430),
    (Tuple 573 239),
    (Tuple 573 595),
    (Tuple 573 131),
    (Tuple 573 433),
    (Tuple 573 703),
    (Tuple 573 309),
    (Tuple 20 254),
    (Tuple 20 617),
    (Tuple 20 256),
    (Tuple 20 462),
    (Tuple 20 482),
    (Tuple 20 186),
    (Tuple 20 275),
    (Tuple 20 873),
    (Tuple 20 193),
    (Tuple 20 463),
    (Tuple 20 644),
    (Tuple 20 162),
    (Tuple 20 195),
    (Tuple 20 453),
    (Tuple 20 277),
    (Tuple 20 233),
    (Tuple 20 257),
    (Tuple 20 377),
    (Tuple 20 258),
    (Tuple 20 501),
    (Tuple 20 259),
    (Tuple 20 197),
    (Tuple 20 278),
    (Tuple 20 279),
    (Tuple 20 917),
    (Tuple 20 282),
    (Tuple 20 39),
    (Tuple 20 200),
    (Tuple 20 283),
    (Tuple 20 201),
    (Tuple 20 202),
    (Tuple 20 204),
    (Tuple 20 205),
    (Tuple 20 208),
    (Tuple 20 284),
    (Tuple 20 288),
    (Tuple 20 25),
    (Tuple 20 212),
    (Tuple 20 796),
    (Tuple 20 511),
    (Tuple 20 645),
    (Tuple 20 23),
    (Tuple 20 289),
    (Tuple 20 506),
    (Tuple 20 383),
    (Tuple 20 66),
    (Tuple 20 647),
    (Tuple 20 660),
    (Tuple 20 217),
    (Tuple 20 261),
    (Tuple 20 219),
    (Tuple 20 654),
    (Tuple 20 390),
    (Tuple 20 649),
    (Tuple 20 68),
    (Tuple 20 618),
    (Tuple 20 394),
    (Tuple 20 797),
    (Tuple 3 610),
    (Tuple 3 136),
    (Tuple 3 137),
    (Tuple 3 138),
    (Tuple 3 31),
    (Tuple 3 139),
    (Tuple 3 851),
    (Tuple 3 140),
    (Tuple 3 141),
    (Tuple 3 398),
    (Tuple 3 142),
    (Tuple 3 143),
    (Tuple 3 454),
    (Tuple 3 7),
    (Tuple 3 144),
    (Tuple 3 611),
    (Tuple 3 852),
    (Tuple 3 455),
    (Tuple 3 8),
    (Tuple 3 146),
    (Tuple 3 9),
    (Tuple 3 10),
    (Tuple 3 11),
    (Tuple 3 12),
    (Tuple 3 918),
    (Tuple 3 919),
    (Tuple 3 608),
    (Tuple 3 148),
    (Tuple 3 13),
    (Tuple 3 456),
    (Tuple 3 660),
    (Tuple 3 386),
    (Tuple 3 14),
    (Tuple 3 661),
    (Tuple 3 149),
    (Tuple 3 15),
    (Tuple 3 150),
    (Tuple 3 151),
    (Tuple 3 457),
    (Tuple 3 458),
    (Tuple 3 459),
    (Tuple 3 612),
    (Tuple 3 153),
    (Tuple 3 853),
    (Tuple 3 920),
    (Tuple 3 155),
    (Tuple 3 613),
    (Tuple 819 722),
    (Tuple 819 723),
    (Tuple 819 160),
    (Tuple 819 724),
    (Tuple 819 34),
    (Tuple 819 725),
    (Tuple 819 681),
    (Tuple 819 764),
    (Tuple 819 726),
    (Tuple 819 727),
    (Tuple 819 766),
    (Tuple 819 667),
    (Tuple 819 728),
    (Tuple 819 769),
    (Tuple 819 730),
    (Tuple 819 731),
    (Tuple 819 670),
    (Tuple 819 672),
    (Tuple 819 675),
    (Tuple 819 734),
    (Tuple 819 735),
    (Tuple 819 834),
    (Tuple 819 736),
    (Tuple 819 835),
    (Tuple 819 737),
    (Tuple 819 908),
    (Tuple 819 738),
    (Tuple 819 838),
    (Tuple 819 739),
    (Tuple 819 676),
    (Tuple 819 633),
    (Tuple 819 740),
    (Tuple 750 750),
    (Tuple 750 880),
    (Tuple 750 809),
    (Tuple 750 810),
    (Tuple 750 751),
    (Tuple 750 513),
    (Tuple 254 277),
    (Tuple 254 205),
    (Tuple 254 206),
    (Tuple 254 286),
    (Tuple 254 168),
    (Tuple 254 511),
    (Tuple 254 215),
    (Tuple 254 262),
    (Tuple 610 610),
    (Tuple 610 136),
    (Tuple 610 851),
    (Tuple 610 5),
    (Tuple 610 140),
    (Tuple 610 141),
    (Tuple 610 142),
    (Tuple 610 454),
    (Tuple 610 8),
    (Tuple 610 146),
    (Tuple 610 10),
    (Tuple 610 11),
    (Tuple 610 608),
    (Tuple 610 148),
    (Tuple 610 13),
    (Tuple 610 456),
    (Tuple 610 14),
    (Tuple 610 150),
    (Tuple 610 457),
    (Tuple 610 612),
    (Tuple 610 154),
    (Tuple 610 613),
    (Tuple 474 474),
    (Tuple 474 78),
    (Tuple 474 257),
    (Tuple 474 311),
    (Tuple 474 361),
    (Tuple 474 476),
    (Tuple 474 477),
    (Tuple 474 67),
    (Tuple 474 50),
    (Tuple 474 115),
    (Tuple 474 479),
    (Tuple 474 618),
    (Tuple 921 404),
    (Tuple 921 417),
    (Tuple 921 107),
    (Tuple 921 306),
    (Tuple 921 119),
    (Tuple 921 55),
    (Tuple 921 57),
    (Tuple 921 126),
    (Tuple 922 762),
    (Tuple 922 34),
    (Tuple 922 824),
    (Tuple 922 627),
    (Tuple 922 825),
    (Tuple 922 264),
    (Tuple 922 629),
    (Tuple 922 772),
    (Tuple 922 682),
    (Tuple 922 673),
    (Tuple 922 832),
    (Tuple 922 363),
    (Tuple 922 837),
    (Tuple 922 923),
    (Tuple 922 786),
    (Tuple 922 789),
    (Tuple 922 790),
    (Tuple 760 760),
    (Tuple 760 845),
    (Tuple 760 761),
    (Tuple 760 763),
    (Tuple 760 846),
    (Tuple 760 847),
    (Tuple 760 765),
    (Tuple 760 767),
    (Tuple 760 771),
    (Tuple 760 415),
    (Tuple 760 848),
    (Tuple 760 776),
    (Tuple 760 503),
    (Tuple 760 849),
    (Tuple 760 850),
    (Tuple 760 777),
    (Tuple 760 778),
    (Tuple 760 832),
    (Tuple 760 363),
    (Tuple 760 57),
    (Tuple 760 532),
    (Tuple 760 791),
    (Tuple 924 914),
    (Tuple 924 915),
    (Tuple 924 293),
    (Tuple 924 294),
    (Tuple 924 295),
    (Tuple 924 296),
    (Tuple 924 297),
    (Tuple 664 806),
    (Tuple 664 629),
    (Tuple 664 772),
    (Tuple 664 674),
    (Tuple 664 385),
    (Tuple 664 424),
    (Tuple 664 782),
    (Tuple 664 841),
    (Tuple 664 786),
    (Tuple 78 574),
    (Tuple 78 575),
    (Tuple 78 263),
    (Tuple 78 301),
    (Tuple 78 368),
    (Tuple 78 80),
    (Tuple 78 325),
    (Tuple 78 579),
    (Tuple 78 867),
    (Tuple 78 327),
    (Tuple 78 81),
    (Tuple 78 925),
    (Tuple 78 82),
    (Tuple 78 705),
    (Tuple 78 258),
    (Tuple 78 501),
    (Tuple 78 83),
    (Tuple 78 580),
    (Tuple 78 259),
    (Tuple 78 581),
    (Tuple 78 706),
    (Tuple 78 582),
    (Tuple 78 540),
    (Tuple 78 38),
    (Tuple 78 402),
    (Tuple 78 39),
    (Tuple 78 583),
    (Tuple 78 405),
    (Tuple 78 234),
    (Tuple 78 584),
    (Tuple 78 87),
    (Tuple 78 332),
    (Tuple 78 688),
    (Tuple 78 333),
    (Tuple 78 334),
    (Tuple 78 335),
    (Tuple 78 337),
    (Tuple 78 338),
    (Tuple 78 689),
    (Tuple 78 207),
    (Tuple 78 926),
    (Tuple 78 41),
    (Tuple 78 339),
    (Tuple 78 42),
    (Tuple 78 340),
    (Tuple 78 587),
    (Tuple 78 588),
    (Tuple 78 668),
    (Tuple 78 98),
    (Tuple 78 99),
    (Tuple 78 312),
    (Tuple 78 100),
    (Tuple 78 341),
    (Tuple 78 557),
    (Tuple 78 342),
    (Tuple 78 343),
    (Tuple 78 416),
    (Tuple 78 346),
    (Tuple 78 690),
    (Tuple 78 103),
    (Tuple 78 745),
    (Tuple 78 591),
    (Tuple 78 347),
    (Tuple 78 419),
    (Tuple 78 420),
    (Tuple 78 106),
    (Tuple 78 746),
    (Tuple 78 348),
    (Tuple 78 528),
    (Tuple 78 693),
    (Tuple 78 369),
    (Tuple 78 114),
    (Tuple 78 425),
    (Tuple 78 116),
    (Tuple 78 863),
    (Tuple 78 426),
    (Tuple 78 120),
    (Tuple 78 121),
    (Tuple 78 350),
    (Tuple 78 427),
    (Tuple 78 428),
    (Tuple 78 859),
    (Tuple 78 352),
    (Tuple 78 125),
    (Tuple 78 430),
    (Tuple 78 354),
    (Tuple 78 633),
    (Tuple 78 703),
    (Tuple 78 596),
    (Tuple 78 597),
    (Tuple 78 132),
    (Tuple 78 866),
    (Tuple 574 574),
    (Tuple 574 500),
    (Tuple 574 79),
    (Tuple 574 81),
    (Tuple 574 328),
    (Tuple 574 37),
    (Tuple 574 86),
    (Tuple 574 405),
    (Tuple 574 361),
    (Tuple 574 331),
    (Tuple 574 87),
    (Tuple 574 88),
    (Tuple 574 89),
    (Tuple 574 406),
    (Tuple 574 92),
    (Tuple 574 408),
    (Tuple 574 337),
    (Tuple 574 94),
    (Tuple 574 586),
    (Tuple 574 509),
    (Tuple 574 235),
    (Tuple 574 41),
    (Tuple 574 42),
    (Tuple 574 409),
    (Tuple 574 97),
    (Tuple 574 542),
    (Tuple 574 265),
    (Tuple 574 99),
    (Tuple 574 410),
    (Tuple 574 101),
    (Tuple 574 413),
    (Tuple 574 414),
    (Tuple 574 417),
    (Tuple 574 102),
    (Tuple 574 103),
    (Tuple 574 104),
    (Tuple 574 420),
    (Tuple 574 421),
    (Tuple 574 107),
    (Tuple 574 108),
    (Tuple 574 422),
    (Tuple 574 109),
    (Tuple 574 306),
    (Tuple 574 111),
    (Tuple 574 49),
    (Tuple 574 528),
    (Tuple 574 112),
    (Tuple 574 237),
    (Tuple 574 113),
    (Tuple 574 363),
    (Tuple 574 424),
    (Tuple 574 530),
    (Tuple 574 369),
    (Tuple 574 114),
    (Tuple 574 52),
    (Tuple 574 425),
    (Tuple 574 115),
    (Tuple 574 116),
    (Tuple 574 238),
    (Tuple 574 593),
    (Tuple 574 117),
    (Tuple 574 118),
    (Tuple 574 119),
    (Tuple 574 120),
    (Tuple 574 121),
    (Tuple 574 427),
    (Tuple 574 428),
    (Tuple 574 122),
    (Tuple 574 267),
    (Tuple 574 123),
    (Tuple 574 124),
    (Tuple 574 125),
    (Tuple 574 126),
    (Tuple 574 127),
    (Tuple 574 239),
    (Tuple 574 128),
    (Tuple 574 129),
    (Tuple 574 130),
    (Tuple 574 594),
    (Tuple 574 131),
    (Tuple 574 433),
    (Tuple 574 132),
    (Tuple 574 308),
    (Tuple 574 435),
    (Tuple 574 133),
    (Tuple 574 309),
    (Tuple 255 232),
    (Tuple 255 215),
    (Tuple 255 262),
    (Tuple 575 403),
    (Tuple 575 404),
    (Tuple 575 405),
    (Tuple 575 603),
    (Tuple 575 87),
    (Tuple 575 89),
    (Tuple 575 90),
    (Tuple 575 91),
    (Tuple 575 332),
    (Tuple 575 407),
    (Tuple 575 93),
    (Tuple 575 509),
    (Tuple 575 41),
    (Tuple 575 97),
    (Tuple 575 98),
    (Tuple 575 99),
    (Tuple 575 102),
    (Tuple 575 103),
    (Tuple 575 104),
    (Tuple 575 107),
    (Tuple 575 109),
    (Tuple 575 111),
    (Tuple 575 113),
    (Tuple 575 114),
    (Tuple 575 52),
    (Tuple 575 116),
    (Tuple 575 349),
    (Tuple 575 118),
    (Tuple 575 267),
    (Tuple 575 126),
    (Tuple 575 129),
    (Tuple 575 130),
    (Tuple 575 594),
    (Tuple 927 927),
    (Tuple 927 877),
    (Tuple 927 657),
    (Tuple 927 311),
    (Tuple 927 361),
    (Tuple 927 928),
    (Tuple 927 266),
    (Tuple 927 431),
    (Tuple 927 173),
    (Tuple 4 137),
    (Tuple 4 138),
    (Tuple 4 31),
    (Tuple 4 5),
    (Tuple 4 165),
    (Tuple 4 361),
    (Tuple 4 144),
    (Tuple 4 485),
    (Tuple 4 167),
    (Tuple 4 148),
    (Tuple 4 660),
    (Tuple 4 14),
    (Tuple 4 15),
    (Tuple 4 151),
    (Tuple 4 152),
    (Tuple 4 16),
    (Tuple 722 723),
    (Tuple 722 679),
    (Tuple 722 536),
    (Tuple 722 359),
    (Tuple 722 821),
    (Tuple 722 680),
    (Tuple 722 822),
    (Tuple 722 762),
    (Tuple 722 803),
    (Tuple 722 724),
    (Tuple 722 929),
    (Tuple 722 823),
    (Tuple 722 34),
    (Tuple 722 626),
    (Tuple 722 824),
    (Tuple 722 627),
    (Tuple 722 527),
    (Tuple 722 764),
    (Tuple 722 825),
    (Tuple 722 727),
    (Tuple 722 766),
    (Tuple 722 667),
    (Tuple 722 728),
    (Tuple 722 264),
    (Tuple 722 826),
    (Tuple 722 800),
    (Tuple 722 804),
    (Tuple 722 696),
    (Tuple 722 827),
    (Tuple 722 828),
    (Tuple 722 829),
    (Tuple 722 770),
    (Tuple 722 771),
    (Tuple 722 772),
    (Tuple 722 669),
    (Tuple 722 345),
    (Tuple 722 47),
    (Tuple 722 729),
    (Tuple 722 730),
    (Tuple 722 731),
    (Tuple 722 682),
    (Tuple 722 775),
    (Tuple 722 776),
    (Tuple 722 745),
    (Tuple 722 673),
    (Tuple 722 830),
    (Tuple 722 831),
    (Tuple 722 733),
    (Tuple 722 832),
    (Tuple 722 734),
    (Tuple 722 295),
    (Tuple 722 698),
    (Tuple 722 735),
    (Tuple 722 529),
    (Tuple 722 385),
    (Tuple 722 363),
    (Tuple 722 833),
    (Tuple 722 631),
    (Tuple 722 779),
    (Tuple 722 736),
    (Tuple 722 780),
    (Tuple 722 781),
    (Tuple 722 836),
    (Tuple 722 837),
    (Tuple 722 782),
    (Tuple 722 238),
    (Tuple 722 738),
    (Tuple 722 838),
    (Tuple 722 839),
    (Tuple 722 632),
    (Tuple 722 699),
    (Tuple 722 429),
    (Tuple 722 840),
    (Tuple 722 57),
    (Tuple 722 841),
    (Tuple 722 783),
    (Tuple 722 784),
    (Tuple 722 353),
    (Tuple 722 785),
    (Tuple 722 786),
    (Tuple 722 787),
    (Tuple 722 788),
    (Tuple 722 701),
    (Tuple 722 514),
    (Tuple 722 789),
    (Tuple 722 533),
    (Tuple 722 683),
    (Tuple 722 790),
    (Tuple 722 393),
    (Tuple 722 615),
    (Tuple 722 515),
    (Tuple 722 842),
    (Tuple 722 843),
    (Tuple 722 910),
    (Tuple 324 324),
    (Tuple 324 500),
    (Tuple 324 806),
    (Tuple 324 695),
    (Tuple 324 525),
    (Tuple 324 207),
    (Tuple 324 97),
    (Tuple 324 668),
    (Tuple 324 767),
    (Tuple 324 312),
    (Tuple 324 773),
    (Tuple 324 672),
    (Tuple 324 778),
    (Tuple 324 674),
    (Tuple 324 907),
    (Tuple 324 363),
    (Tuple 324 424),
    (Tuple 324 530),
    (Tuple 324 267),
    (Tuple 324 60),
    (Tuple 263 263),
    (Tuple 263 930),
    (Tuple 263 536),
    (Tuple 263 368),
    (Tuple 263 359),
    (Tuple 263 325),
    (Tuple 263 803),
    (Tuple 263 328),
    (Tuple 263 525),
    (Tuple 263 234),
    (Tuple 263 235),
    (Tuple 263 42),
    (Tuple 263 800),
    (Tuple 263 804),
    (Tuple 263 97),
    (Tuple 263 265),
    (Tuple 263 43),
    (Tuple 263 861),
    (Tuple 263 410),
    (Tuple 263 341),
    (Tuple 263 362),
    (Tuple 263 343),
    (Tuple 263 418),
    (Tuple 263 546),
    (Tuple 263 775),
    (Tuple 263 776),
    (Tuple 263 102),
    (Tuple 263 105),
    (Tuple 263 733),
    (Tuple 263 422),
    (Tuple 263 236),
    (Tuple 263 111),
    (Tuple 263 49),
    (Tuple 263 295),
    (Tuple 263 698),
    (Tuple 263 237),
    (Tuple 263 529),
    (Tuple 263 385),
    (Tuple 263 363),
    (Tuple 263 530),
    (Tuple 263 631),
    (Tuple 263 369),
    (Tuple 263 531),
    (Tuple 263 52),
    (Tuple 263 781),
    (Tuple 263 349),
    (Tuple 263 238),
    (Tuple 263 266),
    (Tuple 263 350),
    (Tuple 263 699),
    (Tuple 263 56),
    (Tuple 263 428),
    (Tuple 263 267),
    (Tuple 263 123),
    (Tuple 263 125),
    (Tuple 263 787),
    (Tuple 263 430),
    (Tuple 263 239),
    (Tuple 263 532),
    (Tuple 263 307),
    (Tuple 263 433),
    (Tuple 263 60),
    (Tuple 263 357),
    (Tuple 930 930),
    (Tuple 930 31),
    (Tuple 930 266),
    (Tuple 617 617),
    (Tuple 617 22),
    (Tuple 617 9),
    (Tuple 617 285),
    (Tuple 617 222),
    (Tuple 136 136),
    (Tuple 136 137),
    (Tuple 136 468),
    (Tuple 136 138),
    (Tuple 136 31),
    (Tuple 136 139),
    (Tuple 136 851),
    (Tuple 136 5),
    (Tuple 136 140),
    (Tuple 136 143),
    (Tuple 136 7),
    (Tuple 136 144),
    (Tuple 136 145),
    (Tuple 136 8),
    (Tuple 136 9),
    (Tuple 136 10),
    (Tuple 136 11),
    (Tuple 136 12),
    (Tuple 136 260),
    (Tuple 136 608),
    (Tuple 136 148),
    (Tuple 136 13),
    (Tuple 136 456),
    (Tuple 136 660),
    (Tuple 136 14),
    (Tuple 136 15),
    (Tuple 136 150),
    (Tuple 136 151),
    (Tuple 136 457),
    (Tuple 136 459),
    (Tuple 136 612),
    (Tuple 136 153),
    (Tuple 136 154),
    (Tuple 136 155),
    (Tuple 714 437),
    (Tuple 714 256),
    (Tuple 714 468),
    (Tuple 714 470),
    (Tuple 714 260),
    (Tuple 714 716),
    (Tuple 714 653),
    (Tuple 714 151),
    (Tuple 714 152),
    (Tuple 714 172),
    (Tuple 137 256),
    (Tuple 137 468),
    (Tuple 137 275),
    (Tuple 137 139),
    (Tuple 137 851),
    (Tuple 137 140),
    (Tuple 137 463),
    (Tuple 137 141),
    (Tuple 137 142),
    (Tuple 137 143),
    (Tuple 137 454),
    (Tuple 137 144),
    (Tuple 137 611),
    (Tuple 137 145),
    (Tuple 137 852),
    (Tuple 137 146),
    (Tuple 137 931),
    (Tuple 137 10),
    (Tuple 137 11),
    (Tuple 137 918),
    (Tuple 137 608),
    (Tuple 137 932),
    (Tuple 137 506),
    (Tuple 137 661),
    (Tuple 137 149),
    (Tuple 137 648),
    (Tuple 137 457),
    (Tuple 137 458),
    (Tuple 137 612),
    (Tuple 137 655),
    (Tuple 137 853),
    (Tuple 137 155),
    (Tuple 137 613),
    (Tuple 880 751),
    (Tuple 880 388),
    (Tuple 880 513),
    (Tuple 880 752),
    (Tuple 880 753),
    (Tuple 880 754),
    (Tuple 880 755),
    (Tuple 185 185),
    (Tuple 185 375),
    (Tuple 185 275),
    (Tuple 185 189),
    (Tuple 185 190),
    (Tuple 185 191),
    (Tuple 185 192),
    (Tuple 185 193),
    (Tuple 185 376),
    (Tuple 185 463),
    (Tuple 185 195),
    (Tuple 185 453),
    (Tuple 185 21),
    (Tuple 185 196),
    (Tuple 185 280),
    (Tuple 185 282),
    (Tuple 185 165),
    (Tuple 185 200),
    (Tuple 185 378),
    (Tuple 185 166),
    (Tuple 185 464),
    (Tuple 185 379),
    (Tuple 185 208),
    (Tuple 185 209),
    (Tuple 185 210),
    (Tuple 185 211),
    (Tuple 185 168),
    (Tuple 185 213),
    (Tuple 185 289),
    (Tuple 185 381),
    (Tuple 185 382),
    (Tuple 185 383),
    (Tuple 185 216),
    (Tuple 185 217),
    (Tuple 185 387),
    (Tuple 185 390),
    (Tuple 185 221),
    (Tuple 185 222),
    (Tuple 185 290),
    (Tuple 185 225),
    (Tuple 500 325),
    (Tuple 500 579),
    (Tuple 500 81),
    (Tuple 500 328),
    (Tuple 500 807),
    (Tuple 500 501),
    (Tuple 500 83),
    (Tuple 500 933),
    (Tuple 500 581),
    (Tuple 500 38),
    (Tuple 500 583),
    (Tuple 500 87),
    (Tuple 500 88),
    (Tuple 500 91),
    (Tuple 500 332),
    (Tuple 500 688),
    (Tuple 500 333),
    (Tuple 500 334),
    (Tuple 500 335),
    (Tuple 500 338),
    (Tuple 500 207),
    (Tuple 500 42),
    (Tuple 500 340),
    (Tuple 500 587),
    (Tuple 500 668),
    (Tuple 500 767),
    (Tuple 500 98),
    (Tuple 500 312),
    (Tuple 500 100),
    (Tuple 500 342),
    (Tuple 500 101),
    (Tuple 500 102),
    (Tuple 500 103),
    (Tuple 500 305),
    (Tuple 500 672),
    (Tuple 500 105),
    (Tuple 500 49),
    (Tuple 500 907),
    (Tuple 500 112),
    (Tuple 500 531),
    (Tuple 500 120),
    (Tuple 500 124),
    (Tuple 500 676),
    (Tuple 500 430),
    (Tuple 500 128),
    (Tuple 500 633),
    (Tuple 500 433),
    (Tuple 500 703),
    (Tuple 500 435),
    (Tuple 888 888),
    (Tuple 888 624),
    (Tuple 888 889),
    (Tuple 888 890),
    (Tuple 888 891),
    (Tuple 888 526),
    (Tuple 888 813),
    (Tuple 888 892),
    (Tuple 888 893),
    (Tuple 888 438),
    (Tuple 888 486),
    (Tuple 888 894),
    (Tuple 888 895),
    (Tuple 888 896),
    (Tuple 888 14),
    (Tuple 888 780),
    (Tuple 888 897),
    (Tuple 888 898),
    (Tuple 888 57),
    (Tuple 888 841),
    (Tuple 888 353),
    (Tuple 888 701),
    (Tuple 888 899),
    (Tuple 888 900),
    (Tuple 375 275),
    (Tuple 375 276),
    (Tuple 375 189),
    (Tuple 375 190),
    (Tuple 375 193),
    (Tuple 375 376),
    (Tuple 375 195),
    (Tuple 375 453),
    (Tuple 375 21),
    (Tuple 375 196),
    (Tuple 375 199),
    (Tuple 375 165),
    (Tuple 375 200),
    (Tuple 375 378),
    (Tuple 375 203),
    (Tuple 375 166),
    (Tuple 375 208),
    (Tuple 375 209),
    (Tuple 375 210),
    (Tuple 375 211),
    (Tuple 375 168),
    (Tuple 375 212),
    (Tuple 375 213),
    (Tuple 375 381),
    (Tuple 375 383),
    (Tuple 375 217),
    (Tuple 375 171),
    (Tuple 375 218),
    (Tuple 375 387),
    (Tuple 375 649),
    (Tuple 375 68),
    (Tuple 375 221),
    (Tuple 375 222),
    (Tuple 375 290),
    (Tuple 437 437),
    (Tuple 437 256),
    (Tuple 437 190),
    (Tuple 437 5),
    (Tuple 437 6),
    (Tuple 437 257),
    (Tuple 437 470),
    (Tuple 437 454),
    (Tuple 437 10),
    (Tuple 437 716),
    (Tuple 437 456),
    (Tuple 437 660),
    (Tuple 437 14),
    (Tuple 437 661),
    (Tuple 437 151),
    (Tuple 437 152),
    (Tuple 437 154),
    (Tuple 256 31),
    (Tuple 256 190),
    (Tuple 256 644),
    (Tuple 256 470),
    (Tuple 256 200),
    (Tuple 256 206),
    (Tuple 256 9),
    (Tuple 256 168),
    (Tuple 256 716),
    (Tuple 256 717),
    (Tuple 256 23),
    (Tuple 256 381),
    (Tuple 256 148),
    (Tuple 256 215),
    (Tuple 256 653),
    (Tuple 256 661),
    (Tuple 256 15),
    (Tuple 256 152),
    (Tuple 256 459),
    (Tuple 256 154),
    (Tuple 256 172),
    (Tuple 462 187),
    (Tuple 462 188),
    (Tuple 462 161),
    (Tuple 462 194),
    (Tuple 462 205),
    (Tuple 462 206),
    (Tuple 462 286),
    (Tuple 462 23),
    (Tuple 462 215),
    (Tuple 462 261),
    (Tuple 462 262),
    (Tuple 462 220),
    (Tuple 482 187),
    (Tuple 482 194),
    (Tuple 482 277),
    (Tuple 482 197),
    (Tuple 482 211),
    (Tuple 482 23),
    (Tuple 482 262),
    (Tuple 482 220),
    (Tuple 186 187),
    (Tuple 186 191),
    (Tuple 186 194),
    (Tuple 186 22),
    (Tuple 186 170),
    (Tuple 186 213),
    (Tuple 186 214),
    (Tuple 186 215),
    (Tuple 186 220),
    (Tuple 186 223),
    (Tuple 186 224),
    (Tuple 301 302),
    (Tuple 301 579),
    (Tuple 301 81),
    (Tuple 301 328),
    (Tuple 301 37),
    (Tuple 301 84),
    (Tuple 301 402),
    (Tuple 301 405),
    (Tuple 301 331),
    (Tuple 301 87),
    (Tuple 301 88),
    (Tuple 301 90),
    (Tuple 301 92),
    (Tuple 301 407),
    (Tuple 301 408),
    (Tuple 301 303),
    (Tuple 301 95),
    (Tuple 301 586),
    (Tuple 301 41),
    (Tuple 301 97),
    (Tuple 301 542),
    (Tuple 301 99),
    (Tuple 301 100),
    (Tuple 301 417),
    (Tuple 301 102),
    (Tuple 301 103),
    (Tuple 301 104),
    (Tuple 301 420),
    (Tuple 301 105),
    (Tuple 301 106),
    (Tuple 301 107),
    (Tuple 301 108),
    (Tuple 301 109),
    (Tuple 301 110),
    (Tuple 301 306),
    (Tuple 301 49),
    (Tuple 301 528),
    (Tuple 301 112),
    (Tuple 301 113),
    (Tuple 301 693),
    (Tuple 301 369),
    (Tuple 301 114),
    (Tuple 301 52),
    (Tuple 301 425),
    (Tuple 301 116),
    (Tuple 301 117),
    (Tuple 301 119),
    (Tuple 301 426),
    (Tuple 301 120),
    (Tuple 301 121),
    (Tuple 301 267),
    (Tuple 301 124),
    (Tuple 301 126),
    (Tuple 301 127),
    (Tuple 301 430),
    (Tuple 301 129),
    (Tuple 301 130),
    (Tuple 301 594),
    (Tuple 301 595),
    (Tuple 301 131),
    (Tuple 301 132),
    (Tuple 301 308),
    (Tuple 301 133),
    (Tuple 301 357),
    (Tuple 301 309),
    (Tuple 187 275),
    (Tuple 187 191),
    (Tuple 187 193),
    (Tuple 187 194),
    (Tuple 187 453),
    (Tuple 187 277),
    (Tuple 187 197),
    (Tuple 187 198),
    (Tuple 187 279),
    (Tuple 187 280),
    (Tuple 187 204),
    (Tuple 187 284),
    (Tuple 187 288),
    (Tuple 187 796),
    (Tuple 187 289),
    (Tuple 187 382),
    (Tuple 187 383),
    (Tuple 187 220),
    (Tuple 187 390),
    (Tuple 187 392),
    (Tuple 187 223),
    (Tuple 187 394),
    (Tuple 723 679),
    (Tuple 723 63),
    (Tuple 723 536),
    (Tuple 723 820),
    (Tuple 723 624),
    (Tuple 723 359),
    (Tuple 723 806),
    (Tuple 723 821),
    (Tuple 723 680),
    (Tuple 723 822),
    (Tuple 723 762),
    (Tuple 723 803),
    (Tuple 723 724),
    (Tuple 723 929),
    (Tuple 723 823),
    (Tuple 723 34),
    (Tuple 723 626),
    (Tuple 723 824),
    (Tuple 723 37),
    (Tuple 723 39),
    (Tuple 723 526),
    (Tuple 723 681),
    (Tuple 723 361),
    (Tuple 723 627),
    (Tuple 723 527),
    (Tuple 723 764),
    (Tuple 723 825),
    (Tuple 723 726),
    (Tuple 723 727),
    (Tuple 723 766),
    (Tuple 723 667),
    (Tuple 723 728),
    (Tuple 723 264),
    (Tuple 723 826),
    (Tuple 723 800),
    (Tuple 723 804),
    (Tuple 723 696),
    (Tuple 723 629),
    (Tuple 723 827),
    (Tuple 723 294),
    (Tuple 723 934),
    (Tuple 723 769),
    (Tuple 723 935),
    (Tuple 723 828),
    (Tuple 723 829),
    (Tuple 723 770),
    (Tuple 723 771),
    (Tuple 723 65),
    (Tuple 723 772),
    (Tuple 723 669),
    (Tuple 723 414),
    (Tuple 723 345),
    (Tuple 723 47),
    (Tuple 723 630),
    (Tuple 723 729),
    (Tuple 723 730),
    (Tuple 723 731),
    (Tuple 723 682),
    (Tuple 723 775),
    (Tuple 723 776),
    (Tuple 723 732),
    (Tuple 723 562),
    (Tuple 723 673),
    (Tuple 723 830),
    (Tuple 723 831),
    (Tuple 723 733),
    (Tuple 723 832),
    (Tuple 723 675),
    (Tuple 723 734),
    (Tuple 723 295),
    (Tuple 723 698),
    (Tuple 723 735),
    (Tuple 723 529),
    (Tuple 723 385),
    (Tuple 723 363),
    (Tuple 723 833),
    (Tuple 723 631),
    (Tuple 723 779),
    (Tuple 723 834),
    (Tuple 723 736),
    (Tuple 723 835),
    (Tuple 723 780),
    (Tuple 723 781),
    (Tuple 723 836),
    (Tuple 723 837),
    (Tuple 723 782),
    (Tuple 723 737),
    (Tuple 723 238),
    (Tuple 723 908),
    (Tuple 723 738),
    (Tuple 723 838),
    (Tuple 723 839),
    (Tuple 723 632),
    (Tuple 723 699),
    (Tuple 723 429),
    (Tuple 723 840),
    (Tuple 723 57),
    (Tuple 723 936),
    (Tuple 723 841),
    (Tuple 723 783),
    (Tuple 723 784),
    (Tuple 723 353),
    (Tuple 723 785),
    (Tuple 723 739),
    (Tuple 723 923),
    (Tuple 723 786),
    (Tuple 723 787),
    (Tuple 723 788),
    (Tuple 723 701),
    (Tuple 723 514),
    (Tuple 723 532),
    (Tuple 723 634),
    (Tuple 723 677),
    (Tuple 723 789),
    (Tuple 723 533),
    (Tuple 723 740),
    (Tuple 723 683),
    (Tuple 723 790),
    (Tuple 723 460),
    (Tuple 723 393),
    (Tuple 723 615),
    (Tuple 723 515),
    (Tuple 723 842),
    (Tuple 723 843),
    (Tuple 723 910),
    (Tuple 723 173),
    (Tuple 79 577),
    (Tuple 79 704),
    (Tuple 79 80),
    (Tuple 79 325),
    (Tuple 79 326),
    (Tuple 79 579),
    (Tuple 79 925),
    (Tuple 79 82),
    (Tuple 79 83),
    (Tuple 79 580),
    (Tuple 79 582),
    (Tuple 79 36),
    (Tuple 79 540),
    (Tuple 79 38),
    (Tuple 79 692),
    (Tuple 79 87),
    (Tuple 79 41),
    (Tuple 79 42),
    (Tuple 79 342),
    (Tuple 79 561),
    (Tuple 79 546),
    (Tuple 79 591),
    (Tuple 79 548),
    (Tuple 79 641),
    (Tuple 79 707),
    (Tuple 79 597),
    (Tuple 79 132),
    (Tuple 638 638),
    (Tuple 638 302),
    (Tuple 638 577),
    (Tuple 638 639),
    (Tuple 638 32),
    (Tuple 638 80),
    (Tuple 638 763),
    (Tuple 638 539),
    (Tuple 638 692),
    (Tuple 638 640),
    (Tuple 638 339),
    (Tuple 638 621),
    (Tuple 638 478),
    (Tuple 638 848),
    (Tuple 638 236),
    (Tuple 638 693),
    (Tuple 638 369),
    (Tuple 638 641),
    (Tuple 638 53),
    (Tuple 638 115),
    (Tuple 638 119),
    (Tuple 638 126),
    (Tuple 638 431),
    (Tuple 638 133),
    (Tuple 468 851),
    (Tuple 468 5),
    (Tuple 468 141),
    (Tuple 468 142),
    (Tuple 468 454),
    (Tuple 468 611),
    (Tuple 468 146),
    (Tuple 468 9),
    (Tuple 468 919),
    (Tuple 468 608),
    (Tuple 468 148),
    (Tuple 468 456),
    (Tuple 468 653),
    (Tuple 468 457),
    (Tuple 468 612),
    (Tuple 468 655),
    (Tuple 468 937),
    (Tuple 468 938),
    (Tuple 275 190),
    (Tuple 275 193),
    (Tuple 275 194),
    (Tuple 275 21),
    (Tuple 275 196),
    (Tuple 275 198),
    (Tuple 275 165),
    (Tuple 275 200),
    (Tuple 275 378),
    (Tuple 275 166),
    (Tuple 275 208),
    (Tuple 275 209),
    (Tuple 275 211),
    (Tuple 275 168),
    (Tuple 275 288),
    (Tuple 275 66),
    (Tuple 275 222),
    (Tuple 275 797),
    (Tuple 601 603),
    (Tuple 601 25),
    (Tuple 601 369),
    (Tuple 601 52),
    (Tuple 601 60),
    (Tuple 679 822),
    (Tuple 679 725),
    (Tuple 679 764),
    (Tuple 679 726),
    (Tuple 679 727),
    (Tuple 679 766),
    (Tuple 679 828),
    (Tuple 679 939),
    (Tuple 679 730),
    (Tuple 679 731),
    (Tuple 679 831),
    (Tuple 679 675),
    (Tuple 679 734),
    (Tuple 679 833),
    (Tuple 679 834),
    (Tuple 679 836),
    (Tuple 679 840),
    (Tuple 679 784),
    (Tuple 679 786),
    (Tuple 679 787),
    (Tuple 679 740),
    (Tuple 63 325),
    (Tuple 63 763),
    (Tuple 63 258),
    (Tuple 63 259),
    (Tuple 63 581),
    (Tuple 63 540),
    (Tuple 63 727),
    (Tuple 63 87),
    (Tuple 63 338),
    (Tuple 63 667),
    (Tuple 63 304),
    (Tuple 63 42),
    (Tuple 63 931),
    (Tuple 63 767),
    (Tuple 63 260),
    (Tuple 63 742),
    (Tuple 63 940),
    (Tuple 63 561),
    (Tuple 63 546),
    (Tuple 63 672),
    (Tuple 63 734),
    (Tuple 63 67),
    (Tuple 63 736),
    (Tuple 63 941),
    (Tuple 63 658),
    (Tuple 63 740),
    (Tuple 63 905),
    (Tuple 302 576),
    (Tuple 302 577),
    (Tuple 302 33),
    (Tuple 302 325),
    (Tuple 302 871),
    (Tuple 302 35),
    (Tuple 302 83),
    (Tuple 302 494),
    (Tuple 302 582),
    (Tuple 302 540),
    (Tuple 302 605),
    (Tuple 302 606),
    (Tuple 302 692),
    (Tuple 302 476),
    (Tuple 302 338),
    (Tuple 302 42),
    (Tuple 302 621),
    (Tuple 302 478),
    (Tuple 302 561),
    (Tuple 302 591),
    (Tuple 845 761),
    (Tuple 845 763),
    (Tuple 845 847),
    (Tuple 845 765),
    (Tuple 845 767),
    (Tuple 845 771),
    (Tuple 845 415),
    (Tuple 845 848),
    (Tuple 845 849),
    (Tuple 845 850),
    (Tuple 845 777),
    (Tuple 845 778),
    (Tuple 845 56),
    (Tuple 845 791),
    (Tuple 493 32),
    (Tuple 493 33),
    (Tuple 493 35),
    (Tuple 493 605),
    (Tuple 493 260),
    (Tuple 493 417),
    (Tuple 493 561),
    (Tuple 493 496),
    (Tuple 493 497),
    (Tuple 493 52),
    (Tuple 493 53),
    (Tuple 493 370),
    (Tuple 493 391),
    (Tuple 493 58),
    (Tuple 493 127),
    (Tuple 493 460),
    (Tuple 536 536),
    (Tuple 536 625),
    (Tuple 536 806),
    (Tuple 536 724),
    (Tuple 536 925),
    (Tuple 536 258),
    (Tuple 536 807),
    (Tuple 536 38),
    (Tuple 536 681),
    (Tuple 536 726),
    (Tuple 536 727),
    (Tuple 536 332),
    (Tuple 536 766),
    (Tuple 536 667),
    (Tuple 536 207),
    (Tuple 536 728),
    (Tuple 536 235),
    (Tuple 536 340),
    (Tuple 536 587),
    (Tuple 536 668),
    (Tuple 536 767),
    (Tuple 536 478),
    (Tuple 536 772),
    (Tuple 536 773),
    (Tuple 536 414),
    (Tuple 536 862),
    (Tuple 536 47),
    (Tuple 536 731),
    (Tuple 536 305),
    (Tuple 536 672),
    (Tuple 536 347),
    (Tuple 536 733),
    (Tuple 536 348),
    (Tuple 536 832),
    (Tuple 536 734),
    (Tuple 536 907),
    (Tuple 536 385),
    (Tuple 536 779),
    (Tuple 536 736),
    (Tuple 536 835),
    (Tuple 536 782),
    (Tuple 536 737),
    (Tuple 536 632),
    (Tuple 536 859),
    (Tuple 536 936),
    (Tuple 536 700),
    (Tuple 536 923),
    (Tuple 536 676),
    (Tuple 536 514),
    (Tuple 536 677),
    (Tuple 536 740),
    (Tuple 536 790),
    (Tuple 536 515),
    (Tuple 576 83),
    (Tuple 576 403),
    (Tuple 576 87),
    (Tuple 576 88),
    (Tuple 576 89),
    (Tuple 576 42),
    (Tuple 576 409),
    (Tuple 576 97),
    (Tuple 576 557),
    (Tuple 576 412),
    (Tuple 576 773),
    (Tuple 576 102),
    (Tuple 576 103),
    (Tuple 576 104),
    (Tuple 576 420),
    (Tuple 576 106),
    (Tuple 576 107),
    (Tuple 576 108),
    (Tuple 576 109),
    (Tuple 576 306),
    (Tuple 576 112),
    (Tuple 576 113),
    (Tuple 576 424),
    (Tuple 576 114),
    (Tuple 576 52),
    (Tuple 576 425),
    (Tuple 576 115),
    (Tuple 576 116),
    (Tuple 576 118),
    (Tuple 576 119),
    (Tuple 576 427),
    (Tuple 576 267),
    (Tuple 576 123),
    (Tuple 576 126),
    (Tuple 576 127),
    (Tuple 576 128),
    (Tuple 576 130),
    (Tuple 576 433),
    (Tuple 576 132),
    (Tuple 576 308),
    (Tuple 576 133),
    (Tuple 576 309),
    (Tuple 138 138),
    (Tuple 138 139),
    (Tuple 138 5),
    (Tuple 138 140),
    (Tuple 138 141),
    (Tuple 138 142),
    (Tuple 138 143),
    (Tuple 138 7),
    (Tuple 138 144),
    (Tuple 138 852),
    (Tuple 138 8),
    (Tuple 138 9),
    (Tuple 138 10),
    (Tuple 138 147),
    (Tuple 138 12),
    (Tuple 138 918),
    (Tuple 138 608),
    (Tuple 138 932),
    (Tuple 138 14),
    (Tuple 138 661),
    (Tuple 138 149),
    (Tuple 138 151),
    (Tuple 138 920),
    (Tuple 138 942),
    (Tuple 138 155),
    (Tuple 138 460),
    (Tuple 138 613),
    (Tuple 943 525),
    (Tuple 31 451),
    (Tuple 31 33),
    (Tuple 31 139),
    (Tuple 31 5),
    (Tuple 31 140),
    (Tuple 31 463),
    (Tuple 31 453),
    (Tuple 31 141),
    (Tuple 31 398),
    (Tuple 31 142),
    (Tuple 31 258),
    (Tuple 31 259),
    (Tuple 31 454),
    (Tuple 31 7),
    (Tuple 31 144),
    (Tuple 31 611),
    (Tuple 31 852),
    (Tuple 31 715),
    (Tuple 31 204),
    (Tuple 31 146),
    (Tuple 31 147),
    (Tuple 31 918),
    (Tuple 31 919),
    (Tuple 31 212),
    (Tuple 31 213),
    (Tuple 31 608),
    (Tuple 31 932),
    (Tuple 31 506),
    (Tuple 31 647),
    (Tuple 31 386),
    (Tuple 31 653),
    (Tuple 31 661),
    (Tuple 31 219),
    (Tuple 31 149),
    (Tuple 31 150),
    (Tuple 31 941),
    (Tuple 31 458),
    (Tuple 31 612),
    (Tuple 31 153),
    (Tuple 31 655),
    (Tuple 31 920),
    (Tuple 31 225),
    (Tuple 276 189),
    (Tuple 276 190),
    (Tuple 276 191),
    (Tuple 276 193),
    (Tuple 276 165),
    (Tuple 276 200),
    (Tuple 276 166),
    (Tuple 276 211),
    (Tuple 276 170),
    (Tuple 276 23),
    (Tuple 276 394),
    (Tuple 188 161),
    (Tuple 188 191),
    (Tuple 188 198),
    (Tuple 188 200),
    (Tuple 188 206),
    (Tuple 188 383),
    (Tuple 188 215),
    (Tuple 188 171),
    (Tuple 188 262),
    (Tuple 877 32),
    (Tuple 877 33),
    (Tuple 877 657),
    (Tuple 877 311),
    (Tuple 877 928),
    (Tuple 877 370),
    (Tuple 877 391),
    (Tuple 877 59),
    (Tuple 820 724),
    (Tuple 820 824),
    (Tuple 820 627),
    (Tuple 820 825),
    (Tuple 820 726),
    (Tuple 820 727),
    (Tuple 820 766),
    (Tuple 820 207),
    (Tuple 820 264),
    (Tuple 820 668),
    (Tuple 820 827),
    (Tuple 820 731),
    (Tuple 820 675),
    (Tuple 820 735),
    (Tuple 820 736),
    (Tuple 820 837),
    (Tuple 820 923),
    (Tuple 820 786),
    (Tuple 820 677),
    (Tuple 820 740),
    (Tuple 820 842),
    (Tuple 820 910),
    (Tuple 577 577),
    (Tuple 577 80),
    (Tuple 577 81),
    (Tuple 577 580),
    (Tuple 577 87),
    (Tuple 577 88),
    (Tuple 577 585),
    (Tuple 577 586),
    (Tuple 577 235),
    (Tuple 577 312),
    (Tuple 577 101),
    (Tuple 577 417),
    (Tuple 577 105),
    (Tuple 577 106),
    (Tuple 577 108),
    (Tuple 577 109),
    (Tuple 577 111),
    (Tuple 577 112),
    (Tuple 577 363),
    (Tuple 577 369),
    (Tuple 577 114),
    (Tuple 577 641),
    (Tuple 577 120),
    (Tuple 577 121),
    (Tuple 577 122),
    (Tuple 577 123),
    (Tuple 577 126),
    (Tuple 577 483),
    (Tuple 577 532),
    (Tuple 577 597),
    (Tuple 189 873),
    (Tuple 189 191),
    (Tuple 189 192),
    (Tuple 189 193),
    (Tuple 189 376),
    (Tuple 189 463),
    (Tuple 189 644),
    (Tuple 189 195),
    (Tuple 189 257),
    (Tuple 189 21),
    (Tuple 189 258),
    (Tuple 189 259),
    (Tuple 189 196),
    (Tuple 189 279),
    (Tuple 189 280),
    (Tuple 189 199),
    (Tuple 189 282),
    (Tuple 189 165),
    (Tuple 189 378),
    (Tuple 189 203),
    (Tuple 189 166),
    (Tuple 189 208),
    (Tuple 189 284),
    (Tuple 189 209),
    (Tuple 189 210),
    (Tuple 189 211),
    (Tuple 189 212),
    (Tuple 189 213),
    (Tuple 189 645),
    (Tuple 189 289),
    (Tuple 189 382),
    (Tuple 189 646),
    (Tuple 189 383),
    (Tuple 189 647),
    (Tuple 189 216),
    (Tuple 189 384),
    (Tuple 189 217),
    (Tuple 189 219),
    (Tuple 189 593),
    (Tuple 189 387),
    (Tuple 189 648),
    (Tuple 189 390),
    (Tuple 189 649),
    (Tuple 189 68),
    (Tuple 189 221),
    (Tuple 189 222),
    (Tuple 189 290),
    (Tuple 189 223),
    (Tuple 189 225),
    (Tuple 189 394),
    (Tuple 160 33),
    (Tuple 160 193),
    (Tuple 160 141),
    (Tuple 160 724),
    (Tuple 160 258),
    (Tuple 160 711),
    (Tuple 160 259),
    (Tuple 160 759),
    (Tuple 160 87),
    (Tuple 160 455),
    (Tuple 160 264),
    (Tuple 160 826),
    (Tuple 160 42),
    (Tuple 160 731),
    (Tuple 160 591),
    (Tuple 160 673),
    (Tuple 160 737),
    (Tuple 160 783),
    (Tuple 160 784),
    (Tuple 160 739),
    (Tuple 160 786),
    (Tuple 160 126),
    (Tuple 160 787),
    (Tuple 160 788),
    (Tuple 160 308),
    (Tuple 451 167),
    (Tuple 451 386),
    (Tuple 451 16),
    (Tuple 451 795),
    (Tuple 639 81),
    (Tuple 639 86),
    (Tuple 639 87),
    (Tuple 639 89),
    (Tuple 639 407),
    (Tuple 639 265),
    (Tuple 639 411),
    (Tuple 639 417),
    (Tuple 639 546),
    (Tuple 639 102),
    (Tuple 639 103),
    (Tuple 639 107),
    (Tuple 639 109),
    (Tuple 639 236),
    (Tuple 639 641),
    (Tuple 639 52),
    (Tuple 639 116),
    (Tuple 639 117),
    (Tuple 639 119),
    (Tuple 639 121),
    (Tuple 639 122),
    (Tuple 639 267),
    (Tuple 639 123),
    (Tuple 639 57),
    (Tuple 639 125),
    (Tuple 639 126),
    (Tuple 639 128),
    (Tuple 639 130),
    (Tuple 639 132),
    (Tuple 639 133),
    (Tuple 368 33),
    (Tuple 368 325),
    (Tuple 368 21),
    (Tuple 368 196),
    (Tuple 368 199),
    (Tuple 368 311),
    (Tuple 368 527),
    (Tuple 368 378),
    (Tuple 368 89),
    (Tuple 368 387),
    (Tuple 368 221),
    (Tuple 710 711),
    (Tuple 710 944),
    (Tuple 710 691),
    (Tuple 710 260),
    (Tuple 710 712),
    (Tuple 710 117),
    (Tuple 161 206),
    (Tuple 161 511),
    (Tuple 161 23),
    (Tuple 161 215),
    (Tuple 161 261),
    (Tuple 161 262),
    (Tuple 873 873),
    (Tuple 873 190),
    (Tuple 873 192),
    (Tuple 873 21),
    (Tuple 873 64),
    (Tuple 873 200),
    (Tuple 873 166),
    (Tuple 873 208),
    (Tuple 873 168),
    (Tuple 873 260),
    (Tuple 873 170),
    (Tuple 873 381),
    (Tuple 873 214),
    (Tuple 32 32),
    (Tuple 32 33),
    (Tuple 32 475),
    (Tuple 32 233),
    (Tuple 32 257),
    (Tuple 32 35),
    (Tuple 32 501),
    (Tuple 32 494),
    (Tuple 32 39),
    (Tuple 32 541),
    (Tuple 32 311),
    (Tuple 32 495),
    (Tuple 32 303),
    (Tuple 32 945),
    (Tuple 32 42),
    (Tuple 32 928),
    (Tuple 32 478),
    (Tuple 32 25),
    (Tuple 32 561),
    (Tuple 32 316),
    (Tuple 32 496),
    (Tuple 32 497),
    (Tuple 32 641),
    (Tuple 32 53),
    (Tuple 32 593),
    (Tuple 32 370),
    (Tuple 32 54),
    (Tuple 32 55),
    (Tuple 32 391),
    (Tuple 32 58),
    (Tuple 32 59),
    (Tuple 32 658),
    (Tuple 624 890),
    (Tuple 624 258),
    (Tuple 624 38),
    (Tuple 624 727),
    (Tuple 624 852),
    (Tuple 624 87),
    (Tuple 624 667),
    (Tuple 624 42),
    (Tuple 624 668),
    (Tuple 624 767),
    (Tuple 624 906),
    (Tuple 624 939),
    (Tuple 624 672),
    (Tuple 624 438),
    (Tuple 624 486),
    (Tuple 624 894),
    (Tuple 624 895),
    (Tuple 624 896),
    (Tuple 624 834),
    (Tuple 624 736),
    (Tuple 624 898),
    (Tuple 624 859),
    (Tuple 624 899),
    (Tuple 190 191),
    (Tuple 190 193),
    (Tuple 190 376),
    (Tuple 190 463),
    (Tuple 190 644),
    (Tuple 190 195),
    (Tuple 190 278),
    (Tuple 190 279),
    (Tuple 190 280),
    (Tuple 190 282),
    (Tuple 190 200),
    (Tuple 190 204),
    (Tuple 190 379),
    (Tuple 190 209),
    (Tuple 190 210),
    (Tuple 190 212),
    (Tuple 190 213),
    (Tuple 190 382),
    (Tuple 190 646),
    (Tuple 190 383),
    (Tuple 190 384),
    (Tuple 190 217),
    (Tuple 190 219),
    (Tuple 190 649),
    (Tuple 190 290),
    (Tuple 190 225),
    (Tuple 33 475),
    (Tuple 33 35),
    (Tuple 33 657),
    (Tuple 33 494),
    (Tuple 33 502),
    (Tuple 33 39),
    (Tuple 33 40),
    (Tuple 33 541),
    (Tuple 33 165),
    (Tuple 33 311),
    (Tuple 33 361),
    (Tuple 33 692),
    (Tuple 33 495),
    (Tuple 33 476),
    (Tuple 33 303),
    (Tuple 33 315),
    (Tuple 33 945),
    (Tuple 33 265),
    (Tuple 33 170),
    (Tuple 33 316),
    (Tuple 33 381),
    (Tuple 33 106),
    (Tuple 33 236),
    (Tuple 33 496),
    (Tuple 33 528),
    (Tuple 33 497),
    (Tuple 33 50),
    (Tuple 33 385),
    (Tuple 33 53),
    (Tuple 33 117),
    (Tuple 33 370),
    (Tuple 33 54),
    (Tuple 33 55),
    (Tuple 33 56),
    (Tuple 33 391),
    (Tuple 33 221),
    (Tuple 33 58),
    (Tuple 33 126),
    (Tuple 33 59),
    (Tuple 33 431),
    (Tuple 33 479),
    (Tuple 33 173),
    (Tuple 946 847),
    (Tuple 946 235),
    (Tuple 946 265),
    (Tuple 946 503),
    (Tuple 946 363),
    (Tuple 946 424),
    (Tuple 946 266),
    (Tuple 946 532),
    (Tuple 946 789),
    (Tuple 946 364),
    (Tuple 139 851),
    (Tuple 139 5),
    (Tuple 139 140),
    (Tuple 139 141),
    (Tuple 139 142),
    (Tuple 139 143),
    (Tuple 139 454),
    (Tuple 139 7),
    (Tuple 139 144),
    (Tuple 139 145),
    (Tuple 139 852),
    (Tuple 139 8),
    (Tuple 139 146),
    (Tuple 139 9),
    (Tuple 139 10),
    (Tuple 139 11),
    (Tuple 139 12),
    (Tuple 139 918),
    (Tuple 139 381),
    (Tuple 139 608),
    (Tuple 139 148),
    (Tuple 139 13),
    (Tuple 139 456),
    (Tuple 139 660),
    (Tuple 139 386),
    (Tuple 139 653),
    (Tuple 139 14),
    (Tuple 139 661),
    (Tuple 139 149),
    (Tuple 139 15),
    (Tuple 139 389),
    (Tuple 139 150),
    (Tuple 139 151),
    (Tuple 139 459),
    (Tuple 139 153),
    (Tuple 139 853),
    (Tuple 139 920),
    (Tuple 139 942),
    (Tuple 139 154),
    (Tuple 139 155),
    (Tuple 139 460),
    (Tuple 139 613),
    (Tuple 761 325),
    (Tuple 761 763),
    (Tuple 761 947),
    (Tuple 761 847),
    (Tuple 761 495),
    (Tuple 761 765),
    (Tuple 761 667),
    (Tuple 761 42),
    (Tuple 761 767),
    (Tuple 761 773),
    (Tuple 761 415),
    (Tuple 761 731),
    (Tuple 761 848),
    (Tuple 761 503),
    (Tuple 761 849),
    (Tuple 761 850),
    (Tuple 761 777),
    (Tuple 761 423),
    (Tuple 761 736),
    (Tuple 761 532),
    (Tuple 851 5),
    (Tuple 851 140),
    (Tuple 851 8),
    (Tuple 851 9),
    (Tuple 851 10),
    (Tuple 851 11),
    (Tuple 851 608),
    (Tuple 851 148),
    (Tuple 851 13),
    (Tuple 851 456),
    (Tuple 851 150),
    (Tuple 851 457),
    (Tuple 851 612),
    (Tuple 851 153),
    (Tuple 851 154),
    (Tuple 578 403),
    (Tuple 578 331),
    (Tuple 578 87),
    (Tuple 578 407),
    (Tuple 578 42),
    (Tuple 578 416),
    (Tuple 578 417),
    (Tuple 578 102),
    (Tuple 578 103),
    (Tuple 578 104),
    (Tuple 578 420),
    (Tuple 578 108),
    (Tuple 578 306),
    (Tuple 578 528),
    (Tuple 578 112),
    (Tuple 578 113),
    (Tuple 578 114),
    (Tuple 578 116),
    (Tuple 578 117),
    (Tuple 578 121),
    (Tuple 578 267),
    (Tuple 578 126),
    (Tuple 578 127),
    (Tuple 578 594),
    (Tuple 578 595),
    (Tuple 578 433),
    (Tuple 578 132),
    (Tuple 578 308),
    (Tuple 578 133),
    (Tuple 578 309),
    (Tuple 359 806),
    (Tuple 359 325),
    (Tuple 359 579),
    (Tuple 359 867),
    (Tuple 359 327),
    (Tuple 359 82),
    (Tuple 359 83),
    (Tuple 359 259),
    (Tuple 359 582),
    (Tuple 359 38),
    (Tuple 359 402),
    (Tuple 359 681),
    (Tuple 359 727),
    (Tuple 359 584),
    (Tuple 359 87),
    (Tuple 359 332),
    (Tuple 359 688),
    (Tuple 359 333),
    (Tuple 359 334),
    (Tuple 359 335),
    (Tuple 359 337),
    (Tuple 359 338),
    (Tuple 359 689),
    (Tuple 359 667),
    (Tuple 359 207),
    (Tuple 359 926),
    (Tuple 359 42),
    (Tuple 359 340),
    (Tuple 359 587),
    (Tuple 359 668),
    (Tuple 359 98),
    (Tuple 359 312),
    (Tuple 359 934),
    (Tuple 359 100),
    (Tuple 359 342),
    (Tuple 359 862),
    (Tuple 359 672),
    (Tuple 359 347),
    (Tuple 359 106),
    (Tuple 359 348),
    (Tuple 359 734),
    (Tuple 359 528),
    (Tuple 359 736),
    (Tuple 359 116),
    (Tuple 359 863),
    (Tuple 359 426),
    (Tuple 359 352),
    (Tuple 359 532),
    (Tuple 359 633),
    (Tuple 359 131),
    (Tuple 359 703),
    (Tuple 359 596),
    (Tuple 359 355),
    (Tuple 359 132),
    (Tuple 359 842),
    (Tuple 625 625),
    (Tuple 625 687),
    (Tuple 625 34),
    (Tuple 625 37),
    (Tuple 625 627),
    (Tuple 625 337),
    (Tuple 625 409),
    (Tuple 625 767),
    (Tuple 625 697),
    (Tuple 625 772),
    (Tuple 625 47),
    (Tuple 625 102),
    (Tuple 625 305),
    (Tuple 625 420),
    (Tuple 625 236),
    (Tuple 625 52),
    (Tuple 625 782),
    (Tuple 625 349),
    (Tuple 625 351),
    (Tuple 625 699),
    (Tuple 625 428),
    (Tuple 625 429),
    (Tuple 625 353),
    (Tuple 625 430),
    (Tuple 625 532),
    (Tuple 625 789),
    (Tuple 625 533),
    (Tuple 191 192),
    (Tuple 191 194),
    (Tuple 191 162),
    (Tuple 191 195),
    (Tuple 191 453),
    (Tuple 191 257),
    (Tuple 191 258),
    (Tuple 191 196),
    (Tuple 191 197),
    (Tuple 191 198),
    (Tuple 191 279),
    (Tuple 191 280),
    (Tuple 191 282),
    (Tuple 191 165),
    (Tuple 191 200),
    (Tuple 191 201),
    (Tuple 191 202),
    (Tuple 191 203),
    (Tuple 191 205),
    (Tuple 191 208),
    (Tuple 191 209),
    (Tuple 191 211),
    (Tuple 191 168),
    (Tuple 191 170),
    (Tuple 191 288),
    (Tuple 191 212),
    (Tuple 191 23),
    (Tuple 191 215),
    (Tuple 191 66),
    (Tuple 191 216),
    (Tuple 191 387),
    (Tuple 191 220),
    (Tuple 191 390),
    (Tuple 191 222),
    (Tuple 191 483),
    (Tuple 191 223),
    (Tuple 191 224),
    (Tuple 704 81),
    (Tuple 704 328),
    (Tuple 704 37),
    (Tuple 704 405),
    (Tuple 704 361),
    (Tuple 704 88),
    (Tuple 704 90),
    (Tuple 704 91),
    (Tuple 704 332),
    (Tuple 704 92),
    (Tuple 704 586),
    (Tuple 704 97),
    (Tuple 704 312),
    (Tuple 704 411),
    (Tuple 704 590),
    (Tuple 704 417),
    (Tuple 704 102),
    (Tuple 704 103),
    (Tuple 704 104),
    (Tuple 704 420),
    (Tuple 704 107),
    (Tuple 704 108),
    (Tuple 704 109),
    (Tuple 704 528),
    (Tuple 704 113),
    (Tuple 704 114),
    (Tuple 704 115),
    (Tuple 704 863),
    (Tuple 704 238),
    (Tuple 704 426),
    (Tuple 704 120),
    (Tuple 704 428),
    (Tuple 704 122),
    (Tuple 704 267),
    (Tuple 704 123),
    (Tuple 704 57),
    (Tuple 704 124),
    (Tuple 704 125),
    (Tuple 704 126),
    (Tuple 704 131),
    (Tuple 704 309),
    (Tuple 537 806),
    (Tuple 537 325),
    (Tuple 537 871),
    (Tuple 537 858),
    (Tuple 537 233),
    (Tuple 537 539),
    (Tuple 537 711),
    (Tuple 537 540),
    (Tuple 537 659),
    (Tuple 537 42),
    (Tuple 537 543),
    (Tuple 537 43),
    (Tuple 537 560),
    (Tuple 537 45),
    (Tuple 537 544),
    (Tuple 537 545),
    (Tuple 537 46),
    (Tuple 537 418),
    (Tuple 537 561),
    (Tuple 537 546),
    (Tuple 537 547),
    (Tuple 537 236),
    (Tuple 537 872),
    (Tuple 537 548),
    (Tuple 537 51),
    (Tuple 537 550),
    (Tuple 537 389),
    (Tuple 537 551),
    (Tuple 537 552),
    (Tuple 537 239),
    (Tuple 537 534),
    (Tuple 537 553),
    (Tuple 537 554),
    (Tuple 537 563),
    (Tuple 537 307),
    (Tuple 537 355),
    (Tuple 537 480),
    (Tuple 537 911),
    (Tuple 537 564),
    (Tuple 537 240),
    (Tuple 537 505),
    (Tuple 537 60),
    (Tuple 537 133),
    (Tuple 537 866),
    (Tuple 80 80),
    (Tuple 80 867),
    (Tuple 80 82),
    (Tuple 80 84),
    (Tuple 80 39),
    (Tuple 80 86),
    (Tuple 80 405),
    (Tuple 80 87),
    (Tuple 80 91),
    (Tuple 80 688),
    (Tuple 80 338),
    (Tuple 80 100),
    (Tuple 80 342),
    (Tuple 80 413),
    (Tuple 80 102),
    (Tuple 80 103),
    (Tuple 80 106),
    (Tuple 80 236),
    (Tuple 80 110),
    (Tuple 80 49),
    (Tuple 80 369),
    (Tuple 80 641),
    (Tuple 80 116),
    (Tuple 80 266),
    (Tuple 80 126),
    (Tuple 80 131),
    (Tuple 80 309),
    (Tuple 806 806),
    (Tuple 806 325),
    (Tuple 806 762),
    (Tuple 806 695),
    (Tuple 806 724),
    (Tuple 806 687),
    (Tuple 806 34),
    (Tuple 806 539),
    (Tuple 806 501),
    (Tuple 806 37),
    (Tuple 806 666),
    (Tuple 806 540),
    (Tuple 806 38),
    (Tuple 806 847),
    (Tuple 806 234),
    (Tuple 806 87),
    (Tuple 806 88),
    (Tuple 806 92),
    (Tuple 806 766),
    (Tuple 806 94),
    (Tuple 806 338),
    (Tuple 806 667),
    (Tuple 806 42),
    (Tuple 806 587),
    (Tuple 806 409),
    (Tuple 806 97),
    (Tuple 806 668),
    (Tuple 806 767),
    (Tuple 806 43),
    (Tuple 806 770),
    (Tuple 806 772),
    (Tuple 806 669),
    (Tuple 806 345),
    (Tuple 806 630),
    (Tuple 806 670),
    (Tuple 806 546),
    (Tuple 806 775),
    (Tuple 806 102),
    (Tuple 806 305),
    (Tuple 806 672),
    (Tuple 806 420),
    (Tuple 806 547),
    (Tuple 806 733),
    (Tuple 806 422),
    (Tuple 806 236),
    (Tuple 806 110),
    (Tuple 806 674),
    (Tuple 806 49),
    (Tuple 806 734),
    (Tuple 806 112),
    (Tuple 806 385),
    (Tuple 806 424),
    (Tuple 806 51),
    (Tuple 806 736),
    (Tuple 806 52),
    (Tuple 806 782),
    (Tuple 806 699),
    (Tuple 806 429),
    (Tuple 806 57),
    (Tuple 806 784),
    (Tuple 806 124),
    (Tuple 806 785),
    (Tuple 806 125),
    (Tuple 806 676),
    (Tuple 806 786),
    (Tuple 806 126),
    (Tuple 806 787),
    (Tuple 806 430),
    (Tuple 806 239),
    (Tuple 806 701),
    (Tuple 806 514),
    (Tuple 806 634),
    (Tuple 806 534),
    (Tuple 806 553),
    (Tuple 806 307),
    (Tuple 806 131),
    (Tuple 806 355),
    (Tuple 806 903),
    (Tuple 806 393),
    (Tuple 806 60),
    (Tuple 806 133),
    (Tuple 806 357),
    (Tuple 806 309),
    (Tuple 325 81),
    (Tuple 325 858),
    (Tuple 325 925),
    (Tuple 325 233),
    (Tuple 325 360),
    (Tuple 325 328),
    (Tuple 325 525),
    (Tuple 325 539),
    (Tuple 325 501),
    (Tuple 325 37),
    (Tuple 325 540),
    (Tuple 325 659),
    (Tuple 325 847),
    (Tuple 325 404),
    (Tuple 325 86),
    (Tuple 325 405),
    (Tuple 325 361),
    (Tuple 325 234),
    (Tuple 325 527),
    (Tuple 325 88),
    (Tuple 325 89),
    (Tuple 325 90),
    (Tuple 325 406),
    (Tuple 325 407),
    (Tuple 325 303),
    (Tuple 325 337),
    (Tuple 325 94),
    (Tuple 325 207),
    (Tuple 325 235),
    (Tuple 325 41),
    (Tuple 325 42),
    (Tuple 325 865),
    (Tuple 325 804),
    (Tuple 325 409),
    (Tuple 325 97),
    (Tuple 325 542),
    (Tuple 325 265),
    (Tuple 325 543),
    (Tuple 325 312),
    (Tuple 325 294),
    (Tuple 325 43),
    (Tuple 325 100),
    (Tuple 325 560),
    (Tuple 325 45),
    (Tuple 325 341),
    (Tuple 325 544),
    (Tuple 325 697),
    (Tuple 325 771),
    (Tuple 325 65),
    (Tuple 325 46),
    (Tuple 325 413),
    (Tuple 325 862),
    (Tuple 325 415),
    (Tuple 325 630),
    (Tuple 325 416),
    (Tuple 325 418),
    (Tuple 325 546),
    (Tuple 325 346),
    (Tuple 325 801),
    (Tuple 325 776),
    (Tuple 325 102),
    (Tuple 325 305),
    (Tuple 325 745),
    (Tuple 325 562),
    (Tuple 325 503),
    (Tuple 325 420),
    (Tuple 325 547),
    (Tuple 325 106),
    (Tuple 325 108),
    (Tuple 325 422),
    (Tuple 325 236),
    (Tuple 325 306),
    (Tuple 325 872),
    (Tuple 325 832),
    (Tuple 325 423),
    (Tuple 325 548),
    (Tuple 325 112),
    (Tuple 325 237),
    (Tuple 325 50),
    (Tuple 325 529),
    (Tuple 325 693),
    (Tuple 325 385),
    (Tuple 325 363),
    (Tuple 325 424),
    (Tuple 325 530),
    (Tuple 325 369),
    (Tuple 325 51),
    (Tuple 325 531),
    (Tuple 325 52),
    (Tuple 325 425),
    (Tuple 325 115),
    (Tuple 325 349),
    (Tuple 325 238),
    (Tuple 325 117),
    (Tuple 325 15),
    (Tuple 325 549),
    (Tuple 325 426),
    (Tuple 325 550),
    (Tuple 325 266),
    (Tuple 325 839),
    (Tuple 325 389),
    (Tuple 325 699),
    (Tuple 325 56),
    (Tuple 325 427),
    (Tuple 325 428),
    (Tuple 325 267),
    (Tuple 325 123),
    (Tuple 325 57),
    (Tuple 325 391),
    (Tuple 325 551),
    (Tuple 325 125),
    (Tuple 325 126),
    (Tuple 325 127),
    (Tuple 325 552),
    (Tuple 325 430),
    (Tuple 325 239),
    (Tuple 325 431),
    (Tuple 325 532),
    (Tuple 325 634),
    (Tuple 325 789),
    (Tuple 325 534),
    (Tuple 325 553),
    (Tuple 325 432),
    (Tuple 325 554),
    (Tuple 325 563),
    (Tuple 325 364),
    (Tuple 325 129),
    (Tuple 325 307),
    (Tuple 325 595),
    (Tuple 325 131),
    (Tuple 325 433),
    (Tuple 325 355),
    (Tuple 325 480),
    (Tuple 325 564),
    (Tuple 325 356),
    (Tuple 325 434),
    (Tuple 325 240),
    (Tuple 325 505),
    (Tuple 325 308),
    (Tuple 325 60),
    (Tuple 325 241),
    (Tuple 325 133),
    (Tuple 325 309),
    (Tuple 325 866),
    (Tuple 821 821),
    (Tuple 821 680),
    (Tuple 821 762),
    (Tuple 821 724),
    (Tuple 821 34),
    (Tuple 821 824),
    (Tuple 821 725),
    (Tuple 821 726),
    (Tuple 821 727),
    (Tuple 821 766),
    (Tuple 821 667),
    (Tuple 821 728),
    (Tuple 821 668),
    (Tuple 821 827),
    (Tuple 821 773),
    (Tuple 821 47),
    (Tuple 821 731),
    (Tuple 821 733),
    (Tuple 821 675),
    (Tuple 821 734),
    (Tuple 821 631),
    (Tuple 821 779),
    (Tuple 821 834),
    (Tuple 821 736),
    (Tuple 821 835),
    (Tuple 821 782),
    (Tuple 821 738),
    (Tuple 821 839),
    (Tuple 821 699),
    (Tuple 821 859),
    (Tuple 821 840),
    (Tuple 821 787),
    (Tuple 821 788),
    (Tuple 821 633),
    (Tuple 821 740),
    (Tuple 821 842),
    (Tuple 821 843),
    (Tuple 292 292),
    (Tuple 292 914),
    (Tuple 292 915),
    (Tuple 292 293),
    (Tuple 292 916),
    (Tuple 292 295),
    (Tuple 292 297),
    (Tuple 5 5),
    (Tuple 5 140),
    (Tuple 5 141),
    (Tuple 5 6),
    (Tuple 5 142),
    (Tuple 5 258),
    (Tuple 5 143),
    (Tuple 5 454),
    (Tuple 5 7),
    (Tuple 5 144),
    (Tuple 5 611),
    (Tuple 5 852),
    (Tuple 5 455),
    (Tuple 5 146),
    (Tuple 5 10),
    (Tuple 5 11),
    (Tuple 5 147),
    (Tuple 5 12),
    (Tuple 5 918),
    (Tuple 5 608),
    (Tuple 5 148),
    (Tuple 5 13),
    (Tuple 5 660),
    (Tuple 5 386),
    (Tuple 5 661),
    (Tuple 5 149),
    (Tuple 5 150),
    (Tuple 5 457),
    (Tuple 5 859),
    (Tuple 5 458),
    (Tuple 5 612),
    (Tuple 5 153),
    (Tuple 5 655),
    (Tuple 5 853),
    (Tuple 5 937),
    (Tuple 5 938),
    (Tuple 5 154),
    (Tuple 5 155),
    (Tuple 5 948),
    (Tuple 5 613),
    (Tuple 140 140),
    (Tuple 140 141),
    (Tuple 140 398),
    (Tuple 140 142),
    (Tuple 140 143),
    (Tuple 140 454),
    (Tuple 140 7),
    (Tuple 140 144),
    (Tuple 140 611),
    (Tuple 140 8),
    (Tuple 140 146),
    (Tuple 140 9),
    (Tuple 140 10),
    (Tuple 140 11),
    (Tuple 140 147),
    (Tuple 140 12),
    (Tuple 140 918),
    (Tuple 140 608),
    (Tuple 140 13),
    (Tuple 140 456),
    (Tuple 140 14),
    (Tuple 140 661),
    (Tuple 140 15),
    (Tuple 140 150),
    (Tuple 140 151),
    (Tuple 140 457),
    (Tuple 140 458),
    (Tuple 140 612),
    (Tuple 140 853),
    (Tuple 140 920),
    (Tuple 140 154),
    (Tuple 140 155),
    (Tuple 140 613),
    (Tuple 192 193),
    (Tuple 192 376),
    (Tuple 192 463),
    (Tuple 192 453),
    (Tuple 192 21),
    (Tuple 192 196),
    (Tuple 192 279),
    (Tuple 192 280),
    (Tuple 192 199),
    (Tuple 192 282),
    (Tuple 192 200),
    (Tuple 192 166),
    (Tuple 192 204),
    (Tuple 192 208),
    (Tuple 192 284),
    (Tuple 192 209),
    (Tuple 192 210),
    (Tuple 192 211),
    (Tuple 192 168),
    (Tuple 192 212),
    (Tuple 192 289),
    (Tuple 192 382),
    (Tuple 192 383),
    (Tuple 192 216),
    (Tuple 192 387),
    (Tuple 192 648),
    (Tuple 192 390),
    (Tuple 192 649),
    (Tuple 192 68),
    (Tuple 192 221),
    (Tuple 192 222),
    (Tuple 871 360),
    (Tuple 871 83),
    (Tuple 871 37),
    (Tuple 871 361),
    (Tuple 871 234),
    (Tuple 871 89),
    (Tuple 871 42),
    (Tuple 871 43),
    (Tuple 871 46),
    (Tuple 871 418),
    (Tuple 871 546),
    (Tuple 871 547),
    (Tuple 871 236),
    (Tuple 871 306),
    (Tuple 871 548),
    (Tuple 871 424),
    (Tuple 871 52),
    (Tuple 871 115),
    (Tuple 871 117),
    (Tuple 871 119),
    (Tuple 871 121),
    (Tuple 871 56),
    (Tuple 871 126),
    (Tuple 871 127),
    (Tuple 871 552),
    (Tuple 871 239),
    (Tuple 871 431),
    (Tuple 871 554),
    (Tuple 871 129),
    (Tuple 871 307),
    (Tuple 871 434),
    (Tuple 871 505),
    (Tuple 871 241),
    (Tuple 871 133),
    (Tuple 871 309),
    (Tuple 871 866),
    (Tuple 193 376),
    (Tuple 193 194),
    (Tuple 193 463),
    (Tuple 193 644),
    (Tuple 193 195),
    (Tuple 193 453),
    (Tuple 193 257),
    (Tuple 193 64),
    (Tuple 193 259),
    (Tuple 193 196),
    (Tuple 193 280),
    (Tuple 193 199),
    (Tuple 193 282),
    (Tuple 193 165),
    (Tuple 193 200),
    (Tuple 193 22),
    (Tuple 193 378),
    (Tuple 193 203),
    (Tuple 193 166),
    (Tuple 193 204),
    (Tuple 193 464),
    (Tuple 193 379),
    (Tuple 193 380),
    (Tuple 193 208),
    (Tuple 193 284),
    (Tuple 193 167),
    (Tuple 193 286),
    (Tuple 193 209),
    (Tuple 193 211),
    (Tuple 193 168),
    (Tuple 193 169),
    (Tuple 193 170),
    (Tuple 193 212),
    (Tuple 193 23),
    (Tuple 193 382),
    (Tuple 193 214),
    (Tuple 193 383),
    (Tuple 193 66),
    (Tuple 193 216),
    (Tuple 193 217),
    (Tuple 193 171),
    (Tuple 193 593),
    (Tuple 193 387),
    (Tuple 193 220),
    (Tuple 193 390),
    (Tuple 193 221),
    (Tuple 193 222),
    (Tuple 193 290),
    (Tuple 193 223),
    (Tuple 193 225),
    (Tuple 193 394),
    (Tuple 193 507),
    (Tuple 914 915),
    (Tuple 914 293),
    (Tuple 914 916),
    (Tuple 914 294),
    (Tuple 914 295),
    (Tuple 914 296),
    (Tuple 914 297),
    (Tuple 538 538),
    (Tuple 538 233),
    (Tuple 538 35),
    (Tuple 538 234),
    (Tuple 538 303),
    (Tuple 538 42),
    (Tuple 538 265),
    (Tuple 538 43),
    (Tuple 538 544),
    (Tuple 538 46),
    (Tuple 538 546),
    (Tuple 538 547),
    (Tuple 538 422),
    (Tuple 538 236),
    (Tuple 538 424),
    (Tuple 538 52),
    (Tuple 538 117),
    (Tuple 538 550),
    (Tuple 538 389),
    (Tuple 538 239),
    (Tuple 538 553),
    (Tuple 538 554),
    (Tuple 538 364),
    (Tuple 538 307),
    (Tuple 538 355),
    (Tuple 538 434),
    (Tuple 538 505),
    (Tuple 538 60),
    (Tuple 538 133),
    (Tuple 538 866),
    (Tuple 326 83),
    (Tuple 326 37),
    (Tuple 326 85),
    (Tuple 326 744),
    (Tuple 326 87),
    (Tuple 326 334),
    (Tuple 326 408),
    (Tuple 326 337),
    (Tuple 326 804),
    (Tuple 326 409),
    (Tuple 326 97),
    (Tuple 326 542),
    (Tuple 326 98),
    (Tuple 326 410),
    (Tuple 326 100),
    (Tuple 326 697),
    (Tuple 326 342),
    (Tuple 326 101),
    (Tuple 326 413),
    (Tuple 326 102),
    (Tuple 326 103),
    (Tuple 326 420),
    (Tuple 326 106),
    (Tuple 326 49),
    (Tuple 326 528),
    (Tuple 326 112),
    (Tuple 326 237),
    (Tuple 326 114),
    (Tuple 326 52),
    (Tuple 326 425),
    (Tuple 326 349),
    (Tuple 326 238),
    (Tuple 326 118),
    (Tuple 326 120),
    (Tuple 326 427),
    (Tuple 326 124),
    (Tuple 326 126),
    (Tuple 326 127),
    (Tuple 326 430),
    (Tuple 326 239),
    (Tuple 326 357),
    (Tuple 475 257),
    (Tuple 475 657),
    (Tuple 475 311),
    (Tuple 475 928),
    (Tuple 475 370),
    (Tuple 475 391),
    (Tuple 475 58),
    (Tuple 680 822),
    (Tuple 680 724),
    (Tuple 680 925),
    (Tuple 680 823),
    (Tuple 680 34),
    (Tuple 680 725),
    (Tuple 680 681),
    (Tuple 680 764),
    (Tuple 680 726),
    (Tuple 680 727),
    (Tuple 680 766),
    (Tuple 680 667),
    (Tuple 680 728),
    (Tuple 680 800),
    (Tuple 680 668),
    (Tuple 680 769),
    (Tuple 680 828),
    (Tuple 680 47),
    (Tuple 680 729),
    (Tuple 680 672),
    (Tuple 680 831),
    (Tuple 680 675),
    (Tuple 680 734),
    (Tuple 680 907),
    (Tuple 680 735),
    (Tuple 680 834),
    (Tuple 680 736),
    (Tuple 680 835),
    (Tuple 680 737),
    (Tuple 680 838),
    (Tuple 680 859),
    (Tuple 680 840),
    (Tuple 680 700),
    (Tuple 680 739),
    (Tuple 680 923),
    (Tuple 680 633),
    (Tuple 680 740),
    (Tuple 680 910),
    (Tuple 579 81),
    (Tuple 579 82),
    (Tuple 579 83),
    (Tuple 579 84),
    (Tuple 579 85),
    (Tuple 579 403),
    (Tuple 579 404),
    (Tuple 579 86),
    (Tuple 579 583),
    (Tuple 579 405),
    (Tuple 579 744),
    (Tuple 579 331),
    (Tuple 579 87),
    (Tuple 579 88),
    (Tuple 579 89),
    (Tuple 579 90),
    (Tuple 579 91),
    (Tuple 579 585),
    (Tuple 579 332),
    (Tuple 579 92),
    (Tuple 579 333),
    (Tuple 579 407),
    (Tuple 579 408),
    (Tuple 579 94),
    (Tuple 579 95),
    (Tuple 579 509),
    (Tuple 579 235),
    (Tuple 579 41),
    (Tuple 579 97),
    (Tuple 579 542),
    (Tuple 579 98),
    (Tuple 579 99),
    (Tuple 579 312),
    (Tuple 579 100),
    (Tuple 579 557),
    (Tuple 579 101),
    (Tuple 579 344),
    (Tuple 579 416),
    (Tuple 579 417),
    (Tuple 579 102),
    (Tuple 579 103),
    (Tuple 579 104),
    (Tuple 579 420),
    (Tuple 579 105),
    (Tuple 579 106),
    (Tuple 579 107),
    (Tuple 579 108),
    (Tuple 579 109),
    (Tuple 579 110),
    (Tuple 579 111),
    (Tuple 579 49),
    (Tuple 579 528),
    (Tuple 579 592),
    (Tuple 579 112),
    (Tuple 579 113),
    (Tuple 579 857),
    (Tuple 579 693),
    (Tuple 579 530),
    (Tuple 579 369),
    (Tuple 579 114),
    (Tuple 579 52),
    (Tuple 579 115),
    (Tuple 579 116),
    (Tuple 579 349),
    (Tuple 579 117),
    (Tuple 579 119),
    (Tuple 579 426),
    (Tuple 579 120),
    (Tuple 579 121),
    (Tuple 579 428),
    (Tuple 579 122),
    (Tuple 579 267),
    (Tuple 579 123),
    (Tuple 579 57),
    (Tuple 579 124),
    (Tuple 579 707),
    (Tuple 579 126),
    (Tuple 579 127),
    (Tuple 579 430),
    (Tuple 579 128),
    (Tuple 579 129),
    (Tuple 579 130),
    (Tuple 579 594),
    (Tuple 579 595),
    (Tuple 579 131),
    (Tuple 579 433),
    (Tuple 579 597),
    (Tuple 579 132),
    (Tuple 579 308),
    (Tuple 579 133),
    (Tuple 579 357),
    (Tuple 579 309),
    (Tuple 822 822),
    (Tuple 822 762),
    (Tuple 822 34),
    (Tuple 822 824),
    (Tuple 822 725),
    (Tuple 822 627),
    (Tuple 822 527),
    (Tuple 822 727),
    (Tuple 822 766),
    (Tuple 822 264),
    (Tuple 822 826),
    (Tuple 822 42),
    (Tuple 822 827),
    (Tuple 822 828),
    (Tuple 822 770),
    (Tuple 822 731),
    (Tuple 822 682),
    (Tuple 822 673),
    (Tuple 822 486),
    (Tuple 822 733),
    (Tuple 822 734),
    (Tuple 822 833),
    (Tuple 822 631),
    (Tuple 822 779),
    (Tuple 822 780),
    (Tuple 822 781),
    (Tuple 822 837),
    (Tuple 822 839),
    (Tuple 822 632),
    (Tuple 822 699),
    (Tuple 822 840),
    (Tuple 822 783),
    (Tuple 822 784),
    (Tuple 822 353),
    (Tuple 822 785),
    (Tuple 822 786),
    (Tuple 822 787),
    (Tuple 822 788),
    (Tuple 822 514),
    (Tuple 822 740),
    (Tuple 822 683),
    (Tuple 822 393),
    (Tuple 822 615),
    (Tuple 376 376),
    (Tuple 376 194),
    (Tuple 376 463),
    (Tuple 376 195),
    (Tuple 376 21),
    (Tuple 376 196),
    (Tuple 376 278),
    (Tuple 376 280),
    (Tuple 376 199),
    (Tuple 376 282),
    (Tuple 376 165),
    (Tuple 376 200),
    (Tuple 376 166),
    (Tuple 376 204),
    (Tuple 376 208),
    (Tuple 376 284),
    (Tuple 376 209),
    (Tuple 376 210),
    (Tuple 376 211),
    (Tuple 376 168),
    (Tuple 376 383),
    (Tuple 376 217),
    (Tuple 376 221),
    (Tuple 376 222),
    (Tuple 376 224),
    (Tuple 376 394),
    (Tuple 762 724),
    (Tuple 762 929),
    (Tuple 762 34),
    (Tuple 762 807),
    (Tuple 762 725),
    (Tuple 762 764),
    (Tuple 762 726),
    (Tuple 762 727),
    (Tuple 762 766),
    (Tuple 762 667),
    (Tuple 762 207),
    (Tuple 762 728),
    (Tuple 762 800),
    (Tuple 762 668),
    (Tuple 762 768),
    (Tuple 762 769),
    (Tuple 762 935),
    (Tuple 762 828),
    (Tuple 762 813),
    (Tuple 762 939),
    (Tuple 762 731),
    (Tuple 762 671),
    (Tuple 762 831),
    (Tuple 762 734),
    (Tuple 762 833),
    (Tuple 762 779),
    (Tuple 762 834),
    (Tuple 762 736),
    (Tuple 762 835),
    (Tuple 762 780),
    (Tuple 762 836),
    (Tuple 762 737),
    (Tuple 762 738),
    (Tuple 762 859),
    (Tuple 762 909),
    (Tuple 762 352),
    (Tuple 762 923),
    (Tuple 762 740),
    (Tuple 762 842),
    (Tuple 194 194),
    (Tuple 194 195),
    (Tuple 194 453),
    (Tuple 194 277),
    (Tuple 194 259),
    (Tuple 194 197),
    (Tuple 194 198),
    (Tuple 194 279),
    (Tuple 194 280),
    (Tuple 194 282),
    (Tuple 194 165),
    (Tuple 194 200),
    (Tuple 194 283),
    (Tuple 194 203),
    (Tuple 194 166),
    (Tuple 194 204),
    (Tuple 194 205),
    (Tuple 194 464),
    (Tuple 194 284),
    (Tuple 194 209),
    (Tuple 194 211),
    (Tuple 194 288),
    (Tuple 194 212),
    (Tuple 194 23),
    (Tuple 194 289),
    (Tuple 194 382),
    (Tuple 194 383),
    (Tuple 194 216),
    (Tuple 194 171),
    (Tuple 194 262),
    (Tuple 194 220),
    (Tuple 194 390),
    (Tuple 194 392),
    (Tuple 194 223),
    (Tuple 194 224),
    (Tuple 194 394),
    (Tuple 695 666),
    (Tuple 695 329),
    (Tuple 695 38),
    (Tuple 695 526),
    (Tuple 695 330),
    (Tuple 695 727),
    (Tuple 695 495),
    (Tuple 695 333),
    (Tuple 695 667),
    (Tuple 695 207),
    (Tuple 695 926),
    (Tuple 695 42),
    (Tuple 695 800),
    (Tuple 695 696),
    (Tuple 695 97),
    (Tuple 695 668),
    (Tuple 695 767),
    (Tuple 695 312),
    (Tuple 695 697),
    (Tuple 695 772),
    (Tuple 695 305),
    (Tuple 695 672),
    (Tuple 695 734),
    (Tuple 695 698),
    (Tuple 695 782),
    (Tuple 695 699),
    (Tuple 695 923),
    (Tuple 695 676),
    (Tuple 695 633),
    (Tuple 695 677),
    (Tuple 695 842),
    (Tuple 463 463),
    (Tuple 463 644),
    (Tuple 463 195),
    (Tuple 463 453),
    (Tuple 463 21),
    (Tuple 463 259),
    (Tuple 463 196),
    (Tuple 463 199),
    (Tuple 463 378),
    (Tuple 463 315),
    (Tuple 463 203),
    (Tuple 463 166),
    (Tuple 463 379),
    (Tuple 463 380),
    (Tuple 463 208),
    (Tuple 463 9),
    (Tuple 463 209),
    (Tuple 463 210),
    (Tuple 463 211),
    (Tuple 463 168),
    (Tuple 463 170),
    (Tuple 463 212),
    (Tuple 463 213),
    (Tuple 463 645),
    (Tuple 463 23),
    (Tuple 463 381),
    (Tuple 463 383),
    (Tuple 463 384),
    (Tuple 463 218),
    (Tuple 463 387),
    (Tuple 463 648),
    (Tuple 463 390),
    (Tuple 463 68),
    (Tuple 463 221),
    (Tuple 463 222),
    (Tuple 463 290),
    (Tuple 463 224),
    (Tuple 463 225),
    (Tuple 644 195),
    (Tuple 644 453),
    (Tuple 644 21),
    (Tuple 644 259),
    (Tuple 644 196),
    (Tuple 644 199),
    (Tuple 644 166),
    (Tuple 644 379),
    (Tuple 644 380),
    (Tuple 644 208),
    (Tuple 644 211),
    (Tuple 644 212),
    (Tuple 644 645),
    (Tuple 644 23),
    (Tuple 644 383),
    (Tuple 644 66),
    (Tuple 644 387),
    (Tuple 644 649),
    (Tuple 644 221),
    (Tuple 644 222),
    (Tuple 867 867),
    (Tuple 867 327),
    (Tuple 867 687),
    (Tuple 867 34),
    (Tuple 867 626),
    (Tuple 867 824),
    (Tuple 867 84),
    (Tuple 867 404),
    (Tuple 867 526),
    (Tuple 867 86),
    (Tuple 867 583),
    (Tuple 867 527),
    (Tuple 867 87),
    (Tuple 867 406),
    (Tuple 867 92),
    (Tuple 867 334),
    (Tuple 867 337),
    (Tuple 867 94),
    (Tuple 867 804),
    (Tuple 867 97),
    (Tuple 867 542),
    (Tuple 867 827),
    (Tuple 867 861),
    (Tuple 867 100),
    (Tuple 867 669),
    (Tuple 867 413),
    (Tuple 867 345),
    (Tuple 867 630),
    (Tuple 867 102),
    (Tuple 867 103),
    (Tuple 867 305),
    (Tuple 867 420),
    (Tuple 867 421),
    (Tuple 867 105),
    (Tuple 867 106),
    (Tuple 867 733),
    (Tuple 867 832),
    (Tuple 867 49),
    (Tuple 867 295),
    (Tuple 867 698),
    (Tuple 867 112),
    (Tuple 867 529),
    (Tuple 867 530),
    (Tuple 867 531),
    (Tuple 867 425),
    (Tuple 867 781),
    (Tuple 867 349),
    (Tuple 867 549),
    (Tuple 867 120),
    (Tuple 867 351),
    (Tuple 867 632),
    (Tuple 867 699),
    (Tuple 867 353),
    (Tuple 867 124),
    (Tuple 867 125),
    (Tuple 867 430),
    (Tuple 867 789),
    (Tuple 867 533),
    (Tuple 867 433),
    (Tuple 867 703),
    (Tuple 867 790),
    (Tuple 867 393),
    (Tuple 867 842),
    (Tuple 327 81),
    (Tuple 327 803),
    (Tuple 327 83),
    (Tuple 327 582),
    (Tuple 327 37),
    (Tuple 327 84),
    (Tuple 327 39),
    (Tuple 327 404),
    (Tuple 327 526),
    (Tuple 327 86),
    (Tuple 327 583),
    (Tuple 327 744),
    (Tuple 327 331),
    (Tuple 327 87),
    (Tuple 327 88),
    (Tuple 327 91),
    (Tuple 327 332),
    (Tuple 327 688),
    (Tuple 327 92),
    (Tuple 327 338),
    (Tuple 327 509),
    (Tuple 327 340),
    (Tuple 327 804),
    (Tuple 327 409),
    (Tuple 327 97),
    (Tuple 327 542),
    (Tuple 327 98),
    (Tuple 327 312),
    (Tuple 327 410),
    (Tuple 327 100),
    (Tuple 327 342),
    (Tuple 327 590),
    (Tuple 327 413),
    (Tuple 327 345),
    (Tuple 327 416),
    (Tuple 327 102),
    (Tuple 327 103),
    (Tuple 327 305),
    (Tuple 327 420),
    (Tuple 327 421),
    (Tuple 327 105),
    (Tuple 327 106),
    (Tuple 327 108),
    (Tuple 327 109),
    (Tuple 327 110),
    (Tuple 327 111),
    (Tuple 327 49),
    (Tuple 327 528),
    (Tuple 327 592),
    (Tuple 327 112),
    (Tuple 327 529),
    (Tuple 327 530),
    (Tuple 327 369),
    (Tuple 327 114),
    (Tuple 327 52),
    (Tuple 327 425),
    (Tuple 327 349),
    (Tuple 327 549),
    (Tuple 327 120),
    (Tuple 327 427),
    (Tuple 327 428),
    (Tuple 327 267),
    (Tuple 327 124),
    (Tuple 327 125),
    (Tuple 327 126),
    (Tuple 327 430),
    (Tuple 327 239),
    (Tuple 327 594),
    (Tuple 327 595),
    (Tuple 327 131),
    (Tuple 327 433),
    (Tuple 327 703),
    (Tuple 327 132),
    (Tuple 327 876),
    (Tuple 327 308),
    (Tuple 327 435),
    (Tuple 327 357),
    (Tuple 81 82),
    (Tuple 81 501),
    (Tuple 81 83),
    (Tuple 81 580),
    (Tuple 81 581),
    (Tuple 81 706),
    (Tuple 81 582),
    (Tuple 81 85),
    (Tuple 81 38),
    (Tuple 81 39),
    (Tuple 81 404),
    (Tuple 81 405),
    (Tuple 81 584),
    (Tuple 81 87),
    (Tuple 81 90),
    (Tuple 81 91),
    (Tuple 81 332),
    (Tuple 81 688),
    (Tuple 81 333),
    (Tuple 81 334),
    (Tuple 81 93),
    (Tuple 81 338),
    (Tuple 81 689),
    (Tuple 81 926),
    (Tuple 81 41),
    (Tuple 81 340),
    (Tuple 81 587),
    (Tuple 81 588),
    (Tuple 81 98),
    (Tuple 81 312),
    (Tuple 81 342),
    (Tuple 81 590),
    (Tuple 81 344),
    (Tuple 81 862),
    (Tuple 81 102),
    (Tuple 81 103),
    (Tuple 81 305),
    (Tuple 81 591),
    (Tuple 81 347),
    (Tuple 81 348),
    (Tuple 81 49),
    (Tuple 81 528),
    (Tuple 81 112),
    (Tuple 81 530),
    (Tuple 81 52),
    (Tuple 81 425),
    (Tuple 81 349),
    (Tuple 81 120),
    (Tuple 81 122),
    (Tuple 81 352),
    (Tuple 81 124),
    (Tuple 81 676),
    (Tuple 81 430),
    (Tuple 81 703),
    (Tuple 81 356),
    (Tuple 81 132),
    (Tuple 452 309),
    (Tuple 162 377),
    (Tuple 162 280),
    (Tuple 162 282),
    (Tuple 162 874),
    (Tuple 162 283),
    (Tuple 162 284),
    (Tuple 162 169),
    (Tuple 162 288),
    (Tuple 162 289),
    (Tuple 162 941),
    (Tuple 162 658),
    (Tuple 162 794),
    (Tuple 162 795),
    (Tuple 162 618),
    (Tuple 162 394),
    (Tuple 763 846),
    (Tuple 763 847),
    (Tuple 763 765),
    (Tuple 763 767),
    (Tuple 763 771),
    (Tuple 763 65),
    (Tuple 763 415),
    (Tuple 763 848),
    (Tuple 763 503),
    (Tuple 763 849),
    (Tuple 763 777),
    (Tuple 763 778),
    (Tuple 763 236),
    (Tuple 763 363),
    (Tuple 763 641),
    (Tuple 763 532),
    (Tuple 763 791),
    (Tuple 195 453),
    (Tuple 195 277),
    (Tuple 195 21),
    (Tuple 195 258),
    (Tuple 195 259),
    (Tuple 195 196),
    (Tuple 195 197),
    (Tuple 195 279),
    (Tuple 195 280),
    (Tuple 195 199),
    (Tuple 195 282),
    (Tuple 195 200),
    (Tuple 195 378),
    (Tuple 195 166),
    (Tuple 195 204),
    (Tuple 195 379),
    (Tuple 195 208),
    (Tuple 195 210),
    (Tuple 195 211),
    (Tuple 195 168),
    (Tuple 195 288),
    (Tuple 195 213),
    (Tuple 195 289),
    (Tuple 195 381),
    (Tuple 195 214),
    (Tuple 195 383),
    (Tuple 195 66),
    (Tuple 195 216),
    (Tuple 195 218),
    (Tuple 195 390),
    (Tuple 195 649),
    (Tuple 195 221),
    (Tuple 195 222),
    (Tuple 195 392),
    (Tuple 195 223),
    (Tuple 195 460),
    (Tuple 195 394),
    (Tuple 915 293),
    (Tuple 915 9),
    (Tuple 915 294),
    (Tuple 915 295),
    (Tuple 915 297),
    (Tuple 803 803),
    (Tuple 803 724),
    (Tuple 803 83),
    (Tuple 803 666),
    (Tuple 803 329),
    (Tuple 803 38),
    (Tuple 803 764),
    (Tuple 803 727),
    (Tuple 803 87),
    (Tuple 803 332),
    (Tuple 803 688),
    (Tuple 803 333),
    (Tuple 803 667),
    (Tuple 803 207),
    (Tuple 803 926),
    (Tuple 803 800),
    (Tuple 803 668),
    (Tuple 803 312),
    (Tuple 803 100),
    (Tuple 803 342),
    (Tuple 803 949),
    (Tuple 803 862),
    (Tuple 803 416),
    (Tuple 803 305),
    (Tuple 803 672),
    (Tuple 803 562),
    (Tuple 803 348),
    (Tuple 803 734),
    (Tuple 803 736),
    (Tuple 803 349),
    (Tuple 803 859),
    (Tuple 803 909),
    (Tuple 803 633),
    (Tuple 803 842),
    (Tuple 453 165),
    (Tuple 453 361),
    (Tuple 453 202),
    (Tuple 453 378),
    (Tuple 453 206),
    (Tuple 453 208),
    (Tuple 453 284),
    (Tuple 453 167),
    (Tuple 453 168),
    (Tuple 453 170),
    (Tuple 453 212),
    (Tuple 453 23),
    (Tuple 453 214),
    (Tuple 453 66),
    (Tuple 453 216),
    (Tuple 453 171),
    (Tuple 453 218),
    (Tuple 453 387),
    (Tuple 453 220),
    (Tuple 453 222),
    (Tuple 453 224),
    (Tuple 277 21),
    (Tuple 277 165),
    (Tuple 277 200),
    (Tuple 277 166),
    (Tuple 277 211),
    (Tuple 277 66),
    (Tuple 277 220),
    (Tuple 889 889),
    (Tuple 889 890),
    (Tuple 889 891),
    (Tuple 889 665),
    (Tuple 889 681),
    (Tuple 889 852),
    (Tuple 889 892),
    (Tuple 889 893),
    (Tuple 889 438),
    (Tuple 889 486),
    (Tuple 889 894),
    (Tuple 889 895),
    (Tuple 889 896),
    (Tuple 889 897),
    (Tuple 889 898),
    (Tuple 889 859),
    (Tuple 889 899),
    (Tuple 889 900),
    (Tuple 141 142),
    (Tuple 141 143),
    (Tuple 141 454),
    (Tuple 141 7),
    (Tuple 141 144),
    (Tuple 141 611),
    (Tuple 141 145),
    (Tuple 141 8),
    (Tuple 141 146),
    (Tuple 141 9),
    (Tuple 141 11),
    (Tuple 141 12),
    (Tuple 141 608),
    (Tuple 141 148),
    (Tuple 141 13),
    (Tuple 141 456),
    (Tuple 141 14),
    (Tuple 141 15),
    (Tuple 141 150),
    (Tuple 141 151),
    (Tuple 141 457),
    (Tuple 141 612),
    (Tuple 141 153),
    (Tuple 141 154),
    (Tuple 950 920),
    (Tuple 724 724),
    (Tuple 724 34),
    (Tuple 724 626),
    (Tuple 724 824),
    (Tuple 724 725),
    (Tuple 724 627),
    (Tuple 724 527),
    (Tuple 724 764),
    (Tuple 724 825),
    (Tuple 724 726),
    (Tuple 724 727),
    (Tuple 724 92),
    (Tuple 724 766),
    (Tuple 724 667),
    (Tuple 724 728),
    (Tuple 724 264),
    (Tuple 724 826),
    (Tuple 724 769),
    (Tuple 724 770),
    (Tuple 724 772),
    (Tuple 724 669),
    (Tuple 724 345),
    (Tuple 724 47),
    (Tuple 724 630),
    (Tuple 724 729),
    (Tuple 724 730),
    (Tuple 724 731),
    (Tuple 724 670),
    (Tuple 724 682),
    (Tuple 724 775),
    (Tuple 724 776),
    (Tuple 724 732),
    (Tuple 724 562),
    (Tuple 724 673),
    (Tuple 724 830),
    (Tuple 724 831),
    (Tuple 724 733),
    (Tuple 724 832),
    (Tuple 724 675),
    (Tuple 724 734),
    (Tuple 724 698),
    (Tuple 724 735),
    (Tuple 724 529),
    (Tuple 724 385),
    (Tuple 724 363),
    (Tuple 724 631),
    (Tuple 724 779),
    (Tuple 724 834),
    (Tuple 724 736),
    (Tuple 724 835),
    (Tuple 724 780),
    (Tuple 724 781),
    (Tuple 724 837),
    (Tuple 724 782),
    (Tuple 724 737),
    (Tuple 724 238),
    (Tuple 724 593),
    (Tuple 724 908),
    (Tuple 724 738),
    (Tuple 724 632),
    (Tuple 724 699),
    (Tuple 724 57),
    (Tuple 724 841),
    (Tuple 724 783),
    (Tuple 724 784),
    (Tuple 724 353),
    (Tuple 724 785),
    (Tuple 724 739),
    (Tuple 724 676),
    (Tuple 724 786),
    (Tuple 724 787),
    (Tuple 724 788),
    (Tuple 724 701),
    (Tuple 724 514),
    (Tuple 724 789),
    (Tuple 724 533),
    (Tuple 724 740),
    (Tuple 724 683),
    (Tuple 724 790),
    (Tuple 724 393),
    (Tuple 724 615),
    (Tuple 724 842),
    (Tuple 951 678),
    (Tuple 951 67),
    (Tuple 951 53),
    (Tuple 951 68),
    (Tuple 398 257),
    (Tuple 398 35),
    (Tuple 398 64),
    (Tuple 398 37),
    (Tuple 398 200),
    (Tuple 398 311),
    (Tuple 398 8),
    (Tuple 398 235),
    (Tuple 398 381),
    (Tuple 398 496),
    (Tuple 398 218),
    (Tuple 398 15),
    (Tuple 398 266),
    (Tuple 398 16),
    (Tuple 890 890),
    (Tuple 890 891),
    (Tuple 890 144),
    (Tuple 890 892),
    (Tuple 890 893),
    (Tuple 890 438),
    (Tuple 890 486),
    (Tuple 890 894),
    (Tuple 890 895),
    (Tuple 890 896),
    (Tuple 890 14),
    (Tuple 890 897),
    (Tuple 890 898),
    (Tuple 890 899),
    (Tuple 890 900),
    (Tuple 6 6),
    (Tuple 6 257),
    (Tuple 6 258),
    (Tuple 6 454),
    (Tuple 6 455),
    (Tuple 6 146),
    (Tuple 6 10),
    (Tuple 6 12),
    (Tuple 6 918),
    (Tuple 6 13),
    (Tuple 6 506),
    (Tuple 6 660),
    (Tuple 6 386),
    (Tuple 6 653),
    (Tuple 6 14),
    (Tuple 6 151),
    (Tuple 6 859),
    (Tuple 6 152),
    (Tuple 6 154),
    (Tuple 6 155),
    (Tuple 858 525),
    (Tuple 858 539),
    (Tuple 858 234),
    (Tuple 858 42),
    (Tuple 858 43),
    (Tuple 858 45),
    (Tuple 858 544),
    (Tuple 858 46),
    (Tuple 858 547),
    (Tuple 858 422),
    (Tuple 858 236),
    (Tuple 858 424),
    (Tuple 858 51),
    (Tuple 858 389),
    (Tuple 858 552),
    (Tuple 858 431),
    (Tuple 858 553),
    (Tuple 858 554),
    (Tuple 858 364),
    (Tuple 858 307),
    (Tuple 858 355),
    (Tuple 858 480),
    (Tuple 858 434),
    (Tuple 858 240),
    (Tuple 858 60),
    (Tuple 858 133),
    (Tuple 599 599),
    (Tuple 142 143),
    (Tuple 142 454),
    (Tuple 142 7),
    (Tuple 142 144),
    (Tuple 142 611),
    (Tuple 142 145),
    (Tuple 142 8),
    (Tuple 142 146),
    (Tuple 142 9),
    (Tuple 142 10),
    (Tuple 142 11),
    (Tuple 142 147),
    (Tuple 142 12),
    (Tuple 142 608),
    (Tuple 142 148),
    (Tuple 142 13),
    (Tuple 142 456),
    (Tuple 142 369),
    (Tuple 142 14),
    (Tuple 142 15),
    (Tuple 142 150),
    (Tuple 142 151),
    (Tuple 142 457),
    (Tuple 142 459),
    (Tuple 142 612),
    (Tuple 142 153),
    (Tuple 142 853),
    (Tuple 142 154),
    (Tuple 142 155),
    (Tuple 469 469),
    (Tuple 469 257),
    (Tuple 469 660),
    (Tuple 469 15),
    (Tuple 232 257),
    (Tuple 232 258),
    (Tuple 232 259),
    (Tuple 232 206),
    (Tuple 232 67),
    (Tuple 232 859),
    (Tuple 232 618),
    (Tuple 925 37),
    (Tuple 925 526),
    (Tuple 925 334),
    (Tuple 925 97),
    (Tuple 925 697),
    (Tuple 925 413),
    (Tuple 925 345),
    (Tuple 925 630),
    (Tuple 925 305),
    (Tuple 925 421),
    (Tuple 925 112),
    (Tuple 925 531),
    (Tuple 925 52),
    (Tuple 925 425),
    (Tuple 925 349),
    (Tuple 925 549),
    (Tuple 925 632),
    (Tuple 925 699),
    (Tuple 925 428),
    (Tuple 925 125),
    (Tuple 925 430),
    (Tuple 925 595),
    (Tuple 925 131),
    (Tuple 925 703),
    (Tuple 233 525),
    (Tuple 233 39),
    (Tuple 233 405),
    (Tuple 233 527),
    (Tuple 233 476),
    (Tuple 233 235),
    (Tuple 233 43),
    (Tuple 233 100),
    (Tuple 233 45),
    (Tuple 233 46),
    (Tuple 233 104),
    (Tuple 233 236),
    (Tuple 233 51),
    (Tuple 233 52),
    (Tuple 233 238),
    (Tuple 233 120),
    (Tuple 233 429),
    (Tuple 233 267),
    (Tuple 233 123),
    (Tuple 233 57),
    (Tuple 233 126),
    (Tuple 233 552),
    (Tuple 233 430),
    (Tuple 233 239),
    (Tuple 233 553),
    (Tuple 233 554),
    (Tuple 233 364),
    (Tuple 233 16),
    (Tuple 233 240),
    (Tuple 233 505),
    (Tuple 233 60),
    (Tuple 233 241),
    (Tuple 233 357),
    (Tuple 82 82),
    (Tuple 82 83),
    (Tuple 82 84),
    (Tuple 82 405),
    (Tuple 82 361),
    (Tuple 82 331),
    (Tuple 82 87),
    (Tuple 82 88),
    (Tuple 82 89),
    (Tuple 82 332),
    (Tuple 82 335),
    (Tuple 82 93),
    (Tuple 82 94),
    (Tuple 82 338),
    (Tuple 82 41),
    (Tuple 82 42),
    (Tuple 82 97),
    (Tuple 82 542),
    (Tuple 82 98),
    (Tuple 82 99),
    (Tuple 82 100),
    (Tuple 82 557),
    (Tuple 82 416),
    (Tuple 82 417),
    (Tuple 82 102),
    (Tuple 82 103),
    (Tuple 82 305),
    (Tuple 82 104),
    (Tuple 82 420),
    (Tuple 82 106),
    (Tuple 82 107),
    (Tuple 82 108),
    (Tuple 82 109),
    (Tuple 82 306),
    (Tuple 82 111),
    (Tuple 82 49),
    (Tuple 82 528),
    (Tuple 82 592),
    (Tuple 82 113),
    (Tuple 82 369),
    (Tuple 82 52),
    (Tuple 82 115),
    (Tuple 82 116),
    (Tuple 82 117),
    (Tuple 82 426),
    (Tuple 82 120),
    (Tuple 82 121),
    (Tuple 82 122),
    (Tuple 82 267),
    (Tuple 82 123),
    (Tuple 82 126),
    (Tuple 82 128),
    (Tuple 82 130),
    (Tuple 82 131),
    (Tuple 82 132),
    (Tuple 82 308),
    (Tuple 82 133),
    (Tuple 82 309),
    (Tuple 891 852),
    (Tuple 891 813),
    (Tuple 891 918),
    (Tuple 891 892),
    (Tuple 891 893),
    (Tuple 891 438),
    (Tuple 891 486),
    (Tuple 891 894),
    (Tuple 891 895),
    (Tuple 891 896),
    (Tuple 891 897),
    (Tuple 891 898),
    (Tuple 891 859),
    (Tuple 891 899),
    (Tuple 891 900),
    (Tuple 257 34),
    (Tuple 257 64),
    (Tuple 257 197),
    (Tuple 257 40),
    (Tuple 257 22),
    (Tuple 257 476),
    (Tuple 257 89),
    (Tuple 257 205),
    (Tuple 257 206),
    (Tuple 257 379),
    (Tuple 257 9),
    (Tuple 257 285),
    (Tuple 257 23),
    (Tuple 257 214),
    (Tuple 257 471),
    (Tuple 257 171),
    (Tuple 257 51),
    (Tuple 257 52),
    (Tuple 257 266),
    (Tuple 257 513),
    (Tuple 257 16),
    (Tuple 257 60),
    (Tuple 257 241),
    (Tuple 257 173),
    (Tuple 360 360),
    (Tuple 360 539),
    (Tuple 360 83),
    (Tuple 360 582),
    (Tuple 360 540),
    (Tuple 360 329),
    (Tuple 360 311),
    (Tuple 360 330),
    (Tuple 360 495),
    (Tuple 360 332),
    (Tuple 360 338),
    (Tuple 360 42),
    (Tuple 360 668),
    (Tuple 360 341),
    (Tuple 360 362),
    (Tuple 360 343),
    (Tuple 360 561),
    (Tuple 360 546),
    (Tuple 360 859),
    (Tuple 360 352),
    (Tuple 360 658),
    (Tuple 360 355),
    (Tuple 360 564),
    (Tuple 705 605),
    (Tuple 705 583),
    (Tuple 705 405),
    (Tuple 705 87),
    (Tuple 705 88),
    (Tuple 705 542),
    (Tuple 705 100),
    (Tuple 705 414),
    (Tuple 705 417),
    (Tuple 705 103),
    (Tuple 705 105),
    (Tuple 705 106),
    (Tuple 705 109),
    (Tuple 705 52),
    (Tuple 705 116),
    (Tuple 705 126),
    (Tuple 705 132),
    (Tuple 929 34),
    (Tuple 929 824),
    (Tuple 929 627),
    (Tuple 929 825),
    (Tuple 929 727),
    (Tuple 929 667),
    (Tuple 929 728),
    (Tuple 929 264),
    (Tuple 929 826),
    (Tuple 929 770),
    (Tuple 929 731),
    (Tuple 929 673),
    (Tuple 929 733),
    (Tuple 929 832),
    (Tuple 929 698),
    (Tuple 929 631),
    (Tuple 929 736),
    (Tuple 929 780),
    (Tuple 929 837),
    (Tuple 929 839),
    (Tuple 929 699),
    (Tuple 929 57),
    (Tuple 929 783),
    (Tuple 929 784),
    (Tuple 929 786),
    (Tuple 929 787),
    (Tuple 929 514),
    (Tuple 929 683),
    (Tuple 929 615),
    (Tuple 929 843),
    (Tuple 823 727),
    (Tuple 823 667),
    (Tuple 823 264),
    (Tuple 823 730),
    (Tuple 823 673),
    (Tuple 823 831),
    (Tuple 823 780),
    (Tuple 823 781),
    (Tuple 823 837),
    (Tuple 823 783),
    (Tuple 823 784),
    (Tuple 823 786),
    (Tuple 823 787),
    (Tuple 823 615),
    (Tuple 377 202),
    (Tuple 377 167),
    (Tuple 377 285),
    (Tuple 377 288),
    (Tuple 377 25),
    (Tuple 377 23),
    (Tuple 377 289),
    (Tuple 377 171),
    (Tuple 377 224),
    (Tuple 687 666),
    (Tuple 687 38),
    (Tuple 687 402),
    (Tuple 687 726),
    (Tuple 687 332),
    (Tuple 687 688),
    (Tuple 687 912),
    (Tuple 687 333),
    (Tuple 687 667),
    (Tuple 687 207),
    (Tuple 687 800),
    (Tuple 687 868),
    (Tuple 687 696),
    (Tuple 687 588),
    (Tuple 687 668),
    (Tuple 687 827),
    (Tuple 687 949),
    (Tuple 687 773),
    (Tuple 687 345),
    (Tuple 687 862),
    (Tuple 687 774),
    (Tuple 687 416),
    (Tuple 687 731),
    (Tuple 687 670),
    (Tuple 687 801),
    (Tuple 687 732),
    (Tuple 687 672),
    (Tuple 687 562),
    (Tuple 687 347),
    (Tuple 687 503),
    (Tuple 687 733),
    (Tuple 687 832),
    (Tuple 687 675),
    (Tuple 687 907),
    (Tuple 687 779),
    (Tuple 687 52),
    (Tuple 687 699),
    (Tuple 687 859),
    (Tuple 687 700),
    (Tuple 687 923),
    (Tuple 687 786),
    (Tuple 687 701),
    (Tuple 687 633),
    (Tuple 687 677),
    (Tuple 687 702),
    (Tuple 687 843),
    (Tuple 328 83),
    (Tuple 328 581),
    (Tuple 328 582),
    (Tuple 328 38),
    (Tuple 328 605),
    (Tuple 328 405),
    (Tuple 328 87),
    (Tuple 328 90),
    (Tuple 328 332),
    (Tuple 328 688),
    (Tuple 328 333),
    (Tuple 328 93),
    (Tuple 328 337),
    (Tuple 328 338),
    (Tuple 328 340),
    (Tuple 328 587),
    (Tuple 328 98),
    (Tuple 328 312),
    (Tuple 328 100),
    (Tuple 328 557),
    (Tuple 328 342),
    (Tuple 328 103),
    (Tuple 328 305),
    (Tuple 328 591),
    (Tuple 328 420),
    (Tuple 328 348),
    (Tuple 328 120),
    (Tuple 328 435),
    (Tuple 846 847),
    (Tuple 846 765),
    (Tuple 846 767),
    (Tuple 846 415),
    (Tuple 846 848),
    (Tuple 846 849),
    (Tuple 846 850),
    (Tuple 846 777),
    (Tuple 846 778),
    (Tuple 21 280),
    (Tuple 21 378),
    (Tuple 21 315),
    (Tuple 21 166),
    (Tuple 21 208),
    (Tuple 21 209),
    (Tuple 21 210),
    (Tuple 21 211),
    (Tuple 21 212),
    (Tuple 21 213),
    (Tuple 21 645),
    (Tuple 21 289),
    (Tuple 21 382),
    (Tuple 21 646),
    (Tuple 21 383),
    (Tuple 21 647),
    (Tuple 21 216),
    (Tuple 21 217),
    (Tuple 21 218),
    (Tuple 21 219),
    (Tuple 21 648),
    (Tuple 21 390),
    (Tuple 21 649),
    (Tuple 21 68),
    (Tuple 21 290),
    (Tuple 21 225),
    (Tuple 21 394),
    (Tuple 258 196),
    (Tuple 258 40),
    (Tuple 258 22),
    (Tuple 258 203),
    (Tuple 258 43),
    (Tuple 258 170),
    (Tuple 258 65),
    (Tuple 258 23),
    (Tuple 258 305),
    (Tuple 258 214),
    (Tuple 258 112),
    (Tuple 258 237),
    (Tuple 258 693),
    (Tuple 258 51),
    (Tuple 258 52),
    (Tuple 258 799),
    (Tuple 258 125),
    (Tuple 258 222),
    (Tuple 258 658),
    (Tuple 258 16),
    (Tuple 258 224),
    (Tuple 258 60),
    (Tuple 34 34),
    (Tuple 34 666),
    (Tuple 34 725),
    (Tuple 34 681),
    (Tuple 34 627),
    (Tuple 34 764),
    (Tuple 34 726),
    (Tuple 34 727),
    (Tuple 34 766),
    (Tuple 34 667),
    (Tuple 34 728),
    (Tuple 34 800),
    (Tuple 34 668),
    (Tuple 34 767),
    (Tuple 34 934),
    (Tuple 34 935),
    (Tuple 34 828),
    (Tuple 34 829),
    (Tuple 34 770),
    (Tuple 34 773),
    (Tuple 34 939),
    (Tuple 34 47),
    (Tuple 34 729),
    (Tuple 34 730),
    (Tuple 34 731),
    (Tuple 34 670),
    (Tuple 34 682),
    (Tuple 34 732),
    (Tuple 34 672),
    (Tuple 34 831),
    (Tuple 34 733),
    (Tuple 34 675),
    (Tuple 34 734),
    (Tuple 34 698),
    (Tuple 34 735),
    (Tuple 34 833),
    (Tuple 34 779),
    (Tuple 34 834),
    (Tuple 34 736),
    (Tuple 34 835),
    (Tuple 34 780),
    (Tuple 34 737),
    (Tuple 34 908),
    (Tuple 34 738),
    (Tuple 34 839),
    (Tuple 34 699),
    (Tuple 34 859),
    (Tuple 34 840),
    (Tuple 34 936),
    (Tuple 34 783),
    (Tuple 34 784),
    (Tuple 34 785),
    (Tuple 34 700),
    (Tuple 34 739),
    (Tuple 34 923),
    (Tuple 34 676),
    (Tuple 34 786),
    (Tuple 34 787),
    (Tuple 34 701),
    (Tuple 34 514),
    (Tuple 34 633),
    (Tuple 34 677),
    (Tuple 34 702),
    (Tuple 34 740),
    (Tuple 34 683),
    (Tuple 34 615),
    (Tuple 34 842),
    (Tuple 34 843),
    (Tuple 34 910),
    (Tuple 35 35),
    (Tuple 35 501),
    (Tuple 35 494),
    (Tuple 35 605),
    (Tuple 35 39),
    (Tuple 35 311),
    (Tuple 35 303),
    (Tuple 35 170),
    (Tuple 35 414),
    (Tuple 35 316),
    (Tuple 35 236),
    (Tuple 35 496),
    (Tuple 35 497),
    (Tuple 35 52),
    (Tuple 35 53),
    (Tuple 35 593),
    (Tuple 35 117),
    (Tuple 35 370),
    (Tuple 35 54),
    (Tuple 35 55),
    (Tuple 35 56),
    (Tuple 35 391),
    (Tuple 35 58),
    (Tuple 35 126),
    (Tuple 35 59),
    (Tuple 35 173),
    (Tuple 35 309),
    (Tuple 64 278),
    (Tuple 64 279),
    (Tuple 64 280),
    (Tuple 64 281),
    (Tuple 64 282),
    (Tuple 64 874),
    (Tuple 64 22),
    (Tuple 64 288),
    (Tuple 657 758),
    (Tuple 657 311),
    (Tuple 657 928),
    (Tuple 657 952),
    (Tuple 657 53),
    (Tuple 657 55),
    (Tuple 657 58),
    (Tuple 657 431),
    (Tuple 657 173),
    (Tuple 525 501),
    (Tuple 525 83),
    (Tuple 525 933),
    (Tuple 525 711),
    (Tuple 525 581),
    (Tuple 525 540),
    (Tuple 525 38),
    (Tuple 525 39),
    (Tuple 525 338),
    (Tuple 525 628),
    (Tuple 525 207),
    (Tuple 525 339),
    (Tuple 525 42),
    (Tuple 525 587),
    (Tuple 525 767),
    (Tuple 525 312),
    (Tuple 525 362),
    (Tuple 525 546),
    (Tuple 525 801),
    (Tuple 525 419),
    (Tuple 525 503),
    (Tuple 525 859),
    (Tuple 525 352),
    (Tuple 525 676),
    (Tuple 525 355),
    (Tuple 525 866),
    (Tuple 807 38),
    (Tuple 807 627),
    (Tuple 807 88),
    (Tuple 807 91),
    (Tuple 807 424),
    (Tuple 807 676),
    (Tuple 807 789),
    (Tuple 807 615),
    (Tuple 539 539),
    (Tuple 539 234),
    (Tuple 539 89),
    (Tuple 539 303),
    (Tuple 539 42),
    (Tuple 539 543),
    (Tuple 539 43),
    (Tuple 539 560),
    (Tuple 539 45),
    (Tuple 539 46),
    (Tuple 539 418),
    (Tuple 539 546),
    (Tuple 539 562),
    (Tuple 539 547),
    (Tuple 539 422),
    (Tuple 539 236),
    (Tuple 539 548),
    (Tuple 539 385),
    (Tuple 539 424),
    (Tuple 539 641),
    (Tuple 539 51),
    (Tuple 539 52),
    (Tuple 539 117),
    (Tuple 539 550),
    (Tuple 539 389),
    (Tuple 539 551),
    (Tuple 539 126),
    (Tuple 539 552),
    (Tuple 539 239),
    (Tuple 539 431),
    (Tuple 539 532),
    (Tuple 539 534),
    (Tuple 539 553),
    (Tuple 539 554),
    (Tuple 539 364),
    (Tuple 539 129),
    (Tuple 539 307),
    (Tuple 539 355),
    (Tuple 539 480),
    (Tuple 539 434),
    (Tuple 539 240),
    (Tuple 539 505),
    (Tuple 539 60),
    (Tuple 539 241),
    (Tuple 539 133),
    (Tuple 539 309),
    (Tuple 539 866),
    (Tuple 501 36),
    (Tuple 501 38),
    (Tuple 501 405),
    (Tuple 501 91),
    (Tuple 501 337),
    (Tuple 501 235),
    (Tuple 501 42),
    (Tuple 501 97),
    (Tuple 501 312),
    (Tuple 501 43),
    (Tuple 501 362),
    (Tuple 501 46),
    (Tuple 501 102),
    (Tuple 501 103),
    (Tuple 501 104),
    (Tuple 501 673),
    (Tuple 501 547),
    (Tuple 501 236),
    (Tuple 501 111),
    (Tuple 501 49),
    (Tuple 501 693),
    (Tuple 501 530),
    (Tuple 501 369),
    (Tuple 501 114),
    (Tuple 501 52),
    (Tuple 501 425),
    (Tuple 501 120),
    (Tuple 501 266),
    (Tuple 501 427),
    (Tuple 501 428),
    (Tuple 501 267),
    (Tuple 501 123),
    (Tuple 501 57),
    (Tuple 501 783),
    (Tuple 501 124),
    (Tuple 501 126),
    (Tuple 501 787),
    (Tuple 501 59),
    (Tuple 501 364),
    (Tuple 501 60),
    (Tuple 501 435),
    (Tuple 501 241),
    (Tuple 501 309),
    (Tuple 83 37),
    (Tuple 83 84),
    (Tuple 83 85),
    (Tuple 83 402),
    (Tuple 83 403),
    (Tuple 83 404),
    (Tuple 83 583),
    (Tuple 83 405),
    (Tuple 83 361),
    (Tuple 83 234),
    (Tuple 83 744),
    (Tuple 83 331),
    (Tuple 83 87),
    (Tuple 83 88),
    (Tuple 83 89),
    (Tuple 83 90),
    (Tuple 83 91),
    (Tuple 83 585),
    (Tuple 83 332),
    (Tuple 83 406),
    (Tuple 83 92),
    (Tuple 83 333),
    (Tuple 83 334),
    (Tuple 83 335),
    (Tuple 83 407),
    (Tuple 83 408),
    (Tuple 83 337),
    (Tuple 83 94),
    (Tuple 83 338),
    (Tuple 83 95),
    (Tuple 83 586),
    (Tuple 83 509),
    (Tuple 83 96),
    (Tuple 83 235),
    (Tuple 83 41),
    (Tuple 83 42),
    (Tuple 83 97),
    (Tuple 83 542),
    (Tuple 83 98),
    (Tuple 83 99),
    (Tuple 83 410),
    (Tuple 83 411),
    (Tuple 83 100),
    (Tuple 83 557),
    (Tuple 83 590),
    (Tuple 83 101),
    (Tuple 83 413),
    (Tuple 83 345),
    (Tuple 83 415),
    (Tuple 83 416),
    (Tuple 83 417),
    (Tuple 83 346),
    (Tuple 83 102),
    (Tuple 83 103),
    (Tuple 83 305),
    (Tuple 83 104),
    (Tuple 83 745),
    (Tuple 83 420),
    (Tuple 83 421),
    (Tuple 83 105),
    (Tuple 83 106),
    (Tuple 83 107),
    (Tuple 83 108),
    (Tuple 83 422),
    (Tuple 83 109),
    (Tuple 83 110),
    (Tuple 83 306),
    (Tuple 83 111),
    (Tuple 83 49),
    (Tuple 83 528),
    (Tuple 83 592),
    (Tuple 83 112),
    (Tuple 83 237),
    (Tuple 83 113),
    (Tuple 83 424),
    (Tuple 83 530),
    (Tuple 83 369),
    (Tuple 83 114),
    (Tuple 83 531),
    (Tuple 83 52),
    (Tuple 83 425),
    (Tuple 83 115),
    (Tuple 83 116),
    (Tuple 83 349),
    (Tuple 83 238),
    (Tuple 83 117),
    (Tuple 83 118),
    (Tuple 83 119),
    (Tuple 83 426),
    (Tuple 83 120),
    (Tuple 83 121),
    (Tuple 83 427),
    (Tuple 83 428),
    (Tuple 83 122),
    (Tuple 83 429),
    (Tuple 83 267),
    (Tuple 83 123),
    (Tuple 83 124),
    (Tuple 83 125),
    (Tuple 83 707),
    (Tuple 83 126),
    (Tuple 83 127),
    (Tuple 83 430),
    (Tuple 83 239),
    (Tuple 83 128),
    (Tuple 83 432),
    (Tuple 83 129),
    (Tuple 83 130),
    (Tuple 83 594),
    (Tuple 83 595),
    (Tuple 83 131),
    (Tuple 83 433),
    (Tuple 83 703),
    (Tuple 83 596),
    (Tuple 83 597),
    (Tuple 83 505),
    (Tuple 83 132),
    (Tuple 83 308),
    (Tuple 83 60),
    (Tuple 83 435),
    (Tuple 83 241),
    (Tuple 83 133),
    (Tuple 83 357),
    (Tuple 83 309),
    (Tuple 809 809),
    (Tuple 809 751),
    (Tuple 809 882),
    (Tuple 809 388),
    (Tuple 809 753),
    (Tuple 809 754),
    (Tuple 809 755),
    (Tuple 933 234),
    (Tuple 933 303),
    (Tuple 933 235),
    (Tuple 933 264),
    (Tuple 933 265),
    (Tuple 933 697),
    (Tuple 933 418),
    (Tuple 933 775),
    (Tuple 933 236),
    (Tuple 933 363),
    (Tuple 933 424),
    (Tuple 933 121),
    (Tuple 933 122),
    (Tuple 933 125),
    (Tuple 933 634),
    (Tuple 933 432),
    (Tuple 933 364),
    (Tuple 933 131),
    (Tuple 143 7),
    (Tuple 143 144),
    (Tuple 143 8),
    (Tuple 143 9),
    (Tuple 143 11),
    (Tuple 143 12),
    (Tuple 143 918),
    (Tuple 143 148),
    (Tuple 143 14),
    (Tuple 143 15),
    (Tuple 143 150),
    (Tuple 143 151),
    (Tuple 143 153),
    (Tuple 143 154),
    (Tuple 143 155),
    (Tuple 143 460),
    (Tuple 626 38),
    (Tuple 626 681),
    (Tuple 626 764),
    (Tuple 626 726),
    (Tuple 626 727),
    (Tuple 626 766),
    (Tuple 626 667),
    (Tuple 626 207),
    (Tuple 626 728),
    (Tuple 626 42),
    (Tuple 626 800),
    (Tuple 626 668),
    (Tuple 626 828),
    (Tuple 626 813),
    (Tuple 626 731),
    (Tuple 626 670),
    (Tuple 626 671),
    (Tuple 626 732),
    (Tuple 626 672),
    (Tuple 626 504),
    (Tuple 626 675),
    (Tuple 626 734),
    (Tuple 626 907),
    (Tuple 626 779),
    (Tuple 626 834),
    (Tuple 626 736),
    (Tuple 626 780),
    (Tuple 626 700),
    (Tuple 626 923),
    (Tuple 626 740),
    (Tuple 626 842),
    (Tuple 494 494),
    (Tuple 494 42),
    (Tuple 494 236),
    (Tuple 494 53),
    (Tuple 494 117),
    (Tuple 494 370),
    (Tuple 494 56),
    (Tuple 494 391),
    (Tuple 494 58),
    (Tuple 494 59),
    (Tuple 711 711),
    (Tuple 711 944),
    (Tuple 711 163),
    (Tuple 711 691),
    (Tuple 711 39),
    (Tuple 711 40),
    (Tuple 711 361),
    (Tuple 711 89),
    (Tuple 711 303),
    (Tuple 711 235),
    (Tuple 711 42),
    (Tuple 711 312),
    (Tuple 711 43),
    (Tuple 711 45),
    (Tuple 711 621),
    (Tuple 711 544),
    (Tuple 711 46),
    (Tuple 711 414),
    (Tuple 711 712),
    (Tuple 711 546),
    (Tuple 711 236),
    (Tuple 711 306),
    (Tuple 711 548),
    (Tuple 711 237),
    (Tuple 711 424),
    (Tuple 711 369),
    (Tuple 711 117),
    (Tuple 711 55),
    (Tuple 711 429),
    (Tuple 711 267),
    (Tuple 711 126),
    (Tuple 711 552),
    (Tuple 711 658),
    (Tuple 711 431),
    (Tuple 711 307),
    (Tuple 711 240),
    (Tuple 711 308),
    (Tuple 711 60),
    (Tuple 711 173),
    (Tuple 953 919),
    (Tuple 953 14),
    (Tuple 953 172),
    (Tuple 878 878),
    (Tuple 878 879),
    (Tuple 878 119),
    (Tuple 878 127),
    (Tuple 947 947),
    (Tuple 947 771),
    (Tuple 947 415),
    (Tuple 947 776),
    (Tuple 947 503),
    (Tuple 947 363),
    (Tuple 947 532),
    (Tuple 947 791),
    (Tuple 580 87),
    (Tuple 580 91),
    (Tuple 580 97),
    (Tuple 580 312),
    (Tuple 580 411),
    (Tuple 580 478),
    (Tuple 580 417),
    (Tuple 580 102),
    (Tuple 580 104),
    (Tuple 580 106),
    (Tuple 580 107),
    (Tuple 580 528),
    (Tuple 580 113),
    (Tuple 580 363),
    (Tuple 580 369),
    (Tuple 580 114),
    (Tuple 580 531),
    (Tuple 580 52),
    (Tuple 580 120),
    (Tuple 580 267),
    (Tuple 580 123),
    (Tuple 580 124),
    (Tuple 580 125),
    (Tuple 580 126),
    (Tuple 580 532),
    (Tuple 580 129),
    (Tuple 580 309),
    (Tuple 954 470),
    (Tuple 954 717),
    (Tuple 259 196),
    (Tuple 259 36),
    (Tuple 259 37),
    (Tuple 259 199),
    (Tuple 259 39),
    (Tuple 259 40),
    (Tuple 259 22),
    (Tuple 259 234),
    (Tuple 259 202),
    (Tuple 259 205),
    (Tuple 259 509),
    (Tuple 259 41),
    (Tuple 259 380),
    (Tuple 259 409),
    (Tuple 259 285),
    (Tuple 259 97),
    (Tuple 259 211),
    (Tuple 259 169),
    (Tuple 259 170),
    (Tuple 259 413),
    (Tuple 259 212),
    (Tuple 259 23),
    (Tuple 259 381),
    (Tuple 259 214),
    (Tuple 259 420),
    (Tuple 259 236),
    (Tuple 259 49),
    (Tuple 259 112),
    (Tuple 259 530),
    (Tuple 259 369),
    (Tuple 259 51),
    (Tuple 259 52),
    (Tuple 259 119),
    (Tuple 259 120),
    (Tuple 259 56),
    (Tuple 259 123),
    (Tuple 259 353),
    (Tuple 259 124),
    (Tuple 259 221),
    (Tuple 259 126),
    (Tuple 259 787),
    (Tuple 259 16),
    (Tuple 259 131),
    (Tuple 259 308),
    (Tuple 259 60),
    (Tuple 259 241),
    (Tuple 259 173),
    (Tuple 293 916),
    (Tuple 293 9),
    (Tuple 293 294),
    (Tuple 293 955),
    (Tuple 293 295),
    (Tuple 293 297),
    (Tuple 502 39),
    (Tuple 502 495),
    (Tuple 502 773),
    (Tuple 502 415),
    (Tuple 502 363),
    (Tuple 502 424),
    (Tuple 502 370),
    (Tuple 824 725),
    (Tuple 824 764),
    (Tuple 824 726),
    (Tuple 824 727),
    (Tuple 824 766),
    (Tuple 824 667),
    (Tuple 824 728),
    (Tuple 824 668),
    (Tuple 824 934),
    (Tuple 824 772),
    (Tuple 824 939),
    (Tuple 824 731),
    (Tuple 824 670),
    (Tuple 824 671),
    (Tuple 824 672),
    (Tuple 824 831),
    (Tuple 824 733),
    (Tuple 824 675),
    (Tuple 824 734),
    (Tuple 824 735),
    (Tuple 824 779),
    (Tuple 824 834),
    (Tuple 824 736),
    (Tuple 824 737),
    (Tuple 824 908),
    (Tuple 824 738),
    (Tuple 824 840),
    (Tuple 824 923),
    (Tuple 824 633),
    (Tuple 824 740),
    (Tuple 824 842),
    (Tuple 758 758),
    (Tuple 758 759),
    (Tuple 758 42),
    (Tuple 758 865),
    (Tuple 758 928),
    (Tuple 758 591),
    (Tuple 758 126),
    (Tuple 758 866),
    (Tuple 792 167),
    (Tuple 792 742),
    (Tuple 792 793),
    (Tuple 792 658),
    (Tuple 792 794),
    (Tuple 792 795),
    (Tuple 196 196),
    (Tuple 196 280),
    (Tuple 196 165),
    (Tuple 196 200),
    (Tuple 196 378),
    (Tuple 196 315),
    (Tuple 196 203),
    (Tuple 196 166),
    (Tuple 196 204),
    (Tuple 196 208),
    (Tuple 196 284),
    (Tuple 196 209),
    (Tuple 196 210),
    (Tuple 196 211),
    (Tuple 196 168),
    (Tuple 196 742),
    (Tuple 196 212),
    (Tuple 196 213),
    (Tuple 196 645),
    (Tuple 196 289),
    (Tuple 196 382),
    (Tuple 196 646),
    (Tuple 196 506),
    (Tuple 196 383),
    (Tuple 196 647),
    (Tuple 196 216),
    (Tuple 196 384),
    (Tuple 196 217),
    (Tuple 196 218),
    (Tuple 196 219),
    (Tuple 196 387),
    (Tuple 196 648),
    (Tuple 196 390),
    (Tuple 196 649),
    (Tuple 196 68),
    (Tuple 196 221),
    (Tuple 196 222),
    (Tuple 196 290),
    (Tuple 196 225),
    (Tuple 196 172),
    (Tuple 196 394),
    (Tuple 197 220),
    (Tuple 197 223),
    (Tuple 197 507),
    (Tuple 581 37),
    (Tuple 581 84),
    (Tuple 581 402),
    (Tuple 581 403),
    (Tuple 581 404),
    (Tuple 581 526),
    (Tuple 581 86),
    (Tuple 581 405),
    (Tuple 581 744),
    (Tuple 581 331),
    (Tuple 581 88),
    (Tuple 581 90),
    (Tuple 581 91),
    (Tuple 581 92),
    (Tuple 581 407),
    (Tuple 581 408),
    (Tuple 581 337),
    (Tuple 581 95),
    (Tuple 581 235),
    (Tuple 581 41),
    (Tuple 581 97),
    (Tuple 581 265),
    (Tuple 581 98),
    (Tuple 581 410),
    (Tuple 581 411),
    (Tuple 581 100),
    (Tuple 581 260),
    (Tuple 581 101),
    (Tuple 581 65),
    (Tuple 581 414),
    (Tuple 581 417),
    (Tuple 581 418),
    (Tuple 581 346),
    (Tuple 581 102),
    (Tuple 581 103),
    (Tuple 581 305),
    (Tuple 581 104),
    (Tuple 581 420),
    (Tuple 581 105),
    (Tuple 581 106),
    (Tuple 581 107),
    (Tuple 581 108),
    (Tuple 581 109),
    (Tuple 581 111),
    (Tuple 581 49),
    (Tuple 581 528),
    (Tuple 581 112),
    (Tuple 581 113),
    (Tuple 581 693),
    (Tuple 581 385),
    (Tuple 581 530),
    (Tuple 581 369),
    (Tuple 581 114),
    (Tuple 581 52),
    (Tuple 581 349),
    (Tuple 581 117),
    (Tuple 581 119),
    (Tuple 581 549),
    (Tuple 581 426),
    (Tuple 581 120),
    (Tuple 581 121),
    (Tuple 581 427),
    (Tuple 581 428),
    (Tuple 581 122),
    (Tuple 581 267),
    (Tuple 581 123),
    (Tuple 581 124),
    (Tuple 581 125),
    (Tuple 581 126),
    (Tuple 581 127),
    (Tuple 581 430),
    (Tuple 581 239),
    (Tuple 581 128),
    (Tuple 581 534),
    (Tuple 581 130),
    (Tuple 581 131),
    (Tuple 581 433),
    (Tuple 581 356),
    (Tuple 581 505),
    (Tuple 581 132),
    (Tuple 581 308),
    (Tuple 581 435),
    (Tuple 581 133),
    (Tuple 956 956),
    (Tuple 706 706),
    (Tuple 706 37),
    (Tuple 706 403),
    (Tuple 706 404),
    (Tuple 706 583),
    (Tuple 706 234),
    (Tuple 706 88),
    (Tuple 706 91),
    (Tuple 706 332),
    (Tuple 706 92),
    (Tuple 706 334),
    (Tuple 706 408),
    (Tuple 706 337),
    (Tuple 706 94),
    (Tuple 706 95),
    (Tuple 706 509),
    (Tuple 706 235),
    (Tuple 706 97),
    (Tuple 706 542),
    (Tuple 706 265),
    (Tuple 706 410),
    (Tuple 706 100),
    (Tuple 706 101),
    (Tuple 706 413),
    (Tuple 706 345),
    (Tuple 706 102),
    (Tuple 706 103),
    (Tuple 706 305),
    (Tuple 706 104),
    (Tuple 706 420),
    (Tuple 706 421),
    (Tuple 706 105),
    (Tuple 706 109),
    (Tuple 706 49),
    (Tuple 706 112),
    (Tuple 706 237),
    (Tuple 706 693),
    (Tuple 706 530),
    (Tuple 706 114),
    (Tuple 706 531),
    (Tuple 706 425),
    (Tuple 706 349),
    (Tuple 706 549),
    (Tuple 706 120),
    (Tuple 706 122),
    (Tuple 706 267),
    (Tuple 706 124),
    (Tuple 706 125),
    (Tuple 706 126),
    (Tuple 706 430),
    (Tuple 706 595),
    (Tuple 706 131),
    (Tuple 706 308),
    (Tuple 706 60),
    (Tuple 706 435),
    (Tuple 706 357),
    (Tuple 582 37),
    (Tuple 582 84),
    (Tuple 582 85),
    (Tuple 582 403),
    (Tuple 582 404),
    (Tuple 582 405),
    (Tuple 582 361),
    (Tuple 582 234),
    (Tuple 582 331),
    (Tuple 582 88),
    (Tuple 582 89),
    (Tuple 582 90),
    (Tuple 582 91),
    (Tuple 582 585),
    (Tuple 582 406),
    (Tuple 582 92),
    (Tuple 582 407),
    (Tuple 582 408),
    (Tuple 582 303),
    (Tuple 582 94),
    (Tuple 582 95),
    (Tuple 582 586),
    (Tuple 582 509),
    (Tuple 582 235),
    (Tuple 582 804),
    (Tuple 582 97),
    (Tuple 582 265),
    (Tuple 582 99),
    (Tuple 582 43),
    (Tuple 582 410),
    (Tuple 582 413),
    (Tuple 582 417),
    (Tuple 582 418),
    (Tuple 582 102),
    (Tuple 582 103),
    (Tuple 582 305),
    (Tuple 582 104),
    (Tuple 582 420),
    (Tuple 582 421),
    (Tuple 582 106),
    (Tuple 582 107),
    (Tuple 582 108),
    (Tuple 582 109),
    (Tuple 582 49),
    (Tuple 582 528),
    (Tuple 582 112),
    (Tuple 582 237),
    (Tuple 582 113),
    (Tuple 582 529),
    (Tuple 582 693),
    (Tuple 582 363),
    (Tuple 582 369),
    (Tuple 582 114),
    (Tuple 582 52),
    (Tuple 582 425),
    (Tuple 582 115),
    (Tuple 582 116),
    (Tuple 582 349),
    (Tuple 582 238),
    (Tuple 582 117),
    (Tuple 582 118),
    (Tuple 582 119),
    (Tuple 582 549),
    (Tuple 582 426),
    (Tuple 582 120),
    (Tuple 582 121),
    (Tuple 582 427),
    (Tuple 582 122),
    (Tuple 582 267),
    (Tuple 582 123),
    (Tuple 582 57),
    (Tuple 582 124),
    (Tuple 582 126),
    (Tuple 582 127),
    (Tuple 582 552),
    (Tuple 582 430),
    (Tuple 582 239),
    (Tuple 582 128),
    (Tuple 582 432),
    (Tuple 582 129),
    (Tuple 582 130),
    (Tuple 582 595),
    (Tuple 582 433),
    (Tuple 582 132),
    (Tuple 582 308),
    (Tuple 582 435),
    (Tuple 582 133),
    (Tuple 582 357),
    (Tuple 582 309),
    (Tuple 36 540),
    (Tuple 36 605),
    (Tuple 36 39),
    (Tuple 36 404),
    (Tuple 36 89),
    (Tuple 36 42),
    (Tuple 36 43),
    (Tuple 36 561),
    (Tuple 36 546),
    (Tuple 36 530),
    (Tuple 36 369),
    (Tuple 36 52),
    (Tuple 36 115),
    (Tuple 36 430),
    (Tuple 36 239),
    (Tuple 36 364),
    (Tuple 36 355),
    (Tuple 36 505),
    (Tuple 36 133),
    (Tuple 759 86),
    (Tuple 759 591),
    (Tuple 759 126),
    (Tuple 759 308),
    (Tuple 198 205),
    (Tuple 198 288),
    (Tuple 198 23),
    (Tuple 198 215),
    (Tuple 198 262),
    (Tuple 198 390),
    (Tuple 198 223),
    (Tuple 198 394),
    (Tuple 37 540),
    (Tuple 37 85),
    (Tuple 37 402),
    (Tuple 37 605),
    (Tuple 37 39),
    (Tuple 37 405),
    (Tuple 37 726),
    (Tuple 37 727),
    (Tuple 37 744),
    (Tuple 37 87),
    (Tuple 37 91),
    (Tuple 37 332),
    (Tuple 37 688),
    (Tuple 37 912),
    (Tuple 37 333),
    (Tuple 37 335),
    (Tuple 37 337),
    (Tuple 37 338),
    (Tuple 37 689),
    (Tuple 37 667),
    (Tuple 37 95),
    (Tuple 37 207),
    (Tuple 37 42),
    (Tuple 37 800),
    (Tuple 37 587),
    (Tuple 37 588),
    (Tuple 37 668),
    (Tuple 37 98),
    (Tuple 37 312),
    (Tuple 37 100),
    (Tuple 37 341),
    (Tuple 37 557),
    (Tuple 37 342),
    (Tuple 37 344),
    (Tuple 37 862),
    (Tuple 37 346),
    (Tuple 37 776),
    (Tuple 37 103),
    (Tuple 37 745),
    (Tuple 37 672),
    (Tuple 37 562),
    (Tuple 37 347),
    (Tuple 37 419),
    (Tuple 37 503),
    (Tuple 37 504),
    (Tuple 37 106),
    (Tuple 37 907),
    (Tuple 37 592),
    (Tuple 37 736),
    (Tuple 37 52),
    (Tuple 37 116),
    (Tuple 37 120),
    (Tuple 37 350),
    (Tuple 37 351),
    (Tuple 37 427),
    (Tuple 37 700),
    (Tuple 37 125),
    (Tuple 37 354),
    (Tuple 37 677),
    (Tuple 37 703),
    (Tuple 37 596),
    (Tuple 37 132),
    (Tuple 37 876),
    (Tuple 37 357),
    (Tuple 37 866),
    (Tuple 278 279),
    (Tuple 278 280),
    (Tuple 278 282),
    (Tuple 278 200),
    (Tuple 278 288),
    (Tuple 278 289),
    (Tuple 278 383),
    (Tuple 278 171),
    (Tuple 278 224),
    (Tuple 944 163),
    (Tuple 944 691),
    (Tuple 944 712),
    (Tuple 163 691),
    (Tuple 163 712),
    (Tuple 666 681),
    (Tuple 666 629),
    (Tuple 666 97),
    (Tuple 666 772),
    (Tuple 666 345),
    (Tuple 666 682),
    (Tuple 666 673),
    (Tuple 666 733),
    (Tuple 666 48),
    (Tuple 666 236),
    (Tuple 666 429),
    (Tuple 666 353),
    (Tuple 666 787),
    (Tuple 666 789),
    (Tuple 666 393),
    (Tuple 860 87),
    (Tuple 860 88),
    (Tuple 860 412),
    (Tuple 860 102),
    (Tuple 860 107),
    (Tuple 860 236),
    (Tuple 860 111),
    (Tuple 860 425),
    (Tuple 860 116),
    (Tuple 860 118),
    (Tuple 860 119),
    (Tuple 860 427),
    (Tuple 860 707),
    (Tuple 860 132),
    (Tuple 860 133),
    (Tuple 164 164),
    (Tuple 164 169),
    (Tuple 84 85),
    (Tuple 84 402),
    (Tuple 84 87),
    (Tuple 84 91),
    (Tuple 84 332),
    (Tuple 84 688),
    (Tuple 84 335),
    (Tuple 84 93),
    (Tuple 84 337),
    (Tuple 84 338),
    (Tuple 84 689),
    (Tuple 84 96),
    (Tuple 84 41),
    (Tuple 84 340),
    (Tuple 84 588),
    (Tuple 84 98),
    (Tuple 84 312),
    (Tuple 84 861),
    (Tuple 84 100),
    (Tuple 84 557),
    (Tuple 84 103),
    (Tuple 84 591),
    (Tuple 84 347),
    (Tuple 84 419),
    (Tuple 84 106),
    (Tuple 84 348),
    (Tuple 84 528),
    (Tuple 84 592),
    (Tuple 84 116),
    (Tuple 84 427),
    (Tuple 84 352),
    (Tuple 84 707),
    (Tuple 84 703),
    (Tuple 84 356),
    (Tuple 84 597),
    (Tuple 84 132),
    (Tuple 691 712),
    (Tuple 691 236),
    (Tuple 540 540),
    (Tuple 540 659),
    (Tuple 540 605),
    (Tuple 540 39),
    (Tuple 540 404),
    (Tuple 540 606),
    (Tuple 540 361),
    (Tuple 540 234),
    (Tuple 540 527),
    (Tuple 540 89),
    (Tuple 540 406),
    (Tuple 540 408),
    (Tuple 540 303),
    (Tuple 540 42),
    (Tuple 540 409),
    (Tuple 540 265),
    (Tuple 540 43),
    (Tuple 540 45),
    (Tuple 540 544),
    (Tuple 540 65),
    (Tuple 540 46),
    (Tuple 540 773),
    (Tuple 540 414),
    (Tuple 540 345),
    (Tuple 540 415),
    (Tuple 540 630),
    (Tuple 540 418),
    (Tuple 540 546),
    (Tuple 540 102),
    (Tuple 540 305),
    (Tuple 540 104),
    (Tuple 540 562),
    (Tuple 540 503),
    (Tuple 540 547),
    (Tuple 540 108),
    (Tuple 540 422),
    (Tuple 540 236),
    (Tuple 540 306),
    (Tuple 540 872),
    (Tuple 540 49),
    (Tuple 540 496),
    (Tuple 540 423),
    (Tuple 540 548),
    (Tuple 540 112),
    (Tuple 540 237),
    (Tuple 540 363),
    (Tuple 540 424),
    (Tuple 540 369),
    (Tuple 540 51),
    (Tuple 540 52),
    (Tuple 540 115),
    (Tuple 540 117),
    (Tuple 540 119),
    (Tuple 540 550),
    (Tuple 540 121),
    (Tuple 540 389),
    (Tuple 540 56),
    (Tuple 540 427),
    (Tuple 540 267),
    (Tuple 540 123),
    (Tuple 540 57),
    (Tuple 540 799),
    (Tuple 540 551),
    (Tuple 540 125),
    (Tuple 540 126),
    (Tuple 540 127),
    (Tuple 540 552),
    (Tuple 540 430),
    (Tuple 540 239),
    (Tuple 540 431),
    (Tuple 540 532),
    (Tuple 540 534),
    (Tuple 540 553),
    (Tuple 540 432),
    (Tuple 540 554),
    (Tuple 540 563),
    (Tuple 540 364),
    (Tuple 540 129),
    (Tuple 540 307),
    (Tuple 540 433),
    (Tuple 540 355),
    (Tuple 540 480),
    (Tuple 540 564),
    (Tuple 540 434),
    (Tuple 540 240),
    (Tuple 540 505),
    (Tuple 540 60),
    (Tuple 540 241),
    (Tuple 540 133),
    (Tuple 540 357),
    (Tuple 540 173),
    (Tuple 540 309),
    (Tuple 540 866),
    (Tuple 602 407),
    (Tuple 602 306),
    (Tuple 602 369),
    (Tuple 602 52),
    (Tuple 329 526),
    (Tuple 329 234),
    (Tuple 329 91),
    (Tuple 329 337),
    (Tuple 329 341),
    (Tuple 329 697),
    (Tuple 329 343),
    (Tuple 329 669),
    (Tuple 329 345),
    (Tuple 329 420),
    (Tuple 329 422),
    (Tuple 329 49),
    (Tuple 329 698),
    (Tuple 329 112),
    (Tuple 329 237),
    (Tuple 329 529),
    (Tuple 329 363),
    (Tuple 329 369),
    (Tuple 329 51),
    (Tuple 329 531),
    (Tuple 329 349),
    (Tuple 329 351),
    (Tuple 329 353),
    (Tuple 329 125),
    (Tuple 329 430),
    (Tuple 329 514),
    (Tuple 329 505),
    (Tuple 329 515),
    (Tuple 329 357),
    (Tuple 329 309),
    (Tuple 279 199),
    (Tuple 279 200),
    (Tuple 279 22),
    (Tuple 279 361),
    (Tuple 279 203),
    (Tuple 279 166),
    (Tuple 279 208),
    (Tuple 279 284),
    (Tuple 279 170),
    (Tuple 279 288),
    (Tuple 279 212),
    (Tuple 279 289),
    (Tuple 279 214),
    (Tuple 279 66),
    (Tuple 279 171),
    (Tuple 279 290),
    (Tuple 279 224),
    (Tuple 659 42),
    (Tuple 659 43),
    (Tuple 659 45),
    (Tuple 659 544),
    (Tuple 659 46),
    (Tuple 659 546),
    (Tuple 659 422),
    (Tuple 659 236),
    (Tuple 659 423),
    (Tuple 659 548),
    (Tuple 659 550),
    (Tuple 659 553),
    (Tuple 659 554),
    (Tuple 659 364),
    (Tuple 659 307),
    (Tuple 659 355),
    (Tuple 659 480),
    (Tuple 659 564),
    (Tuple 659 434),
    (Tuple 659 240),
    (Tuple 659 60),
    (Tuple 659 133),
    (Tuple 917 380),
    (Tuple 917 16),
    (Tuple 917 241),
    (Tuple 85 85),
    (Tuple 85 402),
    (Tuple 85 403),
    (Tuple 85 526),
    (Tuple 85 86),
    (Tuple 85 583),
    (Tuple 85 744),
    (Tuple 85 331),
    (Tuple 85 87),
    (Tuple 85 88),
    (Tuple 85 91),
    (Tuple 85 332),
    (Tuple 85 406),
    (Tuple 85 92),
    (Tuple 85 334),
    (Tuple 85 335),
    (Tuple 85 337),
    (Tuple 85 94),
    (Tuple 85 338),
    (Tuple 85 95),
    (Tuple 85 509),
    (Tuple 85 304),
    (Tuple 85 340),
    (Tuple 85 587),
    (Tuple 85 588),
    (Tuple 85 409),
    (Tuple 85 97),
    (Tuple 85 542),
    (Tuple 85 98),
    (Tuple 85 312),
    (Tuple 85 410),
    (Tuple 85 411),
    (Tuple 85 100),
    (Tuple 85 342),
    (Tuple 85 101),
    (Tuple 85 413),
    (Tuple 85 345),
    (Tuple 85 346),
    (Tuple 85 102),
    (Tuple 85 103),
    (Tuple 85 305),
    (Tuple 85 104),
    (Tuple 85 591),
    (Tuple 85 347),
    (Tuple 85 420),
    (Tuple 85 105),
    (Tuple 85 106),
    (Tuple 85 107),
    (Tuple 85 109),
    (Tuple 85 110),
    (Tuple 85 49),
    (Tuple 85 528),
    (Tuple 85 592),
    (Tuple 85 112),
    (Tuple 85 237),
    (Tuple 85 529),
    (Tuple 85 530),
    (Tuple 85 369),
    (Tuple 85 114),
    (Tuple 85 531),
    (Tuple 85 52),
    (Tuple 85 425),
    (Tuple 85 115),
    (Tuple 85 116),
    (Tuple 85 349),
    (Tuple 85 118),
    (Tuple 85 120),
    (Tuple 85 427),
    (Tuple 85 122),
    (Tuple 85 267),
    (Tuple 85 123),
    (Tuple 85 124),
    (Tuple 85 125),
    (Tuple 85 707),
    (Tuple 85 126),
    (Tuple 85 127),
    (Tuple 85 430),
    (Tuple 85 354),
    (Tuple 85 128),
    (Tuple 85 594),
    (Tuple 85 595),
    (Tuple 85 131),
    (Tuple 85 433),
    (Tuple 85 132),
    (Tuple 85 435),
    (Tuple 85 357),
    (Tuple 38 404),
    (Tuple 38 526),
    (Tuple 38 86),
    (Tuple 38 405),
    (Tuple 38 361),
    (Tuple 38 234),
    (Tuple 38 527),
    (Tuple 38 744),
    (Tuple 38 88),
    (Tuple 38 90),
    (Tuple 38 91),
    (Tuple 38 912),
    (Tuple 38 406),
    (Tuple 38 92),
    (Tuple 38 333),
    (Tuple 38 334),
    (Tuple 38 335),
    (Tuple 38 408),
    (Tuple 38 337),
    (Tuple 38 94),
    (Tuple 38 689),
    (Tuple 38 509),
    (Tuple 38 235),
    (Tuple 38 264),
    (Tuple 38 42),
    (Tuple 38 800),
    (Tuple 38 804),
    (Tuple 38 409),
    (Tuple 38 97),
    (Tuple 38 542),
    (Tuple 38 668),
    (Tuple 38 265),
    (Tuple 38 99),
    (Tuple 38 312),
    (Tuple 38 43),
    (Tuple 38 861),
    (Tuple 38 410),
    (Tuple 38 411),
    (Tuple 38 100),
    (Tuple 38 697),
    (Tuple 38 590),
    (Tuple 38 101),
    (Tuple 38 413),
    (Tuple 38 414),
    (Tuple 38 415),
    (Tuple 38 47),
    (Tuple 38 630),
    (Tuple 38 416),
    (Tuple 38 417),
    (Tuple 38 418),
    (Tuple 38 775),
    (Tuple 38 801),
    (Tuple 38 776),
    (Tuple 38 102),
    (Tuple 38 103),
    (Tuple 38 305),
    (Tuple 38 104),
    (Tuple 38 745),
    (Tuple 38 562),
    (Tuple 38 420),
    (Tuple 38 106),
    (Tuple 38 107),
    (Tuple 38 108),
    (Tuple 38 422),
    (Tuple 38 109),
    (Tuple 38 236),
    (Tuple 38 110),
    (Tuple 38 674),
    (Tuple 38 111),
    (Tuple 38 832),
    (Tuple 38 49),
    (Tuple 38 112),
    (Tuple 38 237),
    (Tuple 38 113),
    (Tuple 38 529),
    (Tuple 38 693),
    (Tuple 38 385),
    (Tuple 38 363),
    (Tuple 38 424),
    (Tuple 38 530),
    (Tuple 38 369),
    (Tuple 38 114),
    (Tuple 38 531),
    (Tuple 38 52),
    (Tuple 38 425),
    (Tuple 38 349),
    (Tuple 38 238),
    (Tuple 38 118),
    (Tuple 38 549),
    (Tuple 38 426),
    (Tuple 38 266),
    (Tuple 38 839),
    (Tuple 38 351),
    (Tuple 38 632),
    (Tuple 38 428),
    (Tuple 38 122),
    (Tuple 38 429),
    (Tuple 38 123),
    (Tuple 38 57),
    (Tuple 38 124),
    (Tuple 38 125),
    (Tuple 38 676),
    (Tuple 38 126),
    (Tuple 38 127),
    (Tuple 38 787),
    (Tuple 38 239),
    (Tuple 38 701),
    (Tuple 38 514),
    (Tuple 38 532),
    (Tuple 38 128),
    (Tuple 38 634),
    (Tuple 38 789),
    (Tuple 38 533),
    (Tuple 38 364),
    (Tuple 38 683),
    (Tuple 38 131),
    (Tuple 38 433),
    (Tuple 38 703),
    (Tuple 38 480),
    (Tuple 38 356),
    (Tuple 38 790),
    (Tuple 38 393),
    (Tuple 38 308),
    (Tuple 38 615),
    (Tuple 38 133),
    (Tuple 38 357),
    (Tuple 38 309),
    (Tuple 402 402),
    (Tuple 402 403),
    (Tuple 402 404),
    (Tuple 402 526),
    (Tuple 402 86),
    (Tuple 402 583),
    (Tuple 402 234),
    (Tuple 402 744),
    (Tuple 402 331),
    (Tuple 402 87),
    (Tuple 402 585),
    (Tuple 402 406),
    (Tuple 402 92),
    (Tuple 402 334),
    (Tuple 402 337),
    (Tuple 402 94),
    (Tuple 402 95),
    (Tuple 402 586),
    (Tuple 402 509),
    (Tuple 402 926),
    (Tuple 402 340),
    (Tuple 402 800),
    (Tuple 402 804),
    (Tuple 402 588),
    (Tuple 402 409),
    (Tuple 402 97),
    (Tuple 402 542),
    (Tuple 402 265),
    (Tuple 402 98),
    (Tuple 402 861),
    (Tuple 402 411),
    (Tuple 402 100),
    (Tuple 402 342),
    (Tuple 402 101),
    (Tuple 402 343),
    (Tuple 402 413),
    (Tuple 402 345),
    (Tuple 402 630),
    (Tuple 402 346),
    (Tuple 402 102),
    (Tuple 402 103),
    (Tuple 402 305),
    (Tuple 402 104),
    (Tuple 402 591),
    (Tuple 402 347),
    (Tuple 402 420),
    (Tuple 402 105),
    (Tuple 402 106),
    (Tuple 402 422),
    (Tuple 402 110),
    (Tuple 402 111),
    (Tuple 402 49),
    (Tuple 402 528),
    (Tuple 402 592),
    (Tuple 402 112),
    (Tuple 402 237),
    (Tuple 402 693),
    (Tuple 402 369),
    (Tuple 402 114),
    (Tuple 402 531),
    (Tuple 402 52),
    (Tuple 402 425),
    (Tuple 402 349),
    (Tuple 402 238),
    (Tuple 402 118),
    (Tuple 402 549),
    (Tuple 402 699),
    (Tuple 402 427),
    (Tuple 402 428),
    (Tuple 402 122),
    (Tuple 402 123),
    (Tuple 402 124),
    (Tuple 402 125),
    (Tuple 402 126),
    (Tuple 402 127),
    (Tuple 402 430),
    (Tuple 402 239),
    (Tuple 402 128),
    (Tuple 402 432),
    (Tuple 402 594),
    (Tuple 402 595),
    (Tuple 402 131),
    (Tuple 402 433),
    (Tuple 402 703),
    (Tuple 402 308),
    (Tuple 402 435),
    (Tuple 402 357),
    (Tuple 402 309),
    (Tuple 847 847),
    (Tuple 847 765),
    (Tuple 847 91),
    (Tuple 847 767),
    (Tuple 847 771),
    (Tuple 847 773),
    (Tuple 847 415),
    (Tuple 847 848),
    (Tuple 847 672),
    (Tuple 847 850),
    (Tuple 847 777),
    (Tuple 847 778),
    (Tuple 847 593),
    (Tuple 847 791),
    (Tuple 280 199),
    (Tuple 280 165),
    (Tuple 280 200),
    (Tuple 280 202),
    (Tuple 280 203),
    (Tuple 280 166),
    (Tuple 280 204),
    (Tuple 280 208),
    (Tuple 280 284),
    (Tuple 280 209),
    (Tuple 280 211),
    (Tuple 280 168),
    (Tuple 280 170),
    (Tuple 280 288),
    (Tuple 280 212),
    (Tuple 280 23),
    (Tuple 280 214),
    (Tuple 280 383),
    (Tuple 280 66),
    (Tuple 280 216),
    (Tuple 280 171),
    (Tuple 280 51),
    (Tuple 280 220),
    (Tuple 280 390),
    (Tuple 280 221),
    (Tuple 280 222),
    (Tuple 280 290),
    (Tuple 280 224),
    (Tuple 280 225),
    (Tuple 280 394),
    (Tuple 403 403),
    (Tuple 403 692),
    (Tuple 403 87),
    (Tuple 403 335),
    (Tuple 403 336),
    (Tuple 403 93),
    (Tuple 403 337),
    (Tuple 403 338),
    (Tuple 403 689),
    (Tuple 403 586),
    (Tuple 403 96),
    (Tuple 403 340),
    (Tuple 403 587),
    (Tuple 403 588),
    (Tuple 403 98),
    (Tuple 403 99),
    (Tuple 403 312),
    (Tuple 403 100),
    (Tuple 403 557),
    (Tuple 403 412),
    (Tuple 403 590),
    (Tuple 403 344),
    (Tuple 403 102),
    (Tuple 403 103),
    (Tuple 403 347),
    (Tuple 403 106),
    (Tuple 403 528),
    (Tuple 403 112),
    (Tuple 403 116),
    (Tuple 403 120),
    (Tuple 403 350),
    (Tuple 403 124),
    (Tuple 403 707),
    (Tuple 403 126),
    (Tuple 403 594),
    (Tuple 403 596),
    (Tuple 403 597),
    (Tuple 403 132),
    (Tuple 470 715),
    (Tuple 470 260),
    (Tuple 470 717),
    (Tuple 470 506),
    (Tuple 470 653),
    (Tuple 470 661),
    (Tuple 199 39),
    (Tuple 199 727),
    (Tuple 199 203),
    (Tuple 199 204),
    (Tuple 199 209),
    (Tuple 199 210),
    (Tuple 199 212),
    (Tuple 199 213),
    (Tuple 199 645),
    (Tuple 199 289),
    (Tuple 199 382),
    (Tuple 199 646),
    (Tuple 199 506),
    (Tuple 199 383),
    (Tuple 199 647),
    (Tuple 199 216),
    (Tuple 199 384),
    (Tuple 199 217),
    (Tuple 199 219),
    (Tuple 199 648),
    (Tuple 199 390),
    (Tuple 199 649),
    (Tuple 199 68),
    (Tuple 199 392),
    (Tuple 199 290),
    (Tuple 199 225),
    (Tuple 199 394),
    (Tuple 281 288),
    (Tuple 281 214),
    (Tuple 281 224),
    (Tuple 282 200),
    (Tuple 282 22),
    (Tuple 282 202),
    (Tuple 282 378),
    (Tuple 282 203),
    (Tuple 282 166),
    (Tuple 282 204),
    (Tuple 282 205),
    (Tuple 282 206),
    (Tuple 282 208),
    (Tuple 282 284),
    (Tuple 282 211),
    (Tuple 282 168),
    (Tuple 282 170),
    (Tuple 282 288),
    (Tuple 282 23),
    (Tuple 282 289),
    (Tuple 282 214),
    (Tuple 282 383),
    (Tuple 282 215),
    (Tuple 282 66),
    (Tuple 282 306),
    (Tuple 282 50),
    (Tuple 282 171),
    (Tuple 282 221),
    (Tuple 282 222),
    (Tuple 282 224),
    (Tuple 282 173),
    (Tuple 605 361),
    (Tuple 605 338),
    (Tuple 605 95),
    (Tuple 605 42),
    (Tuple 605 414),
    (Tuple 605 417),
    (Tuple 605 561),
    (Tuple 605 102),
    (Tuple 605 305),
    (Tuple 605 104),
    (Tuple 605 106),
    (Tuple 605 236),
    (Tuple 605 49),
    (Tuple 605 496),
    (Tuple 605 369),
    (Tuple 605 51),
    (Tuple 605 531),
    (Tuple 605 52),
    (Tuple 605 115),
    (Tuple 605 428),
    (Tuple 605 122),
    (Tuple 605 429),
    (Tuple 605 352),
    (Tuple 605 126),
    (Tuple 605 127),
    (Tuple 605 432),
    (Tuple 605 241),
    (Tuple 605 133),
    (Tuple 39 405),
    (Tuple 39 87),
    (Tuple 39 338),
    (Tuple 39 235),
    (Tuple 39 41),
    (Tuple 39 42),
    (Tuple 39 97),
    (Tuple 39 312),
    (Tuple 39 342),
    (Tuple 39 169),
    (Tuple 39 46),
    (Tuple 39 546),
    (Tuple 39 103),
    (Tuple 39 305),
    (Tuple 39 104),
    (Tuple 39 236),
    (Tuple 39 67),
    (Tuple 39 112),
    (Tuple 39 530),
    (Tuple 39 369),
    (Tuple 39 114),
    (Tuple 39 531),
    (Tuple 39 120),
    (Tuple 39 267),
    (Tuple 39 125),
    (Tuple 39 126),
    (Tuple 39 357),
    (Tuple 39 309),
    (Tuple 40 311),
    (Tuple 40 87),
    (Tuple 40 42),
    (Tuple 40 742),
    (Tuple 40 288),
    (Tuple 40 25),
    (Tuple 40 289),
    (Tuple 40 132),
    (Tuple 404 726),
    (Tuple 404 87),
    (Tuple 404 90),
    (Tuple 404 91),
    (Tuple 404 332),
    (Tuple 404 688),
    (Tuple 404 912),
    (Tuple 404 333),
    (Tuple 404 334),
    (Tuple 404 335),
    (Tuple 404 337),
    (Tuple 404 338),
    (Tuple 404 689),
    (Tuple 404 207),
    (Tuple 404 926),
    (Tuple 404 42),
    (Tuple 404 340),
    (Tuple 404 800),
    (Tuple 404 587),
    (Tuple 404 588),
    (Tuple 404 668),
    (Tuple 404 98),
    (Tuple 404 100),
    (Tuple 404 557),
    (Tuple 404 342),
    (Tuple 404 590),
    (Tuple 404 344),
    (Tuple 404 862),
    (Tuple 404 416),
    (Tuple 404 690),
    (Tuple 404 103),
    (Tuple 404 305),
    (Tuple 404 591),
    (Tuple 404 672),
    (Tuple 404 347),
    (Tuple 404 419),
    (Tuple 404 106),
    (Tuple 404 746),
    (Tuple 404 348),
    (Tuple 404 592),
    (Tuple 404 112),
    (Tuple 404 116),
    (Tuple 404 120),
    (Tuple 404 352),
    (Tuple 404 676),
    (Tuple 404 354),
    (Tuple 404 703),
    (Tuple 404 596),
    (Tuple 404 356),
    (Tuple 404 903),
    (Tuple 404 132),
    (Tuple 526 87),
    (Tuple 526 90),
    (Tuple 526 332),
    (Tuple 526 688),
    (Tuple 526 337),
    (Tuple 526 338),
    (Tuple 526 207),
    (Tuple 526 235),
    (Tuple 526 42),
    (Tuple 526 340),
    (Tuple 526 668),
    (Tuple 526 342),
    (Tuple 526 949),
    (Tuple 526 732),
    (Tuple 526 672),
    (Tuple 526 347),
    (Tuple 526 106),
    (Tuple 526 746),
    (Tuple 526 348),
    (Tuple 526 834),
    (Tuple 526 859),
    (Tuple 526 352),
    (Tuple 678 212),
    (Tuple 678 67),
    (Tuple 678 53),
    (Tuple 678 68),
    (Tuple 678 69),
    (Tuple 678 173),
    (Tuple 678 70),
    (Tuple 86 331),
    (Tuple 86 87),
    (Tuple 86 90),
    (Tuple 86 91),
    (Tuple 86 332),
    (Tuple 86 688),
    (Tuple 86 333),
    (Tuple 86 334),
    (Tuple 86 335),
    (Tuple 86 337),
    (Tuple 86 338),
    (Tuple 86 207),
    (Tuple 86 340),
    (Tuple 86 800),
    (Tuple 86 587),
    (Tuple 86 588),
    (Tuple 86 97),
    (Tuple 86 668),
    (Tuple 86 98),
    (Tuple 86 312),
    (Tuple 86 100),
    (Tuple 86 557),
    (Tuple 86 342),
    (Tuple 86 344),
    (Tuple 86 862),
    (Tuple 86 103),
    (Tuple 86 305),
    (Tuple 86 591),
    (Tuple 86 347),
    (Tuple 86 106),
    (Tuple 86 348),
    (Tuple 86 49),
    (Tuple 86 528),
    (Tuple 86 592),
    (Tuple 86 114),
    (Tuple 86 116),
    (Tuple 86 863),
    (Tuple 86 426),
    (Tuple 86 120),
    (Tuple 86 427),
    (Tuple 86 124),
    (Tuple 86 125),
    (Tuple 86 354),
    (Tuple 86 703),
    (Tuple 86 132),
    (Tuple 541 235),
    (Tuple 541 496),
    (Tuple 541 53),
    (Tuple 541 115),
    (Tuple 541 391),
    (Tuple 541 58),
    (Tuple 541 126),
    (Tuple 541 127),
    (Tuple 606 42),
    (Tuple 606 415),
    (Tuple 606 546),
    (Tuple 606 422),
    (Tuple 606 236),
    (Tuple 606 369),
    (Tuple 606 51),
    (Tuple 606 389),
    (Tuple 606 552),
    (Tuple 606 431),
    (Tuple 606 60),
    (Tuple 606 133),
    (Tuple 606 309),
    (Tuple 874 874),
    (Tuple 874 288),
    (Tuple 874 386),
    (Tuple 165 378),
    (Tuple 165 203),
    (Tuple 165 284),
    (Tuple 165 210),
    (Tuple 165 170),
    (Tuple 165 212),
    (Tuple 165 796),
    (Tuple 165 289),
    (Tuple 165 383),
    (Tuple 165 218),
    (Tuple 165 390),
    (Tuple 165 221),
    (Tuple 165 290),
    (Tuple 165 225),
    (Tuple 200 283),
    (Tuple 200 957),
    (Tuple 200 958),
    (Tuple 200 203),
    (Tuple 200 166),
    (Tuple 200 204),
    (Tuple 200 464),
    (Tuple 200 208),
    (Tuple 200 284),
    (Tuple 200 209),
    (Tuple 200 210),
    (Tuple 200 213),
    (Tuple 200 796),
    (Tuple 200 645),
    (Tuple 200 289),
    (Tuple 200 381),
    (Tuple 200 383),
    (Tuple 200 647),
    (Tuple 200 216),
    (Tuple 200 384),
    (Tuple 200 217),
    (Tuple 200 171),
    (Tuple 200 218),
    (Tuple 200 262),
    (Tuple 200 219),
    (Tuple 200 390),
    (Tuple 200 649),
    (Tuple 200 68),
    (Tuple 200 290),
    (Tuple 200 223),
    (Tuple 200 394),
    (Tuple 22 285),
    (Tuple 22 288),
    (Tuple 22 506),
    (Tuple 22 223),
    (Tuple 22 507),
    (Tuple 583 405),
    (Tuple 583 744),
    (Tuple 583 331),
    (Tuple 583 87),
    (Tuple 583 90),
    (Tuple 583 332),
    (Tuple 583 688),
    (Tuple 583 912),
    (Tuple 583 333),
    (Tuple 583 335),
    (Tuple 583 337),
    (Tuple 583 689),
    (Tuple 583 586),
    (Tuple 583 926),
    (Tuple 583 340),
    (Tuple 583 98),
    (Tuple 583 312),
    (Tuple 583 100),
    (Tuple 583 342),
    (Tuple 583 590),
    (Tuple 583 344),
    (Tuple 583 416),
    (Tuple 583 801),
    (Tuple 583 305),
    (Tuple 583 745),
    (Tuple 583 562),
    (Tuple 583 347),
    (Tuple 583 420),
    (Tuple 583 106),
    (Tuple 583 109),
    (Tuple 583 746),
    (Tuple 583 348),
    (Tuple 583 592),
    (Tuple 583 114),
    (Tuple 583 116),
    (Tuple 583 863),
    (Tuple 583 120),
    (Tuple 583 124),
    (Tuple 583 125),
    (Tuple 583 703),
    (Tuple 583 596),
    (Tuple 583 356),
    (Tuple 583 903),
    (Tuple 583 876),
    (Tuple 583 435),
    (Tuple 405 405),
    (Tuple 405 87),
    (Tuple 405 91),
    (Tuple 405 688),
    (Tuple 405 335),
    (Tuple 405 337),
    (Tuple 405 94),
    (Tuple 405 338),
    (Tuple 405 509),
    (Tuple 405 41),
    (Tuple 405 304),
    (Tuple 405 97),
    (Tuple 405 99),
    (Tuple 405 861),
    (Tuple 405 100),
    (Tuple 405 557),
    (Tuple 405 342),
    (Tuple 405 478),
    (Tuple 405 102),
    (Tuple 405 103),
    (Tuple 405 591),
    (Tuple 405 420),
    (Tuple 405 105),
    (Tuple 405 49),
    (Tuple 405 528),
    (Tuple 405 112),
    (Tuple 405 369),
    (Tuple 405 116),
    (Tuple 405 427),
    (Tuple 405 267),
    (Tuple 405 124),
    (Tuple 405 125),
    (Tuple 405 707),
    (Tuple 405 126),
    (Tuple 405 128),
    (Tuple 405 596),
    (Tuple 405 132),
    (Tuple 405 357),
    (Tuple 725 627),
    (Tuple 725 825),
    (Tuple 725 826),
    (Tuple 725 827),
    (Tuple 725 772),
    (Tuple 725 731),
    (Tuple 725 775),
    (Tuple 725 673),
    (Tuple 725 733),
    (Tuple 725 833),
    (Tuple 725 631),
    (Tuple 725 781),
    (Tuple 725 841),
    (Tuple 725 783),
    (Tuple 725 784),
    (Tuple 725 353),
    (Tuple 725 785),
    (Tuple 725 786),
    (Tuple 725 787),
    (Tuple 725 788),
    (Tuple 725 514),
    (Tuple 725 683),
    (Tuple 227 227),
    (Tuple 227 214),
    (Tuple 311 315),
    (Tuple 311 42),
    (Tuple 311 312),
    (Tuple 311 477),
    (Tuple 311 928),
    (Tuple 311 952),
    (Tuple 311 497),
    (Tuple 311 50),
    (Tuple 311 53),
    (Tuple 311 370),
    (Tuple 311 391),
    (Tuple 311 58),
    (Tuple 311 59),
    (Tuple 311 431),
    (Tuple 311 16),
    (Tuple 311 173),
    (Tuple 681 681),
    (Tuple 681 627),
    (Tuple 681 527),
    (Tuple 681 825),
    (Tuple 681 92),
    (Tuple 681 667),
    (Tuple 681 264),
    (Tuple 681 826),
    (Tuple 681 668),
    (Tuple 681 697),
    (Tuple 681 590),
    (Tuple 681 345),
    (Tuple 681 47),
    (Tuple 681 630),
    (Tuple 681 731),
    (Tuple 681 775),
    (Tuple 681 486),
    (Tuple 681 733),
    (Tuple 681 832),
    (Tuple 681 698),
    (Tuple 681 112),
    (Tuple 681 363),
    (Tuple 681 631),
    (Tuple 681 782),
    (Tuple 681 549),
    (Tuple 681 632),
    (Tuple 681 699),
    (Tuple 681 428),
    (Tuple 681 429),
    (Tuple 681 784),
    (Tuple 681 353),
    (Tuple 681 785),
    (Tuple 681 700),
    (Tuple 681 125),
    (Tuple 681 786),
    (Tuple 681 787),
    (Tuple 681 514),
    (Tuple 681 533),
    (Tuple 681 433),
    (Tuple 681 393),
    (Tuple 681 615),
    (Tuple 681 515),
    (Tuple 681 843),
    (Tuple 681 357),
    (Tuple 283 202),
    (Tuple 283 208),
    (Tuple 283 288),
    (Tuple 283 214),
    (Tuple 283 50),
    (Tuple 283 171),
    (Tuple 283 224),
    (Tuple 361 692),
    (Tuple 361 603),
    (Tuple 361 476),
    (Tuple 361 87),
    (Tuple 361 338),
    (Tuple 361 667),
    (Tuple 361 42),
    (Tuple 361 477),
    (Tuple 361 928),
    (Tuple 361 478),
    (Tuple 361 712),
    (Tuple 361 591),
    (Tuple 361 67),
    (Tuple 361 50),
    (Tuple 361 641),
    (Tuple 361 116),
    (Tuple 361 370),
    (Tuple 361 69),
    (Tuple 361 132),
    (Tuple 454 611),
    (Tuple 454 8),
    (Tuple 454 146),
    (Tuple 454 9),
    (Tuple 454 11),
    (Tuple 454 12),
    (Tuple 454 608),
    (Tuple 454 148),
    (Tuple 454 13),
    (Tuple 454 456),
    (Tuple 454 14),
    (Tuple 454 15),
    (Tuple 454 150),
    (Tuple 454 151),
    (Tuple 454 457),
    (Tuple 454 459),
    (Tuple 454 612),
    (Tuple 454 153),
    (Tuple 454 154),
    (Tuple 201 68),
    (Tuple 201 223),
    (Tuple 201 797),
    (Tuple 692 90),
    (Tuple 692 42),
    (Tuple 692 417),
    (Tuple 692 104),
    (Tuple 692 422),
    (Tuple 692 236),
    (Tuple 692 424),
    (Tuple 692 369),
    (Tuple 692 641),
    (Tuple 692 238),
    (Tuple 692 119),
    (Tuple 692 427),
    (Tuple 692 267),
    (Tuple 692 123),
    (Tuple 692 57),
    (Tuple 692 391),
    (Tuple 692 126),
    (Tuple 692 127),
    (Tuple 692 308),
    (Tuple 330 265),
    (Tuple 330 362),
    (Tuple 330 343),
    (Tuple 330 49),
    (Tuple 330 363),
    (Tuple 627 764),
    (Tuple 627 727),
    (Tuple 627 766),
    (Tuple 627 667),
    (Tuple 627 207),
    (Tuple 627 728),
    (Tuple 627 629),
    (Tuple 627 668),
    (Tuple 627 934),
    (Tuple 627 935),
    (Tuple 627 829),
    (Tuple 627 772),
    (Tuple 627 939),
    (Tuple 627 774),
    (Tuple 627 47),
    (Tuple 627 729),
    (Tuple 627 731),
    (Tuple 627 670),
    (Tuple 627 671),
    (Tuple 627 672),
    (Tuple 627 675),
    (Tuple 627 734),
    (Tuple 627 907),
    (Tuple 627 833),
    (Tuple 627 834),
    (Tuple 627 736),
    (Tuple 627 835),
    (Tuple 627 836),
    (Tuple 627 737),
    (Tuple 627 738),
    (Tuple 627 838),
    (Tuple 627 859),
    (Tuple 627 676),
    (Tuple 627 740),
    (Tuple 7 7),
    (Tuple 7 144),
    (Tuple 7 852),
    (Tuple 7 10),
    (Tuple 7 147),
    (Tuple 7 918),
    (Tuple 7 939),
    (Tuple 7 608),
    (Tuple 7 932),
    (Tuple 7 653),
    (Tuple 7 14),
    (Tuple 7 959),
    (Tuple 7 661),
    (Tuple 7 149),
    (Tuple 7 151),
    (Tuple 7 633),
    (Tuple 7 458),
    (Tuple 7 740),
    (Tuple 7 153),
    (Tuple 7 853),
    (Tuple 7 920),
    (Tuple 7 613),
    (Tuple 234 234),
    (Tuple 234 87),
    (Tuple 234 333),
    (Tuple 234 337),
    (Tuple 234 207),
    (Tuple 234 42),
    (Tuple 234 800),
    (Tuple 234 543),
    (Tuple 234 312),
    (Tuple 234 43),
    (Tuple 234 341),
    (Tuple 234 362),
    (Tuple 234 545),
    (Tuple 234 46),
    (Tuple 234 418),
    (Tuple 234 561),
    (Tuple 234 546),
    (Tuple 234 690),
    (Tuple 234 305),
    (Tuple 234 419),
    (Tuple 234 503),
    (Tuple 234 236),
    (Tuple 234 348),
    (Tuple 234 548),
    (Tuple 234 112),
    (Tuple 234 51),
    (Tuple 234 349),
    (Tuple 234 389),
    (Tuple 234 551),
    (Tuple 234 125),
    (Tuple 234 552),
    (Tuple 234 239),
    (Tuple 234 532),
    (Tuple 234 702),
    (Tuple 234 534),
    (Tuple 234 554),
    (Tuple 234 563),
    (Tuple 234 307),
    (Tuple 234 355),
    (Tuple 234 911),
    (Tuple 234 356),
    (Tuple 234 240),
    (Tuple 234 866),
    (Tuple 960 42),
    (Tuple 960 43),
    (Tuple 960 46),
    (Tuple 960 418),
    (Tuple 960 422),
    (Tuple 960 424),
    (Tuple 960 51),
    (Tuple 960 534),
    (Tuple 960 355),
    (Tuple 960 240),
    (Tuple 960 505),
    (Tuple 960 60),
    (Tuple 960 133),
    (Tuple 527 527),
    (Tuple 527 727),
    (Tuple 527 338),
    (Tuple 527 667),
    (Tuple 527 207),
    (Tuple 527 728),
    (Tuple 527 42),
    (Tuple 527 800),
    (Tuple 527 668),
    (Tuple 527 341),
    (Tuple 527 418),
    (Tuple 527 675),
    (Tuple 527 734),
    (Tuple 527 736),
    (Tuple 527 859),
    (Tuple 527 352),
    (Tuple 527 239),
    (Tuple 527 633),
    (Tuple 527 355),
    (Tuple 527 356),
    (Tuple 527 876),
    (Tuple 527 866),
    (Tuple 957 204),
    (Tuple 957 66),
    (Tuple 957 223),
    (Tuple 764 825),
    (Tuple 764 727),
    (Tuple 764 264),
    (Tuple 764 934),
    (Tuple 764 770),
    (Tuple 764 771),
    (Tuple 764 669),
    (Tuple 764 47),
    (Tuple 764 729),
    (Tuple 764 730),
    (Tuple 764 731),
    (Tuple 764 682),
    (Tuple 764 673),
    (Tuple 764 831),
    (Tuple 764 733),
    (Tuple 764 832),
    (Tuple 764 833),
    (Tuple 764 631),
    (Tuple 764 779),
    (Tuple 764 736),
    (Tuple 764 780),
    (Tuple 764 781),
    (Tuple 764 837),
    (Tuple 764 782),
    (Tuple 764 839),
    (Tuple 764 632),
    (Tuple 764 699),
    (Tuple 764 783),
    (Tuple 764 784),
    (Tuple 764 785),
    (Tuple 764 786),
    (Tuple 764 787),
    (Tuple 764 788),
    (Tuple 764 701),
    (Tuple 764 514),
    (Tuple 764 533),
    (Tuple 764 683),
    (Tuple 764 790),
    (Tuple 764 393),
    (Tuple 764 615),
    (Tuple 825 726),
    (Tuple 825 727),
    (Tuple 825 766),
    (Tuple 825 667),
    (Tuple 825 728),
    (Tuple 825 768),
    (Tuple 825 769),
    (Tuple 825 935),
    (Tuple 825 829),
    (Tuple 825 731),
    (Tuple 825 671),
    (Tuple 825 672),
    (Tuple 825 830),
    (Tuple 825 675),
    (Tuple 825 734),
    (Tuple 825 907),
    (Tuple 825 735),
    (Tuple 825 834),
    (Tuple 825 736),
    (Tuple 825 835),
    (Tuple 825 908),
    (Tuple 825 738),
    (Tuple 825 739),
    (Tuple 825 923),
    (Tuple 825 740),
    (Tuple 144 144),
    (Tuple 144 611),
    (Tuple 144 145),
    (Tuple 144 852),
    (Tuple 144 455),
    (Tuple 144 8),
    (Tuple 144 146),
    (Tuple 144 9),
    (Tuple 144 10),
    (Tuple 144 11),
    (Tuple 144 12),
    (Tuple 144 918),
    (Tuple 144 919),
    (Tuple 144 608),
    (Tuple 144 932),
    (Tuple 144 653),
    (Tuple 144 14),
    (Tuple 144 661),
    (Tuple 144 150),
    (Tuple 144 151),
    (Tuple 144 152),
    (Tuple 144 458),
    (Tuple 144 459),
    (Tuple 144 153),
    (Tuple 144 655),
    (Tuple 144 937),
    (Tuple 144 920),
    (Tuple 144 155),
    (Tuple 144 460),
    (Tuple 726 334),
    (Tuple 726 667),
    (Tuple 726 264),
    (Tuple 726 826),
    (Tuple 726 804),
    (Tuple 726 629),
    (Tuple 726 935),
    (Tuple 726 410),
    (Tuple 726 770),
    (Tuple 726 697),
    (Tuple 726 772),
    (Tuple 726 669),
    (Tuple 726 47),
    (Tuple 726 729),
    (Tuple 726 731),
    (Tuple 726 682),
    (Tuple 726 775),
    (Tuple 726 673),
    (Tuple 726 830),
    (Tuple 726 733),
    (Tuple 726 698),
    (Tuple 726 112),
    (Tuple 726 631),
    (Tuple 726 834),
    (Tuple 726 736),
    (Tuple 726 780),
    (Tuple 726 837),
    (Tuple 726 782),
    (Tuple 726 349),
    (Tuple 726 238),
    (Tuple 726 839),
    (Tuple 726 632),
    (Tuple 726 699),
    (Tuple 726 429),
    (Tuple 726 57),
    (Tuple 726 841),
    (Tuple 726 783),
    (Tuple 726 784),
    (Tuple 726 353),
    (Tuple 726 785),
    (Tuple 726 786),
    (Tuple 726 787),
    (Tuple 726 788),
    (Tuple 726 701),
    (Tuple 726 514),
    (Tuple 726 634),
    (Tuple 726 789),
    (Tuple 726 683),
    (Tuple 726 790),
    (Tuple 726 393),
    (Tuple 726 843),
    (Tuple 611 8),
    (Tuple 611 146),
    (Tuple 611 9),
    (Tuple 611 11),
    (Tuple 611 12),
    (Tuple 611 608),
    (Tuple 611 148),
    (Tuple 611 13),
    (Tuple 611 456),
    (Tuple 611 14),
    (Tuple 611 15),
    (Tuple 611 150),
    (Tuple 611 457),
    (Tuple 611 612),
    (Tuple 611 153),
    (Tuple 611 154),
    (Tuple 727 766),
    (Tuple 727 728),
    (Tuple 727 264),
    (Tuple 727 826),
    (Tuple 727 804),
    (Tuple 727 696),
    (Tuple 727 629),
    (Tuple 727 265),
    (Tuple 727 827),
    (Tuple 727 294),
    (Tuple 727 934),
    (Tuple 727 769),
    (Tuple 727 935),
    (Tuple 727 828),
    (Tuple 727 829),
    (Tuple 727 770),
    (Tuple 727 697),
    (Tuple 727 813),
    (Tuple 727 771),
    (Tuple 727 65),
    (Tuple 727 669),
    (Tuple 727 345),
    (Tuple 727 47),
    (Tuple 727 630),
    (Tuple 727 729),
    (Tuple 727 730),
    (Tuple 727 731),
    (Tuple 727 682),
    (Tuple 727 775),
    (Tuple 727 776),
    (Tuple 727 673),
    (Tuple 727 830),
    (Tuple 727 831),
    (Tuple 727 733),
    (Tuple 727 832),
    (Tuple 727 675),
    (Tuple 727 734),
    (Tuple 727 295),
    (Tuple 727 698),
    (Tuple 727 735),
    (Tuple 727 529),
    (Tuple 727 385),
    (Tuple 727 833),
    (Tuple 727 631),
    (Tuple 727 779),
    (Tuple 727 780),
    (Tuple 727 781),
    (Tuple 727 837),
    (Tuple 727 782),
    (Tuple 727 737),
    (Tuple 727 238),
    (Tuple 727 839),
    (Tuple 727 351),
    (Tuple 727 632),
    (Tuple 727 699),
    (Tuple 727 429),
    (Tuple 727 840),
    (Tuple 727 57),
    (Tuple 727 841),
    (Tuple 727 783),
    (Tuple 727 784),
    (Tuple 727 353),
    (Tuple 727 785),
    (Tuple 727 739),
    (Tuple 727 786),
    (Tuple 727 787),
    (Tuple 727 788),
    (Tuple 727 701),
    (Tuple 727 514),
    (Tuple 727 532),
    (Tuple 727 634),
    (Tuple 727 789),
    (Tuple 727 533),
    (Tuple 727 740),
    (Tuple 727 683),
    (Tuple 727 790),
    (Tuple 727 460),
    (Tuple 727 393),
    (Tuple 727 615),
    (Tuple 727 515),
    (Tuple 727 842),
    (Tuple 727 843),
    (Tuple 727 910),
    (Tuple 145 852),
    (Tuple 145 10),
    (Tuple 145 918),
    (Tuple 145 919),
    (Tuple 145 608),
    (Tuple 145 932),
    (Tuple 145 14),
    (Tuple 145 153),
    (Tuple 145 655),
    (Tuple 145 937),
    (Tuple 145 920),
    (Tuple 145 942),
    (Tuple 145 938),
    (Tuple 145 948),
    (Tuple 145 460),
    (Tuple 744 87),
    (Tuple 744 332),
    (Tuple 744 336),
    (Tuple 744 338),
    (Tuple 744 340),
    (Tuple 744 587),
    (Tuple 744 588),
    (Tuple 744 97),
    (Tuple 744 98),
    (Tuple 744 312),
    (Tuple 744 411),
    (Tuple 744 100),
    (Tuple 744 342),
    (Tuple 744 344),
    (Tuple 744 346),
    (Tuple 744 102),
    (Tuple 744 103),
    (Tuple 744 305),
    (Tuple 744 347),
    (Tuple 744 419),
    (Tuple 744 106),
    (Tuple 744 49),
    (Tuple 744 528),
    (Tuple 744 112),
    (Tuple 744 114),
    (Tuple 744 52),
    (Tuple 744 116),
    (Tuple 744 863),
    (Tuple 744 120),
    (Tuple 744 427),
    (Tuple 744 125),
    (Tuple 744 430),
    (Tuple 744 432),
    (Tuple 744 594),
    (Tuple 744 131),
    (Tuple 744 356),
    (Tuple 744 132),
    (Tuple 331 87),
    (Tuple 331 91),
    (Tuple 331 332),
    (Tuple 331 688),
    (Tuple 331 912),
    (Tuple 331 335),
    (Tuple 331 337),
    (Tuple 331 338),
    (Tuple 331 689),
    (Tuple 331 339),
    (Tuple 331 340),
    (Tuple 331 668),
    (Tuple 331 98),
    (Tuple 331 100),
    (Tuple 331 557),
    (Tuple 331 342),
    (Tuple 331 590),
    (Tuple 331 416),
    (Tuple 331 305),
    (Tuple 331 745),
    (Tuple 331 591),
    (Tuple 331 419),
    (Tuple 331 420),
    (Tuple 331 106),
    (Tuple 331 348),
    (Tuple 331 49),
    (Tuple 331 112),
    (Tuple 331 114),
    (Tuple 331 52),
    (Tuple 331 425),
    (Tuple 331 863),
    (Tuple 331 120),
    (Tuple 331 124),
    (Tuple 331 676),
    (Tuple 331 430),
    (Tuple 331 131),
    (Tuple 331 703),
    (Tuple 331 356),
    (Tuple 331 132),
    (Tuple 603 87),
    (Tuple 603 407),
    (Tuple 603 542),
    (Tuple 603 110),
    (Tuple 603 369),
    (Tuple 603 52),
    (Tuple 603 116),
    (Tuple 603 126),
    (Tuple 603 130),
    (Tuple 603 132),
    (Tuple 495 804),
    (Tuple 495 771),
    (Tuple 495 343),
    (Tuple 495 773),
    (Tuple 495 415),
    (Tuple 495 503),
    (Tuple 495 236),
    (Tuple 495 363),
    (Tuple 495 424),
    (Tuple 495 52),
    (Tuple 495 53),
    (Tuple 495 370),
    (Tuple 495 55),
    (Tuple 495 391),
    (Tuple 495 126),
    (Tuple 495 59),
    (Tuple 495 532),
    (Tuple 495 791),
    (Tuple 495 60),
    (Tuple 765 765),
    (Tuple 765 767),
    (Tuple 765 771),
    (Tuple 765 773),
    (Tuple 765 415),
    (Tuple 765 848),
    (Tuple 765 503),
    (Tuple 765 849),
    (Tuple 765 850),
    (Tuple 765 777),
    (Tuple 765 778),
    (Tuple 765 791),
    (Tuple 202 379),
    (Tuple 202 170),
    (Tuple 202 288),
    (Tuple 202 25),
    (Tuple 202 289),
    (Tuple 852 8),
    (Tuple 852 9),
    (Tuple 852 10),
    (Tuple 852 13),
    (Tuple 852 486),
    (Tuple 852 456),
    (Tuple 852 894),
    (Tuple 852 631),
    (Tuple 852 896),
    (Tuple 852 14),
    (Tuple 852 150),
    (Tuple 852 459),
    (Tuple 852 153),
    (Tuple 852 900),
    (Tuple 852 154),
    (Tuple 852 155),
    (Tuple 584 87),
    (Tuple 584 88),
    (Tuple 584 91),
    (Tuple 584 92),
    (Tuple 584 557),
    (Tuple 584 101),
    (Tuple 584 102),
    (Tuple 584 103),
    (Tuple 584 107),
    (Tuple 584 109),
    (Tuple 584 306),
    (Tuple 584 51),
    (Tuple 584 52),
    (Tuple 584 116),
    (Tuple 584 117),
    (Tuple 584 121),
    (Tuple 584 122),
    (Tuple 584 267),
    (Tuple 584 124),
    (Tuple 584 126),
    (Tuple 584 127),
    (Tuple 584 129),
    (Tuple 584 130),
    (Tuple 584 132),
    (Tuple 584 308),
    (Tuple 476 477),
    (Tuple 476 50),
    (Tuple 476 641),
    (Tuple 476 115),
    (Tuple 476 479),
    (Tuple 87 87),
    (Tuple 87 88),
    (Tuple 87 89),
    (Tuple 87 90),
    (Tuple 87 91),
    (Tuple 87 585),
    (Tuple 87 332),
    (Tuple 87 688),
    (Tuple 87 912),
    (Tuple 87 406),
    (Tuple 87 92),
    (Tuple 87 333),
    (Tuple 87 334),
    (Tuple 87 335),
    (Tuple 87 407),
    (Tuple 87 93),
    (Tuple 87 408),
    (Tuple 87 337),
    (Tuple 87 94),
    (Tuple 87 338),
    (Tuple 87 689),
    (Tuple 87 95),
    (Tuple 87 586),
    (Tuple 87 509),
    (Tuple 87 96),
    (Tuple 87 926),
    (Tuple 87 235),
    (Tuple 87 41),
    (Tuple 87 339),
    (Tuple 87 264),
    (Tuple 87 304),
    (Tuple 87 340),
    (Tuple 87 804),
    (Tuple 87 588),
    (Tuple 87 409),
    (Tuple 87 97),
    (Tuple 87 542),
    (Tuple 87 265),
    (Tuple 87 98),
    (Tuple 87 99),
    (Tuple 87 312),
    (Tuple 87 861),
    (Tuple 87 410),
    (Tuple 87 411),
    (Tuple 87 100),
    (Tuple 87 557),
    (Tuple 87 412),
    (Tuple 87 342),
    (Tuple 87 590),
    (Tuple 87 101),
    (Tuple 87 170),
    (Tuple 87 65),
    (Tuple 87 344),
    (Tuple 87 413),
    (Tuple 87 414),
    (Tuple 87 212),
    (Tuple 87 416),
    (Tuple 87 731),
    (Tuple 87 417),
    (Tuple 87 346),
    (Tuple 87 801),
    (Tuple 87 102),
    (Tuple 87 103),
    (Tuple 87 305),
    (Tuple 87 104),
    (Tuple 87 745),
    (Tuple 87 591),
    (Tuple 87 347),
    (Tuple 87 419),
    (Tuple 87 420),
    (Tuple 87 421),
    (Tuple 87 105),
    (Tuple 87 106),
    (Tuple 87 107),
    (Tuple 87 108),
    (Tuple 87 109),
    (Tuple 87 746),
    (Tuple 87 110),
    (Tuple 87 306),
    (Tuple 87 111),
    (Tuple 87 49),
    (Tuple 87 528),
    (Tuple 87 592),
    (Tuple 87 112),
    (Tuple 87 237),
    (Tuple 87 113),
    (Tuple 87 529),
    (Tuple 87 693),
    (Tuple 87 385),
    (Tuple 87 424),
    (Tuple 87 530),
    (Tuple 87 369),
    (Tuple 87 114),
    (Tuple 87 51),
    (Tuple 87 531),
    (Tuple 87 52),
    (Tuple 87 425),
    (Tuple 87 115),
    (Tuple 87 116),
    (Tuple 87 349),
    (Tuple 87 863),
    (Tuple 87 238),
    (Tuple 87 117),
    (Tuple 87 118),
    (Tuple 87 119),
    (Tuple 87 549),
    (Tuple 87 426),
    (Tuple 87 120),
    (Tuple 87 121),
    (Tuple 87 389),
    (Tuple 87 632),
    (Tuple 87 56),
    (Tuple 87 427),
    (Tuple 87 428),
    (Tuple 87 122),
    (Tuple 87 429),
    (Tuple 87 267),
    (Tuple 87 123),
    (Tuple 87 513),
    (Tuple 87 57),
    (Tuple 87 124),
    (Tuple 87 799),
    (Tuple 87 125),
    (Tuple 87 707),
    (Tuple 87 126),
    (Tuple 87 127),
    (Tuple 87 430),
    (Tuple 87 239),
    (Tuple 87 431),
    (Tuple 87 532),
    (Tuple 87 128),
    (Tuple 87 634),
    (Tuple 87 534),
    (Tuple 87 432),
    (Tuple 87 129),
    (Tuple 87 130),
    (Tuple 87 594),
    (Tuple 87 595),
    (Tuple 87 131),
    (Tuple 87 433),
    (Tuple 87 703),
    (Tuple 87 596),
    (Tuple 87 356),
    (Tuple 87 597),
    (Tuple 87 132),
    (Tuple 87 308),
    (Tuple 87 615),
    (Tuple 87 60),
    (Tuple 87 435),
    (Tuple 87 133),
    (Tuple 87 357),
    (Tuple 87 173),
    (Tuple 87 309),
    (Tuple 378 315),
    (Tuple 378 166),
    (Tuple 378 208),
    (Tuple 378 209),
    (Tuple 378 210),
    (Tuple 378 212),
    (Tuple 378 213),
    (Tuple 378 646),
    (Tuple 378 506),
    (Tuple 378 383),
    (Tuple 378 384),
    (Tuple 378 218),
    (Tuple 378 387),
    (Tuple 378 648),
    (Tuple 378 390),
    (Tuple 378 649),
    (Tuple 378 68),
    (Tuple 378 221),
    (Tuple 378 290),
    (Tuple 378 225),
    (Tuple 88 91),
    (Tuple 88 332),
    (Tuple 88 688),
    (Tuple 88 335),
    (Tuple 88 337),
    (Tuple 88 338),
    (Tuple 88 586),
    (Tuple 88 41),
    (Tuple 88 339),
    (Tuple 88 304),
    (Tuple 88 340),
    (Tuple 88 587),
    (Tuple 88 588),
    (Tuple 88 97),
    (Tuple 88 98),
    (Tuple 88 312),
    (Tuple 88 100),
    (Tuple 88 557),
    (Tuple 88 412),
    (Tuple 88 342),
    (Tuple 88 102),
    (Tuple 88 305),
    (Tuple 88 745),
    (Tuple 88 591),
    (Tuple 88 419),
    (Tuple 88 106),
    (Tuple 88 109),
    (Tuple 88 746),
    (Tuple 88 863),
    (Tuple 88 426),
    (Tuple 88 120),
    (Tuple 88 124),
    (Tuple 88 126),
    (Tuple 88 356),
    (Tuple 88 903),
    (Tuple 89 338),
    (Tuple 89 41),
    (Tuple 89 42),
    (Tuple 89 557),
    (Tuple 89 260),
    (Tuple 89 561),
    (Tuple 89 546),
    (Tuple 89 116),
    (Tuple 89 596),
    (Tuple 89 132),
    (Tuple 455 9),
    (Tuple 455 12),
    (Tuple 455 148),
    (Tuple 455 13),
    (Tuple 455 15),
    (Tuple 455 151),
    (Tuple 455 152),
    (Tuple 455 459),
    (Tuple 455 153),
    (Tuple 455 154),
    (Tuple 916 297),
    (Tuple 90 91),
    (Tuple 90 332),
    (Tuple 90 406),
    (Tuple 90 335),
    (Tuple 90 337),
    (Tuple 90 338),
    (Tuple 90 95),
    (Tuple 90 96),
    (Tuple 90 587),
    (Tuple 90 804),
    (Tuple 90 97),
    (Tuple 90 557),
    (Tuple 90 342),
    (Tuple 90 413),
    (Tuple 90 102),
    (Tuple 90 103),
    (Tuple 90 591),
    (Tuple 90 419),
    (Tuple 90 420),
    (Tuple 90 421),
    (Tuple 90 105),
    (Tuple 90 106),
    (Tuple 90 348),
    (Tuple 90 111),
    (Tuple 90 49),
    (Tuple 90 112),
    (Tuple 90 531),
    (Tuple 90 52),
    (Tuple 90 425),
    (Tuple 90 116),
    (Tuple 90 349),
    (Tuple 90 120),
    (Tuple 90 427),
    (Tuple 90 123),
    (Tuple 90 124),
    (Tuple 90 125),
    (Tuple 90 126),
    (Tuple 90 430),
    (Tuple 90 131),
    (Tuple 90 596),
    (Tuple 90 132),
    (Tuple 91 332),
    (Tuple 91 688),
    (Tuple 91 334),
    (Tuple 91 335),
    (Tuple 91 336),
    (Tuple 91 337),
    (Tuple 91 94),
    (Tuple 91 338),
    (Tuple 91 689),
    (Tuple 91 586),
    (Tuple 91 509),
    (Tuple 91 96),
    (Tuple 91 41),
    (Tuple 91 339),
    (Tuple 91 961),
    (Tuple 91 304),
    (Tuple 91 340),
    (Tuple 91 587),
    (Tuple 91 588),
    (Tuple 91 97),
    (Tuple 91 542),
    (Tuple 91 668),
    (Tuple 91 767),
    (Tuple 91 98),
    (Tuple 91 312),
    (Tuple 91 411),
    (Tuple 91 100),
    (Tuple 91 557),
    (Tuple 91 342),
    (Tuple 91 590),
    (Tuple 91 344),
    (Tuple 91 413),
    (Tuple 91 346),
    (Tuple 91 102),
    (Tuple 91 103),
    (Tuple 91 104),
    (Tuple 91 591),
    (Tuple 91 419),
    (Tuple 91 420),
    (Tuple 91 421),
    (Tuple 91 105),
    (Tuple 91 106),
    (Tuple 91 110),
    (Tuple 91 348),
    (Tuple 91 49),
    (Tuple 91 528),
    (Tuple 91 112),
    (Tuple 91 114),
    (Tuple 91 425),
    (Tuple 91 116),
    (Tuple 91 349),
    (Tuple 91 238),
    (Tuple 91 549),
    (Tuple 91 120),
    (Tuple 91 350),
    (Tuple 91 124),
    (Tuple 91 126),
    (Tuple 91 128),
    (Tuple 91 131),
    (Tuple 91 433),
    (Tuple 91 703),
    (Tuple 91 356),
    (Tuple 91 903),
    (Tuple 91 132),
    (Tuple 91 435),
    (Tuple 91 309),
    (Tuple 585 332),
    (Tuple 585 338),
    (Tuple 585 689),
    (Tuple 585 41),
    (Tuple 585 340),
    (Tuple 585 587),
    (Tuple 585 542),
    (Tuple 585 98),
    (Tuple 585 312),
    (Tuple 585 861),
    (Tuple 585 100),
    (Tuple 585 102),
    (Tuple 585 103),
    (Tuple 585 305),
    (Tuple 585 106),
    (Tuple 585 49),
    (Tuple 585 528),
    (Tuple 585 112),
    (Tuple 585 52),
    (Tuple 585 116),
    (Tuple 585 120),
    (Tuple 585 124),
    (Tuple 585 126),
    (Tuple 585 354),
    (Tuple 585 128),
    (Tuple 585 131),
    (Tuple 585 132),
    (Tuple 585 435),
    (Tuple 332 332),
    (Tuple 332 688),
    (Tuple 332 912),
    (Tuple 332 406),
    (Tuple 332 92),
    (Tuple 332 334),
    (Tuple 332 336),
    (Tuple 332 408),
    (Tuple 332 337),
    (Tuple 332 94),
    (Tuple 332 338),
    (Tuple 332 95),
    (Tuple 332 586),
    (Tuple 332 509),
    (Tuple 332 235),
    (Tuple 332 340),
    (Tuple 332 800),
    (Tuple 332 804),
    (Tuple 332 588),
    (Tuple 332 409),
    (Tuple 332 97),
    (Tuple 332 542),
    (Tuple 332 98),
    (Tuple 332 312),
    (Tuple 332 861),
    (Tuple 332 410),
    (Tuple 332 411),
    (Tuple 332 100),
    (Tuple 332 557),
    (Tuple 332 697),
    (Tuple 332 342),
    (Tuple 332 590),
    (Tuple 332 101),
    (Tuple 332 413),
    (Tuple 332 414),
    (Tuple 332 862),
    (Tuple 332 630),
    (Tuple 332 416),
    (Tuple 332 775),
    (Tuple 332 346),
    (Tuple 332 102),
    (Tuple 332 103),
    (Tuple 332 104),
    (Tuple 332 591),
    (Tuple 332 420),
    (Tuple 332 421),
    (Tuple 332 105),
    (Tuple 332 106),
    (Tuple 332 733),
    (Tuple 332 107),
    (Tuple 332 108),
    (Tuple 332 422),
    (Tuple 332 109),
    (Tuple 332 110),
    (Tuple 332 111),
    (Tuple 332 832),
    (Tuple 332 49),
    (Tuple 332 528),
    (Tuple 332 592),
    (Tuple 332 112),
    (Tuple 332 237),
    (Tuple 332 529),
    (Tuple 332 693),
    (Tuple 332 363),
    (Tuple 332 530),
    (Tuple 332 114),
    (Tuple 332 51),
    (Tuple 332 531),
    (Tuple 332 52),
    (Tuple 332 116),
    (Tuple 332 349),
    (Tuple 332 118),
    (Tuple 332 549),
    (Tuple 332 120),
    (Tuple 332 266),
    (Tuple 332 350),
    (Tuple 332 351),
    (Tuple 332 699),
    (Tuple 332 427),
    (Tuple 332 428),
    (Tuple 332 429),
    (Tuple 332 267),
    (Tuple 332 123),
    (Tuple 332 124),
    (Tuple 332 125),
    (Tuple 332 126),
    (Tuple 332 430),
    (Tuple 332 128),
    (Tuple 332 634),
    (Tuple 332 432),
    (Tuple 332 131),
    (Tuple 332 433),
    (Tuple 332 703),
    (Tuple 332 596),
    (Tuple 332 132),
    (Tuple 332 393),
    (Tuple 332 308),
    (Tuple 332 435),
    (Tuple 332 357),
    (Tuple 332 309),
    (Tuple 688 688),
    (Tuple 688 92),
    (Tuple 688 334),
    (Tuple 688 337),
    (Tuple 688 509),
    (Tuple 688 235),
    (Tuple 688 340),
    (Tuple 688 804),
    (Tuple 688 588),
    (Tuple 688 97),
    (Tuple 688 542),
    (Tuple 688 98),
    (Tuple 688 312),
    (Tuple 688 861),
    (Tuple 688 410),
    (Tuple 688 100),
    (Tuple 688 342),
    (Tuple 688 101),
    (Tuple 688 416),
    (Tuple 688 102),
    (Tuple 688 103),
    (Tuple 688 420),
    (Tuple 688 421),
    (Tuple 688 105),
    (Tuple 688 108),
    (Tuple 688 109),
    (Tuple 688 49),
    (Tuple 688 528),
    (Tuple 688 112),
    (Tuple 688 237),
    (Tuple 688 530),
    (Tuple 688 369),
    (Tuple 688 114),
    (Tuple 688 531),
    (Tuple 688 52),
    (Tuple 688 425),
    (Tuple 688 782),
    (Tuple 688 349),
    (Tuple 688 238),
    (Tuple 688 549),
    (Tuple 688 120),
    (Tuple 688 350),
    (Tuple 688 427),
    (Tuple 688 428),
    (Tuple 688 122),
    (Tuple 688 267),
    (Tuple 688 124),
    (Tuple 688 125),
    (Tuple 688 126),
    (Tuple 688 430),
    (Tuple 688 128),
    (Tuple 688 432),
    (Tuple 688 703),
    (Tuple 688 356),
    (Tuple 688 393),
    (Tuple 688 308),
    (Tuple 688 435),
    (Tuple 912 334),
    (Tuple 912 409),
    (Tuple 912 542),
    (Tuple 912 697),
    (Tuple 912 101),
    (Tuple 912 345),
    (Tuple 912 630),
    (Tuple 912 102),
    (Tuple 912 103),
    (Tuple 912 305),
    (Tuple 912 420),
    (Tuple 912 421),
    (Tuple 912 111),
    (Tuple 912 49),
    (Tuple 912 112),
    (Tuple 912 237),
    (Tuple 912 114),
    (Tuple 912 531),
    (Tuple 912 425),
    (Tuple 912 349),
    (Tuple 912 120),
    (Tuple 912 353),
    (Tuple 912 124),
    (Tuple 912 125),
    (Tuple 912 430),
    (Tuple 912 595),
    (Tuple 912 131),
    (Tuple 912 703),
    (Tuple 912 357),
    (Tuple 912 309),
    (Tuple 406 333),
    (Tuple 406 334),
    (Tuple 406 335),
    (Tuple 406 337),
    (Tuple 406 338),
    (Tuple 406 689),
    (Tuple 406 667),
    (Tuple 406 95),
    (Tuple 406 207),
    (Tuple 406 926),
    (Tuple 406 340),
    (Tuple 406 587),
    (Tuple 406 767),
    (Tuple 406 312),
    (Tuple 406 100),
    (Tuple 406 342),
    (Tuple 406 590),
    (Tuple 406 414),
    (Tuple 406 862),
    (Tuple 406 745),
    (Tuple 406 672),
    (Tuple 406 347),
    (Tuple 406 419),
    (Tuple 406 106),
    (Tuple 406 746),
    (Tuple 406 348),
    (Tuple 406 592),
    (Tuple 406 52),
    (Tuple 406 120),
    (Tuple 406 859),
    (Tuple 406 923),
    (Tuple 406 676),
    (Tuple 406 633),
    (Tuple 406 703),
    (Tuple 406 596),
    (Tuple 92 333),
    (Tuple 92 334),
    (Tuple 92 335),
    (Tuple 92 338),
    (Tuple 92 207),
    (Tuple 92 926),
    (Tuple 92 340),
    (Tuple 92 800),
    (Tuple 92 587),
    (Tuple 92 588),
    (Tuple 92 668),
    (Tuple 92 98),
    (Tuple 92 312),
    (Tuple 92 100),
    (Tuple 92 557),
    (Tuple 92 342),
    (Tuple 92 344),
    (Tuple 92 690),
    (Tuple 92 591),
    (Tuple 92 347),
    (Tuple 92 419),
    (Tuple 92 106),
    (Tuple 92 348),
    (Tuple 92 114),
    (Tuple 92 52),
    (Tuple 92 116),
    (Tuple 92 120),
    (Tuple 92 676),
    (Tuple 92 354),
    (Tuple 92 633),
    (Tuple 92 596),
    (Tuple 92 132),
    (Tuple 92 876),
    (Tuple 333 333),
    (Tuple 333 408),
    (Tuple 333 337),
    (Tuple 333 94),
    (Tuple 333 338),
    (Tuple 333 95),
    (Tuple 333 509),
    (Tuple 333 409),
    (Tuple 333 97),
    (Tuple 333 542),
    (Tuple 333 410),
    (Tuple 333 100),
    (Tuple 333 557),
    (Tuple 333 590),
    (Tuple 333 101),
    (Tuple 333 344),
    (Tuple 333 416),
    (Tuple 333 102),
    (Tuple 333 103),
    (Tuple 333 305),
    (Tuple 333 104),
    (Tuple 333 420),
    (Tuple 333 421),
    (Tuple 333 105),
    (Tuple 333 108),
    (Tuple 333 109),
    (Tuple 333 110),
    (Tuple 333 111),
    (Tuple 333 49),
    (Tuple 333 112),
    (Tuple 333 530),
    (Tuple 333 531),
    (Tuple 333 52),
    (Tuple 333 425),
    (Tuple 333 116),
    (Tuple 333 349),
    (Tuple 333 549),
    (Tuple 333 428),
    (Tuple 333 267),
    (Tuple 333 123),
    (Tuple 333 57),
    (Tuple 333 124),
    (Tuple 333 125),
    (Tuple 333 126),
    (Tuple 333 787),
    (Tuple 333 430),
    (Tuple 333 239),
    (Tuple 333 128),
    (Tuple 333 594),
    (Tuple 333 595),
    (Tuple 333 131),
    (Tuple 333 433),
    (Tuple 333 703),
    (Tuple 333 132),
    (Tuple 333 435),
    (Tuple 333 357),
    (Tuple 333 309),
    (Tuple 334 335),
    (Tuple 334 408),
    (Tuple 334 337),
    (Tuple 334 94),
    (Tuple 334 338),
    (Tuple 334 689),
    (Tuple 334 95),
    (Tuple 334 586),
    (Tuple 334 207),
    (Tuple 334 340),
    (Tuple 334 800),
    (Tuple 334 588),
    (Tuple 334 97),
    (Tuple 334 542),
    (Tuple 334 668),
    (Tuple 334 98),
    (Tuple 334 312),
    (Tuple 334 410),
    (Tuple 334 100),
    (Tuple 334 557),
    (Tuple 334 342),
    (Tuple 334 590),
    (Tuple 334 344),
    (Tuple 334 413),
    (Tuple 334 345),
    (Tuple 334 862),
    (Tuple 334 416),
    (Tuple 334 102),
    (Tuple 334 103),
    (Tuple 334 305),
    (Tuple 334 591),
    (Tuple 334 347),
    (Tuple 334 503),
    (Tuple 334 420),
    (Tuple 334 105),
    (Tuple 334 106),
    (Tuple 334 109),
    (Tuple 334 49),
    (Tuple 334 592),
    (Tuple 334 112),
    (Tuple 334 237),
    (Tuple 334 693),
    (Tuple 334 530),
    (Tuple 334 736),
    (Tuple 334 531),
    (Tuple 334 52),
    (Tuple 334 425),
    (Tuple 334 349),
    (Tuple 334 118),
    (Tuple 334 549),
    (Tuple 334 266),
    (Tuple 334 427),
    (Tuple 334 428),
    (Tuple 334 267),
    (Tuple 334 124),
    (Tuple 334 125),
    (Tuple 334 430),
    (Tuple 334 239),
    (Tuple 334 514),
    (Tuple 334 432),
    (Tuple 334 703),
    (Tuple 334 357),
    (Tuple 335 335),
    (Tuple 335 337),
    (Tuple 335 94),
    (Tuple 335 95),
    (Tuple 335 509),
    (Tuple 335 804),
    (Tuple 335 409),
    (Tuple 335 97),
    (Tuple 335 542),
    (Tuple 335 410),
    (Tuple 335 100),
    (Tuple 335 101),
    (Tuple 335 102),
    (Tuple 335 103),
    (Tuple 335 305),
    (Tuple 335 104),
    (Tuple 335 745),
    (Tuple 335 591),
    (Tuple 335 420),
    (Tuple 335 421),
    (Tuple 335 105),
    (Tuple 335 107),
    (Tuple 335 110),
    (Tuple 335 111),
    (Tuple 335 49),
    (Tuple 335 528),
    (Tuple 335 592),
    (Tuple 335 112),
    (Tuple 335 237),
    (Tuple 335 113),
    (Tuple 335 529),
    (Tuple 335 114),
    (Tuple 335 52),
    (Tuple 335 425),
    (Tuple 335 349),
    (Tuple 335 118),
    (Tuple 335 426),
    (Tuple 335 120),
    (Tuple 335 267),
    (Tuple 335 123),
    (Tuple 335 124),
    (Tuple 335 125),
    (Tuple 335 126),
    (Tuple 335 127),
    (Tuple 335 430),
    (Tuple 335 128),
    (Tuple 335 129),
    (Tuple 335 594),
    (Tuple 335 595),
    (Tuple 335 131),
    (Tuple 335 433),
    (Tuple 335 703),
    (Tuple 335 480),
    (Tuple 335 132),
    (Tuple 335 435),
    (Tuple 335 309),
    (Tuple 336 303),
    (Tuple 336 265),
    (Tuple 336 312),
    (Tuple 336 478),
    (Tuple 336 344),
    (Tuple 336 103),
    (Tuple 336 106),
    (Tuple 336 108),
    (Tuple 336 306),
    (Tuple 336 49),
    (Tuple 336 528),
    (Tuple 336 363),
    (Tuple 336 369),
    (Tuple 336 120),
    (Tuple 336 122),
    (Tuple 336 126),
    (Tuple 336 430),
    (Tuple 962 514),
    (Tuple 407 338),
    (Tuple 407 689),
    (Tuple 407 96),
    (Tuple 407 42),
    (Tuple 407 99),
    (Tuple 407 557),
    (Tuple 407 591),
    (Tuple 407 116),
    (Tuple 407 596),
    (Tuple 407 132),
    (Tuple 93 93),
    (Tuple 93 97),
    (Tuple 93 417),
    (Tuple 93 102),
    (Tuple 93 103),
    (Tuple 93 305),
    (Tuple 93 104),
    (Tuple 93 108),
    (Tuple 93 306),
    (Tuple 93 113),
    (Tuple 93 530),
    (Tuple 93 114),
    (Tuple 93 52),
    (Tuple 93 116),
    (Tuple 93 349),
    (Tuple 93 117),
    (Tuple 93 122),
    (Tuple 93 123),
    (Tuple 93 126),
    (Tuple 93 132),
    (Tuple 93 133),
    (Tuple 93 309),
    (Tuple 408 337),
    (Tuple 408 338),
    (Tuple 408 689),
    (Tuple 408 207),
    (Tuple 408 340),
    (Tuple 408 587),
    (Tuple 408 98),
    (Tuple 408 312),
    (Tuple 408 411),
    (Tuple 408 100),
    (Tuple 408 342),
    (Tuple 408 862),
    (Tuple 408 347),
    (Tuple 408 419),
    (Tuple 408 746),
    (Tuple 408 348),
    (Tuple 408 120),
    (Tuple 408 352),
    (Tuple 408 124),
    (Tuple 408 700),
    (Tuple 408 703),
    (Tuple 303 338),
    (Tuple 303 945),
    (Tuple 303 42),
    (Tuple 303 543),
    (Tuple 303 43),
    (Tuple 303 560),
    (Tuple 303 46),
    (Tuple 303 712),
    (Tuple 303 561),
    (Tuple 303 546),
    (Tuple 303 496),
    (Tuple 303 54),
    (Tuple 303 352),
    (Tuple 303 307),
    (Tuple 303 355),
    (Tuple 303 866),
    (Tuple 715 715),
    (Tuple 715 716),
    (Tuple 715 653),
    (Tuple 715 152),
    (Tuple 715 172),
    (Tuple 315 315),
    (Tuple 315 380),
    (Tuple 315 9),
    (Tuple 315 381),
    (Tuple 315 497),
    (Tuple 315 648),
    (Tuple 315 370),
    (Tuple 315 221),
    (Tuple 766 667),
    (Tuple 766 728),
    (Tuple 766 264),
    (Tuple 766 826),
    (Tuple 766 827),
    (Tuple 766 935),
    (Tuple 766 829),
    (Tuple 766 770),
    (Tuple 766 772),
    (Tuple 766 669),
    (Tuple 766 345),
    (Tuple 766 47),
    (Tuple 766 729),
    (Tuple 766 730),
    (Tuple 766 731),
    (Tuple 766 682),
    (Tuple 766 775),
    (Tuple 766 776),
    (Tuple 766 673),
    (Tuple 766 733),
    (Tuple 766 832),
    (Tuple 766 734),
    (Tuple 766 295),
    (Tuple 766 698),
    (Tuple 766 363),
    (Tuple 766 833),
    (Tuple 766 631),
    (Tuple 766 779),
    (Tuple 766 780),
    (Tuple 766 781),
    (Tuple 766 837),
    (Tuple 766 782),
    (Tuple 766 238),
    (Tuple 766 839),
    (Tuple 766 632),
    (Tuple 766 699),
    (Tuple 766 429),
    (Tuple 766 57),
    (Tuple 766 841),
    (Tuple 766 783),
    (Tuple 766 784),
    (Tuple 766 353),
    (Tuple 766 785),
    (Tuple 766 786),
    (Tuple 766 787),
    (Tuple 766 788),
    (Tuple 766 701),
    (Tuple 766 514),
    (Tuple 766 634),
    (Tuple 766 533),
    (Tuple 766 683),
    (Tuple 766 790),
    (Tuple 766 393),
    (Tuple 766 615),
    (Tuple 766 515),
    (Tuple 766 842),
    (Tuple 766 910),
    (Tuple 337 94),
    (Tuple 337 689),
    (Tuple 337 95),
    (Tuple 337 586),
    (Tuple 337 207),
    (Tuple 337 509),
    (Tuple 337 340),
    (Tuple 337 800),
    (Tuple 337 587),
    (Tuple 337 804),
    (Tuple 337 588),
    (Tuple 337 97),
    (Tuple 337 542),
    (Tuple 337 265),
    (Tuple 337 98),
    (Tuple 337 312),
    (Tuple 337 861),
    (Tuple 337 100),
    (Tuple 337 557),
    (Tuple 337 697),
    (Tuple 337 342),
    (Tuple 337 101),
    (Tuple 337 949),
    (Tuple 337 345),
    (Tuple 337 862),
    (Tuple 337 416),
    (Tuple 337 776),
    (Tuple 337 102),
    (Tuple 337 690),
    (Tuple 337 103),
    (Tuple 337 305),
    (Tuple 337 745),
    (Tuple 337 347),
    (Tuple 337 503),
    (Tuple 337 420),
    (Tuple 337 421),
    (Tuple 337 106),
    (Tuple 337 108),
    (Tuple 337 348),
    (Tuple 337 111),
    (Tuple 337 49),
    (Tuple 337 528),
    (Tuple 337 112),
    (Tuple 337 237),
    (Tuple 337 530),
    (Tuple 337 114),
    (Tuple 337 531),
    (Tuple 337 52),
    (Tuple 337 425),
    (Tuple 337 116),
    (Tuple 337 349),
    (Tuple 337 863),
    (Tuple 337 549),
    (Tuple 337 120),
    (Tuple 337 427),
    (Tuple 337 428),
    (Tuple 337 859),
    (Tuple 337 122),
    (Tuple 337 352),
    (Tuple 337 353),
    (Tuple 337 124),
    (Tuple 337 125),
    (Tuple 337 923),
    (Tuple 337 707),
    (Tuple 337 430),
    (Tuple 337 354),
    (Tuple 337 702),
    (Tuple 337 595),
    (Tuple 337 131),
    (Tuple 337 433),
    (Tuple 337 703),
    (Tuple 337 596),
    (Tuple 337 132),
    (Tuple 337 876),
    (Tuple 337 309),
    (Tuple 8 146),
    (Tuple 8 10),
    (Tuple 8 11),
    (Tuple 8 147),
    (Tuple 8 12),
    (Tuple 8 918),
    (Tuple 8 919),
    (Tuple 8 608),
    (Tuple 8 932),
    (Tuple 8 13),
    (Tuple 8 386),
    (Tuple 8 959),
    (Tuple 8 661),
    (Tuple 8 150),
    (Tuple 8 457),
    (Tuple 8 458),
    (Tuple 8 153),
    (Tuple 8 853),
    (Tuple 8 920),
    (Tuple 8 613),
    (Tuple 203 166),
    (Tuple 203 204),
    (Tuple 203 209),
    (Tuple 203 210),
    (Tuple 203 213),
    (Tuple 203 796),
    (Tuple 203 382),
    (Tuple 203 383),
    (Tuple 203 384),
    (Tuple 203 67),
    (Tuple 203 217),
    (Tuple 203 218),
    (Tuple 203 648),
    (Tuple 203 390),
    (Tuple 203 649),
    (Tuple 203 68),
    (Tuple 203 69),
    (Tuple 203 392),
    (Tuple 203 290),
    (Tuple 94 338),
    (Tuple 94 689),
    (Tuple 94 339),
    (Tuple 94 340),
    (Tuple 94 588),
    (Tuple 94 98),
    (Tuple 94 312),
    (Tuple 94 100),
    (Tuple 94 557),
    (Tuple 94 342),
    (Tuple 94 416),
    (Tuple 94 305),
    (Tuple 94 106),
    (Tuple 94 116),
    (Tuple 94 352),
    (Tuple 94 124),
    (Tuple 94 596),
    (Tuple 94 132),
    (Tuple 166 204),
    (Tuple 166 379),
    (Tuple 166 284),
    (Tuple 166 209),
    (Tuple 166 210),
    (Tuple 166 211),
    (Tuple 166 168),
    (Tuple 166 212),
    (Tuple 166 213),
    (Tuple 166 289),
    (Tuple 166 382),
    (Tuple 166 506),
    (Tuple 166 383),
    (Tuple 166 216),
    (Tuple 166 384),
    (Tuple 166 218),
    (Tuple 166 387),
    (Tuple 166 648),
    (Tuple 166 390),
    (Tuple 166 221),
    (Tuple 166 222),
    (Tuple 166 392),
    (Tuple 166 290),
    (Tuple 166 225),
    (Tuple 166 394),
    (Tuple 204 208),
    (Tuple 204 284),
    (Tuple 204 167),
    (Tuple 204 209),
    (Tuple 204 211),
    (Tuple 204 168),
    (Tuple 204 170),
    (Tuple 204 288),
    (Tuple 204 212),
    (Tuple 204 214),
    (Tuple 204 383),
    (Tuple 204 66),
    (Tuple 204 216),
    (Tuple 204 593),
    (Tuple 204 220),
    (Tuple 204 390),
    (Tuple 204 222),
    (Tuple 204 224),
    (Tuple 204 394),
    (Tuple 205 168),
    (Tuple 205 25),
    (Tuple 205 511),
    (Tuple 205 23),
    (Tuple 205 289),
    (Tuple 205 506),
    (Tuple 205 220),
    (Tuple 205 223),
    (Tuple 879 117),
    (Tuple 879 119),
    (Tuple 879 127),
    (Tuple 963 380),
    (Tuple 963 381),
    (Tuple 963 16),
    (Tuple 464 171),
    (Tuple 464 220),
    (Tuple 464 223),
    (Tuple 338 95),
    (Tuple 338 586),
    (Tuple 338 509),
    (Tuple 338 235),
    (Tuple 338 41),
    (Tuple 338 588),
    (Tuple 338 409),
    (Tuple 338 97),
    (Tuple 338 542),
    (Tuple 338 265),
    (Tuple 338 98),
    (Tuple 338 99),
    (Tuple 338 861),
    (Tuple 338 410),
    (Tuple 338 100),
    (Tuple 338 697),
    (Tuple 338 342),
    (Tuple 338 590),
    (Tuple 338 101),
    (Tuple 338 65),
    (Tuple 338 413),
    (Tuple 338 345),
    (Tuple 338 416),
    (Tuple 338 417),
    (Tuple 338 102),
    (Tuple 338 103),
    (Tuple 338 305),
    (Tuple 338 104),
    (Tuple 338 420),
    (Tuple 338 421),
    (Tuple 338 105),
    (Tuple 338 106),
    (Tuple 338 107),
    (Tuple 338 108),
    (Tuple 338 422),
    (Tuple 338 109),
    (Tuple 338 110),
    (Tuple 338 306),
    (Tuple 338 111),
    (Tuple 338 49),
    (Tuple 338 528),
    (Tuple 338 112),
    (Tuple 338 237),
    (Tuple 338 113),
    (Tuple 338 529),
    (Tuple 338 693),
    (Tuple 338 363),
    (Tuple 338 424),
    (Tuple 338 530),
    (Tuple 338 369),
    (Tuple 338 114),
    (Tuple 338 51),
    (Tuple 338 531),
    (Tuple 338 52),
    (Tuple 338 425),
    (Tuple 338 115),
    (Tuple 338 349),
    (Tuple 338 238),
    (Tuple 338 118),
    (Tuple 338 119),
    (Tuple 338 549),
    (Tuple 338 426),
    (Tuple 338 120),
    (Tuple 338 121),
    (Tuple 338 350),
    (Tuple 338 427),
    (Tuple 338 428),
    (Tuple 338 122),
    (Tuple 338 429),
    (Tuple 338 267),
    (Tuple 338 123),
    (Tuple 338 57),
    (Tuple 338 124),
    (Tuple 338 125),
    (Tuple 338 126),
    (Tuple 338 127),
    (Tuple 338 430),
    (Tuple 338 239),
    (Tuple 338 128),
    (Tuple 338 432),
    (Tuple 338 129),
    (Tuple 338 130),
    (Tuple 338 595),
    (Tuple 338 131),
    (Tuple 338 433),
    (Tuple 338 703),
    (Tuple 338 356),
    (Tuple 338 132),
    (Tuple 338 393),
    (Tuple 338 308),
    (Tuple 338 60),
    (Tuple 338 435),
    (Tuple 338 133),
    (Tuple 338 357),
    (Tuple 338 309),
    (Tuple 206 286),
    (Tuple 206 23),
    (Tuple 206 520),
    (Tuple 206 215),
    (Tuple 206 261),
    (Tuple 206 262),
    (Tuple 206 507),
    (Tuple 379 168),
    (Tuple 379 170),
    (Tuple 379 288),
    (Tuple 379 646),
    (Tuple 379 383),
    (Tuple 379 390),
    (Tuple 379 649),
    (Tuple 379 223),
    (Tuple 689 235),
    (Tuple 689 409),
    (Tuple 689 97),
    (Tuple 689 542),
    (Tuple 689 100),
    (Tuple 689 697),
    (Tuple 689 101),
    (Tuple 689 345),
    (Tuple 689 416),
    (Tuple 689 102),
    (Tuple 689 103),
    (Tuple 689 305),
    (Tuple 689 104),
    (Tuple 689 420),
    (Tuple 689 421),
    (Tuple 689 105),
    (Tuple 689 106),
    (Tuple 689 49),
    (Tuple 689 112),
    (Tuple 689 237),
    (Tuple 689 529),
    (Tuple 689 530),
    (Tuple 689 369),
    (Tuple 689 114),
    (Tuple 689 531),
    (Tuple 689 52),
    (Tuple 689 425),
    (Tuple 689 349),
    (Tuple 689 549),
    (Tuple 689 120),
    (Tuple 689 266),
    (Tuple 689 57),
    (Tuple 689 124),
    (Tuple 689 126),
    (Tuple 689 430),
    (Tuple 689 128),
    (Tuple 689 594),
    (Tuple 689 595),
    (Tuple 689 131),
    (Tuple 689 433),
    (Tuple 689 703),
    (Tuple 689 132),
    (Tuple 689 435),
    (Tuple 689 309),
    (Tuple 667 667),
    (Tuple 667 509),
    (Tuple 667 728),
    (Tuple 667 264),
    (Tuple 667 826),
    (Tuple 667 800),
    (Tuple 667 804),
    (Tuple 667 696),
    (Tuple 667 409),
    (Tuple 667 629),
    (Tuple 667 827),
    (Tuple 667 294),
    (Tuple 667 934),
    (Tuple 667 769),
    (Tuple 667 935),
    (Tuple 667 829),
    (Tuple 667 770),
    (Tuple 667 771),
    (Tuple 667 65),
    (Tuple 667 772),
    (Tuple 667 773),
    (Tuple 667 669),
    (Tuple 667 414),
    (Tuple 667 345),
    (Tuple 667 47),
    (Tuple 667 630),
    (Tuple 667 729),
    (Tuple 667 730),
    (Tuple 667 731),
    (Tuple 667 682),
    (Tuple 667 775),
    (Tuple 667 776),
    (Tuple 667 732),
    (Tuple 667 562),
    (Tuple 667 503),
    (Tuple 667 673),
    (Tuple 667 830),
    (Tuple 667 733),
    (Tuple 667 674),
    (Tuple 667 832),
    (Tuple 667 734),
    (Tuple 667 295),
    (Tuple 667 698),
    (Tuple 667 735),
    (Tuple 667 529),
    (Tuple 667 385),
    (Tuple 667 363),
    (Tuple 667 424),
    (Tuple 667 631),
    (Tuple 667 779),
    (Tuple 667 834),
    (Tuple 667 736),
    (Tuple 667 780),
    (Tuple 667 781),
    (Tuple 667 837),
    (Tuple 667 782),
    (Tuple 667 737),
    (Tuple 667 238),
    (Tuple 667 117),
    (Tuple 667 908),
    (Tuple 667 738),
    (Tuple 667 839),
    (Tuple 667 632),
    (Tuple 667 699),
    (Tuple 667 56),
    (Tuple 667 429),
    (Tuple 667 57),
    (Tuple 667 841),
    (Tuple 667 783),
    (Tuple 667 784),
    (Tuple 667 353),
    (Tuple 667 785),
    (Tuple 667 739),
    (Tuple 667 923),
    (Tuple 667 786),
    (Tuple 667 126),
    (Tuple 667 787),
    (Tuple 667 788),
    (Tuple 667 701),
    (Tuple 667 514),
    (Tuple 667 532),
    (Tuple 667 633),
    (Tuple 667 634),
    (Tuple 667 677),
    (Tuple 667 789),
    (Tuple 667 533),
    (Tuple 667 683),
    (Tuple 667 480),
    (Tuple 667 790),
    (Tuple 667 393),
    (Tuple 667 615),
    (Tuple 667 515),
    (Tuple 667 842),
    (Tuple 667 843),
    (Tuple 667 910),
    (Tuple 628 504),
    (Tuple 628 782),
    (Tuple 628 57),
    (Tuple 95 95),
    (Tuple 95 587),
    (Tuple 95 804),
    (Tuple 95 98),
    (Tuple 95 100),
    (Tuple 95 590),
    (Tuple 95 416),
    (Tuple 95 103),
    (Tuple 95 305),
    (Tuple 95 745),
    (Tuple 95 347),
    (Tuple 95 419),
    (Tuple 95 420),
    (Tuple 95 105),
    (Tuple 95 746),
    (Tuple 95 348),
    (Tuple 95 49),
    (Tuple 95 592),
    (Tuple 95 112),
    (Tuple 95 693),
    (Tuple 95 530),
    (Tuple 95 52),
    (Tuple 95 349),
    (Tuple 95 426),
    (Tuple 95 120),
    (Tuple 95 124),
    (Tuple 95 707),
    (Tuple 95 126),
    (Tuple 95 430),
    (Tuple 95 432),
    (Tuple 95 433),
    (Tuple 95 903),
    (Tuple 95 132),
    (Tuple 95 308),
    (Tuple 95 309),
    (Tuple 964 964),
    (Tuple 586 586),
    (Tuple 586 587),
    (Tuple 586 588),
    (Tuple 586 98),
    (Tuple 586 312),
    (Tuple 586 342),
    (Tuple 586 590),
    (Tuple 586 102),
    (Tuple 586 305),
    (Tuple 586 745),
    (Tuple 586 105),
    (Tuple 586 49),
    (Tuple 586 531),
    (Tuple 586 120),
    (Tuple 586 123),
    (Tuple 586 352),
    (Tuple 586 124),
    (Tuple 586 676),
    (Tuple 586 433),
    (Tuple 586 435),
    (Tuple 207 207),
    (Tuple 207 800),
    (Tuple 207 804),
    (Tuple 207 868),
    (Tuple 207 409),
    (Tuple 207 97),
    (Tuple 207 265),
    (Tuple 207 769),
    (Tuple 207 935),
    (Tuple 207 410),
    (Tuple 207 100),
    (Tuple 207 697),
    (Tuple 207 772),
    (Tuple 207 413),
    (Tuple 207 345),
    (Tuple 207 630),
    (Tuple 207 775),
    (Tuple 207 801),
    (Tuple 207 776),
    (Tuple 207 102),
    (Tuple 207 305),
    (Tuple 207 503),
    (Tuple 207 420),
    (Tuple 207 105),
    (Tuple 207 673),
    (Tuple 207 108),
    (Tuple 207 422),
    (Tuple 207 236),
    (Tuple 207 110),
    (Tuple 207 674),
    (Tuple 207 111),
    (Tuple 207 49),
    (Tuple 207 907),
    (Tuple 207 112),
    (Tuple 207 237),
    (Tuple 207 529),
    (Tuple 207 363),
    (Tuple 207 424),
    (Tuple 207 531),
    (Tuple 207 52),
    (Tuple 207 780),
    (Tuple 207 425),
    (Tuple 207 349),
    (Tuple 207 238),
    (Tuple 207 118),
    (Tuple 207 549),
    (Tuple 207 266),
    (Tuple 207 699),
    (Tuple 207 428),
    (Tuple 207 429),
    (Tuple 207 267),
    (Tuple 207 123),
    (Tuple 207 353),
    (Tuple 207 785),
    (Tuple 207 125),
    (Tuple 207 126),
    (Tuple 207 787),
    (Tuple 207 430),
    (Tuple 207 514),
    (Tuple 207 532),
    (Tuple 207 634),
    (Tuple 207 789),
    (Tuple 207 533),
    (Tuple 207 595),
    (Tuple 207 356),
    (Tuple 207 393),
    (Tuple 207 615),
    (Tuple 207 60),
    (Tuple 207 435),
    (Tuple 207 357),
    (Tuple 945 53),
    (Tuple 945 370),
    (Tuple 945 54),
    (Tuple 945 55),
    (Tuple 945 391),
    (Tuple 945 58),
    (Tuple 945 59),
    (Tuple 509 509),
    (Tuple 509 587),
    (Tuple 509 98),
    (Tuple 509 312),
    (Tuple 509 100),
    (Tuple 509 557),
    (Tuple 509 412),
    (Tuple 509 342),
    (Tuple 509 416),
    (Tuple 509 305),
    (Tuple 509 347),
    (Tuple 509 419),
    (Tuple 509 106),
    (Tuple 509 109),
    (Tuple 509 746),
    (Tuple 509 348),
    (Tuple 509 120),
    (Tuple 509 124),
    (Tuple 509 633),
    (Tuple 509 703),
    (Tuple 640 478),
    (Tuple 640 422),
    (Tuple 640 236),
    (Tuple 640 306),
    (Tuple 640 369),
    (Tuple 640 641),
    (Tuple 640 53),
    (Tuple 640 121),
    (Tuple 640 267),
    (Tuple 728 728),
    (Tuple 728 264),
    (Tuple 728 826),
    (Tuple 728 827),
    (Tuple 728 768),
    (Tuple 728 770),
    (Tuple 728 772),
    (Tuple 728 669),
    (Tuple 728 345),
    (Tuple 728 729),
    (Tuple 728 730),
    (Tuple 728 731),
    (Tuple 728 775),
    (Tuple 728 776),
    (Tuple 728 673),
    (Tuple 728 733),
    (Tuple 728 674),
    (Tuple 728 832),
    (Tuple 728 734),
    (Tuple 728 295),
    (Tuple 728 698),
    (Tuple 728 363),
    (Tuple 728 631),
    (Tuple 728 779),
    (Tuple 728 736),
    (Tuple 728 780),
    (Tuple 728 781),
    (Tuple 728 837),
    (Tuple 728 782),
    (Tuple 728 839),
    (Tuple 728 632),
    (Tuple 728 699),
    (Tuple 728 841),
    (Tuple 728 783),
    (Tuple 728 784),
    (Tuple 728 353),
    (Tuple 728 785),
    (Tuple 728 786),
    (Tuple 728 787),
    (Tuple 728 788),
    (Tuple 728 701),
    (Tuple 728 514),
    (Tuple 728 532),
    (Tuple 728 533),
    (Tuple 728 683),
    (Tuple 728 393),
    (Tuple 728 615),
    (Tuple 728 842),
    (Tuple 485 9),
    (Tuple 485 471),
    (Tuple 485 15),
    (Tuple 96 99),
    (Tuple 96 100),
    (Tuple 96 557),
    (Tuple 96 417),
    (Tuple 96 102),
    (Tuple 96 103),
    (Tuple 96 104),
    (Tuple 96 591),
    (Tuple 96 106),
    (Tuple 96 107),
    (Tuple 96 110),
    (Tuple 96 306),
    (Tuple 96 49),
    (Tuple 96 113),
    (Tuple 96 52),
    (Tuple 96 115),
    (Tuple 96 116),
    (Tuple 96 117),
    (Tuple 96 118),
    (Tuple 96 121),
    (Tuple 96 267),
    (Tuple 96 707),
    (Tuple 96 126),
    (Tuple 96 128),
    (Tuple 96 129),
    (Tuple 96 132),
    (Tuple 96 308),
    (Tuple 96 133),
    (Tuple 926 926),
    (Tuple 926 804),
    (Tuple 926 97),
    (Tuple 926 668),
    (Tuple 926 98),
    (Tuple 926 412),
    (Tuple 926 772),
    (Tuple 926 345),
    (Tuple 926 47),
    (Tuple 926 630),
    (Tuple 926 776),
    (Tuple 926 305),
    (Tuple 926 421),
    (Tuple 926 486),
    (Tuple 926 49),
    (Tuple 926 698),
    (Tuple 926 592),
    (Tuple 926 112),
    (Tuple 926 530),
    (Tuple 926 531),
    (Tuple 926 52),
    (Tuple 926 425),
    (Tuple 926 349),
    (Tuple 926 863),
    (Tuple 926 350),
    (Tuple 926 699),
    (Tuple 926 267),
    (Tuple 926 353),
    (Tuple 926 124),
    (Tuple 926 125),
    (Tuple 926 676),
    (Tuple 926 126),
    (Tuple 926 430),
    (Tuple 926 703),
    (Tuple 235 235),
    (Tuple 235 961),
    (Tuple 235 42),
    (Tuple 235 340),
    (Tuple 235 587),
    (Tuple 235 668),
    (Tuple 235 767),
    (Tuple 235 312),
    (Tuple 235 861),
    (Tuple 235 708),
    (Tuple 235 560),
    (Tuple 235 362),
    (Tuple 235 342),
    (Tuple 235 46),
    (Tuple 235 546),
    (Tuple 235 672),
    (Tuple 235 49),
    (Tuple 235 120),
    (Tuple 235 350),
    (Tuple 235 941),
    (Tuple 235 676),
    (Tuple 235 430),
    (Tuple 41 41),
    (Tuple 41 42),
    (Tuple 41 97),
    (Tuple 41 98),
    (Tuple 41 99),
    (Tuple 41 312),
    (Tuple 41 100),
    (Tuple 41 557),
    (Tuple 41 417),
    (Tuple 41 102),
    (Tuple 41 103),
    (Tuple 41 104),
    (Tuple 41 420),
    (Tuple 41 106),
    (Tuple 41 107),
    (Tuple 41 108),
    (Tuple 41 109),
    (Tuple 41 49),
    (Tuple 41 528),
    (Tuple 41 112),
    (Tuple 41 113),
    (Tuple 41 116),
    (Tuple 41 117),
    (Tuple 41 120),
    (Tuple 41 121),
    (Tuple 41 427),
    (Tuple 41 122),
    (Tuple 41 267),
    (Tuple 41 123),
    (Tuple 41 124),
    (Tuple 41 125),
    (Tuple 41 707),
    (Tuple 41 126),
    (Tuple 41 127),
    (Tuple 41 128),
    (Tuple 41 534),
    (Tuple 41 130),
    (Tuple 41 131),
    (Tuple 41 132),
    (Tuple 41 308),
    (Tuple 339 961),
    (Tuple 339 97),
    (Tuple 339 542),
    (Tuple 339 265),
    (Tuple 339 98),
    (Tuple 339 410),
    (Tuple 339 411),
    (Tuple 339 100),
    (Tuple 339 478),
    (Tuple 339 345),
    (Tuple 339 417),
    (Tuple 339 102),
    (Tuple 339 103),
    (Tuple 339 305),
    (Tuple 339 421),
    (Tuple 339 107),
    (Tuple 339 422),
    (Tuple 339 109),
    (Tuple 339 528),
    (Tuple 339 592),
    (Tuple 339 112),
    (Tuple 339 237),
    (Tuple 339 693),
    (Tuple 339 369),
    (Tuple 339 114),
    (Tuple 339 425),
    (Tuple 339 117),
    (Tuple 339 120),
    (Tuple 339 428),
    (Tuple 339 429),
    (Tuple 339 267),
    (Tuple 339 123),
    (Tuple 339 124),
    (Tuple 339 126),
    (Tuple 339 430),
    (Tuple 339 532),
    (Tuple 339 789),
    (Tuple 339 432),
    (Tuple 339 129),
    (Tuple 339 433),
    (Tuple 339 597),
    (Tuple 339 132),
    (Tuple 339 133),
    (Tuple 339 309),
    (Tuple 146 9),
    (Tuple 146 10),
    (Tuple 146 11),
    (Tuple 146 608),
    (Tuple 146 148),
    (Tuple 146 13),
    (Tuple 146 456),
    (Tuple 146 14),
    (Tuple 146 15),
    (Tuple 146 150),
    (Tuple 146 457),
    (Tuple 146 612),
    (Tuple 146 153),
    (Tuple 146 154),
    (Tuple 380 815),
    (Tuple 380 212),
    (Tuple 380 646),
    (Tuple 380 506),
    (Tuple 380 383),
    (Tuple 380 647),
    (Tuple 380 67),
    (Tuple 380 217),
    (Tuple 380 648),
    (Tuple 380 390),
    (Tuple 380 68),
    (Tuple 380 290),
    (Tuple 380 394),
    (Tuple 264 668),
    (Tuple 264 767),
    (Tuple 264 768),
    (Tuple 264 934),
    (Tuple 264 769),
    (Tuple 264 935),
    (Tuple 264 829),
    (Tuple 264 742),
    (Tuple 264 774),
    (Tuple 264 731),
    (Tuple 264 671),
    (Tuple 264 672),
    (Tuple 264 675),
    (Tuple 264 734),
    (Tuple 264 907),
    (Tuple 264 735),
    (Tuple 264 834),
    (Tuple 264 736),
    (Tuple 264 835),
    (Tuple 264 836),
    (Tuple 264 737),
    (Tuple 264 908),
    (Tuple 264 738),
    (Tuple 264 838),
    (Tuple 264 859),
    (Tuple 264 840),
    (Tuple 264 923),
    (Tuple 264 633),
    (Tuple 264 740),
    (Tuple 264 842),
    (Tuple 961 265),
    (Tuple 961 417),
    (Tuple 961 102),
    (Tuple 961 103),
    (Tuple 961 106),
    (Tuple 961 111),
    (Tuple 961 49),
    (Tuple 961 369),
    (Tuple 961 52),
    (Tuple 961 425),
    (Tuple 961 428),
    (Tuple 961 122),
    (Tuple 961 123),
    (Tuple 961 430),
    (Tuple 961 239),
    (Tuple 961 131),
    (Tuple 208 284),
    (Tuple 208 209),
    (Tuple 208 210),
    (Tuple 208 288),
    (Tuple 208 212),
    (Tuple 208 213),
    (Tuple 208 645),
    (Tuple 208 289),
    (Tuple 208 382),
    (Tuple 208 646),
    (Tuple 208 506),
    (Tuple 208 383),
    (Tuple 208 216),
    (Tuple 208 217),
    (Tuple 208 218),
    (Tuple 208 648),
    (Tuple 208 390),
    (Tuple 208 649),
    (Tuple 208 68),
    (Tuple 208 222),
    (Tuple 208 392),
    (Tuple 208 290),
    (Tuple 208 225),
    (Tuple 208 394),
    (Tuple 826 730),
    (Tuple 826 731),
    (Tuple 826 670),
    (Tuple 826 675),
    (Tuple 826 734),
    (Tuple 826 907),
    (Tuple 826 834),
    (Tuple 826 835),
    (Tuple 826 737),
    (Tuple 826 593),
    (Tuple 826 908),
    (Tuple 826 738),
    (Tuple 826 859),
    (Tuple 826 739),
    (Tuple 826 676),
    (Tuple 826 740),
    (Tuple 304 65),
    (Tuple 304 417),
    (Tuple 304 103),
    (Tuple 304 107),
    (Tuple 304 109),
    (Tuple 304 52),
    (Tuple 304 116),
    (Tuple 304 124),
    (Tuple 304 126),
    (Tuple 304 594),
    (Tuple 304 595),
    (Tuple 304 132),
    (Tuple 42 865),
    (Tuple 42 409),
    (Tuple 42 97),
    (Tuple 42 668),
    (Tuple 42 265),
    (Tuple 42 543),
    (Tuple 42 312),
    (Tuple 42 43),
    (Tuple 42 560),
    (Tuple 42 45),
    (Tuple 42 341),
    (Tuple 42 557),
    (Tuple 42 544),
    (Tuple 42 362),
    (Tuple 42 545),
    (Tuple 42 170),
    (Tuple 42 771),
    (Tuple 42 65),
    (Tuple 42 343),
    (Tuple 42 46),
    (Tuple 42 773),
    (Tuple 42 414),
    (Tuple 42 345),
    (Tuple 42 415),
    (Tuple 42 630),
    (Tuple 42 731),
    (Tuple 42 418),
    (Tuple 42 561),
    (Tuple 42 546),
    (Tuple 42 801),
    (Tuple 42 776),
    (Tuple 42 745),
    (Tuple 42 562),
    (Tuple 42 503),
    (Tuple 42 547),
    (Tuple 42 106),
    (Tuple 42 422),
    (Tuple 42 236),
    (Tuple 42 306),
    (Tuple 42 872),
    (Tuple 42 674),
    (Tuple 42 423),
    (Tuple 42 548),
    (Tuple 42 112),
    (Tuple 42 237),
    (Tuple 42 113),
    (Tuple 42 50),
    (Tuple 42 529),
    (Tuple 42 385),
    (Tuple 42 363),
    (Tuple 42 424),
    (Tuple 42 369),
    (Tuple 42 114),
    (Tuple 42 51),
    (Tuple 42 52),
    (Tuple 42 115),
    (Tuple 42 349),
    (Tuple 42 117),
    (Tuple 42 118),
    (Tuple 42 119),
    (Tuple 42 426),
    (Tuple 42 120),
    (Tuple 42 550),
    (Tuple 42 266),
    (Tuple 42 389),
    (Tuple 42 55),
    (Tuple 42 56),
    (Tuple 42 427),
    (Tuple 42 429),
    (Tuple 42 267),
    (Tuple 42 123),
    (Tuple 42 513),
    (Tuple 42 57),
    (Tuple 42 391),
    (Tuple 42 551),
    (Tuple 42 125),
    (Tuple 42 126),
    (Tuple 42 127),
    (Tuple 42 552),
    (Tuple 42 239),
    (Tuple 42 431),
    (Tuple 42 532),
    (Tuple 42 634),
    (Tuple 42 534),
    (Tuple 42 553),
    (Tuple 42 432),
    (Tuple 42 554),
    (Tuple 42 563),
    (Tuple 42 364),
    (Tuple 42 16),
    (Tuple 42 129),
    (Tuple 42 307),
    (Tuple 42 433),
    (Tuple 42 355),
    (Tuple 42 480),
    (Tuple 42 911),
    (Tuple 42 564),
    (Tuple 42 434),
    (Tuple 42 240),
    (Tuple 42 505),
    (Tuple 42 308),
    (Tuple 42 60),
    (Tuple 42 515),
    (Tuple 42 241),
    (Tuple 42 133),
    (Tuple 42 357),
    (Tuple 42 173),
    (Tuple 42 309),
    (Tuple 42 866),
    (Tuple 340 340),
    (Tuple 340 804),
    (Tuple 340 588),
    (Tuple 340 409),
    (Tuple 340 97),
    (Tuple 340 542),
    (Tuple 340 98),
    (Tuple 340 312),
    (Tuple 340 861),
    (Tuple 340 410),
    (Tuple 340 411),
    (Tuple 340 100),
    (Tuple 340 342),
    (Tuple 340 590),
    (Tuple 340 101),
    (Tuple 340 345),
    (Tuple 340 862),
    (Tuple 340 630),
    (Tuple 340 416),
    (Tuple 340 346),
    (Tuple 340 102),
    (Tuple 340 103),
    (Tuple 340 305),
    (Tuple 340 104),
    (Tuple 340 347),
    (Tuple 340 420),
    (Tuple 340 421),
    (Tuple 340 105),
    (Tuple 340 106),
    (Tuple 340 109),
    (Tuple 340 110),
    (Tuple 340 49),
    (Tuple 340 528),
    (Tuple 340 112),
    (Tuple 340 237),
    (Tuple 340 693),
    (Tuple 340 530),
    (Tuple 340 369),
    (Tuple 340 114),
    (Tuple 340 531),
    (Tuple 340 52),
    (Tuple 340 349),
    (Tuple 340 238),
    (Tuple 340 118),
    (Tuple 340 549),
    (Tuple 340 120),
    (Tuple 340 699),
    (Tuple 340 427),
    (Tuple 340 428),
    (Tuple 340 122),
    (Tuple 340 429),
    (Tuple 340 267),
    (Tuple 340 123),
    (Tuple 340 124),
    (Tuple 340 125),
    (Tuple 340 126),
    (Tuple 340 430),
    (Tuple 340 239),
    (Tuple 340 128),
    (Tuple 340 432),
    (Tuple 340 594),
    (Tuple 340 595),
    (Tuple 340 131),
    (Tuple 340 433),
    (Tuple 340 703),
    (Tuple 340 356),
    (Tuple 340 393),
    (Tuple 340 308),
    (Tuple 340 435),
    (Tuple 340 357),
    (Tuple 340 309),
    (Tuple 800 804),
    (Tuple 800 409),
    (Tuple 800 629),
    (Tuple 800 97),
    (Tuple 800 668),
    (Tuple 800 827),
    (Tuple 800 861),
    (Tuple 800 697),
    (Tuple 800 949),
    (Tuple 800 772),
    (Tuple 800 413),
    (Tuple 800 345),
    (Tuple 800 630),
    (Tuple 800 731),
    (Tuple 800 305),
    (Tuple 800 672),
    (Tuple 800 347),
    (Tuple 800 420),
    (Tuple 800 733),
    (Tuple 800 236),
    (Tuple 800 110),
    (Tuple 800 698),
    (Tuple 800 112),
    (Tuple 800 693),
    (Tuple 800 530),
    (Tuple 800 631),
    (Tuple 800 779),
    (Tuple 800 736),
    (Tuple 800 531),
    (Tuple 800 52),
    (Tuple 800 425),
    (Tuple 800 782),
    (Tuple 800 349),
    (Tuple 800 238),
    (Tuple 800 350),
    (Tuple 800 632),
    (Tuple 800 699),
    (Tuple 800 427),
    (Tuple 800 428),
    (Tuple 800 429),
    (Tuple 800 267),
    (Tuple 800 123),
    (Tuple 800 57),
    (Tuple 800 353),
    (Tuple 800 786),
    (Tuple 800 430),
    (Tuple 800 239),
    (Tuple 800 701),
    (Tuple 800 514),
    (Tuple 800 634),
    (Tuple 800 789),
    (Tuple 800 533),
    (Tuple 800 432),
    (Tuple 800 740),
    (Tuple 800 595),
    (Tuple 800 131),
    (Tuple 800 393),
    (Tuple 800 842),
    (Tuple 800 843),
    (Tuple 800 357),
    (Tuple 587 409),
    (Tuple 587 97),
    (Tuple 587 542),
    (Tuple 587 265),
    (Tuple 587 98),
    (Tuple 587 99),
    (Tuple 587 411),
    (Tuple 587 100),
    (Tuple 587 697),
    (Tuple 587 101),
    (Tuple 587 344),
    (Tuple 587 413),
    (Tuple 587 416),
    (Tuple 587 417),
    (Tuple 587 346),
    (Tuple 587 801),
    (Tuple 587 102),
    (Tuple 587 103),
    (Tuple 587 104),
    (Tuple 587 745),
    (Tuple 587 419),
    (Tuple 587 420),
    (Tuple 587 421),
    (Tuple 587 105),
    (Tuple 587 106),
    (Tuple 587 107),
    (Tuple 587 108),
    (Tuple 587 109),
    (Tuple 587 236),
    (Tuple 587 110),
    (Tuple 587 49),
    (Tuple 587 528),
    (Tuple 587 112),
    (Tuple 587 237),
    (Tuple 587 113),
    (Tuple 587 529),
    (Tuple 587 363),
    (Tuple 587 424),
    (Tuple 587 530),
    (Tuple 587 369),
    (Tuple 587 114),
    (Tuple 587 531),
    (Tuple 587 52),
    (Tuple 587 425),
    (Tuple 587 117),
    (Tuple 587 118),
    (Tuple 587 549),
    (Tuple 587 120),
    (Tuple 587 121),
    (Tuple 587 427),
    (Tuple 587 428),
    (Tuple 587 122),
    (Tuple 587 267),
    (Tuple 587 123),
    (Tuple 587 124),
    (Tuple 587 125),
    (Tuple 587 126),
    (Tuple 587 127),
    (Tuple 587 430),
    (Tuple 587 634),
    (Tuple 587 432),
    (Tuple 587 131),
    (Tuple 587 433),
    (Tuple 587 356),
    (Tuple 587 308),
    (Tuple 587 435),
    (Tuple 587 357),
    (Tuple 587 309),
    (Tuple 931 409),
    (Tuple 931 211),
    (Tuple 931 697),
    (Tuple 931 65),
    (Tuple 931 345),
    (Tuple 931 381),
    (Tuple 931 49),
    (Tuple 931 112),
    (Tuple 931 529),
    (Tuple 931 14),
    (Tuple 931 699),
    (Tuple 931 125),
    (Tuple 931 152),
    (Tuple 931 239),
    (Tuple 284 209),
    (Tuple 284 211),
    (Tuple 284 170),
    (Tuple 284 288),
    (Tuple 284 382),
    (Tuple 284 214),
    (Tuple 284 66),
    (Tuple 284 216),
    (Tuple 284 387),
    (Tuple 284 220),
    (Tuple 284 222),
    (Tuple 284 223),
    (Tuple 284 224),
    (Tuple 284 394),
    (Tuple 284 797),
    (Tuple 804 668),
    (Tuple 804 312),
    (Tuple 804 342),
    (Tuple 804 862),
    (Tuple 804 690),
    (Tuple 804 305),
    (Tuple 804 672),
    (Tuple 804 347),
    (Tuple 804 736),
    (Tuple 804 52),
    (Tuple 804 859),
    (Tuple 804 352),
    (Tuple 804 923),
    (Tuple 804 676),
    (Tuple 804 532),
    (Tuple 804 633),
    (Tuple 9 11),
    (Tuple 9 147),
    (Tuple 9 12),
    (Tuple 9 918),
    (Tuple 9 608),
    (Tuple 9 932),
    (Tuple 9 646),
    (Tuple 9 506),
    (Tuple 9 652),
    (Tuple 9 660),
    (Tuple 9 386),
    (Tuple 9 653),
    (Tuple 9 14),
    (Tuple 9 959),
    (Tuple 9 661),
    (Tuple 9 149),
    (Tuple 9 648),
    (Tuple 9 151),
    (Tuple 9 457),
    (Tuple 9 859),
    (Tuple 9 458),
    (Tuple 9 290),
    (Tuple 9 612),
    (Tuple 9 153),
    (Tuple 9 655),
    (Tuple 9 853),
    (Tuple 9 937),
    (Tuple 9 920),
    (Tuple 9 938),
    (Tuple 9 155),
    (Tuple 9 948),
    (Tuple 9 613),
    (Tuple 167 167),
    (Tuple 167 260),
    (Tuple 167 288),
    (Tuple 167 25),
    (Tuple 167 289),
    (Tuple 167 793),
    (Tuple 167 658),
    (Tuple 167 223),
    (Tuple 167 794),
    (Tuple 167 795),
    (Tuple 868 772),
    (Tuple 868 669),
    (Tuple 868 632),
    (Tuple 868 699),
    (Tuple 868 353),
    (Tuple 868 700),
    (Tuple 868 633),
    (Tuple 868 515),
    (Tuple 696 696),
    (Tuple 696 629),
    (Tuple 696 97),
    (Tuple 696 772),
    (Tuple 696 345),
    (Tuple 696 731),
    (Tuple 696 672),
    (Tuple 696 698),
    (Tuple 696 736),
    (Tuple 696 782),
    (Tuple 696 632),
    (Tuple 696 699),
    (Tuple 696 353),
    (Tuple 696 701),
    (Tuple 696 789),
    (Tuple 696 393),
    (Tuple 588 97),
    (Tuple 588 98),
    (Tuple 588 411),
    (Tuple 588 100),
    (Tuple 588 590),
    (Tuple 588 413),
    (Tuple 588 345),
    (Tuple 588 630),
    (Tuple 588 346),
    (Tuple 588 102),
    (Tuple 588 103),
    (Tuple 588 305),
    (Tuple 588 104),
    (Tuple 588 347),
    (Tuple 588 420),
    (Tuple 588 105),
    (Tuple 588 106),
    (Tuple 588 109),
    (Tuple 588 110),
    (Tuple 588 49),
    (Tuple 588 528),
    (Tuple 588 112),
    (Tuple 588 530),
    (Tuple 588 369),
    (Tuple 588 114),
    (Tuple 588 531),
    (Tuple 588 52),
    (Tuple 588 425),
    (Tuple 588 349),
    (Tuple 588 238),
    (Tuple 588 549),
    (Tuple 588 120),
    (Tuple 588 427),
    (Tuple 588 429),
    (Tuple 588 267),
    (Tuple 588 123),
    (Tuple 588 353),
    (Tuple 588 124),
    (Tuple 588 126),
    (Tuple 588 128),
    (Tuple 588 594),
    (Tuple 588 595),
    (Tuple 588 131),
    (Tuple 588 435),
    (Tuple 10 11),
    (Tuple 10 12),
    (Tuple 10 918),
    (Tuple 10 608),
    (Tuple 10 148),
    (Tuple 10 456),
    (Tuple 10 150),
    (Tuple 10 151),
    (Tuple 10 457),
    (Tuple 10 458),
    (Tuple 10 459),
    (Tuple 10 612),
    (Tuple 10 153),
    (Tuple 10 920),
    (Tuple 10 154),
    (Tuple 10 155),
    (Tuple 409 668),
    (Tuple 409 767),
    (Tuple 409 98),
    (Tuple 409 312),
    (Tuple 409 100),
    (Tuple 409 342),
    (Tuple 409 773),
    (Tuple 409 346),
    (Tuple 409 801),
    (Tuple 409 672),
    (Tuple 409 347),
    (Tuple 409 419),
    (Tuple 409 503),
    (Tuple 409 106),
    (Tuple 409 426),
    (Tuple 409 350),
    (Tuple 409 354),
    (Tuple 409 532),
    (Tuple 409 633),
    (Tuple 285 219),
    (Tuple 629 668),
    (Tuple 629 47),
    (Tuple 629 731),
    (Tuple 629 670),
    (Tuple 629 671),
    (Tuple 629 732),
    (Tuple 629 832),
    (Tuple 629 779),
    (Tuple 629 834),
    (Tuple 629 736),
    (Tuple 629 859),
    (Tuple 629 353),
    (Tuple 629 700),
    (Tuple 629 923),
    (Tuple 629 702),
    (Tuple 629 740),
    (Tuple 629 683),
    (Tuple 629 842),
    (Tuple 629 843),
    (Tuple 11 12),
    (Tuple 11 918),
    (Tuple 11 260),
    (Tuple 11 608),
    (Tuple 11 148),
    (Tuple 11 13),
    (Tuple 11 653),
    (Tuple 11 14),
    (Tuple 11 661),
    (Tuple 11 149),
    (Tuple 11 150),
    (Tuple 11 151),
    (Tuple 11 457),
    (Tuple 11 458),
    (Tuple 11 612),
    (Tuple 11 153),
    (Tuple 11 655),
    (Tuple 11 853),
    (Tuple 11 613),
    (Tuple 286 965),
    (Tuple 286 23),
    (Tuple 286 289),
    (Tuple 286 215),
    (Tuple 286 262),
    (Tuple 286 507),
    (Tuple 97 668),
    (Tuple 97 98),
    (Tuple 97 312),
    (Tuple 97 861),
    (Tuple 97 411),
    (Tuple 97 100),
    (Tuple 97 341),
    (Tuple 97 557),
    (Tuple 97 362),
    (Tuple 97 342),
    (Tuple 97 590),
    (Tuple 97 949),
    (Tuple 97 344),
    (Tuple 97 345),
    (Tuple 97 862),
    (Tuple 97 416),
    (Tuple 97 346),
    (Tuple 97 690),
    (Tuple 97 103),
    (Tuple 97 305),
    (Tuple 97 745),
    (Tuple 97 591),
    (Tuple 97 347),
    (Tuple 97 419),
    (Tuple 97 503),
    (Tuple 97 106),
    (Tuple 97 109),
    (Tuple 97 348),
    (Tuple 97 528),
    (Tuple 97 116),
    (Tuple 97 863),
    (Tuple 97 120),
    (Tuple 97 350),
    (Tuple 97 352),
    (Tuple 97 676),
    (Tuple 97 354),
    (Tuple 97 703),
    (Tuple 97 596),
    (Tuple 97 132),
    (Tuple 966 966),
    (Tuple 542 98),
    (Tuple 542 312),
    (Tuple 542 100),
    (Tuple 542 557),
    (Tuple 542 342),
    (Tuple 542 590),
    (Tuple 542 344),
    (Tuple 542 416),
    (Tuple 542 305),
    (Tuple 542 745),
    (Tuple 542 347),
    (Tuple 542 106),
    (Tuple 542 109),
    (Tuple 542 348),
    (Tuple 542 116),
    (Tuple 542 120),
    (Tuple 542 352),
    (Tuple 542 124),
    (Tuple 542 703),
    (Tuple 542 597),
    (Tuple 542 132),
    (Tuple 668 668),
    (Tuple 668 827),
    (Tuple 668 43),
    (Tuple 668 769),
    (Tuple 668 410),
    (Tuple 668 45),
    (Tuple 668 770),
    (Tuple 668 697),
    (Tuple 668 772),
    (Tuple 668 669),
    (Tuple 668 345),
    (Tuple 668 862),
    (Tuple 668 415),
    (Tuple 668 47),
    (Tuple 668 630),
    (Tuple 668 731),
    (Tuple 668 418),
    (Tuple 668 682),
    (Tuple 668 775),
    (Tuple 668 801),
    (Tuple 668 776),
    (Tuple 668 102),
    (Tuple 668 305),
    (Tuple 668 562),
    (Tuple 668 420),
    (Tuple 668 105),
    (Tuple 668 673),
    (Tuple 668 547),
    (Tuple 668 486),
    (Tuple 668 733),
    (Tuple 668 107),
    (Tuple 668 422),
    (Tuple 668 236),
    (Tuple 668 674),
    (Tuple 668 832),
    (Tuple 668 49),
    (Tuple 668 295),
    (Tuple 668 698),
    (Tuple 668 112),
    (Tuple 668 529),
    (Tuple 668 385),
    (Tuple 668 424),
    (Tuple 668 530),
    (Tuple 668 631),
    (Tuple 668 779),
    (Tuple 668 531),
    (Tuple 668 52),
    (Tuple 668 780),
    (Tuple 668 425),
    (Tuple 668 781),
    (Tuple 668 349),
    (Tuple 668 238),
    (Tuple 668 118),
    (Tuple 668 839),
    (Tuple 668 351),
    (Tuple 668 632),
    (Tuple 668 699),
    (Tuple 668 428),
    (Tuple 668 429),
    (Tuple 668 267),
    (Tuple 668 123),
    (Tuple 668 57),
    (Tuple 668 784),
    (Tuple 668 353),
    (Tuple 668 785),
    (Tuple 668 551),
    (Tuple 668 125),
    (Tuple 668 786),
    (Tuple 668 126),
    (Tuple 668 787),
    (Tuple 668 430),
    (Tuple 668 788),
    (Tuple 668 701),
    (Tuple 668 514),
    (Tuple 668 634),
    (Tuple 668 789),
    (Tuple 668 533),
    (Tuple 668 534),
    (Tuple 668 554),
    (Tuple 668 307),
    (Tuple 668 683),
    (Tuple 668 131),
    (Tuple 668 703),
    (Tuple 668 355),
    (Tuple 668 480),
    (Tuple 668 790),
    (Tuple 668 393),
    (Tuple 668 615),
    (Tuple 265 312),
    (Tuple 265 362),
    (Tuple 265 305),
    (Tuple 265 347),
    (Tuple 265 419),
    (Tuple 265 350),
    (Tuple 265 676),
    (Tuple 265 354),
    (Tuple 265 866),
    (Tuple 827 770),
    (Tuple 827 47),
    (Tuple 827 775),
    (Tuple 827 776),
    (Tuple 827 672),
    (Tuple 827 733),
    (Tuple 827 734),
    (Tuple 827 698),
    (Tuple 827 735),
    (Tuple 827 833),
    (Tuple 827 779),
    (Tuple 827 834),
    (Tuple 827 736),
    (Tuple 827 737),
    (Tuple 827 738),
    (Tuple 827 632),
    (Tuple 827 699),
    (Tuple 827 429),
    (Tuple 827 923),
    (Tuple 827 701),
    (Tuple 827 633),
    (Tuple 827 740),
    (Tuple 827 393),
    (Tuple 827 615),
    (Tuple 827 515),
    (Tuple 827 842),
    (Tuple 827 843),
    (Tuple 209 210),
    (Tuple 209 211),
    (Tuple 209 168),
    (Tuple 209 212),
    (Tuple 209 645),
    (Tuple 209 382),
    (Tuple 209 383),
    (Tuple 209 216),
    (Tuple 209 217),
    (Tuple 209 387),
    (Tuple 209 648),
    (Tuple 209 390),
    (Tuple 209 649),
    (Tuple 209 68),
    (Tuple 209 221),
    (Tuple 209 222),
    (Tuple 209 290),
    (Tuple 209 394),
    (Tuple 767 767),
    (Tuple 767 312),
    (Tuple 767 771),
    (Tuple 767 65),
    (Tuple 767 772),
    (Tuple 767 773),
    (Tuple 767 415),
    (Tuple 767 630),
    (Tuple 767 848),
    (Tuple 767 776),
    (Tuple 767 305),
    (Tuple 767 503),
    (Tuple 767 849),
    (Tuple 767 850),
    (Tuple 767 777),
    (Tuple 767 108),
    (Tuple 767 778),
    (Tuple 767 236),
    (Tuple 767 674),
    (Tuple 767 111),
    (Tuple 767 832),
    (Tuple 767 113),
    (Tuple 767 385),
    (Tuple 767 363),
    (Tuple 767 424),
    (Tuple 767 52),
    (Tuple 767 115),
    (Tuple 767 782),
    (Tuple 767 593),
    (Tuple 767 699),
    (Tuple 767 56),
    (Tuple 767 428),
    (Tuple 767 429),
    (Tuple 767 57),
    (Tuple 767 936),
    (Tuple 767 353),
    (Tuple 767 787),
    (Tuple 767 239),
    (Tuple 767 701),
    (Tuple 767 532),
    (Tuple 767 634),
    (Tuple 767 789),
    (Tuple 767 534),
    (Tuple 767 791),
    (Tuple 767 515),
    (Tuple 767 173),
    (Tuple 767 309),
    (Tuple 210 211),
    (Tuple 210 168),
    (Tuple 210 213),
    (Tuple 210 381),
    (Tuple 210 383),
    (Tuple 210 217),
    (Tuple 210 218),
    (Tuple 210 387),
    (Tuple 210 390),
    (Tuple 210 649),
    (Tuple 210 221),
    (Tuple 210 222),
    (Tuple 210 290),
    (Tuple 210 797),
    (Tuple 98 312),
    (Tuple 98 861),
    (Tuple 98 411),
    (Tuple 98 100),
    (Tuple 98 557),
    (Tuple 98 342),
    (Tuple 98 101),
    (Tuple 98 413),
    (Tuple 98 346),
    (Tuple 98 102),
    (Tuple 98 103),
    (Tuple 98 305),
    (Tuple 98 104),
    (Tuple 98 591),
    (Tuple 98 347),
    (Tuple 98 420),
    (Tuple 98 105),
    (Tuple 98 106),
    (Tuple 98 109),
    (Tuple 98 110),
    (Tuple 98 111),
    (Tuple 98 49),
    (Tuple 98 528),
    (Tuple 98 592),
    (Tuple 98 112),
    (Tuple 98 237),
    (Tuple 98 529),
    (Tuple 98 693),
    (Tuple 98 114),
    (Tuple 98 531),
    (Tuple 98 52),
    (Tuple 98 425),
    (Tuple 98 349),
    (Tuple 98 238),
    (Tuple 98 549),
    (Tuple 98 120),
    (Tuple 98 427),
    (Tuple 98 428),
    (Tuple 98 123),
    (Tuple 98 124),
    (Tuple 98 126),
    (Tuple 98 430),
    (Tuple 98 354),
    (Tuple 98 128),
    (Tuple 98 432),
    (Tuple 98 594),
    (Tuple 98 595),
    (Tuple 98 131),
    (Tuple 98 433),
    (Tuple 98 703),
    (Tuple 98 356),
    (Tuple 98 132),
    (Tuple 98 308),
    (Tuple 98 435),
    (Tuple 98 357),
    (Tuple 99 557),
    (Tuple 99 342),
    (Tuple 99 103),
    (Tuple 99 104),
    (Tuple 99 591),
    (Tuple 99 420),
    (Tuple 99 107),
    (Tuple 99 109),
    (Tuple 99 113),
    (Tuple 99 52),
    (Tuple 99 115),
    (Tuple 99 116),
    (Tuple 99 119),
    (Tuple 99 121),
    (Tuple 99 267),
    (Tuple 99 124),
    (Tuple 99 126),
    (Tuple 99 128),
    (Tuple 99 130),
    (Tuple 99 594),
    (Tuple 99 596),
    (Tuple 99 597),
    (Tuple 99 132),
    (Tuple 543 43),
    (Tuple 543 45),
    (Tuple 543 544),
    (Tuple 543 46),
    (Tuple 543 418),
    (Tuple 543 546),
    (Tuple 543 547),
    (Tuple 543 422),
    (Tuple 543 236),
    (Tuple 543 51),
    (Tuple 543 550),
    (Tuple 543 389),
    (Tuple 543 552),
    (Tuple 543 239),
    (Tuple 543 534),
    (Tuple 543 553),
    (Tuple 543 554),
    (Tuple 543 364),
    (Tuple 543 307),
    (Tuple 543 355),
    (Tuple 543 480),
    (Tuple 543 434),
    (Tuple 543 240),
    (Tuple 543 505),
    (Tuple 543 60),
    (Tuple 543 133),
    (Tuple 312 312),
    (Tuple 312 410),
    (Tuple 312 411),
    (Tuple 312 100),
    (Tuple 312 557),
    (Tuple 312 697),
    (Tuple 312 342),
    (Tuple 312 590),
    (Tuple 312 478),
    (Tuple 312 101),
    (Tuple 312 413),
    (Tuple 312 102),
    (Tuple 312 103),
    (Tuple 312 305),
    (Tuple 312 104),
    (Tuple 312 562),
    (Tuple 312 347),
    (Tuple 312 503),
    (Tuple 312 420),
    (Tuple 312 421),
    (Tuple 312 105),
    (Tuple 312 106),
    (Tuple 312 107),
    (Tuple 312 108),
    (Tuple 312 109),
    (Tuple 312 236),
    (Tuple 312 110),
    (Tuple 312 49),
    (Tuple 312 528),
    (Tuple 312 592),
    (Tuple 312 112),
    (Tuple 312 237),
    (Tuple 312 529),
    (Tuple 312 693),
    (Tuple 312 530),
    (Tuple 312 369),
    (Tuple 312 114),
    (Tuple 312 531),
    (Tuple 312 52),
    (Tuple 312 425),
    (Tuple 312 349),
    (Tuple 312 549),
    (Tuple 312 426),
    (Tuple 312 120),
    (Tuple 312 266),
    (Tuple 312 427),
    (Tuple 312 428),
    (Tuple 312 429),
    (Tuple 312 267),
    (Tuple 312 123),
    (Tuple 312 124),
    (Tuple 312 125),
    (Tuple 312 676),
    (Tuple 312 126),
    (Tuple 312 430),
    (Tuple 312 239),
    (Tuple 312 128),
    (Tuple 312 634),
    (Tuple 312 432),
    (Tuple 312 595),
    (Tuple 312 131),
    (Tuple 312 433),
    (Tuple 312 703),
    (Tuple 312 132),
    (Tuple 312 435),
    (Tuple 312 357),
    (Tuple 294 955),
    (Tuple 294 672),
    (Tuple 294 295),
    (Tuple 294 296),
    (Tuple 294 297),
    (Tuple 294 859),
    (Tuple 294 633),
    (Tuple 287 593),
    (Tuple 287 224),
    (Tuple 768 772),
    (Tuple 768 731),
    (Tuple 768 673),
    (Tuple 768 733),
    (Tuple 768 832),
    (Tuple 768 631),
    (Tuple 768 780),
    (Tuple 768 837),
    (Tuple 768 783),
    (Tuple 768 784),
    (Tuple 768 785),
    (Tuple 768 786),
    (Tuple 768 787),
    (Tuple 768 683),
    (Tuple 43 560),
    (Tuple 43 45),
    (Tuple 43 544),
    (Tuple 43 545),
    (Tuple 43 46),
    (Tuple 43 418),
    (Tuple 43 561),
    (Tuple 43 546),
    (Tuple 43 562),
    (Tuple 43 547),
    (Tuple 43 422),
    (Tuple 43 236),
    (Tuple 43 872),
    (Tuple 43 423),
    (Tuple 43 548),
    (Tuple 43 51),
    (Tuple 43 52),
    (Tuple 43 550),
    (Tuple 43 389),
    (Tuple 43 941),
    (Tuple 43 551),
    (Tuple 43 552),
    (Tuple 43 658),
    (Tuple 43 239),
    (Tuple 43 534),
    (Tuple 43 553),
    (Tuple 43 554),
    (Tuple 43 563),
    (Tuple 43 364),
    (Tuple 43 307),
    (Tuple 43 355),
    (Tuple 43 480),
    (Tuple 43 911),
    (Tuple 43 564),
    (Tuple 43 434),
    (Tuple 43 240),
    (Tuple 43 60),
    (Tuple 43 133),
    (Tuple 43 866),
    (Tuple 810 755),
    (Tuple 934 669),
    (Tuple 934 731),
    (Tuple 934 673),
    (Tuple 934 632),
    (Tuple 934 783),
    (Tuple 934 787),
    (Tuple 934 788),
    (Tuple 934 683),
    (Tuple 934 615),
    (Tuple 769 772),
    (Tuple 769 47),
    (Tuple 769 731),
    (Tuple 769 733),
    (Tuple 769 833),
    (Tuple 769 631),
    (Tuple 769 780),
    (Tuple 769 837),
    (Tuple 769 782),
    (Tuple 769 783),
    (Tuple 769 784),
    (Tuple 769 786),
    (Tuple 769 787),
    (Tuple 769 740),
    (Tuple 935 935),
    (Tuple 935 828),
    (Tuple 935 770),
    (Tuple 935 47),
    (Tuple 935 731),
    (Tuple 935 672),
    (Tuple 935 733),
    (Tuple 935 832),
    (Tuple 935 833),
    (Tuple 935 353),
    (Tuple 935 785),
    (Tuple 935 786),
    (Tuple 935 787),
    (Tuple 935 514),
    (Tuple 935 683),
    (Tuple 935 790),
    (Tuple 935 615),
    (Tuple 861 342),
    (Tuple 861 418),
    (Tuple 861 305),
    (Tuple 861 420),
    (Tuple 861 422),
    (Tuple 861 236),
    (Tuple 861 49),
    (Tuple 861 528),
    (Tuple 861 112),
    (Tuple 861 369),
    (Tuple 861 52),
    (Tuple 861 549),
    (Tuple 861 266),
    (Tuple 861 267),
    (Tuple 861 126),
    (Tuple 861 239),
    (Tuple 861 594),
    (Tuple 861 595),
    (Tuple 861 132),
    (Tuple 861 357),
    (Tuple 708 351),
    (Tuple 211 288),
    (Tuple 211 212),
    (Tuple 211 213),
    (Tuple 211 645),
    (Tuple 211 289),
    (Tuple 211 382),
    (Tuple 211 646),
    (Tuple 211 383),
    (Tuple 211 216),
    (Tuple 211 384),
    (Tuple 211 217),
    (Tuple 211 218),
    (Tuple 211 219),
    (Tuple 211 648),
    (Tuple 211 390),
    (Tuple 211 649),
    (Tuple 211 68),
    (Tuple 211 392),
    (Tuple 211 290),
    (Tuple 211 225),
    (Tuple 211 394),
    (Tuple 211 507),
    (Tuple 828 47),
    (Tuple 828 729),
    (Tuple 828 731),
    (Tuple 828 775),
    (Tuple 828 673),
    (Tuple 828 830),
    (Tuple 828 733),
    (Tuple 828 833),
    (Tuple 828 631),
    (Tuple 828 780),
    (Tuple 828 781),
    (Tuple 828 839),
    (Tuple 828 632),
    (Tuple 828 840),
    (Tuple 828 783),
    (Tuple 828 784),
    (Tuple 828 785),
    (Tuple 828 786),
    (Tuple 828 787),
    (Tuple 828 788),
    (Tuple 828 514),
    (Tuple 828 683),
    (Tuple 828 393),
    (Tuple 410 100),
    (Tuple 410 342),
    (Tuple 410 875),
    (Tuple 410 305),
    (Tuple 410 745),
    (Tuple 410 347),
    (Tuple 410 419),
    (Tuple 410 106),
    (Tuple 410 348),
    (Tuple 410 352),
    (Tuple 410 676),
    (Tuple 410 354),
    (Tuple 147 12),
    (Tuple 147 13),
    (Tuple 147 456),
    (Tuple 147 150),
    (Tuple 147 151),
    (Tuple 147 16),
    (Tuple 147 459),
    (Tuple 147 153),
    (Tuple 147 155),
    (Tuple 411 100),
    (Tuple 411 342),
    (Tuple 411 346),
    (Tuple 411 102),
    (Tuple 411 103),
    (Tuple 411 591),
    (Tuple 411 105),
    (Tuple 411 106),
    (Tuple 411 49),
    (Tuple 411 528),
    (Tuple 411 112),
    (Tuple 411 114),
    (Tuple 411 531),
    (Tuple 411 124),
    (Tuple 411 676),
    (Tuple 411 126),
    (Tuple 411 128),
    (Tuple 411 356),
    (Tuple 589 306),
    (Tuple 589 52),
    (Tuple 589 56),
    (Tuple 589 126),
    (Tuple 589 533),
    (Tuple 12 918),
    (Tuple 12 919),
    (Tuple 12 608),
    (Tuple 12 932),
    (Tuple 12 148),
    (Tuple 12 13),
    (Tuple 12 959),
    (Tuple 12 661),
    (Tuple 12 149),
    (Tuple 12 15),
    (Tuple 12 150),
    (Tuple 12 458),
    (Tuple 12 153),
    (Tuple 12 920),
    (Tuple 12 613),
    (Tuple 44 288),
    (Tuple 100 557),
    (Tuple 100 342),
    (Tuple 100 590),
    (Tuple 100 413),
    (Tuple 100 345),
    (Tuple 100 346),
    (Tuple 100 102),
    (Tuple 100 103),
    (Tuple 100 305),
    (Tuple 100 591),
    (Tuple 100 347),
    (Tuple 100 420),
    (Tuple 100 421),
    (Tuple 100 105),
    (Tuple 100 106),
    (Tuple 100 109),
    (Tuple 100 110),
    (Tuple 100 348),
    (Tuple 100 49),
    (Tuple 100 528),
    (Tuple 100 592),
    (Tuple 100 112),
    (Tuple 100 237),
    (Tuple 100 693),
    (Tuple 100 424),
    (Tuple 100 530),
    (Tuple 100 114),
    (Tuple 100 531),
    (Tuple 100 52),
    (Tuple 100 425),
    (Tuple 100 349),
    (Tuple 100 863),
    (Tuple 100 120),
    (Tuple 100 427),
    (Tuple 100 428),
    (Tuple 100 124),
    (Tuple 100 125),
    (Tuple 100 707),
    (Tuple 100 126),
    (Tuple 100 430),
    (Tuple 100 532),
    (Tuple 100 128),
    (Tuple 100 594),
    (Tuple 100 595),
    (Tuple 100 131),
    (Tuple 100 433),
    (Tuple 100 703),
    (Tuple 100 596),
    (Tuple 100 356),
    (Tuple 100 132),
    (Tuple 100 308),
    (Tuple 100 435),
    (Tuple 100 357),
    (Tuple 906 841),
    (Tuple 906 701),
    (Tuple 560 45),
    (Tuple 560 544),
    (Tuple 560 46),
    (Tuple 560 418),
    (Tuple 560 546),
    (Tuple 560 547),
    (Tuple 560 51),
    (Tuple 560 551),
    (Tuple 560 552),
    (Tuple 560 239),
    (Tuple 560 553),
    (Tuple 560 554),
    (Tuple 560 307),
    (Tuple 560 355),
    (Tuple 560 480),
    (Tuple 560 434),
    (Tuple 560 240),
    (Tuple 560 133),
    (Tuple 829 731),
    (Tuple 829 682),
    (Tuple 829 837),
    (Tuple 829 782),
    (Tuple 829 699),
    (Tuple 829 841),
    (Tuple 829 783),
    (Tuple 829 784),
    (Tuple 45 45),
    (Tuple 45 544),
    (Tuple 45 545),
    (Tuple 45 46),
    (Tuple 45 418),
    (Tuple 45 561),
    (Tuple 45 546),
    (Tuple 45 547),
    (Tuple 45 422),
    (Tuple 45 872),
    (Tuple 45 548),
    (Tuple 45 550),
    (Tuple 45 534),
    (Tuple 45 553),
    (Tuple 45 554),
    (Tuple 45 307),
    (Tuple 45 355),
    (Tuple 45 480),
    (Tuple 45 564),
    (Tuple 45 434),
    (Tuple 45 505),
    (Tuple 45 60),
    (Tuple 45 866),
    (Tuple 621 712),
    (Tuple 621 369),
    (Tuple 621 641),
    (Tuple 621 117),
    (Tuple 770 813),
    (Tuple 770 47),
    (Tuple 770 729),
    (Tuple 770 731),
    (Tuple 770 671),
    (Tuple 770 732),
    (Tuple 770 672),
    (Tuple 770 734),
    (Tuple 770 833),
    (Tuple 770 779),
    (Tuple 770 834),
    (Tuple 770 736),
    (Tuple 770 835),
    (Tuple 770 737),
    (Tuple 770 738),
    (Tuple 770 838),
    (Tuple 770 859),
    (Tuple 770 700),
    (Tuple 770 739),
    (Tuple 770 923),
    (Tuple 770 633),
    (Tuple 770 740),
    (Tuple 770 842),
    (Tuple 341 341),
    (Tuple 341 362),
    (Tuple 341 342),
    (Tuple 341 101),
    (Tuple 341 343),
    (Tuple 341 690),
    (Tuple 341 236),
    (Tuple 341 49),
    (Tuple 341 112),
    (Tuple 341 369),
    (Tuple 341 531),
    (Tuple 341 349),
    (Tuple 341 266),
    (Tuple 341 699),
    (Tuple 341 428),
    (Tuple 341 123),
    (Tuple 341 357),
    (Tuple 477 478),
    (Tuple 477 50),
    (Tuple 477 51),
    (Tuple 477 53),
    (Tuple 477 115),
    (Tuple 477 55),
    (Tuple 477 58),
    (Tuple 477 479),
    (Tuple 477 60),
    (Tuple 477 173),
    (Tuple 557 412),
    (Tuple 557 416),
    (Tuple 557 417),
    (Tuple 557 102),
    (Tuple 557 103),
    (Tuple 557 305),
    (Tuple 557 104),
    (Tuple 557 420),
    (Tuple 557 105),
    (Tuple 557 106),
    (Tuple 557 107),
    (Tuple 557 109),
    (Tuple 557 110),
    (Tuple 557 306),
    (Tuple 557 111),
    (Tuple 557 49),
    (Tuple 557 112),
    (Tuple 557 113),
    (Tuple 557 529),
    (Tuple 557 693),
    (Tuple 557 530),
    (Tuple 557 369),
    (Tuple 557 114),
    (Tuple 557 52),
    (Tuple 557 425),
    (Tuple 557 115),
    (Tuple 557 116),
    (Tuple 557 349),
    (Tuple 557 118),
    (Tuple 557 119),
    (Tuple 557 120),
    (Tuple 557 121),
    (Tuple 557 427),
    (Tuple 557 267),
    (Tuple 557 123),
    (Tuple 557 57),
    (Tuple 557 124),
    (Tuple 557 125),
    (Tuple 557 126),
    (Tuple 557 127),
    (Tuple 557 128),
    (Tuple 557 129),
    (Tuple 557 130),
    (Tuple 557 594),
    (Tuple 557 131),
    (Tuple 557 132),
    (Tuple 557 308),
    (Tuple 557 357),
    (Tuple 557 309),
    (Tuple 544 545),
    (Tuple 544 46),
    (Tuple 544 561),
    (Tuple 544 546),
    (Tuple 544 547),
    (Tuple 544 422),
    (Tuple 544 236),
    (Tuple 544 548),
    (Tuple 544 51),
    (Tuple 544 389),
    (Tuple 544 941),
    (Tuple 544 552),
    (Tuple 544 239),
    (Tuple 544 534),
    (Tuple 544 553),
    (Tuple 544 364),
    (Tuple 544 307),
    (Tuple 544 355),
    (Tuple 544 434),
    (Tuple 544 240),
    (Tuple 544 505),
    (Tuple 544 60),
    (Tuple 412 773),
    (Tuple 412 102),
    (Tuple 412 103),
    (Tuple 412 104),
    (Tuple 412 107),
    (Tuple 412 109),
    (Tuple 412 306),
    (Tuple 412 111),
    (Tuple 412 112),
    (Tuple 412 113),
    (Tuple 412 424),
    (Tuple 412 114),
    (Tuple 412 52),
    (Tuple 412 116),
    (Tuple 412 238),
    (Tuple 412 118),
    (Tuple 412 119),
    (Tuple 412 121),
    (Tuple 412 427),
    (Tuple 412 267),
    (Tuple 412 126),
    (Tuple 412 127),
    (Tuple 412 430),
    (Tuple 412 128),
    (Tuple 412 130),
    (Tuple 412 594),
    (Tuple 412 131),
    (Tuple 412 132),
    (Tuple 697 342),
    (Tuple 697 949),
    (Tuple 697 344),
    (Tuple 697 801),
    (Tuple 697 732),
    (Tuple 697 672),
    (Tuple 697 503),
    (Tuple 697 348),
    (Tuple 697 734),
    (Tuple 697 907),
    (Tuple 697 693),
    (Tuple 697 736),
    (Tuple 697 52),
    (Tuple 697 700),
    (Tuple 697 923),
    (Tuple 697 676),
    (Tuple 697 702),
    (Tuple 697 876),
    (Tuple 697 842),
    (Tuple 813 892),
    (Tuple 813 486),
    (Tuple 813 698),
    (Tuple 813 894),
    (Tuple 813 895),
    (Tuple 813 896),
    (Tuple 813 898),
    (Tuple 813 782),
    (Tuple 813 899),
    (Tuple 813 533),
    (Tuple 813 900),
    (Tuple 918 381),
    (Tuple 918 608),
    (Tuple 918 148),
    (Tuple 918 13),
    (Tuple 918 456),
    (Tuple 918 14),
    (Tuple 918 959),
    (Tuple 918 15),
    (Tuple 918 150),
    (Tuple 918 151),
    (Tuple 918 353),
    (Tuple 918 152),
    (Tuple 918 16),
    (Tuple 918 459),
    (Tuple 918 153),
    (Tuple 918 920),
    (Tuple 918 942),
    (Tuple 918 154),
    (Tuple 918 155),
    (Tuple 918 460),
    (Tuple 168 213),
    (Tuple 168 796),
    (Tuple 168 511),
    (Tuple 168 645),
    (Tuple 168 382),
    (Tuple 168 646),
    (Tuple 168 383),
    (Tuple 168 647),
    (Tuple 168 216),
    (Tuple 168 217),
    (Tuple 168 219),
    (Tuple 168 648),
    (Tuple 168 390),
    (Tuple 168 68),
    (Tuple 168 290),
    (Tuple 168 225),
    (Tuple 362 362),
    (Tuple 362 343),
    (Tuple 362 49),
    (Tuple 362 125),
    (Tuple 362 357),
    (Tuple 342 590),
    (Tuple 342 101),
    (Tuple 342 949),
    (Tuple 342 344),
    (Tuple 342 413),
    (Tuple 342 416),
    (Tuple 342 346),
    (Tuple 342 102),
    (Tuple 342 103),
    (Tuple 342 305),
    (Tuple 342 104),
    (Tuple 342 745),
    (Tuple 342 562),
    (Tuple 342 420),
    (Tuple 342 421),
    (Tuple 342 105),
    (Tuple 342 106),
    (Tuple 342 107),
    (Tuple 342 108),
    (Tuple 342 109),
    (Tuple 342 110),
    (Tuple 342 306),
    (Tuple 342 111),
    (Tuple 342 49),
    (Tuple 342 528),
    (Tuple 342 592),
    (Tuple 342 112),
    (Tuple 342 113),
    (Tuple 342 693),
    (Tuple 342 385),
    (Tuple 342 530),
    (Tuple 342 369),
    (Tuple 342 114),
    (Tuple 342 531),
    (Tuple 342 52),
    (Tuple 342 349),
    (Tuple 342 863),
    (Tuple 342 118),
    (Tuple 342 549),
    (Tuple 342 426),
    (Tuple 342 120),
    (Tuple 342 427),
    (Tuple 342 428),
    (Tuple 342 122),
    (Tuple 342 123),
    (Tuple 342 124),
    (Tuple 342 125),
    (Tuple 342 707),
    (Tuple 342 126),
    (Tuple 342 430),
    (Tuple 342 532),
    (Tuple 342 594),
    (Tuple 342 595),
    (Tuple 342 703),
    (Tuple 342 356),
    (Tuple 342 132),
    (Tuple 342 308),
    (Tuple 342 357),
    (Tuple 342 309),
    (Tuple 815 110),
    (Tuple 260 169),
    (Tuple 260 65),
    (Tuple 260 520),
    (Tuple 260 104),
    (Tuple 260 456),
    (Tuple 260 736),
    (Tuple 260 783),
    (Tuple 260 126),
    (Tuple 260 16),
    (Tuple 545 46),
    (Tuple 545 546),
    (Tuple 545 547),
    (Tuple 545 422),
    (Tuple 545 236),
    (Tuple 545 424),
    (Tuple 545 51),
    (Tuple 545 389),
    (Tuple 545 552),
    (Tuple 545 239),
    (Tuple 545 534),
    (Tuple 545 553),
    (Tuple 545 434),
    (Tuple 545 240),
    (Tuple 545 505),
    (Tuple 545 60),
    (Tuple 742 65),
    (Tuple 742 420),
    (Tuple 742 782),
    (Tuple 742 120),
    (Tuple 742 221),
    (Tuple 742 125),
    (Tuple 742 126),
    (Tuple 742 430),
    (Tuple 742 173),
    (Tuple 169 169),
    (Tuple 169 593),
    (Tuple 169 172),
    (Tuple 928 928),
    (Tuple 928 952),
    (Tuple 928 370),
    (Tuple 928 55),
    (Tuple 928 391),
    (Tuple 928 431),
    (Tuple 928 173),
    (Tuple 590 590),
    (Tuple 590 346),
    (Tuple 590 102),
    (Tuple 590 103),
    (Tuple 590 305),
    (Tuple 590 104),
    (Tuple 590 347),
    (Tuple 590 420),
    (Tuple 590 421),
    (Tuple 590 105),
    (Tuple 590 106),
    (Tuple 590 49),
    (Tuple 590 112),
    (Tuple 590 52),
    (Tuple 590 863),
    (Tuple 590 120),
    (Tuple 590 122),
    (Tuple 590 124),
    (Tuple 590 126),
    (Tuple 590 430),
    (Tuple 590 132),
    (Tuple 478 305),
    (Tuple 478 422),
    (Tuple 478 236),
    (Tuple 478 528),
    (Tuple 478 112),
    (Tuple 478 50),
    (Tuple 478 693),
    (Tuple 478 369),
    (Tuple 478 641),
    (Tuple 478 53),
    (Tuple 478 115),
    (Tuple 478 119),
    (Tuple 478 126),
    (Tuple 478 479),
    (Tuple 478 364),
    (Tuple 478 308),
    (Tuple 478 60),
    (Tuple 478 309),
    (Tuple 101 690),
    (Tuple 101 305),
    (Tuple 101 745),
    (Tuple 101 347),
    (Tuple 101 419),
    (Tuple 101 348),
    (Tuple 101 120),
    (Tuple 170 288),
    (Tuple 170 25),
    (Tuple 170 212),
    (Tuple 170 316),
    (Tuple 170 289),
    (Tuple 170 646),
    (Tuple 170 506),
    (Tuple 170 383),
    (Tuple 170 216),
    (Tuple 170 67),
    (Tuple 170 497),
    (Tuple 170 370),
    (Tuple 170 390),
    (Tuple 170 68),
    (Tuple 170 223),
    (Tuple 170 905),
    (Tuple 170 394),
    (Tuple 170 797),
    (Tuple 170 507),
    (Tuple 949 949),
    (Tuple 949 772),
    (Tuple 949 102),
    (Tuple 949 420),
    (Tuple 949 49),
    (Tuple 949 425),
    (Tuple 949 699),
    (Tuple 949 123),
    (Tuple 771 773),
    (Tuple 771 774),
    (Tuple 771 415),
    (Tuple 771 731),
    (Tuple 771 848),
    (Tuple 771 503),
    (Tuple 771 849),
    (Tuple 771 850),
    (Tuple 771 777),
    (Tuple 771 734),
    (Tuple 771 423),
    (Tuple 771 736),
    (Tuple 771 532),
    (Tuple 65 940),
    (Tuple 65 672),
    (Tuple 65 67),
    (Tuple 65 736),
    (Tuple 65 941),
    (Tuple 65 658),
    (Tuple 65 740),
    (Tuple 65 905),
    (Tuple 772 773),
    (Tuple 772 669),
    (Tuple 772 345),
    (Tuple 772 731),
    (Tuple 772 670),
    (Tuple 772 776),
    (Tuple 772 732),
    (Tuple 772 672),
    (Tuple 772 562),
    (Tuple 772 503),
    (Tuple 772 674),
    (Tuple 772 675),
    (Tuple 772 907),
    (Tuple 772 735),
    (Tuple 772 779),
    (Tuple 772 834),
    (Tuple 772 736),
    (Tuple 772 835),
    (Tuple 772 52),
    (Tuple 772 738),
    (Tuple 772 839),
    (Tuple 772 859),
    (Tuple 772 936),
    (Tuple 772 783),
    (Tuple 772 784),
    (Tuple 772 700),
    (Tuple 772 923),
    (Tuple 772 676),
    (Tuple 772 786),
    (Tuple 772 701),
    (Tuple 772 514),
    (Tuple 772 677),
    (Tuple 772 789),
    (Tuple 772 702),
    (Tuple 772 740),
    (Tuple 772 842),
    (Tuple 772 910),
    (Tuple 343 690),
    (Tuple 46 414),
    (Tuple 46 418),
    (Tuple 46 561),
    (Tuple 46 546),
    (Tuple 46 547),
    (Tuple 46 422),
    (Tuple 46 236),
    (Tuple 46 872),
    (Tuple 46 423),
    (Tuple 46 548),
    (Tuple 46 424),
    (Tuple 46 51),
    (Tuple 46 550),
    (Tuple 46 389),
    (Tuple 46 941),
    (Tuple 46 57),
    (Tuple 46 551),
    (Tuple 46 125),
    (Tuple 46 552),
    (Tuple 46 658),
    (Tuple 46 239),
    (Tuple 46 431),
    (Tuple 46 532),
    (Tuple 46 534),
    (Tuple 46 553),
    (Tuple 46 554),
    (Tuple 46 563),
    (Tuple 46 364),
    (Tuple 46 307),
    (Tuple 46 355),
    (Tuple 46 480),
    (Tuple 46 564),
    (Tuple 46 434),
    (Tuple 46 240),
    (Tuple 46 505),
    (Tuple 46 60),
    (Tuple 46 133),
    (Tuple 773 774),
    (Tuple 773 415),
    (Tuple 773 731),
    (Tuple 773 776),
    (Tuple 773 305),
    (Tuple 773 672),
    (Tuple 773 562),
    (Tuple 773 503),
    (Tuple 773 673),
    (Tuple 773 363),
    (Tuple 773 631),
    (Tuple 773 736),
    (Tuple 773 780),
    (Tuple 773 837),
    (Tuple 773 699),
    (Tuple 773 841),
    (Tuple 773 783),
    (Tuple 773 784),
    (Tuple 773 532),
    (Tuple 773 789),
    (Tuple 773 790),
    (Tuple 773 791),
    (Tuple 892 892),
    (Tuple 892 893),
    (Tuple 892 438),
    (Tuple 892 486),
    (Tuple 892 894),
    (Tuple 892 895),
    (Tuple 892 896),
    (Tuple 892 897),
    (Tuple 892 898),
    (Tuple 892 899),
    (Tuple 892 900),
    (Tuple 952 431),
    (Tuple 952 173),
    (Tuple 967 967),
    (Tuple 344 413),
    (Tuple 344 345),
    (Tuple 344 102),
    (Tuple 344 420),
    (Tuple 344 421),
    (Tuple 344 105),
    (Tuple 344 49),
    (Tuple 344 112),
    (Tuple 344 530),
    (Tuple 344 369),
    (Tuple 344 114),
    (Tuple 344 52),
    (Tuple 344 116),
    (Tuple 344 349),
    (Tuple 344 120),
    (Tuple 344 124),
    (Tuple 344 430),
    (Tuple 344 131),
    (Tuple 344 433),
    (Tuple 344 132),
    (Tuple 344 357),
    (Tuple 344 309),
    (Tuple 669 731),
    (Tuple 669 732),
    (Tuple 669 672),
    (Tuple 669 733),
    (Tuple 669 734),
    (Tuple 669 735),
    (Tuple 669 834),
    (Tuple 669 736),
    (Tuple 669 835),
    (Tuple 669 859),
    (Tuple 669 909),
    (Tuple 669 936),
    (Tuple 669 923),
    (Tuple 669 633),
    (Tuple 669 677),
    (Tuple 669 740),
    (Tuple 669 842),
    (Tuple 669 910),
    (Tuple 413 414),
    (Tuple 413 416),
    (Tuple 413 346),
    (Tuple 413 103),
    (Tuple 413 305),
    (Tuple 413 745),
    (Tuple 413 347),
    (Tuple 413 106),
    (Tuple 413 109),
    (Tuple 413 348),
    (Tuple 413 693),
    (Tuple 413 116),
    (Tuple 413 120),
    (Tuple 413 124),
    (Tuple 413 432),
    (Tuple 413 703),
    (Tuple 413 132),
    (Tuple 414 414),
    (Tuple 414 561),
    (Tuple 414 546),
    (Tuple 414 486),
    (Tuple 414 49),
    (Tuple 414 593),
    (Tuple 414 859),
    (Tuple 414 125),
    (Tuple 414 132),
    (Tuple 939 47),
    (Tuple 939 731),
    (Tuple 939 690),
    (Tuple 939 673),
    (Tuple 939 733),
    (Tuple 939 631),
    (Tuple 939 779),
    (Tuple 939 51),
    (Tuple 939 150),
    (Tuple 939 841),
    (Tuple 939 353),
    (Tuple 939 785),
    (Tuple 939 787),
    (Tuple 939 634),
    (Tuple 939 60),
    (Tuple 939 241),
    (Tuple 716 716),
    (Tuple 716 717),
    (Tuple 716 653),
    (Tuple 716 151),
    (Tuple 716 152),
    (Tuple 716 172),
    (Tuple 919 14),
    (Tuple 919 15),
    (Tuple 919 459),
    (Tuple 919 172),
    (Tuple 288 940),
    (Tuple 288 289),
    (Tuple 288 214),
    (Tuple 288 215),
    (Tuple 288 66),
    (Tuple 288 171),
    (Tuple 288 219),
    (Tuple 288 220),
    (Tuple 288 221),
    (Tuple 288 224),
    (Tuple 25 289),
    (Tuple 25 369),
    (Tuple 25 262),
    (Tuple 25 126),
    (Tuple 345 345),
    (Tuple 345 862),
    (Tuple 345 47),
    (Tuple 345 731),
    (Tuple 345 801),
    (Tuple 345 690),
    (Tuple 345 671),
    (Tuple 345 672),
    (Tuple 345 419),
    (Tuple 345 503),
    (Tuple 345 106),
    (Tuple 345 348),
    (Tuple 345 734),
    (Tuple 345 112),
    (Tuple 345 693),
    (Tuple 345 779),
    (Tuple 345 834),
    (Tuple 345 661),
    (Tuple 345 120),
    (Tuple 345 350),
    (Tuple 345 351),
    (Tuple 345 859),
    (Tuple 345 352),
    (Tuple 345 700),
    (Tuple 345 923),
    (Tuple 345 532),
    (Tuple 345 702),
    (Tuple 345 432),
    (Tuple 345 876),
    (Tuple 345 842),
    (Tuple 345 866),
    (Tuple 212 212),
    (Tuple 212 645),
    (Tuple 212 381),
    (Tuple 212 382),
    (Tuple 212 383),
    (Tuple 212 66),
    (Tuple 212 216),
    (Tuple 212 384),
    (Tuple 212 67),
    (Tuple 212 217),
    (Tuple 212 387),
    (Tuple 212 648),
    (Tuple 212 390),
    (Tuple 212 649),
    (Tuple 212 68),
    (Tuple 212 221),
    (Tuple 212 69),
    (Tuple 212 222),
    (Tuple 212 392),
    (Tuple 212 290),
    (Tuple 212 225),
    (Tuple 212 394),
    (Tuple 862 801),
    (Tuple 862 776),
    (Tuple 862 305),
    (Tuple 862 105),
    (Tuple 862 111),
    (Tuple 862 49),
    (Tuple 862 112),
    (Tuple 862 237),
    (Tuple 862 530),
    (Tuple 862 531),
    (Tuple 862 52),
    (Tuple 862 425),
    (Tuple 862 349),
    (Tuple 862 549),
    (Tuple 862 120),
    (Tuple 862 428),
    (Tuple 862 124),
    (Tuple 862 125),
    (Tuple 862 676),
    (Tuple 862 430),
    (Tuple 862 514),
    (Tuple 862 131),
    (Tuple 862 433),
    (Tuple 862 703),
    (Tuple 862 357),
    (Tuple 965 965),
    (Tuple 965 51),
    (Tuple 965 60),
    (Tuple 213 213),
    (Tuple 213 381),
    (Tuple 213 647),
    (Tuple 213 387),
    (Tuple 213 390),
    (Tuple 213 68),
    (Tuple 213 221),
    (Tuple 213 222),
    (Tuple 213 392),
    (Tuple 774 415),
    (Tuple 774 776),
    (Tuple 774 674),
    (Tuple 774 363),
    (Tuple 774 936),
    (Tuple 774 786),
    (Tuple 774 532),
    (Tuple 774 789),
    (Tuple 712 381),
    (Tuple 712 236),
    (Tuple 712 872),
    (Tuple 712 369),
    (Tuple 712 57),
    (Tuple 712 60),
    (Tuple 712 173),
    (Tuple 796 796),
    (Tuple 796 66),
    (Tuple 511 520),
    (Tuple 511 215),
    (Tuple 415 415),
    (Tuple 415 848),
    (Tuple 415 801),
    (Tuple 415 672),
    (Tuple 415 849),
    (Tuple 415 850),
    (Tuple 415 777),
    (Tuple 415 778),
    (Tuple 415 734),
    (Tuple 415 423),
    (Tuple 415 736),
    (Tuple 415 941),
    (Tuple 415 909),
    (Tuple 415 532),
    (Tuple 415 633),
    (Tuple 415 791),
    (Tuple 47 731),
    (Tuple 47 682),
    (Tuple 47 672),
    (Tuple 47 562),
    (Tuple 47 831),
    (Tuple 47 733),
    (Tuple 47 832),
    (Tuple 47 734),
    (Tuple 47 833),
    (Tuple 47 631),
    (Tuple 47 779),
    (Tuple 47 834),
    (Tuple 47 736),
    (Tuple 47 835),
    (Tuple 47 780),
    (Tuple 47 782),
    (Tuple 47 908),
    (Tuple 47 738),
    (Tuple 47 699),
    (Tuple 47 859),
    (Tuple 47 783),
    (Tuple 47 353),
    (Tuple 47 785),
    (Tuple 47 701),
    (Tuple 47 514),
    (Tuple 47 740),
    (Tuple 47 683),
    (Tuple 47 393),
    (Tuple 47 842),
    (Tuple 630 546),
    (Tuple 630 672),
    (Tuple 630 347),
    (Tuple 630 734),
    (Tuple 630 907),
    (Tuple 630 736),
    (Tuple 630 859),
    (Tuple 630 125),
    (Tuple 630 532),
    (Tuple 630 842),
    (Tuple 940 381),
    (Tuple 940 214),
    (Tuple 940 66),
    (Tuple 940 224),
    (Tuple 645 381),
    (Tuple 645 382),
    (Tuple 645 216),
    (Tuple 645 68),
    (Tuple 645 221),
    (Tuple 645 222),
    (Tuple 729 730),
    (Tuple 729 731),
    (Tuple 729 682),
    (Tuple 729 831),
    (Tuple 729 734),
    (Tuple 729 698),
    (Tuple 729 833),
    (Tuple 729 834),
    (Tuple 729 736),
    (Tuple 729 835),
    (Tuple 729 780),
    (Tuple 729 738),
    (Tuple 729 839),
    (Tuple 729 699),
    (Tuple 729 840),
    (Tuple 729 784),
    (Tuple 729 786),
    (Tuple 729 787),
    (Tuple 729 701),
    (Tuple 729 514),
    (Tuple 729 683),
    (Tuple 729 393),
    (Tuple 729 615),
    (Tuple 416 801),
    (Tuple 416 102),
    (Tuple 416 103),
    (Tuple 416 305),
    (Tuple 416 104),
    (Tuple 416 672),
    (Tuple 416 419),
    (Tuple 416 420),
    (Tuple 416 421),
    (Tuple 416 105),
    (Tuple 416 108),
    (Tuple 416 110),
    (Tuple 416 348),
    (Tuple 416 49),
    (Tuple 416 112),
    (Tuple 416 529),
    (Tuple 416 114),
    (Tuple 416 116),
    (Tuple 416 349),
    (Tuple 416 118),
    (Tuple 416 549),
    (Tuple 416 120),
    (Tuple 416 350),
    (Tuple 416 427),
    (Tuple 416 267),
    (Tuple 416 352),
    (Tuple 416 124),
    (Tuple 416 125),
    (Tuple 416 126),
    (Tuple 416 430),
    (Tuple 416 702),
    (Tuple 416 594),
    (Tuple 416 131),
    (Tuple 416 433),
    (Tuple 416 703),
    (Tuple 416 132),
    (Tuple 717 717),
    (Tuple 717 152),
    (Tuple 717 172),
    (Tuple 730 731),
    (Tuple 730 682),
    (Tuple 730 673),
    (Tuple 730 736),
    (Tuple 730 780),
    (Tuple 730 781),
    (Tuple 730 837),
    (Tuple 730 699),
    (Tuple 730 841),
    (Tuple 730 783),
    (Tuple 730 784),
    (Tuple 730 786),
    (Tuple 730 787),
    (Tuple 730 788),
    (Tuple 730 514),
    (Tuple 730 683),
    (Tuple 731 670),
    (Tuple 731 682),
    (Tuple 731 775),
    (Tuple 731 776),
    (Tuple 731 732),
    (Tuple 731 672),
    (Tuple 731 673),
    (Tuple 731 830),
    (Tuple 731 831),
    (Tuple 731 733),
    (Tuple 731 832),
    (Tuple 731 675),
    (Tuple 731 734),
    (Tuple 731 907),
    (Tuple 731 698),
    (Tuple 731 735),
    (Tuple 731 529),
    (Tuple 731 385),
    (Tuple 731 833),
    (Tuple 731 631),
    (Tuple 731 779),
    (Tuple 731 834),
    (Tuple 731 736),
    (Tuple 731 835),
    (Tuple 731 780),
    (Tuple 731 781),
    (Tuple 731 836),
    (Tuple 731 837),
    (Tuple 731 782),
    (Tuple 731 737),
    (Tuple 731 593),
    (Tuple 731 908),
    (Tuple 731 738),
    (Tuple 731 838),
    (Tuple 731 632),
    (Tuple 731 699),
    (Tuple 731 859),
    (Tuple 731 840),
    (Tuple 731 57),
    (Tuple 731 841),
    (Tuple 731 783),
    (Tuple 731 784),
    (Tuple 731 353),
    (Tuple 731 785),
    (Tuple 731 739),
    (Tuple 731 923),
    (Tuple 731 676),
    (Tuple 731 786),
    (Tuple 731 787),
    (Tuple 731 788),
    (Tuple 731 701),
    (Tuple 731 514),
    (Tuple 731 633),
    (Tuple 731 789),
    (Tuple 731 533),
    (Tuple 731 740),
    (Tuple 731 683),
    (Tuple 731 790),
    (Tuple 731 393),
    (Tuple 731 615),
    (Tuple 731 515),
    (Tuple 731 842),
    (Tuple 731 843),
    (Tuple 417 561),
    (Tuple 417 591),
    (Tuple 417 419),
    (Tuple 417 116),
    (Tuple 417 121),
    (Tuple 417 352),
    (Tuple 417 132),
    (Tuple 848 848),
    (Tuple 848 503),
    (Tuple 848 849),
    (Tuple 848 850),
    (Tuple 848 777),
    (Tuple 848 778),
    (Tuple 848 532),
    (Tuple 848 791),
    (Tuple 418 561),
    (Tuple 418 546),
    (Tuple 418 547),
    (Tuple 418 236),
    (Tuple 418 554),
    (Tuple 418 307),
    (Tuple 418 355),
    (Tuple 418 480),
    (Tuple 418 911),
    (Tuple 418 866),
    (Tuple 670 682),
    (Tuple 670 776),
    (Tuple 670 672),
    (Tuple 670 673),
    (Tuple 670 733),
    (Tuple 670 424),
    (Tuple 670 631),
    (Tuple 670 780),
    (Tuple 670 781),
    (Tuple 670 699),
    (Tuple 670 57),
    (Tuple 670 841),
    (Tuple 670 783),
    (Tuple 670 784),
    (Tuple 670 353),
    (Tuple 670 786),
    (Tuple 670 787),
    (Tuple 670 788),
    (Tuple 670 514),
    (Tuple 670 634),
    (Tuple 670 789),
    (Tuple 670 615),
    (Tuple 682 672),
    (Tuple 682 734),
    (Tuple 682 735),
    (Tuple 682 833),
    (Tuple 682 779),
    (Tuple 682 834),
    (Tuple 682 736),
    (Tuple 682 835),
    (Tuple 682 836),
    (Tuple 682 738),
    (Tuple 682 838),
    (Tuple 682 859),
    (Tuple 682 840),
    (Tuple 682 700),
    (Tuple 682 923),
    (Tuple 682 676),
    (Tuple 682 740),
    (Tuple 682 842),
    (Tuple 682 910),
    (Tuple 561 546),
    (Tuple 561 104),
    (Tuple 561 547),
    (Tuple 561 422),
    (Tuple 561 236),
    (Tuple 561 306),
    (Tuple 561 496),
    (Tuple 561 548),
    (Tuple 561 369),
    (Tuple 561 51),
    (Tuple 561 52),
    (Tuple 561 115),
    (Tuple 561 117),
    (Tuple 561 550),
    (Tuple 561 389),
    (Tuple 561 126),
    (Tuple 561 127),
    (Tuple 561 552),
    (Tuple 561 239),
    (Tuple 561 431),
    (Tuple 561 534),
    (Tuple 561 364),
    (Tuple 561 129),
    (Tuple 561 307),
    (Tuple 561 355),
    (Tuple 561 434),
    (Tuple 561 505),
    (Tuple 561 308),
    (Tuple 561 60),
    (Tuple 561 241),
    (Tuple 561 133),
    (Tuple 561 309),
    (Tuple 546 546),
    (Tuple 546 562),
    (Tuple 546 503),
    (Tuple 546 547),
    (Tuple 546 422),
    (Tuple 546 236),
    (Tuple 546 872),
    (Tuple 546 423),
    (Tuple 546 548),
    (Tuple 546 50),
    (Tuple 546 385),
    (Tuple 546 424),
    (Tuple 546 369),
    (Tuple 546 51),
    (Tuple 546 52),
    (Tuple 546 115),
    (Tuple 546 550),
    (Tuple 546 389),
    (Tuple 546 56),
    (Tuple 546 429),
    (Tuple 546 57),
    (Tuple 546 551),
    (Tuple 546 126),
    (Tuple 546 552),
    (Tuple 546 239),
    (Tuple 546 431),
    (Tuple 546 534),
    (Tuple 546 553),
    (Tuple 546 554),
    (Tuple 546 563),
    (Tuple 546 364),
    (Tuple 546 129),
    (Tuple 546 307),
    (Tuple 546 355),
    (Tuple 546 480),
    (Tuple 546 564),
    (Tuple 546 434),
    (Tuple 546 240),
    (Tuple 546 505),
    (Tuple 546 60),
    (Tuple 546 515),
    (Tuple 546 241),
    (Tuple 546 133),
    (Tuple 546 173),
    (Tuple 23 289),
    (Tuple 23 506),
    (Tuple 23 383),
    (Tuple 23 262),
    (Tuple 23 648),
    (Tuple 23 390),
    (Tuple 775 671),
    (Tuple 775 672),
    (Tuple 775 733),
    (Tuple 775 675),
    (Tuple 775 734),
    (Tuple 775 833),
    (Tuple 775 779),
    (Tuple 775 834),
    (Tuple 775 736),
    (Tuple 775 835),
    (Tuple 775 838),
    (Tuple 775 351),
    (Tuple 775 840),
    (Tuple 775 700),
    (Tuple 775 923),
    (Tuple 775 786),
    (Tuple 775 633),
    (Tuple 775 740),
    (Tuple 775 842),
    (Tuple 775 910),
    (Tuple 316 497),
    (Tuple 316 53),
    (Tuple 316 370),
    (Tuple 316 54),
    (Tuple 316 391),
    (Tuple 316 58),
    (Tuple 316 59),
    (Tuple 316 658),
    (Tuple 346 346),
    (Tuple 346 102),
    (Tuple 346 103),
    (Tuple 346 305),
    (Tuple 346 347),
    (Tuple 346 420),
    (Tuple 346 106),
    (Tuple 346 110),
    (Tuple 346 49),
    (Tuple 346 528),
    (Tuple 346 112),
    (Tuple 346 114),
    (Tuple 346 427),
    (Tuple 346 123),
    (Tuple 346 124),
    (Tuple 346 125),
    (Tuple 346 430),
    (Tuple 346 594),
    (Tuple 346 595),
    (Tuple 346 356),
    (Tuple 346 132),
    (Tuple 346 435),
    (Tuple 801 801),
    (Tuple 801 776),
    (Tuple 801 305),
    (Tuple 801 503),
    (Tuple 801 420),
    (Tuple 801 112),
    (Tuple 801 530),
    (Tuple 801 52),
    (Tuple 801 425),
    (Tuple 801 699),
    (Tuple 801 122),
    (Tuple 801 352),
    (Tuple 801 353),
    (Tuple 801 125),
    (Tuple 801 532),
    (Tuple 801 703),
    (Tuple 776 671),
    (Tuple 776 672),
    (Tuple 776 503),
    (Tuple 776 348),
    (Tuple 776 734),
    (Tuple 776 907),
    (Tuple 776 779),
    (Tuple 776 736),
    (Tuple 776 859),
    (Tuple 776 909),
    (Tuple 776 936),
    (Tuple 776 923),
    (Tuple 776 676),
    (Tuple 776 532),
    (Tuple 776 633),
    (Tuple 776 677),
    (Tuple 955 297),
    (Tuple 102 103),
    (Tuple 102 305),
    (Tuple 102 745),
    (Tuple 102 591),
    (Tuple 102 347),
    (Tuple 102 419),
    (Tuple 102 106),
    (Tuple 102 109),
    (Tuple 102 746),
    (Tuple 102 348),
    (Tuple 102 528),
    (Tuple 102 592),
    (Tuple 102 52),
    (Tuple 102 116),
    (Tuple 102 863),
    (Tuple 102 426),
    (Tuple 102 120),
    (Tuple 102 427),
    (Tuple 102 352),
    (Tuple 102 124),
    (Tuple 102 923),
    (Tuple 102 707),
    (Tuple 102 354),
    (Tuple 102 633),
    (Tuple 102 432),
    (Tuple 102 131),
    (Tuple 102 703),
    (Tuple 102 596),
    (Tuple 102 356),
    (Tuple 102 597),
    (Tuple 102 903),
    (Tuple 102 132),
    (Tuple 289 214),
    (Tuple 289 66),
    (Tuple 289 216),
    (Tuple 289 171),
    (Tuple 289 219),
    (Tuple 289 387),
    (Tuple 289 220),
    (Tuple 289 390),
    (Tuple 289 222),
    (Tuple 289 483),
    (Tuple 289 224),
    (Tuple 690 103),
    (Tuple 690 305),
    (Tuple 690 49),
    (Tuple 690 112),
    (Tuple 690 237),
    (Tuple 690 549),
    (Tuple 690 351),
    (Tuple 690 427),
    (Tuple 690 122),
    (Tuple 690 125),
    (Tuple 690 430),
    (Tuple 671 733),
    (Tuple 671 674),
    (Tuple 671 832),
    (Tuple 671 385),
    (Tuple 671 631),
    (Tuple 671 780),
    (Tuple 671 632),
    (Tuple 671 353),
    (Tuple 671 787),
    (Tuple 671 790),
    (Tuple 103 305),
    (Tuple 103 745),
    (Tuple 103 591),
    (Tuple 103 347),
    (Tuple 103 419),
    (Tuple 103 420),
    (Tuple 103 106),
    (Tuple 103 110),
    (Tuple 103 49),
    (Tuple 103 528),
    (Tuple 103 592),
    (Tuple 103 112),
    (Tuple 103 693),
    (Tuple 103 530),
    (Tuple 103 114),
    (Tuple 103 116),
    (Tuple 103 349),
    (Tuple 103 120),
    (Tuple 103 350),
    (Tuple 103 427),
    (Tuple 103 267),
    (Tuple 103 123),
    (Tuple 103 124),
    (Tuple 103 707),
    (Tuple 103 676),
    (Tuple 103 126),
    (Tuple 103 430),
    (Tuple 103 354),
    (Tuple 103 128),
    (Tuple 103 594),
    (Tuple 103 131),
    (Tuple 103 433),
    (Tuple 103 703),
    (Tuple 103 596),
    (Tuple 103 356),
    (Tuple 103 597),
    (Tuple 103 132),
    (Tuple 103 435),
    (Tuple 381 646),
    (Tuple 381 383),
    (Tuple 381 647),
    (Tuple 381 217),
    (Tuple 381 653),
    (Tuple 381 219),
    (Tuple 381 390),
    (Tuple 381 859),
    (Tuple 381 649),
    (Tuple 381 68),
    (Tuple 381 655),
    (Tuple 811 751),
    (Tuple 811 388),
    (Tuple 811 513),
    (Tuple 811 752),
    (Tuple 811 753),
    (Tuple 811 754),
    (Tuple 811 755),
    (Tuple 520 520),
    (Tuple 305 305),
    (Tuple 305 745),
    (Tuple 305 672),
    (Tuple 305 347),
    (Tuple 305 503),
    (Tuple 305 420),
    (Tuple 305 421),
    (Tuple 305 105),
    (Tuple 305 106),
    (Tuple 305 108),
    (Tuple 305 746),
    (Tuple 305 110),
    (Tuple 305 49),
    (Tuple 305 528),
    (Tuple 305 592),
    (Tuple 305 112),
    (Tuple 305 237),
    (Tuple 305 693),
    (Tuple 305 385),
    (Tuple 305 530),
    (Tuple 305 531),
    (Tuple 305 52),
    (Tuple 305 349),
    (Tuple 305 863),
    (Tuple 305 549),
    (Tuple 305 426),
    (Tuple 305 350),
    (Tuple 305 351),
    (Tuple 305 699),
    (Tuple 305 427),
    (Tuple 305 428),
    (Tuple 305 859),
    (Tuple 305 122),
    (Tuple 305 267),
    (Tuple 305 353),
    (Tuple 305 124),
    (Tuple 305 125),
    (Tuple 305 923),
    (Tuple 305 430),
    (Tuple 305 354),
    (Tuple 305 239),
    (Tuple 305 532),
    (Tuple 305 595),
    (Tuple 305 131),
    (Tuple 305 433),
    (Tuple 305 703),
    (Tuple 305 356),
    (Tuple 305 132),
    (Tuple 305 876),
    (Tuple 305 435),
    (Tuple 305 357),
    (Tuple 305 309),
    (Tuple 608 148),
    (Tuple 608 13),
    (Tuple 608 456),
    (Tuple 608 14),
    (Tuple 608 661),
    (Tuple 608 149),
    (Tuple 608 15),
    (Tuple 608 150),
    (Tuple 608 151),
    (Tuple 608 457),
    (Tuple 608 458),
    (Tuple 608 459),
    (Tuple 608 612),
    (Tuple 608 153),
    (Tuple 608 655),
    (Tuple 608 853),
    (Tuple 608 920),
    (Tuple 608 154),
    (Tuple 608 155),
    (Tuple 608 613),
    (Tuple 382 214),
    (Tuple 382 66),
    (Tuple 382 387),
    (Tuple 382 390),
    (Tuple 382 649),
    (Tuple 382 221),
    (Tuple 382 222),
    (Tuple 382 392),
    (Tuple 382 225),
    (Tuple 932 932),
    (Tuple 932 14),
    (Tuple 932 149),
    (Tuple 932 15),
    (Tuple 932 151),
    (Tuple 932 459),
    (Tuple 932 920),
    (Tuple 932 155),
    (Tuple 932 460),
    (Tuple 732 732),
    (Tuple 732 672),
    (Tuple 732 832),
    (Tuple 732 698),
    (Tuple 732 782),
    (Tuple 732 737),
    (Tuple 732 632),
    (Tuple 732 699),
    (Tuple 732 936),
    (Tuple 732 353),
    (Tuple 732 923),
    (Tuple 732 787),
    (Tuple 732 701),
    (Tuple 732 514),
    (Tuple 732 533),
    (Tuple 732 683),
    (Tuple 732 790),
    (Tuple 732 393),
    (Tuple 732 515),
    (Tuple 732 842),
    (Tuple 732 843),
    (Tuple 104 591),
    (Tuple 104 419),
    (Tuple 104 106),
    (Tuple 104 592),
    (Tuple 104 116),
    (Tuple 104 593),
    (Tuple 104 120),
    (Tuple 104 121),
    (Tuple 104 352),
    (Tuple 104 124),
    (Tuple 104 707),
    (Tuple 104 596),
    (Tuple 104 597),
    (Tuple 104 903),
    (Tuple 104 132),
    (Tuple 104 435),
    (Tuple 745 745),
    (Tuple 745 105),
    (Tuple 745 110),
    (Tuple 745 348),
    (Tuple 745 49),
    (Tuple 745 112),
    (Tuple 745 237),
    (Tuple 745 52),
    (Tuple 745 425),
    (Tuple 745 349),
    (Tuple 745 549),
    (Tuple 745 120),
    (Tuple 745 124),
    (Tuple 745 131),
    (Tuple 745 435),
    (Tuple 745 357),
    (Tuple 646 506),
    (Tuple 646 219),
    (Tuple 646 387),
    (Tuple 646 221),
    (Tuple 646 222),
    (Tuple 646 16),
    (Tuple 591 420),
    (Tuple 591 106),
    (Tuple 591 107),
    (Tuple 591 108),
    (Tuple 591 109),
    (Tuple 591 306),
    (Tuple 591 49),
    (Tuple 591 528),
    (Tuple 591 112),
    (Tuple 591 113),
    (Tuple 591 369),
    (Tuple 591 114),
    (Tuple 591 52),
    (Tuple 591 116),
    (Tuple 591 117),
    (Tuple 591 118),
    (Tuple 591 426),
    (Tuple 591 121),
    (Tuple 591 122),
    (Tuple 591 267),
    (Tuple 591 123),
    (Tuple 591 126),
    (Tuple 591 129),
    (Tuple 591 130),
    (Tuple 591 595),
    (Tuple 591 131),
    (Tuple 591 132),
    (Tuple 591 308),
    (Tuple 591 133),
    (Tuple 672 672),
    (Tuple 672 562),
    (Tuple 672 503),
    (Tuple 672 673),
    (Tuple 672 733),
    (Tuple 672 422),
    (Tuple 672 674),
    (Tuple 672 111),
    (Tuple 672 832),
    (Tuple 672 295),
    (Tuple 672 698),
    (Tuple 672 237),
    (Tuple 672 529),
    (Tuple 672 363),
    (Tuple 672 424),
    (Tuple 672 631),
    (Tuple 672 779),
    (Tuple 672 531),
    (Tuple 672 52),
    (Tuple 672 780),
    (Tuple 672 781),
    (Tuple 672 837),
    (Tuple 672 782),
    (Tuple 672 266),
    (Tuple 672 839),
    (Tuple 672 351),
    (Tuple 672 632),
    (Tuple 672 699),
    (Tuple 672 428),
    (Tuple 672 429),
    (Tuple 672 909),
    (Tuple 672 936),
    (Tuple 672 841),
    (Tuple 672 784),
    (Tuple 672 353),
    (Tuple 672 785),
    (Tuple 672 125),
    (Tuple 672 923),
    (Tuple 672 786),
    (Tuple 672 787),
    (Tuple 672 788),
    (Tuple 672 701),
    (Tuple 672 514),
    (Tuple 672 532),
    (Tuple 672 633),
    (Tuple 672 634),
    (Tuple 672 789),
    (Tuple 672 533),
    (Tuple 672 432),
    (Tuple 672 683),
    (Tuple 672 131),
    (Tuple 672 790),
    (Tuple 672 393),
    (Tuple 672 791),
    (Tuple 672 615),
    (Tuple 672 515),
    (Tuple 672 842),
    (Tuple 672 843),
    (Tuple 672 910),
    (Tuple 672 357),
    (Tuple 562 562),
    (Tuple 562 108),
    (Tuple 562 674),
    (Tuple 562 832),
    (Tuple 562 49),
    (Tuple 562 548),
    (Tuple 562 112),
    (Tuple 562 529),
    (Tuple 562 531),
    (Tuple 562 349),
    (Tuple 562 699),
    (Tuple 562 859),
    (Tuple 562 429),
    (Tuple 562 701),
    (Tuple 562 432),
    (Tuple 562 307),
    (Tuple 562 790),
    (Tuple 562 876),
    (Tuple 148 660),
    (Tuple 148 150),
    (Tuple 148 457),
    (Tuple 148 612),
    (Tuple 148 655),
    (Tuple 148 853),
    (Tuple 148 937),
    (Tuple 148 154),
    (Tuple 214 383),
    (Tuple 214 390),
    (Tuple 214 649),
    (Tuple 214 483),
    (Tuple 214 392),
    (Tuple 214 618),
    (Tuple 214 797),
    (Tuple 347 347),
    (Tuple 347 420),
    (Tuple 347 421),
    (Tuple 347 105),
    (Tuple 347 106),
    (Tuple 347 107),
    (Tuple 347 109),
    (Tuple 347 110),
    (Tuple 347 111),
    (Tuple 347 49),
    (Tuple 347 528),
    (Tuple 347 112),
    (Tuple 347 237),
    (Tuple 347 369),
    (Tuple 347 114),
    (Tuple 347 531),
    (Tuple 347 52),
    (Tuple 347 425),
    (Tuple 347 116),
    (Tuple 347 349),
    (Tuple 347 238),
    (Tuple 347 120),
    (Tuple 347 266),
    (Tuple 347 699),
    (Tuple 347 428),
    (Tuple 347 429),
    (Tuple 347 267),
    (Tuple 347 123),
    (Tuple 347 124),
    (Tuple 347 125),
    (Tuple 347 126),
    (Tuple 347 127),
    (Tuple 347 430),
    (Tuple 347 239),
    (Tuple 347 532),
    (Tuple 347 789),
    (Tuple 347 595),
    (Tuple 347 131),
    (Tuple 347 433),
    (Tuple 347 703),
    (Tuple 347 132),
    (Tuple 347 435),
    (Tuple 347 357),
    (Tuple 419 420),
    (Tuple 419 105),
    (Tuple 419 106),
    (Tuple 419 109),
    (Tuple 419 49),
    (Tuple 419 528),
    (Tuple 419 112),
    (Tuple 419 363),
    (Tuple 419 424),
    (Tuple 419 530),
    (Tuple 419 114),
    (Tuple 419 531),
    (Tuple 419 52),
    (Tuple 419 425),
    (Tuple 419 117),
    (Tuple 419 118),
    (Tuple 419 120),
    (Tuple 419 121),
    (Tuple 419 427),
    (Tuple 419 428),
    (Tuple 419 122),
    (Tuple 419 429),
    (Tuple 419 267),
    (Tuple 419 123),
    (Tuple 419 124),
    (Tuple 419 125),
    (Tuple 419 126),
    (Tuple 419 430),
    (Tuple 419 239),
    (Tuple 419 131),
    (Tuple 419 132),
    (Tuple 419 308),
    (Tuple 419 357),
    (Tuple 419 309),
    (Tuple 503 503),
    (Tuple 503 504),
    (Tuple 503 778),
    (Tuple 503 49),
    (Tuple 503 907),
    (Tuple 503 112),
    (Tuple 503 529),
    (Tuple 503 363),
    (Tuple 503 51),
    (Tuple 503 52),
    (Tuple 503 782),
    (Tuple 503 349),
    (Tuple 503 266),
    (Tuple 503 632),
    (Tuple 503 699),
    (Tuple 503 267),
    (Tuple 503 430),
    (Tuple 503 532),
    (Tuple 503 533),
    (Tuple 503 433),
    (Tuple 503 791),
    (Tuple 503 60),
    (Tuple 503 515),
    (Tuple 503 357),
    (Tuple 503 309),
    (Tuple 420 420),
    (Tuple 420 106),
    (Tuple 420 109),
    (Tuple 420 746),
    (Tuple 420 348),
    (Tuple 420 528),
    (Tuple 420 592),
    (Tuple 420 693),
    (Tuple 420 116),
    (Tuple 420 349),
    (Tuple 420 426),
    (Tuple 420 120),
    (Tuple 420 350),
    (Tuple 420 427),
    (Tuple 420 859),
    (Tuple 420 352),
    (Tuple 420 124),
    (Tuple 420 707),
    (Tuple 420 354),
    (Tuple 420 633),
    (Tuple 420 131),
    (Tuple 420 703),
    (Tuple 420 596),
    (Tuple 420 356),
    (Tuple 420 597),
    (Tuple 420 903),
    (Tuple 420 132),
    (Tuple 13 660),
    (Tuple 13 661),
    (Tuple 13 457),
    (Tuple 13 458),
    (Tuple 13 612),
    (Tuple 13 153),
    (Tuple 13 655),
    (Tuple 13 937),
    (Tuple 421 348),
    (Tuple 421 592),
    (Tuple 421 426),
    (Tuple 421 120),
    (Tuple 421 352),
    (Tuple 421 124),
    (Tuple 506 66),
    (Tuple 105 106),
    (Tuple 105 746),
    (Tuple 105 348),
    (Tuple 105 592),
    (Tuple 105 426),
    (Tuple 105 120),
    (Tuple 105 121),
    (Tuple 105 124),
    (Tuple 105 354),
    (Tuple 105 131),
    (Tuple 105 703),
    (Tuple 105 132),
    (Tuple 893 438),
    (Tuple 893 486),
    (Tuple 893 894),
    (Tuple 893 895),
    (Tuple 893 896),
    (Tuple 893 898),
    (Tuple 893 899),
    (Tuple 893 900),
    (Tuple 673 831),
    (Tuple 673 675),
    (Tuple 673 734),
    (Tuple 673 907),
    (Tuple 673 735),
    (Tuple 673 833),
    (Tuple 673 834),
    (Tuple 673 736),
    (Tuple 673 835),
    (Tuple 673 836),
    (Tuple 673 737),
    (Tuple 673 593),
    (Tuple 673 908),
    (Tuple 673 738),
    (Tuple 673 838),
    (Tuple 673 859),
    (Tuple 673 840),
    (Tuple 673 739),
    (Tuple 673 676),
    (Tuple 673 740),
    (Tuple 438 438),
    (Tuple 438 486),
    (Tuple 438 894),
    (Tuple 438 895),
    (Tuple 438 896),
    (Tuple 438 897),
    (Tuple 438 898),
    (Tuple 438 859),
    (Tuple 438 899),
    (Tuple 438 900),
    (Tuple 504 385),
    (Tuple 504 57),
    (Tuple 504 841),
    (Tuple 504 634),
    (Tuple 504 615),
    (Tuple 830 733),
    (Tuple 830 832),
    (Tuple 830 734),
    (Tuple 830 698),
    (Tuple 830 735),
    (Tuple 830 833),
    (Tuple 830 736),
    (Tuple 830 835),
    (Tuple 830 837),
    (Tuple 830 353),
    (Tuple 830 786),
    (Tuple 830 787),
    (Tuple 830 701),
    (Tuple 830 615),
    (Tuple 547 872),
    (Tuple 547 423),
    (Tuple 547 548),
    (Tuple 547 550),
    (Tuple 547 551),
    (Tuple 547 658),
    (Tuple 547 239),
    (Tuple 547 534),
    (Tuple 547 553),
    (Tuple 547 554),
    (Tuple 547 563),
    (Tuple 547 307),
    (Tuple 547 355),
    (Tuple 547 480),
    (Tuple 547 911),
    (Tuple 547 564),
    (Tuple 547 240),
    (Tuple 547 866),
    (Tuple 849 850),
    (Tuple 849 777),
    (Tuple 849 778),
    (Tuple 849 791),
    (Tuple 106 106),
    (Tuple 106 107),
    (Tuple 106 422),
    (Tuple 106 109),
    (Tuple 106 110),
    (Tuple 106 111),
    (Tuple 106 49),
    (Tuple 106 528),
    (Tuple 106 112),
    (Tuple 106 693),
    (Tuple 106 530),
    (Tuple 106 114),
    (Tuple 106 531),
    (Tuple 106 425),
    (Tuple 106 349),
    (Tuple 106 118),
    (Tuple 106 120),
    (Tuple 106 427),
    (Tuple 106 428),
    (Tuple 106 859),
    (Tuple 106 122),
    (Tuple 106 267),
    (Tuple 106 124),
    (Tuple 106 125),
    (Tuple 106 707),
    (Tuple 106 126),
    (Tuple 106 430),
    (Tuple 106 354),
    (Tuple 106 239),
    (Tuple 106 594),
    (Tuple 106 595),
    (Tuple 106 131),
    (Tuple 106 433),
    (Tuple 106 596),
    (Tuple 106 132),
    (Tuple 106 308),
    (Tuple 106 435),
    (Tuple 106 357),
    (Tuple 850 850),
    (Tuple 850 777),
    (Tuple 850 778),
    (Tuple 850 532),
    (Tuple 850 791),
    (Tuple 652 15),
    (Tuple 486 486),
    (Tuple 486 894),
    (Tuple 486 895),
    (Tuple 486 896),
    (Tuple 486 959),
    (Tuple 486 661),
    (Tuple 486 897),
    (Tuple 486 898),
    (Tuple 486 899),
    (Tuple 486 900),
    (Tuple 831 733),
    (Tuple 831 631),
    (Tuple 831 780),
    (Tuple 831 781),
    (Tuple 831 837),
    (Tuple 831 839),
    (Tuple 831 699),
    (Tuple 831 841),
    (Tuple 831 783),
    (Tuple 831 784),
    (Tuple 831 786),
    (Tuple 831 787),
    (Tuple 831 788),
    (Tuple 831 514),
    (Tuple 831 533),
    (Tuple 831 615),
    (Tuple 968 968),
    (Tuple 733 733),
    (Tuple 733 832),
    (Tuple 733 675),
    (Tuple 733 734),
    (Tuple 733 735),
    (Tuple 733 833),
    (Tuple 733 779),
    (Tuple 733 834),
    (Tuple 733 736),
    (Tuple 733 835),
    (Tuple 733 737),
    (Tuple 733 593),
    (Tuple 733 738),
    (Tuple 733 838),
    (Tuple 733 839),
    (Tuple 733 859),
    (Tuple 733 840),
    (Tuple 733 909),
    (Tuple 733 784),
    (Tuple 733 739),
    (Tuple 733 923),
    (Tuple 733 676),
    (Tuple 733 633),
    (Tuple 733 740),
    (Tuple 733 790),
    (Tuple 733 842),
    (Tuple 733 910),
    (Tuple 383 383),
    (Tuple 383 66),
    (Tuple 383 217),
    (Tuple 383 219),
    (Tuple 383 387),
    (Tuple 383 390),
    (Tuple 383 68),
    (Tuple 383 221),
    (Tuple 383 222),
    (Tuple 383 392),
    (Tuple 383 290),
    (Tuple 383 225),
    (Tuple 107 116),
    (Tuple 107 121),
    (Tuple 107 352),
    (Tuple 107 707),
    (Tuple 107 596),
    (Tuple 107 597),
    (Tuple 107 132),
    (Tuple 777 778),
    (Tuple 777 532),
    (Tuple 777 791),
    (Tuple 48 674),
    (Tuple 48 677),
    (Tuple 215 262),
    (Tuple 215 223),
    (Tuple 215 507),
    (Tuple 108 120),
    (Tuple 108 352),
    (Tuple 108 124),
    (Tuple 422 872),
    (Tuple 422 551),
    (Tuple 422 554),
    (Tuple 422 563),
    (Tuple 422 307),
    (Tuple 422 355),
    (Tuple 422 911),
    (Tuple 422 240),
    (Tuple 109 49),
    (Tuple 109 112),
    (Tuple 109 530),
    (Tuple 109 425),
    (Tuple 109 116),
    (Tuple 109 593),
    (Tuple 109 120),
    (Tuple 109 427),
    (Tuple 109 267),
    (Tuple 109 123),
    (Tuple 109 124),
    (Tuple 109 131),
    (Tuple 109 703),
    (Tuple 109 596),
    (Tuple 109 132),
    (Tuple 778 532),
    (Tuple 778 791),
    (Tuple 66 647),
    (Tuple 66 216),
    (Tuple 66 219),
    (Tuple 66 654),
    (Tuple 66 390),
    (Tuple 66 392),
    (Tuple 66 223),
    (Tuple 66 394),
    (Tuple 66 797),
    (Tuple 236 872),
    (Tuple 236 423),
    (Tuple 236 548),
    (Tuple 236 385),
    (Tuple 236 641),
    (Tuple 236 550),
    (Tuple 236 941),
    (Tuple 236 352),
    (Tuple 236 551),
    (Tuple 236 239),
    (Tuple 236 532),
    (Tuple 236 534),
    (Tuple 236 554),
    (Tuple 236 563),
    (Tuple 236 307),
    (Tuple 236 355),
    (Tuple 236 480),
    (Tuple 236 911),
    (Tuple 236 564),
    (Tuple 236 866),
    (Tuple 746 746),
    (Tuple 746 110),
    (Tuple 746 111),
    (Tuple 746 49),
    (Tuple 746 528),
    (Tuple 746 592),
    (Tuple 746 237),
    (Tuple 746 529),
    (Tuple 746 114),
    (Tuple 746 51),
    (Tuple 746 52),
    (Tuple 746 116),
    (Tuple 746 349),
    (Tuple 746 549),
    (Tuple 746 351),
    (Tuple 746 124),
    (Tuple 746 594),
    (Tuple 746 595),
    (Tuple 746 131),
    (Tuple 746 433),
    (Tuple 746 703),
    (Tuple 746 903),
    (Tuple 746 132),
    (Tuple 746 60),
    (Tuple 110 110),
    (Tuple 110 528),
    (Tuple 110 116),
    (Tuple 110 863),
    (Tuple 110 427),
    (Tuple 110 594),
    (Tuple 110 595),
    (Tuple 110 703),
    (Tuple 110 596),
    (Tuple 110 132),
    (Tuple 306 132),
    (Tuple 969 901),
    (Tuple 456 660),
    (Tuple 456 959),
    (Tuple 456 661),
    (Tuple 456 457),
    (Tuple 456 458),
    (Tuple 456 612),
    (Tuple 456 655),
    (Tuple 456 853),
    (Tuple 456 937),
    (Tuple 456 920),
    (Tuple 456 938),
    (Tuple 456 613),
    (Tuple 751 882),
    (Tuple 751 388),
    (Tuple 751 513),
    (Tuple 751 752),
    (Tuple 751 753),
    (Tuple 751 754),
    (Tuple 751 755),
    (Tuple 751 884),
    (Tuple 872 424),
    (Tuple 872 51),
    (Tuple 872 550),
    (Tuple 872 389),
    (Tuple 872 552),
    (Tuple 872 239),
    (Tuple 872 534),
    (Tuple 872 553),
    (Tuple 872 554),
    (Tuple 872 364),
    (Tuple 872 307),
    (Tuple 872 564),
    (Tuple 872 434),
    (Tuple 872 60),
    (Tuple 872 133),
    (Tuple 348 111),
    (Tuple 348 49),
    (Tuple 348 528),
    (Tuple 348 112),
    (Tuple 348 237),
    (Tuple 348 529),
    (Tuple 348 530),
    (Tuple 348 114),
    (Tuple 348 531),
    (Tuple 348 52),
    (Tuple 348 425),
    (Tuple 348 349),
    (Tuple 348 549),
    (Tuple 348 120),
    (Tuple 348 699),
    (Tuple 348 428),
    (Tuple 348 429),
    (Tuple 348 267),
    (Tuple 348 123),
    (Tuple 348 353),
    (Tuple 348 124),
    (Tuple 348 125),
    (Tuple 348 430),
    (Tuple 348 128),
    (Tuple 348 432),
    (Tuple 348 594),
    (Tuple 348 595),
    (Tuple 348 131),
    (Tuple 348 433),
    (Tuple 348 703),
    (Tuple 348 357),
    (Tuple 348 309),
    (Tuple 674 674),
    (Tuple 674 734),
    (Tuple 674 907),
    (Tuple 674 859),
    (Tuple 674 676),
    (Tuple 674 677),
    (Tuple 674 842),
    (Tuple 647 647),
    (Tuple 647 387),
    (Tuple 647 221),
    (Tuple 647 222),
    (Tuple 647 16),
    (Tuple 111 111),
    (Tuple 111 116),
    (Tuple 111 633),
    (Tuple 111 132),
    (Tuple 832 832),
    (Tuple 832 734),
    (Tuple 832 907),
    (Tuple 832 833),
    (Tuple 832 779),
    (Tuple 832 834),
    (Tuple 832 736),
    (Tuple 832 780),
    (Tuple 832 737),
    (Tuple 832 908),
    (Tuple 832 859),
    (Tuple 832 840),
    (Tuple 832 909),
    (Tuple 832 936),
    (Tuple 832 353),
    (Tuple 832 739),
    (Tuple 832 923),
    (Tuple 832 676),
    (Tuple 832 633),
    (Tuple 832 677),
    (Tuple 832 740),
    (Tuple 832 790),
    (Tuple 832 842),
    (Tuple 49 592),
    (Tuple 49 112),
    (Tuple 49 693),
    (Tuple 49 114),
    (Tuple 49 52),
    (Tuple 49 116),
    (Tuple 49 863),
    (Tuple 49 426),
    (Tuple 49 120),
    (Tuple 49 121),
    (Tuple 49 350),
    (Tuple 49 859),
    (Tuple 49 352),
    (Tuple 49 124),
    (Tuple 49 125),
    (Tuple 49 676),
    (Tuple 49 354),
    (Tuple 49 532),
    (Tuple 49 634),
    (Tuple 49 432),
    (Tuple 49 131),
    (Tuple 49 703),
    (Tuple 49 356),
    (Tuple 49 597),
    (Tuple 49 132),
    (Tuple 49 876),
    (Tuple 49 435),
    (Tuple 49 357),
    (Tuple 675 734),
    (Tuple 675 631),
    (Tuple 675 736),
    (Tuple 675 781),
    (Tuple 675 837),
    (Tuple 675 738),
    (Tuple 675 783),
    (Tuple 675 784),
    (Tuple 675 353),
    (Tuple 675 785),
    (Tuple 675 676),
    (Tuple 675 786),
    (Tuple 675 787),
    (Tuple 675 788),
    (Tuple 675 514),
    (Tuple 675 683),
    (Tuple 675 615),
    (Tuple 216 387),
    (Tuple 216 390),
    (Tuple 216 222),
    (Tuple 216 225),
    (Tuple 216 394),
    (Tuple 734 295),
    (Tuple 734 698),
    (Tuple 734 735),
    (Tuple 734 529),
    (Tuple 734 385),
    (Tuple 734 363),
    (Tuple 734 833),
    (Tuple 734 631),
    (Tuple 734 779),
    (Tuple 734 736),
    (Tuple 734 780),
    (Tuple 734 781),
    (Tuple 734 837),
    (Tuple 734 782),
    (Tuple 734 238),
    (Tuple 734 839),
    (Tuple 734 351),
    (Tuple 734 632),
    (Tuple 734 699),
    (Tuple 734 429),
    (Tuple 734 57),
    (Tuple 734 841),
    (Tuple 734 783),
    (Tuple 734 784),
    (Tuple 734 353),
    (Tuple 734 785),
    (Tuple 734 786),
    (Tuple 734 787),
    (Tuple 734 788),
    (Tuple 734 701),
    (Tuple 734 514),
    (Tuple 734 532),
    (Tuple 734 634),
    (Tuple 734 789),
    (Tuple 734 533),
    (Tuple 734 683),
    (Tuple 734 433),
    (Tuple 734 790),
    (Tuple 734 393),
    (Tuple 734 615),
    (Tuple 734 515),
    (Tuple 734 842),
    (Tuple 496 497),
    (Tuple 496 52),
    (Tuple 496 53),
    (Tuple 496 115),
    (Tuple 496 117),
    (Tuple 496 370),
    (Tuple 496 54),
    (Tuple 496 55),
    (Tuple 496 56),
    (Tuple 496 391),
    (Tuple 496 58),
    (Tuple 496 59),
    (Tuple 295 295),
    (Tuple 295 296),
    (Tuple 295 736),
    (Tuple 295 859),
    (Tuple 295 740),
    (Tuple 423 424),
    (Tuple 423 51),
    (Tuple 423 554),
    (Tuple 423 364),
    (Tuple 423 307),
    (Tuple 423 355),
    (Tuple 423 505),
    (Tuple 423 791),
    (Tuple 423 60),
    (Tuple 907 385),
    (Tuple 907 363),
    (Tuple 907 424),
    (Tuple 907 631),
    (Tuple 907 52),
    (Tuple 907 780),
    (Tuple 907 349),
    (Tuple 907 238),
    (Tuple 907 699),
    (Tuple 907 428),
    (Tuple 907 57),
    (Tuple 907 936),
    (Tuple 907 841),
    (Tuple 907 353),
    (Tuple 907 787),
    (Tuple 907 514),
    (Tuple 907 634),
    (Tuple 907 789),
    (Tuple 907 615),
    (Tuple 907 515),
    (Tuple 907 842),
    (Tuple 528 528),
    (Tuple 528 112),
    (Tuple 528 114),
    (Tuple 528 116),
    (Tuple 528 427),
    (Tuple 528 124),
    (Tuple 528 707),
    (Tuple 528 126),
    (Tuple 528 354),
    (Tuple 528 131),
    (Tuple 528 356),
    (Tuple 528 132),
    (Tuple 384 67),
    (Tuple 384 387),
    (Tuple 384 648),
    (Tuple 384 390),
    (Tuple 384 68),
    (Tuple 384 221),
    (Tuple 67 53),
    (Tuple 67 68),
    (Tuple 67 69),
    (Tuple 67 431),
    (Tuple 67 16),
    (Tuple 67 173),
    (Tuple 67 70),
    (Tuple 548 51),
    (Tuple 548 550),
    (Tuple 548 389),
    (Tuple 548 57),
    (Tuple 548 552),
    (Tuple 548 239),
    (Tuple 548 431),
    (Tuple 548 553),
    (Tuple 548 554),
    (Tuple 548 563),
    (Tuple 548 364),
    (Tuple 548 307),
    (Tuple 548 355),
    (Tuple 548 564),
    (Tuple 548 434),
    (Tuple 548 240),
    (Tuple 548 505),
    (Tuple 548 60),
    (Tuple 698 735),
    (Tuple 698 529),
    (Tuple 698 779),
    (Tuple 698 834),
    (Tuple 698 736),
    (Tuple 698 835),
    (Tuple 698 737),
    (Tuple 698 738),
    (Tuple 698 936),
    (Tuple 698 923),
    (Tuple 698 702),
    (Tuple 698 740),
    (Tuple 698 842),
    (Tuple 592 112),
    (Tuple 592 529),
    (Tuple 592 114),
    (Tuple 592 52),
    (Tuple 592 427),
    (Tuple 592 124),
    (Tuple 592 126),
    (Tuple 592 430),
    (Tuple 592 131),
    (Tuple 592 703),
    (Tuple 592 132),
    (Tuple 592 357),
    (Tuple 735 631),
    (Tuple 735 736),
    (Tuple 735 835),
    (Tuple 735 780),
    (Tuple 735 781),
    (Tuple 735 837),
    (Tuple 735 699),
    (Tuple 735 429),
    (Tuple 735 841),
    (Tuple 735 783),
    (Tuple 735 784),
    (Tuple 735 785),
    (Tuple 735 786),
    (Tuple 735 787),
    (Tuple 735 788),
    (Tuple 735 514),
    (Tuple 112 693),
    (Tuple 112 530),
    (Tuple 112 114),
    (Tuple 112 52),
    (Tuple 112 116),
    (Tuple 112 349),
    (Tuple 112 863),
    (Tuple 112 593),
    (Tuple 112 120),
    (Tuple 112 350),
    (Tuple 112 427),
    (Tuple 112 859),
    (Tuple 112 352),
    (Tuple 112 124),
    (Tuple 112 125),
    (Tuple 112 676),
    (Tuple 112 354),
    (Tuple 112 702),
    (Tuple 112 131),
    (Tuple 112 703),
    (Tuple 112 596),
    (Tuple 112 597),
    (Tuple 112 903),
    (Tuple 112 132),
    (Tuple 112 876),
    (Tuple 112 435),
    (Tuple 112 842),
    (Tuple 112 866),
    (Tuple 901 901),
    (Tuple 901 970),
    (Tuple 237 426),
    (Tuple 237 120),
    (Tuple 237 352),
    (Tuple 237 125),
    (Tuple 237 676),
    (Tuple 237 354),
    (Tuple 237 355),
    (Tuple 237 866),
    (Tuple 113 113),
    (Tuple 113 116),
    (Tuple 113 121),
    (Tuple 113 707),
    (Tuple 113 596),
    (Tuple 113 597),
    (Tuple 113 132),
    (Tuple 497 53),
    (Tuple 497 370),
    (Tuple 497 54),
    (Tuple 497 55),
    (Tuple 497 56),
    (Tuple 497 58),
    (Tuple 497 59),
    (Tuple 497 173),
    (Tuple 50 479),
    (Tuple 660 14),
    (Tuple 660 15),
    (Tuple 660 150),
    (Tuple 660 16),
    (Tuple 529 736),
    (Tuple 529 52),
    (Tuple 529 738),
    (Tuple 529 120),
    (Tuple 529 909),
    (Tuple 529 700),
    (Tuple 529 923),
    (Tuple 529 634),
    (Tuple 529 702),
    (Tuple 529 740),
    (Tuple 529 433),
    (Tuple 529 596),
    (Tuple 529 355),
    (Tuple 529 842),
    (Tuple 529 866),
    (Tuple 217 387),
    (Tuple 217 649),
    (Tuple 217 222),
    (Tuple 857 115),
    (Tuple 857 126),
    (Tuple 693 693),
    (Tuple 693 530),
    (Tuple 693 52),
    (Tuple 693 123),
    (Tuple 693 352),
    (Tuple 693 676),
    (Tuple 693 132),
    (Tuple 693 435),
    (Tuple 385 51),
    (Tuple 385 676),
    (Tuple 385 787),
    (Tuple 385 701),
    (Tuple 385 355),
    (Tuple 894 894),
    (Tuple 894 895),
    (Tuple 894 896),
    (Tuple 894 14),
    (Tuple 894 897),
    (Tuple 894 898),
    (Tuple 894 899),
    (Tuple 894 900),
    (Tuple 363 834),
    (Tuple 363 736),
    (Tuple 363 859),
    (Tuple 363 909),
    (Tuple 363 352),
    (Tuple 363 532),
    (Tuple 171 795),
    (Tuple 171 394),
    (Tuple 833 631),
    (Tuple 833 780),
    (Tuple 833 781),
    (Tuple 833 836),
    (Tuple 833 839),
    (Tuple 833 699),
    (Tuple 833 840),
    (Tuple 833 783),
    (Tuple 833 784),
    (Tuple 833 785),
    (Tuple 833 786),
    (Tuple 833 787),
    (Tuple 833 788),
    (Tuple 833 701),
    (Tuple 833 514),
    (Tuple 833 740),
    (Tuple 833 683),
    (Tuple 833 393),
    (Tuple 424 736),
    (Tuple 424 859),
    (Tuple 424 676),
    (Tuple 424 563),
    (Tuple 424 307),
    (Tuple 424 355),
    (Tuple 530 425),
    (Tuple 530 426),
    (Tuple 530 120),
    (Tuple 530 350),
    (Tuple 530 427),
    (Tuple 530 124),
    (Tuple 530 125),
    (Tuple 530 923),
    (Tuple 530 676),
    (Tuple 530 430),
    (Tuple 530 633),
    (Tuple 530 703),
    (Tuple 530 876),
    (Tuple 895 896),
    (Tuple 895 897),
    (Tuple 895 898),
    (Tuple 895 899),
    (Tuple 895 900),
    (Tuple 631 834),
    (Tuple 631 736),
    (Tuple 631 835),
    (Tuple 631 836),
    (Tuple 631 593),
    (Tuple 631 908),
    (Tuple 631 738),
    (Tuple 631 859),
    (Tuple 631 840),
    (Tuple 631 739),
    (Tuple 631 923),
    (Tuple 631 676),
    (Tuple 631 633),
    (Tuple 631 677),
    (Tuple 631 702),
    (Tuple 631 740),
    (Tuple 631 842),
    (Tuple 386 386),
    (Tuple 386 14),
    (Tuple 386 16),
    (Tuple 386 459),
    (Tuple 386 154),
    (Tuple 896 896),
    (Tuple 896 897),
    (Tuple 896 898),
    (Tuple 896 899),
    (Tuple 896 900),
    (Tuple 779 779),
    (Tuple 779 834),
    (Tuple 779 736),
    (Tuple 779 699),
    (Tuple 779 859),
    (Tuple 779 429),
    (Tuple 779 353),
    (Tuple 779 785),
    (Tuple 779 923),
    (Tuple 779 786),
    (Tuple 779 701),
    (Tuple 779 514),
    (Tuple 779 633),
    (Tuple 779 533),
    (Tuple 779 740),
    (Tuple 779 683),
    (Tuple 779 790),
    (Tuple 779 393),
    (Tuple 779 843),
    (Tuple 779 910),
    (Tuple 834 780),
    (Tuple 834 781),
    (Tuple 834 837),
    (Tuple 834 738),
    (Tuple 834 839),
    (Tuple 834 632),
    (Tuple 834 699),
    (Tuple 834 841),
    (Tuple 834 783),
    (Tuple 834 784),
    (Tuple 834 353),
    (Tuple 834 785),
    (Tuple 834 786),
    (Tuple 834 787),
    (Tuple 834 788),
    (Tuple 834 701),
    (Tuple 834 514),
    (Tuple 834 789),
    (Tuple 834 533),
    (Tuple 834 683),
    (Tuple 834 790),
    (Tuple 834 393),
    (Tuple 834 615),
    (Tuple 834 515),
    (Tuple 369 641),
    (Tuple 369 116),
    (Tuple 369 352),
    (Tuple 369 354),
    (Tuple 369 132),
    (Tuple 653 14),
    (Tuple 653 959),
    (Tuple 653 152),
    (Tuple 653 16),
    (Tuple 653 459),
    (Tuple 653 153),
    (Tuple 653 460),
    (Tuple 653 172),
    (Tuple 296 297),
    (Tuple 14 959),
    (Tuple 14 661),
    (Tuple 14 149),
    (Tuple 14 150),
    (Tuple 14 151),
    (Tuple 14 458),
    (Tuple 14 459),
    (Tuple 14 612),
    (Tuple 14 153),
    (Tuple 14 655),
    (Tuple 14 853),
    (Tuple 14 937),
    (Tuple 14 920),
    (Tuple 14 938),
    (Tuple 14 155),
    (Tuple 14 613),
    (Tuple 114 114),
    (Tuple 114 425),
    (Tuple 114 116),
    (Tuple 114 118),
    (Tuple 114 120),
    (Tuple 114 427),
    (Tuple 114 124),
    (Tuple 114 707),
    (Tuple 114 126),
    (Tuple 114 354),
    (Tuple 114 596),
    (Tuple 114 356),
    (Tuple 114 597),
    (Tuple 114 132),
    (Tuple 959 959),
    (Tuple 959 152),
    (Tuple 959 154),
    (Tuple 959 155),
    (Tuple 959 460),
    (Tuple 959 172),
    (Tuple 641 641),
    (Tuple 641 53),
    (Tuple 641 115),
    (Tuple 641 119),
    (Tuple 641 55),
    (Tuple 641 56),
    (Tuple 641 57),
    (Tuple 641 58),
    (Tuple 641 126),
    (Tuple 641 431),
    (Tuple 641 129),
    (Tuple 641 309),
    (Tuple 51 550),
    (Tuple 51 389),
    (Tuple 51 352),
    (Tuple 51 707),
    (Tuple 51 702),
    (Tuple 51 554),
    (Tuple 51 563),
    (Tuple 51 307),
    (Tuple 51 355),
    (Tuple 51 480),
    (Tuple 51 911),
    (Tuple 51 564),
    (Tuple 51 434),
    (Tuple 51 240),
    (Tuple 736 736),
    (Tuple 736 780),
    (Tuple 736 781),
    (Tuple 736 837),
    (Tuple 736 782),
    (Tuple 736 737),
    (Tuple 736 238),
    (Tuple 736 593),
    (Tuple 736 908),
    (Tuple 736 738),
    (Tuple 736 839),
    (Tuple 736 632),
    (Tuple 736 699),
    (Tuple 736 429),
    (Tuple 736 57),
    (Tuple 736 841),
    (Tuple 736 783),
    (Tuple 736 784),
    (Tuple 736 353),
    (Tuple 736 785),
    (Tuple 736 786),
    (Tuple 736 787),
    (Tuple 736 788),
    (Tuple 736 701),
    (Tuple 736 514),
    (Tuple 736 532),
    (Tuple 736 634),
    (Tuple 736 789),
    (Tuple 736 533),
    (Tuple 736 683),
    (Tuple 736 790),
    (Tuple 736 393),
    (Tuple 736 615),
    (Tuple 736 515),
    (Tuple 736 842),
    (Tuple 736 843),
    (Tuple 661 15),
    (Tuple 661 151),
    (Tuple 661 152),
    (Tuple 661 459),
    (Tuple 661 153),
    (Tuple 661 920),
    (Tuple 661 154),
    (Tuple 661 155),
    (Tuple 661 460),
    (Tuple 661 172),
    (Tuple 218 221),
    (Tuple 218 223),
    (Tuple 261 261),
    (Tuple 261 262),
    (Tuple 531 426),
    (Tuple 531 120),
    (Tuple 531 352),
    (Tuple 531 124),
    (Tuple 531 125),
    (Tuple 531 676),
    (Tuple 531 354),
    (Tuple 531 703),
    (Tuple 531 356),
    (Tuple 835 780),
    (Tuple 835 781),
    (Tuple 835 837),
    (Tuple 835 699),
    (Tuple 835 429),
    (Tuple 835 841),
    (Tuple 835 783),
    (Tuple 835 784),
    (Tuple 835 353),
    (Tuple 835 785),
    (Tuple 835 786),
    (Tuple 835 787),
    (Tuple 835 788),
    (Tuple 835 701),
    (Tuple 835 514),
    (Tuple 835 683),
    (Tuple 835 615),
    (Tuple 52 52),
    (Tuple 52 425),
    (Tuple 52 116),
    (Tuple 52 349),
    (Tuple 52 593),
    (Tuple 52 121),
    (Tuple 52 350),
    (Tuple 52 351),
    (Tuple 52 427),
    (Tuple 52 428),
    (Tuple 52 859),
    (Tuple 52 352),
    (Tuple 52 124),
    (Tuple 52 700),
    (Tuple 52 125),
    (Tuple 52 707),
    (Tuple 52 676),
    (Tuple 52 430),
    (Tuple 52 354),
    (Tuple 52 658),
    (Tuple 52 532),
    (Tuple 52 633),
    (Tuple 52 702),
    (Tuple 52 432),
    (Tuple 52 554),
    (Tuple 52 307),
    (Tuple 52 596),
    (Tuple 52 355),
    (Tuple 52 480),
    (Tuple 52 564),
    (Tuple 52 356),
    (Tuple 52 434),
    (Tuple 52 903),
    (Tuple 52 132),
    (Tuple 52 309),
    (Tuple 52 866),
    (Tuple 780 836),
    (Tuple 780 737),
    (Tuple 780 908),
    (Tuple 780 838),
    (Tuple 780 699),
    (Tuple 780 840),
    (Tuple 780 784),
    (Tuple 780 676),
    (Tuple 780 786),
    (Tuple 780 740),
    (Tuple 53 593),
    (Tuple 53 370),
    (Tuple 53 54),
    (Tuple 53 55),
    (Tuple 53 68),
    (Tuple 53 69),
    (Tuple 53 58),
    (Tuple 53 59),
    (Tuple 53 658),
    (Tuple 897 898),
    (Tuple 897 900),
    (Tuple 425 120),
    (Tuple 425 350),
    (Tuple 425 859),
    (Tuple 425 124),
    (Tuple 425 703),
    (Tuple 425 597),
    (Tuple 425 132),
    (Tuple 115 116),
    (Tuple 115 593),
    (Tuple 115 121),
    (Tuple 115 352),
    (Tuple 115 707),
    (Tuple 115 354),
    (Tuple 115 479),
    (Tuple 115 596),
    (Tuple 115 355),
    (Tuple 115 597),
    (Tuple 115 132),
    (Tuple 115 866),
    (Tuple 781 737),
    (Tuple 781 908),
    (Tuple 781 738),
    (Tuple 781 839),
    (Tuple 781 859),
    (Tuple 781 840),
    (Tuple 781 909),
    (Tuple 781 739),
    (Tuple 781 676),
    (Tuple 781 633),
    (Tuple 781 740),
    (Tuple 116 349),
    (Tuple 116 238),
    (Tuple 116 118),
    (Tuple 116 119),
    (Tuple 116 427),
    (Tuple 116 122),
    (Tuple 116 267),
    (Tuple 116 123),
    (Tuple 116 57),
    (Tuple 116 125),
    (Tuple 116 126),
    (Tuple 116 129),
    (Tuple 116 130),
    (Tuple 116 594),
    (Tuple 116 595),
    (Tuple 116 131),
    (Tuple 116 132),
    (Tuple 898 899),
    (Tuple 898 900),
    (Tuple 836 839),
    (Tuple 836 632),
    (Tuple 836 783),
    (Tuple 836 784),
    (Tuple 836 785),
    (Tuple 836 786),
    (Tuple 836 787),
    (Tuple 836 788),
    (Tuple 836 683),
    (Tuple 836 615),
    (Tuple 837 908),
    (Tuple 837 738),
    (Tuple 837 838),
    (Tuple 837 840),
    (Tuple 837 740),
    (Tuple 782 859),
    (Tuple 782 909),
    (Tuple 782 700),
    (Tuple 782 923),
    (Tuple 782 676),
    (Tuple 782 633),
    (Tuple 782 740),
    (Tuple 971 460),
    (Tuple 558 558),
    (Tuple 737 632),
    (Tuple 737 699),
    (Tuple 737 783),
    (Tuple 737 784),
    (Tuple 737 785),
    (Tuple 737 786),
    (Tuple 737 787),
    (Tuple 737 788),
    (Tuple 737 701),
    (Tuple 737 514),
    (Tuple 737 533),
    (Tuple 737 683),
    (Tuple 737 790),
    (Tuple 737 393),
    (Tuple 737 615),
    (Tuple 349 863),
    (Tuple 349 426),
    (Tuple 349 120),
    (Tuple 349 859),
    (Tuple 349 124),
    (Tuple 349 700),
    (Tuple 349 125),
    (Tuple 349 676),
    (Tuple 349 354),
    (Tuple 349 703),
    (Tuple 349 596),
    (Tuple 349 356),
    (Tuple 349 132),
    (Tuple 349 842),
    (Tuple 863 863),
    (Tuple 863 120),
    (Tuple 863 124),
    (Tuple 863 125),
    (Tuple 863 126),
    (Tuple 863 430),
    (Tuple 863 633),
    (Tuple 863 131),
    (Tuple 863 703),
    (Tuple 863 132),
    (Tuple 863 357),
    (Tuple 238 700),
    (Tuple 238 740),
    (Tuple 238 132),
    (Tuple 219 219),
    (Tuple 219 221),
    (Tuple 219 392),
    (Tuple 593 267),
    (Tuple 593 57),
    (Tuple 593 783),
    (Tuple 593 784),
    (Tuple 593 786),
    (Tuple 593 58),
    (Tuple 593 126),
    (Tuple 593 59),
    (Tuple 387 648),
    (Tuple 387 390),
    (Tuple 387 649),
    (Tuple 387 68),
    (Tuple 387 221),
    (Tuple 387 392),
    (Tuple 387 290),
    (Tuple 387 225),
    (Tuple 117 352),
    (Tuple 117 866),
    (Tuple 793 658),
    (Tuple 793 794),
    (Tuple 793 795),
    (Tuple 118 352),
    (Tuple 118 132),
    (Tuple 149 149),
    (Tuple 149 15),
    (Tuple 149 151),
    (Tuple 149 459),
    (Tuple 149 655),
    (Tuple 908 839),
    (Tuple 908 57),
    (Tuple 908 841),
    (Tuple 908 783),
    (Tuple 908 784),
    (Tuple 908 785),
    (Tuple 908 786),
    (Tuple 908 787),
    (Tuple 908 788),
    (Tuple 908 514),
    (Tuple 908 683),
    (Tuple 908 615),
    (Tuple 648 648),
    (Tuple 648 390),
    (Tuple 648 68),
    (Tuple 648 221),
    (Tuple 648 222),
    (Tuple 648 290),
    (Tuple 648 459),
    (Tuple 370 370),
    (Tuple 370 54),
    (Tuple 370 55),
    (Tuple 370 56),
    (Tuple 370 391),
    (Tuple 370 58),
    (Tuple 370 59),
    (Tuple 370 431),
    (Tuple 370 173),
    (Tuple 119 121),
    (Tuple 119 707),
    (Tuple 119 597),
    (Tuple 119 132),
    (Tuple 15 612),
    (Tuple 15 153),
    (Tuple 15 655),
    (Tuple 15 853),
    (Tuple 15 937),
    (Tuple 15 938),
    (Tuple 15 948),
    (Tuple 738 838),
    (Tuple 738 841),
    (Tuple 738 783),
    (Tuple 738 784),
    (Tuple 738 785),
    (Tuple 738 786),
    (Tuple 738 787),
    (Tuple 738 788),
    (Tuple 738 701),
    (Tuple 738 683),
    (Tuple 738 393),
    (Tuple 738 615),
    (Tuple 838 783),
    (Tuple 838 784),
    (Tuple 838 786),
    (Tuple 838 787),
    (Tuple 838 788),
    (Tuple 838 615),
    (Tuple 882 388),
    (Tuple 882 513),
    (Tuple 882 752),
    (Tuple 882 753),
    (Tuple 882 754),
    (Tuple 882 755),
    (Tuple 549 120),
    (Tuple 549 352),
    (Tuple 549 125),
    (Tuple 549 703),
    (Tuple 549 903),
    (Tuple 549 876),
    (Tuple 426 120),
    (Tuple 426 428),
    (Tuple 426 267),
    (Tuple 426 123),
    (Tuple 426 124),
    (Tuple 426 125),
    (Tuple 426 126),
    (Tuple 426 430),
    (Tuple 426 132),
    (Tuple 426 357),
    (Tuple 54 55),
    (Tuple 54 391),
    (Tuple 54 126),
    (Tuple 54 59),
    (Tuple 220 390),
    (Tuple 220 392),
    (Tuple 220 223),
    (Tuple 220 394),
    (Tuple 120 120),
    (Tuple 120 427),
    (Tuple 120 267),
    (Tuple 120 123),
    (Tuple 120 124),
    (Tuple 120 125),
    (Tuple 120 707),
    (Tuple 120 676),
    (Tuple 120 126),
    (Tuple 120 128),
    (Tuple 120 634),
    (Tuple 120 131),
    (Tuple 120 433),
    (Tuple 120 703),
    (Tuple 120 596),
    (Tuple 120 132),
    (Tuple 120 435),
    (Tuple 120 357),
    (Tuple 120 309),
    (Tuple 550 389),
    (Tuple 550 57),
    (Tuple 550 552),
    (Tuple 550 431),
    (Tuple 550 553),
    (Tuple 550 554),
    (Tuple 550 364),
    (Tuple 550 307),
    (Tuple 550 355),
    (Tuple 550 480),
    (Tuple 550 911),
    (Tuple 550 564),
    (Tuple 550 434),
    (Tuple 550 60),
    (Tuple 654 16),
    (Tuple 388 388),
    (Tuple 388 513),
    (Tuple 388 752),
    (Tuple 388 753),
    (Tuple 388 754),
    (Tuple 388 883),
    (Tuple 388 755),
    (Tuple 388 884),
    (Tuple 121 126),
    (Tuple 121 128),
    (Tuple 121 130),
    (Tuple 121 132),
    (Tuple 121 309),
    (Tuple 266 676),
    (Tuple 350 350),
    (Tuple 350 427),
    (Tuple 350 428),
    (Tuple 350 122),
    (Tuple 350 125),
    (Tuple 350 430),
    (Tuple 350 432),
    (Tuple 350 595),
    (Tuple 350 433),
    (Tuple 350 703),
    (Tuple 350 435),
    (Tuple 350 357),
    (Tuple 839 839),
    (Tuple 839 840),
    (Tuple 839 633),
    (Tuple 839 740),
    (Tuple 351 351),
    (Tuple 351 699),
    (Tuple 351 700),
    (Tuple 351 923),
    (Tuple 351 676),
    (Tuple 351 701),
    (Tuple 351 702),
    (Tuple 351 876),
    (Tuple 351 843),
    (Tuple 351 866),
    (Tuple 389 352),
    (Tuple 389 551),
    (Tuple 389 563),
    (Tuple 389 307),
    (Tuple 389 355),
    (Tuple 389 911),
    (Tuple 389 564),
    (Tuple 389 240),
    (Tuple 389 60),
    (Tuple 632 859),
    (Tuple 632 700),
    (Tuple 632 923),
    (Tuple 632 740),
    (Tuple 632 842),
    (Tuple 632 910),
    (Tuple 699 699),
    (Tuple 699 859),
    (Tuple 699 352),
    (Tuple 699 700),
    (Tuple 699 739),
    (Tuple 699 125),
    (Tuple 699 923),
    (Tuple 699 676),
    (Tuple 699 701),
    (Tuple 699 532),
    (Tuple 699 633),
    (Tuple 699 677),
    (Tuple 699 533),
    (Tuple 699 702),
    (Tuple 699 740),
    (Tuple 699 790),
    (Tuple 699 876),
    (Tuple 699 842),
    (Tuple 699 843),
    (Tuple 699 910),
    (Tuple 390 390),
    (Tuple 390 649),
    (Tuple 390 68),
    (Tuple 390 221),
    (Tuple 390 222),
    (Tuple 390 392),
    (Tuple 390 290),
    (Tuple 390 224),
    (Tuple 390 225),
    (Tuple 390 394),
    (Tuple 150 457),
    (Tuple 150 612),
    (Tuple 150 853),
    (Tuple 150 155),
    (Tuple 150 613),
    (Tuple 55 55),
    (Tuple 55 58),
    (Tuple 55 59),
    (Tuple 55 658),
    (Tuple 55 479),
    (Tuple 56 866),
    (Tuple 427 125),
    (Tuple 427 707),
    (Tuple 427 676),
    (Tuple 427 430),
    (Tuple 427 354),
    (Tuple 427 432),
    (Tuple 427 594),
    (Tuple 427 595),
    (Tuple 427 703),
    (Tuple 427 596),
    (Tuple 427 356),
    (Tuple 427 132),
    (Tuple 941 239),
    (Tuple 941 364),
    (Tuple 941 240),
    (Tuple 941 173),
    (Tuple 151 151),
    (Tuple 151 458),
    (Tuple 151 655),
    (Tuple 151 920),
    (Tuple 151 938),
    (Tuple 151 155),
    (Tuple 457 612),
    (Tuple 457 154),
    (Tuple 428 352),
    (Tuple 428 676),
    (Tuple 428 354),
    (Tuple 859 57),
    (Tuple 859 783),
    (Tuple 859 784),
    (Tuple 859 353),
    (Tuple 859 785),
    (Tuple 859 125),
    (Tuple 859 786),
    (Tuple 859 787),
    (Tuple 859 788),
    (Tuple 859 701),
    (Tuple 859 514),
    (Tuple 859 532),
    (Tuple 859 634),
    (Tuple 859 789),
    (Tuple 859 683),
    (Tuple 859 790),
    (Tuple 859 615),
    (Tuple 859 515),
    (Tuple 122 122),
    (Tuple 122 352),
    (Tuple 122 703),
    (Tuple 429 923),
    (Tuple 429 676),
    (Tuple 429 633),
    (Tuple 429 677),
    (Tuple 429 702),
    (Tuple 429 876),
    (Tuple 429 866),
    (Tuple 267 352),
    (Tuple 267 707),
    (Tuple 267 676),
    (Tuple 267 596),
    (Tuple 267 132),
    (Tuple 840 783),
    (Tuple 840 784),
    (Tuple 840 785),
    (Tuple 840 786),
    (Tuple 840 787),
    (Tuple 840 788),
    (Tuple 840 701),
    (Tuple 840 514),
    (Tuple 840 683),
    (Tuple 840 615),
    (Tuple 123 352),
    (Tuple 123 676),
    (Tuple 123 356),
    (Tuple 513 513),
    (Tuple 513 752),
    (Tuple 513 753),
    (Tuple 513 754),
    (Tuple 513 883),
    (Tuple 513 755),
    (Tuple 513 884),
    (Tuple 649 649),
    (Tuple 649 68),
    (Tuple 649 221),
    (Tuple 649 222),
    (Tuple 649 225),
    (Tuple 57 676),
    (Tuple 57 658),
    (Tuple 57 563),
    (Tuple 57 740),
    (Tuple 57 307),
    (Tuple 57 355),
    (Tuple 57 564),
    (Tuple 57 240),
    (Tuple 57 132),
    (Tuple 909 909),
    (Tuple 909 936),
    (Tuple 909 841),
    (Tuple 909 784),
    (Tuple 909 923),
    (Tuple 909 786),
    (Tuple 909 788),
    (Tuple 909 532),
    (Tuple 909 789),
    (Tuple 909 683),
    (Tuple 909 790),
    (Tuple 909 791),
    (Tuple 936 936),
    (Tuple 936 784),
    (Tuple 936 788),
    (Tuple 936 789),
    (Tuple 936 790),
    (Tuple 936 393),
    (Tuple 352 125),
    (Tuple 352 126),
    (Tuple 352 127),
    (Tuple 352 430),
    (Tuple 352 532),
    (Tuple 352 364),
    (Tuple 352 595),
    (Tuple 352 433),
    (Tuple 352 505),
    (Tuple 352 308),
    (Tuple 352 60),
    (Tuple 352 515),
    (Tuple 352 133),
    (Tuple 352 309),
    (Tuple 391 866),
    (Tuple 841 841),
    (Tuple 841 739),
    (Tuple 841 740),
    (Tuple 783 784),
    (Tuple 783 739),
    (Tuple 783 676),
    (Tuple 783 740),
    (Tuple 783 910),
    (Tuple 784 739),
    (Tuple 784 923),
    (Tuple 784 676),
    (Tuple 784 633),
    (Tuple 784 740),
    (Tuple 784 910),
    (Tuple 353 353),
    (Tuple 353 700),
    (Tuple 353 923),
    (Tuple 353 676),
    (Tuple 353 633),
    (Tuple 353 702),
    (Tuple 353 740),
    (Tuple 353 876),
    (Tuple 353 842),
    (Tuple 353 843),
    (Tuple 353 910),
    (Tuple 124 124),
    (Tuple 124 125),
    (Tuple 124 126),
    (Tuple 124 430),
    (Tuple 124 128),
    (Tuple 124 633),
    (Tuple 124 432),
    (Tuple 124 131),
    (Tuple 124 703),
    (Tuple 124 596),
    (Tuple 124 356),
    (Tuple 124 597),
    (Tuple 124 132),
    (Tuple 124 435),
    (Tuple 124 357),
    (Tuple 68 68),
    (Tuple 68 221),
    (Tuple 68 69),
    (Tuple 68 222),
    (Tuple 68 905),
    (Tuple 68 225),
    (Tuple 752 752),
    (Tuple 752 753),
    (Tuple 752 754),
    (Tuple 752 883),
    (Tuple 752 755),
    (Tuple 752 884),
    (Tuple 785 739),
    (Tuple 785 923),
    (Tuple 785 676),
    (Tuple 785 740),
    (Tuple 221 392),
    (Tuple 221 290),
    (Tuple 221 225),
    (Tuple 221 394),
    (Tuple 551 551),
    (Tuple 551 552),
    (Tuple 551 239),
    (Tuple 551 534),
    (Tuple 551 553),
    (Tuple 551 554),
    (Tuple 551 364),
    (Tuple 551 307),
    (Tuple 551 355),
    (Tuple 551 480),
    (Tuple 551 911),
    (Tuple 551 240),
    (Tuple 551 505),
    (Tuple 551 60),
    (Tuple 551 133),
    (Tuple 551 866),
    (Tuple 700 700),
    (Tuple 700 787),
    (Tuple 700 701),
    (Tuple 700 634),
    (Tuple 700 533),
    (Tuple 700 683),
    (Tuple 700 393),
    (Tuple 700 843),
    (Tuple 700 357),
    (Tuple 739 786),
    (Tuple 739 787),
    (Tuple 739 788),
    (Tuple 739 514),
    (Tuple 739 740),
    (Tuple 739 683),
    (Tuple 739 615),
    (Tuple 125 125),
    (Tuple 125 676),
    (Tuple 125 430),
    (Tuple 125 633),
    (Tuple 125 432),
    (Tuple 125 131),
    (Tuple 125 433),
    (Tuple 125 356),
    (Tuple 125 132),
    (Tuple 125 876),
    (Tuple 125 866),
    (Tuple 69 173),
    (Tuple 753 754),
    (Tuple 753 883),
    (Tuple 753 884),
    (Tuple 923 923),
    (Tuple 923 786),
    (Tuple 923 787),
    (Tuple 923 430),
    (Tuple 923 788),
    (Tuple 923 701),
    (Tuple 923 514),
    (Tuple 923 789),
    (Tuple 923 533),
    (Tuple 923 683),
    (Tuple 923 790),
    (Tuple 923 393),
    (Tuple 923 515),
    (Tuple 923 843),
    (Tuple 923 357),
    (Tuple 707 126),
    (Tuple 707 127),
    (Tuple 707 130),
    (Tuple 707 594),
    (Tuple 707 132),
    (Tuple 707 60),
    (Tuple 676 786),
    (Tuple 676 126),
    (Tuple 676 787),
    (Tuple 676 788),
    (Tuple 676 514),
    (Tuple 676 532),
    (Tuple 676 634),
    (Tuple 676 789),
    (Tuple 676 683),
    (Tuple 676 356),
    (Tuple 676 615),
    (Tuple 676 357),
    (Tuple 786 786),
    (Tuple 786 740),
    (Tuple 786 843),
    (Tuple 786 910),
    (Tuple 152 152),
    (Tuple 152 153),
    (Tuple 152 655),
    (Tuple 152 920),
    (Tuple 152 155),
    (Tuple 152 172),
    (Tuple 58 59),
    (Tuple 58 658),
    (Tuple 126 126),
    (Tuple 126 354),
    (Tuple 126 563),
    (Tuple 126 596),
    (Tuple 126 356),
    (Tuple 126 597),
    (Tuple 126 903),
    (Tuple 126 132),
    (Tuple 126 308),
    (Tuple 126 866),
    (Tuple 127 354),
    (Tuple 127 132),
    (Tuple 222 392),
    (Tuple 222 290),
    (Tuple 222 225),
    (Tuple 222 618),
    (Tuple 222 394),
    (Tuple 552 239),
    (Tuple 552 534),
    (Tuple 552 554),
    (Tuple 552 563),
    (Tuple 552 307),
    (Tuple 552 355),
    (Tuple 552 480),
    (Tuple 552 911),
    (Tuple 552 564),
    (Tuple 552 240),
    (Tuple 552 866),
    (Tuple 787 658),
    (Tuple 787 633),
    (Tuple 787 702),
    (Tuple 787 740),
    (Tuple 787 842),
    (Tuple 787 910),
    (Tuple 430 354),
    (Tuple 430 532),
    (Tuple 430 633),
    (Tuple 430 703),
    (Tuple 430 356),
    (Tuple 59 658),
    (Tuple 354 532),
    (Tuple 354 433),
    (Tuple 658 173),
    (Tuple 239 239),
    (Tuple 239 532),
    (Tuple 239 534),
    (Tuple 239 553),
    (Tuple 239 432),
    (Tuple 239 554),
    (Tuple 239 563),
    (Tuple 239 364),
    (Tuple 239 307),
    (Tuple 239 355),
    (Tuple 239 480),
    (Tuple 239 911),
    (Tuple 239 564),
    (Tuple 239 505),
    (Tuple 239 241),
    (Tuple 239 866),
    (Tuple 483 483),
    (Tuple 788 633),
    (Tuple 788 740),
    (Tuple 754 754),
    (Tuple 754 883),
    (Tuple 754 755),
    (Tuple 754 884),
    (Tuple 883 755),
    (Tuple 701 701),
    (Tuple 701 740),
    (Tuple 701 842),
    (Tuple 701 843),
    (Tuple 701 910),
    (Tuple 514 514),
    (Tuple 514 633),
    (Tuple 514 740),
    (Tuple 514 842),
    (Tuple 514 843),
    (Tuple 431 563),
    (Tuple 431 355),
    (Tuple 431 564),
    (Tuple 532 532),
    (Tuple 532 677),
    (Tuple 532 533),
    (Tuple 532 534),
    (Tuple 532 703),
    (Tuple 532 357),
    (Tuple 532 309),
    (Tuple 392 224),
    (Tuple 392 394),
    (Tuple 128 703),
    (Tuple 128 356),
    (Tuple 128 132),
    (Tuple 633 633),
    (Tuple 633 634),
    (Tuple 633 683),
    (Tuple 633 790),
    (Tuple 633 393),
    (Tuple 633 615),
    (Tuple 633 515),
    (Tuple 633 842),
    (Tuple 633 843),
    (Tuple 633 357),
    (Tuple 634 533),
    (Tuple 677 677),
    (Tuple 677 789),
    (Tuple 677 842),
    (Tuple 789 702),
    (Tuple 899 899),
    (Tuple 899 900),
    (Tuple 533 740),
    (Tuple 533 876),
    (Tuple 702 702),
    (Tuple 702 60),
    (Tuple 534 534),
    (Tuple 534 553),
    (Tuple 534 554),
    (Tuple 534 563),
    (Tuple 534 307),
    (Tuple 534 355),
    (Tuple 534 480),
    (Tuple 534 911),
    (Tuple 534 240),
    (Tuple 534 133),
    (Tuple 534 866),
    (Tuple 479 479),
    (Tuple 458 16),
    (Tuple 458 153),
    (Tuple 458 155),
    (Tuple 553 554),
    (Tuple 553 563),
    (Tuple 553 364),
    (Tuple 553 307),
    (Tuple 553 355),
    (Tuple 553 480),
    (Tuple 553 911),
    (Tuple 553 564),
    (Tuple 553 240),
    (Tuple 553 866),
    (Tuple 432 432),
    (Tuple 432 703),
    (Tuple 432 843),
    (Tuple 432 866),
    (Tuple 554 554),
    (Tuple 554 563),
    (Tuple 554 364),
    (Tuple 554 307),
    (Tuple 554 355),
    (Tuple 554 480),
    (Tuple 554 564),
    (Tuple 554 240),
    (Tuple 554 505),
    (Tuple 554 60),
    (Tuple 554 241),
    (Tuple 554 133),
    (Tuple 563 307),
    (Tuple 563 355),
    (Tuple 563 434),
    (Tuple 563 240),
    (Tuple 563 505),
    (Tuple 563 60),
    (Tuple 364 355),
    (Tuple 364 480),
    (Tuple 364 564),
    (Tuple 16 153),
    (Tuple 16 223),
    (Tuple 129 596),
    (Tuple 129 355),
    (Tuple 129 132),
    (Tuple 129 866),
    (Tuple 130 596),
    (Tuple 130 597),
    (Tuple 130 132),
    (Tuple 290 394),
    (Tuple 594 595),
    (Tuple 594 703),
    (Tuple 594 596),
    (Tuple 594 132),
    (Tuple 740 683),
    (Tuple 740 393),
    (Tuple 740 515),
    (Tuple 740 843),
    (Tuple 307 307),
    (Tuple 307 355),
    (Tuple 307 480),
    (Tuple 307 911),
    (Tuple 307 564),
    (Tuple 307 434),
    (Tuple 307 240),
    (Tuple 307 505),
    (Tuple 307 60),
    (Tuple 307 241),
    (Tuple 307 133),
    (Tuple 307 357),
    (Tuple 307 866),
    (Tuple 683 683),
    (Tuple 683 842),
    (Tuple 683 910),
    (Tuple 459 153),
    (Tuple 459 655),
    (Tuple 459 920),
    (Tuple 612 153),
    (Tuple 612 154),
    (Tuple 612 613),
    (Tuple 595 132),
    (Tuple 131 703),
    (Tuple 131 132),
    (Tuple 131 435),
    (Tuple 433 866),
    (Tuple 703 356),
    (Tuple 153 153),
    (Tuple 153 853),
    (Tuple 153 155),
    (Tuple 153 460),
    (Tuple 153 613),
    (Tuple 596 596),
    (Tuple 355 480),
    (Tuple 355 564),
    (Tuple 355 434),
    (Tuple 355 240),
    (Tuple 355 505),
    (Tuple 355 60),
    (Tuple 355 515),
    (Tuple 355 241),
    (Tuple 355 133),
    (Tuple 355 357),
    (Tuple 355 309),
    (Tuple 355 866),
    (Tuple 900 900),
    (Tuple 655 655),
    (Tuple 655 937),
    (Tuple 655 920),
    (Tuple 655 942),
    (Tuple 655 938),
    (Tuple 655 154),
    (Tuple 655 948),
    (Tuple 655 460),
    (Tuple 853 154),
    (Tuple 480 480),
    (Tuple 480 911),
    (Tuple 480 564),
    (Tuple 480 60),
    (Tuple 911 240),
    (Tuple 911 505),
    (Tuple 911 60),
    (Tuple 911 241),
    (Tuple 911 133),
    (Tuple 911 309),
    (Tuple 937 942),
    (Tuple 937 938),
    (Tuple 937 154),
    (Tuple 937 948),
    (Tuple 937 460),
    (Tuple 920 920),
    (Tuple 920 942),
    (Tuple 920 154),
    (Tuple 920 155),
    (Tuple 920 460),
    (Tuple 942 938),
    (Tuple 942 225),
    (Tuple 942 948),
    (Tuple 938 154),
    (Tuple 938 948),
    (Tuple 938 460),
    (Tuple 223 223),
    (Tuple 223 224),
    (Tuple 564 434),
    (Tuple 564 60),
    (Tuple 154 460),
    (Tuple 154 613),
    (Tuple 794 795),
    (Tuple 224 394),
    (Tuple 224 797),
    (Tuple 356 435),
    (Tuple 356 357),
    (Tuple 356 309),
    (Tuple 225 225),
    (Tuple 225 507),
    (Tuple 755 884),
    (Tuple 795 795),
    (Tuple 434 60),
    (Tuple 790 842),
    (Tuple 948 460),
    (Tuple 597 132),
    (Tuple 597 308),
    (Tuple 460 460),
    (Tuple 240 240),
    (Tuple 240 505),
    (Tuple 240 866),
    (Tuple 903 308),
    (Tuple 505 866),
    (Tuple 132 132),
    (Tuple 132 308),
    (Tuple 132 173),
    (Tuple 132 309),
    (Tuple 393 876),
    (Tuple 393 842),
    (Tuple 393 910),
    (Tuple 876 515),
    (Tuple 876 357),
    (Tuple 172 172),
    (Tuple 515 842),
    (Tuple 515 843),
    (Tuple 515 910),
    (Tuple 842 842),
    (Tuple 842 843),
    (Tuple 241 241),
    (Tuple 241 866),
    (Tuple 843 843),
    (Tuple 843 910),
    (Tuple 910 910),
    (Tuple 133 866),
    (Tuple 357 866),
    (Tuple 613 613),
    (Tuple 309 866),
    (Tuple 866 866)]

